<h1 align="center">
IntervalArithmetic

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaintervals.github.io/IntervalArithmetic.jl/stable)
[![DOI](https://zenodo.org/badge/87007945.svg)](https://zenodo.org/badge/latestdoi/87007945)
[![Build Status](https://github.com/JuliaIntervals/IntervalArithmetic.jl/workflows/CI/badge.svg)](https://github.com/JuliaIntervals/IntervalArithmetic.jl/actions/workflows/CI.yml)
[![coverage](https://codecov.io/gh/JuliaIntervals/IntervalArithmetic.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaIntervals/IntervalArithmetic.jl)
</h1>

IntervalArithmetic.jl is a Julia package for validated numerics. All calculations are carried out using [interval arithmetic](https://en.wikipedia.org/wiki/Interval_arithmetic) where quantities are treated as intervals. The final result is a rigorous enclosure of the true value.

The IntervalArithmetic library is compliant with the [IEEE 1788-2015 standard for interval arithmetic](https://standards.ieee.org/findstds/standard/1788-2015.html).

The IntervalArithmetic library is part of the [JuliaInterval organisation](https://juliaintervals.github.io).

## Documentation

The official documentation is available online: https://juliaintervals.github.io/IntervalArithmetic.jl/stable.

## Installation

The IntervalArithmetic.jl package requires to [install Julia](https://julialang.org/downloads/) (v1.10 or above).

Then, start Julia and execute the following command in the REPL:

```julia
using Pkg; Pkg.add("IntervalArithmetic")
```

## Citation

If you use the IntervalArithmetic library in your publication, research, teaching, or other activities, please use the BibTeX template [CITATION.bib](https://github.com/JuliaIntervals/IntervalArithmetic.jl/blob/master/CITATION.bib).

@testset "Difference between checked and unchecked bare intervals" begin
    @test IntervalArithmetic._unsafe_bareinterval(Float64, 1, 2) === bareinterval(1, 2)

    @test inf(IntervalArithmetic._unsafe_bareinterval(Float64, 3, 2)) == 3
    @test isempty_interval(bareinterval(3, 2))
    @test isnai(interval(3, 2))

    # `:set_based` flavor
    @test sup(IntervalArithmetic._unsafe_bareinterval(Float64, Inf, Inf)) == Inf
    @test isempty_interval(bareinterval(Inf, Inf))
    @test isnai(interval(Inf, Inf))
    @test isnai(interval(1//0, 1//0))
    @test isnai(interval(-1//0, -1//0))
    @test isnai(interval(1//0, -1//0))
end

@testset "Basics" begin
    @test typeof(interval(1, 2)) == Interval{Float64}
    @test typeof(big(interval(1, 2))) == Interval{BigFloat}
    for T ∈ (Float16, Float32, Float64, BigFloat)
        @test typeof(interval(T, 1, 2)) == Interval{T}
    end
    for T ∈ [InteractiveUtils.subtypes(Signed) ; InteractiveUtils.subtypes(Unsigned)]
        @test typeof(interval(Rational{T}, 1, 2)) == Interval{Rational{T}}
    end
    @test eltype(interval(1, 2)) == Interval{Float64}
    @test IntervalArithmetic.numtype(interval(1, 2)) == Float64
    @test typeof(interval(BigInt(1), 11//10)) == Interval{Rational{BigInt}}

    @test inf(interval(1, 2)) == 1 && sup(interval(1, 2)) == 2

    @test isequal_interval(
        interval(Float64, 1, 1), interval(Float64, 1), interval(1),
        interval(Float64, interval(1)), interval(interval(1)),
        interval(BigFloat, 1, 1), interval(BigFloat, 1), interval(big(1)),
        interval(Float64, 1, 1), interval(1, 1), interval(Float64, 1), interval(1))

    @test isequal_interval(
        interval(Rational{Int}, 1//10, 1//10), interval(1//10, 1//10), interval(Rational{Int}, 1//10), interval(1//10),
        interval(Rational{Int}, interval(1//10)), interval(interval(1//10)),
        interval(Rational{BigInt}, 1//10, 1//10), interval(Rational{BigInt}, 1//10), interval(big(1//10)),
        interval(Rational{Int}, 1//10, 1//10), interval(1//10, 1//10), interval(Rational{Int}, 1//10), interval(1//10))

    @test_throws MethodError BareInterval(1)
    @test_throws MethodError BareInterval{Float64}(1)
    @test_throws MethodError BareInterval(1, 2)
    @test_throws MethodError BareInterval{Float64}(1, 2)

    @test !isguaranteed(Interval(1))
    @test !isguaranteed(Interval{Float64}(1))
    @test_throws MethodError Interval(1, 2)
    @test_throws MethodError Interval{Float64}(1, 2)

    @test isequal_interval(
        BareInterval{Float64}(bareinterval(3, 4)), BareInterval{BigFloat}(bareinterval(3, 4)),
        BareInterval{Rational{Int}}(bareinterval(3, 4)), BareInterval{Rational{BigInt}}(bareinterval(3, 4)),
        bareinterval(3, 4))

    @test isequal_interval(
        Interval{Float64}(interval(3, 4)), Interval{BigFloat}(interval(3, 4)),
        Interval{Rational{Int}}(interval(3, 4)), Interval{Rational{BigInt}}(interval(3, 4)),
        interval(3, 4))

    @test isempty_interval(bareinterval(2, 1))
    @test isempty_interval(bareinterval(Inf))
    @test isempty_interval(bareinterval(-Inf))
    @test isempty_interval(bareinterval(1, NaN))
    @test isempty_interval(bareinterval(NaN))

    @test isnai(interval(2, 1))
    @test isnai(interval(Inf))
    @test isnai(interval(-Inf))
    @test isnai(interval(1, NaN))
    @test isnai(interval(NaN))

    @test isnai(interval(1//0))
    @test isnai(interval(-1//0))

    # check no issue with `Integer` modular arithmetic
    @test bounds(interval(typemin(Int64), typemax(Int64))) == (float(typemin(Int64)), float(typemax(Int64)))

    # 1//10 < 0.1, 2//10 < 0.2
    @test !in_interval(1//10, interval(0.1, 0.2)) && in_interval(2//10, interval(0.1, 0.2))

    @test isequal_interval(interval(1//2), interval(0.5))
    @test inf(interval(1//10)) == 1//10 && sup(interval(1//10)) == 1//10

    x = interval(1 + 2im)
    @test typeof(x) == Complex{Interval{Float64}}
    @test isequal_interval(x, complex(interval(1), interval(2)))

    @test IntervalArithmetic.Symbols.:..(1, 2) === interval(1, 2; format = :infsup)
end

@testset "Irrationals" begin
    for irr ∈ (MathConstants.:π, MathConstants.:γ, MathConstants.:catalan, MathConstants.:φ, MathConstants.:ℯ)
        for T ∈ (Float16, Float32, Float64, BigFloat)
            @test in_interval(irr, interval(T, irr))
            if T !== BigFloat
                @test nextfloat(inf(interval(T, irr))) == sup(interval(T, irr))
            end
        end
        for T ∈ [InteractiveUtils.subtypes(Signed) ; InteractiveUtils.subtypes(Unsigned)]
            @test in_interval(irr, interval(Rational{T}, irr))
        end
    end
end

@testset "Midpoint" begin
    @test isequal_interval(IntervalArithmetic.Symbols.:±(0.5, 1),
        interval(0.5, 1; format = :midpoint),
        interval(0.5, 1+0im; format = :midpoint),
        interval(0.5, interval(1+0im); format = :midpoint),
        interval(-0.5, 1.5))

    @test isequal_interval(IntervalArithmetic.Symbols.:±(interval(0.5, 1), interval(1, 2)),
        interval(interval(0.5, 1), interval(1, 2); format = :midpoint),
        interval(-1.5, 3))

    @test isequal_interval(IntervalArithmetic.Symbols.:±(0.5+im, 1),
        interval(0.5+im, 1; format = :midpoint),
        interval(0.5+im, 1+0im; format = :midpoint),
        interval(interval(0.5+im), interval(1+0im); format = :midpoint),
        complex(interval(-0.5, 1.5), interval(0, 2)))

    @test_throws DomainError interval(0.5+im, 1+im; format = :midpoint)
end

@testset "Decorations" begin
    a = interval(1, 2)
    b = interval(1, 2, IntervalArithmetic.com)
    c = interval(1, 2, IntervalArithmetic.dac)
    d = interval(a, IntervalArithmetic.dac)

    @test decoration(a) == IntervalArithmetic.com
    @test decoration(b) == IntervalArithmetic.com
    @test decoration(c) == IntervalArithmetic.dac
    @test decoration(d) == IntervalArithmetic.dac

    @test decoration(interval(2, 0.1)) == decoration(interval(2, 0.1, IntervalArithmetic.com)) == IntervalArithmetic.ill
end

@testset "Conversions and promotions" begin
    bx = bareinterval(Float64, π)
    by = bareinterval(BigFloat, π)
    big_bx, big_by = promote(bx, by)
    @test promote_type(typeof(bx), typeof(by)) == typeof(big_bx) == BareInterval{BigFloat}
    @test isequal_interval(big_bx, BareInterval{BigFloat}(bx))
    @test isequal_interval(big_by, by)
    # cannot convert a `Real` to a `BareInterval`
    @test_throws MethodError convert(BareInterval, 1)
    @test_throws MethodError convert(BareInterval{Float64}, 1)

    x = interval(Float64, π)
    y = interval(BigFloat, π)
    big_x, big_y = promote(x, y)
    @test promote_type(typeof(x), typeof(y)) == typeof(big_x) == Interval{BigFloat}
    @test isequal_interval(big_x, Interval{BigFloat}(x))
    @test isequal_interval(big_y, y)
    # can convert a `Real` to an `Interval`
    @test isequal_interval(convert(Interval{Float64}, 1), interval(1)) & (isguaranteed(convert(Interval{Float64}, 1)) == !isguaranteed(interval(1)))
    @test isequal_interval(convert(Complex{Interval{Float64}}, 1), interval(1+0im)) & (isguaranteed(convert(Complex{Interval{Float64}}, 1)) == !isguaranteed(interval(1+0im)))
    @test isequal_interval(convert(Complex{Interval{Float64}}, im), interval(im)) & (isguaranteed(convert(Complex{Interval{Float64}}, im)) == !isguaranteed(interval(im)))
    @test isequal_interval(convert(Interval{Float64}, 1+0im), convert(Interval{Float64}, interval(1+0im)), interval(1))
    @test_throws DomainError convert(Interval{Float64}, 1+im)
    @test_throws DomainError convert(Interval{Float64}, interval(1+im))
end

@testset "Interval types conversion" begin
    i = interval(IS.Interval(1, 2))
    @test isequal_interval(i, interval(1., 2.)) && !isguaranteed(i)
    i = interval(IS.Interval(0.1, 2))
    @test isequal_interval(i, interval(0.1, 2.)) && !isguaranteed(i)
    @test interval(Float64, IS.Interval(0.1, 2)) === i

    i = interval(IS.iv"[0.1, Inf)")
    @test isequal_interval(i, interval(0.1, Inf)) && !isguaranteed(i)
    @test interval(IS.iv"[0.1, Inf]") === nai(Float64)
    @test interval(IS.iv"(0.1, Inf]") === nai(Float64)
    @test interval(IS.iv"(0.1, Inf)") === nai(Float64)
    @test interval(IS.iv"(0.1, 1)") === nai(Float64)
    @test interval(IS.iv"(0.1, 1]") === nai(Float64)

    @test IS.Interval(interval(1, 2)) === IS.Interval(1., 2.)
    @test IS.Interval(interval(0.1, 2)) === IS.Interval(0.1, 2.)
    @test IS.Interval(interval(0.1, Inf)) === IS.iv"[0.1, Inf)"
    @test IS.Interval(interval(-Inf, Inf)) === IS.iv"(-Inf, Inf)"
end

@testset "Propagation of `isguaranteed`" begin
    @test !isguaranteed(interval(convert(Interval{Float64}, 0), interval(convert(Interval{Float64}, 1))))
    @test !isguaranteed(interval(0, convert(Interval{Float64}, 1)))
    @test !isguaranteed(interval(convert(Interval{Float64}, 0), 1))
end

"""
    bisect(x, α=0.5)
    bisect(x, i, α=0.5)

Split an interval `x` at a relative position `α`, where `α = 0.5` corresponds
to the midpoint.

Split the `i`-th component of a vector `x` at a relative position `α`, where
`α = 0.5` corresponds to the midpoint.
"""
function bisect(x::BareInterval{T}, α::Real = 0.5) where {T<:NumTypes}
    0 ≤ α ≤ 1 || return throw(DomainError(α, "`bisect` only accepts a relative position between 0 and 1"))
    isatomic(x) && return (x, emptyinterval(BareInterval{T}))
    m = mid(x, α)
    return (_unsafe_bareinterval(T, inf(x), m), _unsafe_bareinterval(T, m, sup(x)))
end

function bisect(x::Interval, α::Real = 0.5)
    r₁, r₂ = bisect(bareinterval(x), α)
    d₁, d₂ = min(decoration(x), decoration(r₁)), min(decoration(x), decoration(r₂))
    t = isguaranteed(x)
    return (_unsafe_interval(r₁, d₁, t), _unsafe_interval(r₂, d₂, t))
end

function bisect(x::AbstractVector, i::Integer, α::Real = 0.5)
    x₁ = copy(x)
    x₂ = copy(x)
    x₁[i], x₂[i] = bisect(x[i], α)
    return (x₁, x₂)
end

"""
    mince(x, n)

Split an interval `x` in `n` intervals of the same diameter.

Split the `i`-th component of a vector `x` in `n[i]` intervals of the
same diameter; `n` can be a tuple of integers, or a single integer in which case
the same `n` is used for all the components of `x`.
"""
mince(x::BareInterval{T}, n::Integer) where {T<:NumTypes} = mince!(Vector{BareInterval{T}}(undef, n), x, n)

mince(x::Interval{T}, n::Integer) where {T<:NumTypes} = mince!(Vector{Interval{T}}(undef, n), x, n)

mince(x::AbstractVector, n::NTuple{N,Integer}) where {N} = mince!(Vector{typeof(x)}(undef, prod(n)), x, n)

mince(x::AbstractVector, n::Integer) = mince(x, ntuple(_ -> n, length(x)))

"""
    mince!(v, x, n)

In-place version of [`mince`](@ref).
"""
function mince!(v::AbstractVector{<:BareInterval}, x::BareInterval{T}, n::Integer) where {T<:NumTypes}
    nodes = LinRange(inf(x), sup(x), n+1)
    @inbounds for i ∈ 1:n
        v[i] = _unsafe_bareinterval(T, nodes[i], nodes[i+1])
    end
    return v
end

function mince!(v::AbstractVector{<:Interval}, x::Interval{T}, n::Integer) where {T<:NumTypes}
    nodes = LinRange(inf(x), sup(x), n+1)
    d = decoration(x)
    t = isguaranteed(x)
    @inbounds for i ∈ 1:n
        rᵢ = _unsafe_bareinterval(T, nodes[i], nodes[i+1])
        dᵢ = min(d, decoration(rᵢ))
        v[i] = _unsafe_interval(rᵢ, dᵢ, t)
    end
    return v
end

function mince!(v::AbstractVector, x::AbstractVector, n::NTuple{N,Integer}) where {N}
    len = length(x)
    len == N || return throw(DimensionMismatch("x has length $len, n has length $N"))
    @inbounds minced_intervals = [mince(xᵢ, nᵢ) for (xᵢ, nᵢ) ∈ zip(x, n)]
    resize!(v, prod(n))
    @inbounds for (k, cut_indices) ∈ enumerate(CartesianIndices(n))
        y = similar(x, N)
        @inbounds for (i, j) ∈ enumerate(eachindex(y))
            y[j] = minced_intervals[i][cut_indices[i]]
        end
        v[k] = y
    end
    return v
end

mince!(v::AbstractVector, x::AbstractVector, n::Integer) = mince!(v, x, ntuple(_ -> n, length(x)))

using IntervalArithmetic: leftof, intersect_domain, isempty_domain

@testset "Domain" begin
    @testset "Construction" begin
        @test_throws ErrorException Domain{:oopen, :closed}(0, 1)
        @test_throws ErrorException Domain{:open, :close}(0, 1)
        @test_throws MethodError Piecewise(
            (Domain{:closed, :closed}(1, 2), Domain{:open, :open}(2, 3)),
            (sin, cos), (-1,), (2, 3))
        @test_throws ArgumentError Piecewise(
            (Domain{:closed, :closed}(1, 2), Domain{:open, :open}(2, 3)),
            (sin, cos), (-1,-1), (2, 3))
        @test_throws MethodError Piecewise(
            (Domain{:closed, :closed}(1, 2), Domain{:open, :open}(2, 3)),
            (sin, cos, log), (-1,), (2))
    end

    @testset "leftof" begin
        d1 = Domain{:open, :closed}(0, 1)
        d2 = Domain{:open, :open}(0, 1)
        d3 = Domain{:open, :closed}(1, 2)
        d4 = Domain{:closed, :closed}(1, 2)

        @test !leftof(d1, d2)
        @test leftof(d1, d3)
        @test !leftof(d1, d4)

        @test leftof(d2, d3)
        @test leftof(d2, d4)
    end

    @testset "intersect_domain" begin
        d1 = Domain{:closed, :open}(0, 10)
        d2 = Domain{:closed, :open}(2, 15)
        d3 = Domain{:open, :closed}(4, 7)
        d4 = Domain{:open, :closed}(-20, 3)

        @test intersect_domain(d1, d2) == Domain{:closed, :open}(2, 10)
        @test intersect_domain(d1, d3) == Domain{:open, :closed}(4, 7)
        @test intersect_domain(d1, d4) == Domain{:closed, :closed}(0, 3)
        @test intersect_domain(d2, d3) == Domain{:open, :closed}(4, 7)
        @test intersect_domain(d2, d4) == Domain{:closed, :closed}(2, 3)
        @test intersect_domain(d3, d4) == Domain()
    end

    @testset "isempty_domain" begin
        @test isempty_domain(Domain{:open, :open}(1, 1))
        @test !isempty_domain(Domain{:closed, :closed}(1, 1))
        @test !isempty_domain(Domain{:open, :open}(1, 2))
        @test isempty_domain(Domain())
    end
end

@testset "Piecewise constructor" begin
    d1 = Domain{:open, :closed}(0, 1)
    d2 = Domain{:open, :closed}(1, 2)
    d3 = Domain{:closed, :closed}(1, 2)

    @test_throws ArgumentError Piecewise(d2 => Constant(0), d1 => Constant(1))
    @test_throws ArgumentError Piecewise(d1 => Constant(0), d3 => Constant(1))
end

@testset "Step function" begin
    step = Piecewise(
        Domain{:open, :closed}(-Inf, 0) => Constant(0),
        Domain{:open, :open}(0, 1000) => Constant(1)
    )

    @test step(-1) == 0
    @test step(100) == 1
    @test isequal_interval(step(interval(-3.2, -2.1)), interval(0))
    @test decoration(step(interval(-3.33))) == com
    @test isequal_interval(step(interval(2.3, 3.4)), interval(1))
    @test decoration(step(interval(4.44))) == com
    @test isequal_interval(step(interval(-22.2, 33.3)), interval(0, 1))
    @test decoration(step(interval(-11, 11))) == def
    @test decoration(step(interval(500, 2000))) == trv
end

@testset "abs" begin
    myabs = Piecewise(
        Domain{:open, :closed}(-Inf, 0) => x -> -x,
        Domain{:open, :open}(0, Inf) => identity ;
        continuity = [0]
    )

    @test myabs(-1) == 1
    @test myabs(100) == 100
    @test isequal_interval(myabs(interval(-3.2, -2.1)), interval(2.1, 3.2))
    @test decoration(myabs(interval(-3.33))) == com
    @test isequal_interval(myabs(interval(2.3, 3.4)), interval(2.3, 3.4))
    @test decoration(myabs(interval(4.444))) == com
    @test isequal_interval(myabs(interval(-22.2, 33.3)), interval(0, 33.3))
    @test decoration(myabs(interval(-11, 11))) == com
end

@testset "Out of domain" begin
    window = Piecewise(
        Domain{:open, :closed}(-π, π) => x -> 1/2 * (cos(x) + 1)
    )

    @test_throws DomainError window(123)
    @test isequal_interval(window(interval(0, π)), interval(0, 1))
    @test decoration(window(interval(-π, 0))) == com
    @test isequal_interval(window(interval(-10, 10)), interval(0, 1))
    @test decoration(window(interval(-10, 10))) == trv
    @test isempty_interval(window(interval(100, 1000)))
end

@testset "Derivatives" begin
    slide = Piecewise(
        Domain{:open, :closed}(-Inf, -1) => x -> -2x - 1,
        Domain{:open, :closed}(-1, 0) => x -> x^2,
        Domain{:open, :open}(0, Inf) => Constant(0) ;
        continuity = [1, 1]
    )

    @test ForwardDiff.derivative(slide, -5.5) == -2
    @test ForwardDiff.derivative(slide, -0.5) == -1
    @test ForwardDiff.derivative(slide, 1.2) == 0 

    @test isequal_interval(
        ForwardDiff.derivative(slide, interval(-7, -3)),
        interval(-2)
    )
    @test isequal_interval(
        ForwardDiff.derivative(slide, interval(-0.7, -0.3)),
        interval(-1.4, -0.6)
    )
    @test isequal_interval(
        ForwardDiff.derivative(slide, interval(0.7, 1.3)),
        interval(0)
    )

    @test isequal_interval(
        ForwardDiff.derivative(slide, interval(-1.7, -0.3)),
        interval(-2, -0.6)
    )

    @test isequal_interval(
        ForwardDiff.derivative(slide, interval(-0.7, 1.3)),
        interval(-1.4, 0)
    )

    @test isequal_interval(
        ForwardDiff.derivative(slide, interval(-1.7, 1.3)),
        interval(-2, 0)
    )

    x1 = interval(-0.5, 0)
    x2 = interval(-3, -2)

    grad1 = ForwardDiff.gradient(xx -> slide(-xx[1]^2), [x1, x2])
    grad2 = ForwardDiff.gradient(xx -> slide(0.7xx[2]), [x1, x2])

    g1 = -2x1 * ForwardDiff.derivative(slide, -x1^2)
    g2 = 0.7 * ForwardDiff.derivative(slide, x2)

    @test isequal_interval(grad1[1], g1)
    @test isequal_interval(grad1[2], interval(0))
    @test isequal_interval(grad2[1], interval(0))
    @test isequal_interval(grad2[2], g2)

    grad = ForwardDiff.gradient(xx -> slide(-xx[1]^2 + 0.7xx[2]), [x1, x2])
    g1 = -2x1 * ForwardDiff.derivative(slide, -x1^2 + 0.7x2)
    g2 = 0.7 * ForwardDiff.derivative(slide, -x1^2 + 0.7x2)
    @test isequal_interval(grad[1], g1)
    @test isequal_interval(grad[2], g2)
end

@testset "Singularities" begin
    f = Piecewise(
        Domain{:open, :closed}(0, 1) => Constant(0),
        Domain{:open, :closed}(1, 2) => x -> 0.5x,
        Domain{:open, :closed}(2, 3) => Constant(1),
        Domain{:open, :open}(3, 4) => x -> (x-3)^2 + 1 ;
        continuity = [-1, 0, 1]
    )

    @test decoration(f(interval(0.5, 1.5))) == def
    @test decoration(f(interval(1.5, 2.5))) == com
    @test decoration(f(interval(2.5, 3.5))) == com

    df = x -> ForwardDiff.derivative(f, x)
    @test decoration(df(interval(0.5, 1.5))) == def
    @test decoration(df(interval(1.5, 2.5))) == def
    @test decoration(df(interval(2.5, 3.5))) == com
end

functions = Dict(
    "atan2" => x -> "atan($x)",
    "add" => x -> "+($x)",
    "sub" => x -> "-($x)",
    "pos" => x -> "+($x)",
    "neg" => x -> "-($x)",
    "mul" => x -> "*($x)",
    "div" => x -> "/($x)",
    "convexHull" => x -> "hull($x)",
    "intersection" => x -> "intersect_interval($x)",
    "interior" => x -> "isinterior($x)",
    "subset" => x -> "issubset_interval($x)",
    "equal" => x -> "isequal_interval($x)",
    "sqr" => x -> "pown($x, 2)",
    "pow" => x -> "pow($x)",
    "rootn" => x -> "rootn($x)",
    "sqrt" => x -> "sqrt($x)",
    "exp" => x -> "exp($x)",
    "exp2" => x -> "exp2($x)",
    "exp10" => x -> "exp10($x)",
    "log" => x -> "log($x)",
    "log2" => x -> "log2($x)",
    "log10" => x -> "log10($x)",
    "sin" => x -> "sin($x)",
    "cos" => x -> "cos($x)",
    "tan" => x -> "tan($x)",
    "cot" => x -> "cot($x)",
    "asin" => x -> "asin($x)",
    "acos" => x -> "acos($x)",
    "atan" => x -> "atan($x)",
    "acot" => x -> "acot($x)",
    "sinh" => x -> "sinh($x)",
    "cosh" => x -> "cosh($x)",
    "tanh" => x -> "tanh($x)",
    "coth" => x -> "coth($x)",
    "asinh" => x -> "asinh($x)",
    "acosh" => x -> "acosh($x)",
    "atanh" => x -> "atanh($x)",
    "acoth" => x -> "acoth($x)",
    "expm1" => x -> "expm1($x)",
    "logp1" => x -> "log1p($x)",
    "cbrt" => x -> "cbrt($x)",
    "csc" => x -> "csc($x)",
    "csch" => x -> "csch($x)",
    "hypot" => x -> "hypot($x)",
    "sec" => x -> "sec($x)",
    "sech" => x -> "sech($x)",
    "intervalPart" => x -> "bareinterval($x)",
    "isEmpty" => x -> "isempty_interval($x)",
    "isEntire" => x -> "isentire_interval($x)",
    "isNaI" => x -> "isnai($x)",
    "less" => x -> "isweakless($x)",
    "strictLess" => x -> "isstrictless($x)",
    "precedes" => x -> "precedes($x)",
    "strictPrecedes" => x -> "strictprecedes($x)",
    "disjoint" => x -> "isdisjoint_interval($x)",
    "newDec" => x -> "interval($x)",
    "setDec" => x -> "interval($x)",
    "decorationPart" => x -> "decoration($x)",
    "recip" => x -> "inv($x)",
    "fma" => x -> "fma($x)",
    "pown" => x -> "pown($x)",
    "sign" => x -> "sign($x)",
    "ceil" => x -> "ceil($x)",
    "floor" => x -> "floor($x)",
    "trunc" => x -> "trunc($x)",
    "roundTiesToEven" => x -> "round($x)",
    "roundTiesToAway" => x -> "round($x, RoundNearestTiesAway)",
    "abs" => x -> "abs($x)",
    "min" => x -> "min($x)",
    "max" => x -> "max($x)",
    "inf" => x -> "inf($x)",
    "sup" => x -> "sup($x)",
    "mid" => x -> "mid($x)",
    "rad" => x -> "radius($x)",
    "midRad" => x -> "midradius($x)",
    "wid" => x -> "diam($x)",
    "mag" => x -> "mag($x)",
    "mig" => x -> "mig($x)",
    "overlap" => x -> "overlap($x)",
    "isCommonInterval" => x -> "iscommon($x)",
    "isSingleton" => x -> "isthin($x)",
    "isMember" => x -> "in_interval($x)",
    "cancelPlus" => x -> "cancelplus($x)",
    "cancelMinus" => x -> "cancelminus($x)",
    "sum_nearest" => x -> "sum($x)",
    "dot_nearest" => x -> "sum(.*($x))",
    "sum_abs_nearest" => x -> "sum(abs.($x))",
    "sum_sqr_nearest" => x -> "sum($x.^2)"
)

"""
    generate(filename::AbstractString)

Generate the julia tests from the file `filename` contained in a folder named
`itl` located in the current directory. The file must have the extension `.itl`.
The output is a Julia file with the same name, with the extension `.jl`, located
in the folder named `ITF1788_tests`. Return the path of the output file.
"""
function generate(filename::AbstractString)
    src = joinpath(@__DIR__, "itl", filename)
    lines = readlines(src)

    rx_start = r"^\s*testcase\s+\S+\s+\{\s*$" # where testcase blocks start
    rx_end = r"^\s*\}\s*$" # where testcase blocks end
    block_start = findall(line -> occursin(rx_start, line), lines)
    block_end = findall(line -> occursin(rx_end, line), lines)

    len = length(block_start)
    len == length(block_end) || return throw(ArgumentError("opening and closing braces do not match in $filename"))

    mkpath("ITF1788_tests")
    dest = joinpath("ITF1788_tests", replace(filename, ".itl" => ".jl"))

    open(dest, "w") do io
        i = 1
        for (bstart, bend) ∈ zip(block_start, block_end)
            testset = parse_block(view(lines, bstart:bend))
            i < len ? write(io, testset * "\n") : write(io, testset)
            i += 1
        end
    end

    return dest
end

function parse_block(block)
    blockname = match(r"^\s*testcase\s+(\S+)\s+\{\s*$", block[1])[1]

    testset = """@testset "$blockname" begin
            """
    indentation = "    "
    for i ∈ 2:length(block)-1
        line = strip(block[i])
        isempty(line) | startswith(line, "//") && continue
        command = parse_command(line)
        testset = """$testset
        $indentation$command
        """
    end
    testset = """$testset
            end
            """

    return testset
end

# e.g. `add [1, 2] [1, 2] = [2, 4]` is parsed as `@test +(interval(1, 2), interval(1, 2)) === interval(2, 4)`
function parse_command(line)
    # extract parts in line
    m = match(r"^(.+)=(.+);$", line)
    lhs = m[1]
    vrhs = split(m[2], "signal")
    haswarning = length(vrhs) > 1
    rhs = vrhs[1]

    lhs = parse_lhs(lhs)
    rhs = parse_rhs(rhs)

    expr = build_expression(lhs, rhs)
    command = "@test $expr"

    if occursin("dot_nearest {0x10000000000001p0, 0x1p104} {0x0fffffffffffffp0, -1.0} = -1.0", line)
        # broken test unrelated to interval airthmetic
        command = "@test_broken $expr"
    elseif occursin("atan2 [-0.0, 1.0]_com [-2.0, -0.1]_com = [0X1.ABA397C7259DDP+0, 0X1.921FB54442D19P+1]_dac", line)
        # erroneous test: the decoration of the result should be `com`
        command =
            """
            @warn "The original test `atan2 [-0.0, 1.0]_com [-2.0, -0.1]_com = [0X1.ABA397C7259DDP+0, 0X1.921FB54442D19P+1]_dac` is wrong and has been modified. The result should have the decoration `com`"
                @test atan(interval(bareinterval(-0.0, 1.0), com), interval(bareinterval(-2.0, -0.1), com)) === interval(bareinterval(0x1.ABA397C7259DDP+0, 0x1.921FB54442D19P+1), com)"""
    end

    command = haswarning ? "@test_logs (:warn,) $command" : command

    return command
end

function parse_lhs(lhs)
    lhs = strip(lhs)
    m =  match(r"^(\S+) (.+)$", lhs)
    fname = m[1]
    args = m[2]

    #special case, input text
    fname == "b-textToInterval" && return "parse(BareInterval{Float64}, $args)"
    fname == "d-textToInterval" && return "parse(Interval{Float64}, $args)"

    # input numbers
    args = replace(args, "infinity" => "Inf", "X" => "x")
    if fname == "b-numsToInterval"
        args = join(split(args), ',')
        return "bareinterval($args)"
    end

    if fname == "d-numsToInterval"
        args = join(split(args), ',')
        return "interval($args)"
    end

    # input intervals
    rx = r"\[([^\]]+)\](?:_(\w+))?"
    for m ∈ eachmatch(rx, args)
        args = replace(args, m.match => parse_interval(m[1], m[2]))
    end

    args = replace(args, " " => ", ")
    args = replace(args, ",," => ",")
    args = replace(args, "{" => "[")
    args = replace(args, "}" => "]")
    args = replace(args, "[Float64]" => "{Float64}")
    return functions[fname](args)
end

int_to_float(x) = x * ifelse(isnothing(tryparse(Int64, x)), "", ".0")

function parse_rhs(rhs)
    rhs = replace(strip(rhs),
        "infinity"     => "Inf",
        "X"            => "x",
        "bothEmpty"    => "IntervalArithmetic.Overlap.both_empty",
        "firstEmpty"   => "IntervalArithmetic.Overlap.first_empty",
        "secondEmpty"  => "IntervalArithmetic.Overlap.second_empty",
        "before"       => "IntervalArithmetic.Overlap.before",
        "meets"        => "IntervalArithmetic.Overlap.meets",
        "overlaps"     => "IntervalArithmetic.Overlap.overlaps",
        "starts"       => "IntervalArithmetic.Overlap.starts",
        "containedBy"  => "IntervalArithmetic.Overlap.contained_by",
        "finishes"     => "IntervalArithmetic.Overlap.finishes",
        "equals"       => "IntervalArithmetic.Overlap.equals",
        "finishedBy"   => "IntervalArithmetic.Overlap.finished_by",
        "contains"     => "IntervalArithmetic.Overlap.contains",
        "startedBy"    => "IntervalArithmetic.Overlap.started_by",
        "overlappedBy" => "IntervalArithmetic.Overlap.overlapped_by",
        "metBy"        => "IntervalArithmetic.Overlap.met_by",
        "after"        => "IntervalArithmetic.Overlap.after")
    if occursin('[', rhs) # one or more intervals
        rx = r"\[([^\]]+)\](?:_(\w+))?"
        ivals = [parse_interval(m[1], m[2]) for m ∈ eachmatch(rx, rhs)]
        return ivals
    else # one or more scalar/boolean values separated by space
        return map(int_to_float, split(rhs))
    end
end

function parse_interval(ival::AbstractString, dec::Union{Nothing,AbstractString})
    ival == "nai" && return "nai(Interval{Float64})"
    if ival == "entire"
        ival = "entireinterval(BareInterval{Float64})"
    elseif ival == "empty"
        ival = "emptyinterval(BareInterval{Float64})"
    else
        ival = "bareinterval($ival)"
    end
    isnothing(dec) && return ival
    return "interval($ival, $dec)"
end

function build_expression(lhs::AbstractString, rhs::Vector)
    length(rhs) == 1 && return build_expression(lhs, rhs[1])
    expr = [build_expression(lhs * "[$i]", r) for (i, r) ∈ enumerate(rhs)]
    return join(expr, " && ")
end

function build_expression(lhs::AbstractString, rhs::AbstractString)
    rhs == "nai()" && return "isnai($lhs)"
    rhs == "NaN" && return "isnan($lhs)"
    return "$lhs === $rhs"
end

using Test

using ForwardDiff
using IntervalArithmetic
using InteractiveUtils
import Arblib
import IntervalSets as IS

include("generate_ITF1788.jl")

# interval tests
for f ∈ filter(isfile, readdir("interval_tests"; join = true))
    @testset "$f" begin
        include(f)
    end
end

# interval tests using Supposition
# We use Pkg.add to add a specific version of Supposition
using Pkg
Pkg.add(url = "https://github.com/Seelengrab/Supposition.jl.git", rev = "feat/support_x86")
using Supposition, Supposition.Data

for f ∈ filter(isfile, readdir("interval_tests/supposition"; join = true))
    @testset "$f" begin
        include(f)
    end
end
Pkg.rm("Supposition")

# ITF1788 tests
# these tests were generated using:
# for f ∈ readdir("itl")
#     if !occursin("LICENSE", f)
#         generate(f)
#     end
# end
for f ∈ readdir("ITF1788_tests"; join = true)
    @testset "$f" begin
        include(f)
    end
end

# Aqua tests
include("aqua.jl")

"""
    numtype(T)

Return the bound type of the interval.

# Examples

```jldoctest
julia> numtype(interval(1, 2))
Float64

julia> numtype(interval(Float32, 1, 2))
Float32
```
"""
numtype(::Type{BareInterval{T}}) where {T<:NumTypes} = T
numtype(::Type{Interval{T}}) where {T<:NumTypes} = T
numtype(::Type{Complex{T}}) where {T<:Real} = numtype(T)
numtype(::Type{T}) where {T} = T
numtype(::T) where {T} = numtype(T)

# standard `Real` functions

for f ∈ (:float, :big)
    @eval begin
        Base.$f(x::BareInterval{T}) where {T<:NumTypes} = BareInterval{$f(T)}(x)
        Base.$f(x::Interval{<:NumTypes}) = _unsafe_interval($f(bareinterval(x)), decoration(x), isguaranteed(x))
    end
end

for f ∈ (:zero, :one)
    @eval begin
        Base.$f(::Type{BareInterval{T}}) where {T<:NumTypes} = _unsafe_bareinterval(T, $f(T), $f(T))
        Base.$f(::BareInterval{T}) where {T<:NumTypes} = $f(BareInterval{T})

        Base.$f(::Type{Interval{T}}) where {T<:NumTypes} = _unsafe_interval($f(BareInterval{T}), com, true)
        Base.$f(x::Interval{T}) where {T<:NumTypes} = _unsafe_interval($f(BareInterval{T}), com, isguaranteed(x))
    end
end

Base.zero(::Type{Complex{Interval{T}}}) where {T<:NumTypes} = complex(zero(Interval{T}), zero(Interval{T}))
Base.zero(x::Complex{<:Interval}) = complex(zero(real(x)), zero(imag(x)))

Base.one(::Type{Complex{Interval{T}}}) where {T<:NumTypes} = complex(one(Interval{T}), zero(Interval{T}))
Base.one(x::Complex{<:Interval}) = complex(one(real(x)), zero(imag(x)))

Base.typemin(::Type{BareInterval{T}}) where {T<:NumTypes} =
    _unsafe_bareinterval(T, typemin(T), nextfloat(typemin(T)))
Base.typemin(::Type{Interval{T}}) where {T<:NumTypes} =
    _unsafe_interval(typemin(BareInterval{T}), dac, true)

Base.typemax(::Type{BareInterval{T}}) where {T<:NumTypes} =
    _unsafe_bareinterval(T, prevfloat(typemax(T)), typemax(T))
Base.typemax(::Type{Interval{T}}) where {T<:NumTypes} =
    _unsafe_interval(typemax(BareInterval{T}), dac, true)

function Base.eps(::Type{BareInterval{T}}) where {T<:NumTypes}
    x = eps(T)
    return _unsafe_bareinterval(T, x, x)
end
function Base.eps(x::BareInterval{T}) where {T<:NumTypes}
    y = max(eps(inf(x)), eps(sup(x)))
    return _unsafe_bareinterval(T, y, y)
end
Base.eps(::Type{Interval{T}}) where {T<:NumTypes} =
    _unsafe_interval(eps(BareInterval{T}), com, true)
Base.eps(x::Interval) = _unsafe_interval(eps(bareinterval(x)), com, isguaranteed(x))

"""
    hash(x::BareInterval, h::UInt)
    hash(x::Interval, h::UInt)

Compute the integer hash code for an interval. Note that equality of intervals
is given by [`isequal_interval`](@ref) rather than the `==` operator.
"""
Base.hash(x::BareInterval, h::UInt) = hash(sup(x), hash(inf(x), hash(BareInterval, h)))
Base.hash(x::Interval, h::UInt) = hash(sup(x), hash(inf(x), hash(Interval, h)))

#

struct InconclusiveBooleanOperation <: Exception
    operation   :: String
    alternative :: String
end

Base.showerror(io::IO, e::InconclusiveBooleanOperation) =
    print(io, "InconclusiveBooleanOperation: The operation `$(e.operation)` cannot be determined unambiguously. See the documentation for more information. See also `$(e.alternative)`.")

#

function Base.:(==)(x::Interval, y::Interval) # also returned when calling `≤`, `≥`, `isequal`
    isthin(x) & isthin(y) && return isequal_interval(x, y)
    isdisjoint_interval(x, y) && return false
    return throw(InconclusiveBooleanOperation("$x == $y", "isequal_interval"))
end

function Base.:<(x::Interval, y::Interval)
    strictprecedes(x, y) && return true
    strictprecedes(y, x) && return false
    isthin(x) & isthin(y) && return !isequal_interval(x, y)
    return throw(InconclusiveBooleanOperation("$x < $y", "strictprecedes"))
end

function Base.isfinite(x::Interval) # also returned when calling `isinf`
    isbounded(x) && return true
    return throw(InconclusiveBooleanOperation("isfinite($x)", "isbounded"))
end

Base.isnan(x::Interval) = isnai(x)

function Base.isinteger(x::Interval)
    isthin(x) | isdisjoint_interval(x, floor(x), ceil(x)) && return isthininteger(x)
    return throw(InconclusiveBooleanOperation("isinteger($x)", "isthininteger"))
end

# disallowed

Base.in(::Interval, ::Interval) =
    throw(ArgumentError("`in` is purposely not supported for intervals. See instead `in_interval`"))

Base.isempty(::Interval) =
    throw(ArgumentError("`isempty` is purposely not supported for intervals. See instead `isempty_interval`"))

Base.isapprox(::Interval, ::Interval) =
    throw(ArgumentError("`isapprox` is purposely not supported for intervals"))

Base.isdisjoint(::Interval, ::Interval) =
    throw(ArgumentError("`isdisjoint` is purposely not supported for intervals. See instead `isdisjoint_interval`"))
Base.issubset(::Interval, ::Interval) =
    throw(ArgumentError("`issubset` is purposely not supported for intervals. See instead `issubset_interval`"))
Base.issetequal(::Interval, ::Interval) =
    throw(ArgumentError("`issetequal` is purposely not supported for intervals. See instead `isequal_interval`"))
Base.intersect(::Interval, ::Interval...) =
    throw(ArgumentError("`intersect` is purposely not supported for intervals. See instead `intersect_interval`"))

Base.union!(::BitSet, ::Interval) = # needed to resolve ambiguity
    throw(ArgumentError("`union!` is purposely not supported for intervals. See instead `hull`"))
Base.union!(::AbstractSet, ::Interval) = # also returned when calling `intersect`, `symdiff` with intervals
    throw(ArgumentError("`union!` is purposely not supported for intervals. See instead `hull`"))
Base.union!(::AbstractVector{S}, ::Interval) where {S} =
    throw(ArgumentError("`union!` is purposely not supported for intervals. See instead `hull`"))
Base.union!(::AbstractVector{S}, ::Interval, ::Any, ::Any...) where {S} =
    throw(ArgumentError("`union!` is purposely not supported for intervals. See instead `hull`"))
Base.union!(::AbstractVector{S}, ::Interval, ::Interval, ::Any...) where {S} =
    throw(ArgumentError("`union!` is purposely not supported for intervals. See instead `hull`"))
Base.union!(::AbstractVector{S}, ::Any, ::Interval, ::Any...) where {S} =
    throw(ArgumentError("`union!` is purposely not supported for intervals. See instead `hull`"))

Base.setdiff(::Interval) =
    throw(ArgumentError("`setdiff` is purposely not supported for intervals. See instead `interiordiff`"))
Base.setdiff!(::AbstractSet, ::Interval) =
    throw(ArgumentError("`setdiff!` is purposely not supported for intervals. See instead `interiordiff`"))

import IrrationalConstants

@testset "IrrationalConstants.jl" begin
    # Get all exported constants from IrrationalConstants
    irr_names = names(IrrationalConstants; all=false, imported=false)
    
    for irr_name ∈ irr_names
        irr = getproperty(IrrationalConstants, irr_name)
        # Skip non-irrational types
        if !isa(irr, IrrationalConstants.IrrationalConstant)
            continue
        end
        
        for T ∈ (Float16, Float32, Float64, BigFloat)
            @test in_interval(irr, interval(T, irr))
            if T !== BigFloat
                @test nextfloat(inf(interval(T, irr))) == sup(interval(T, irr))
            end
        end

        for T ∈ InteractiveUtils.subtypes(Signed)
            @test in_interval(irr, interval(Rational{T}, irr)) broken=(irr == IrrationalConstants.invsqrt2π && T == Int8 && VERSION ≤ v"1.13")
        end

        # Negative irrationals obviously lack unsigned representations
        irr < 0 && continue

        for T ∈ InteractiveUtils.subtypes(Unsigned)
            @test in_interval(irr, interval(Rational{T}, irr))
        end
    end
end

@testset "rational_power_test" begin
    @test isequal_interval(pow(emptyinterval(), 1//3), emptyinterval())
    @test isequal_interval(pow(interval(1, 8), 1//3), interval(1, 2))
    @test issubset_interval(interval(2^(1//3), 2), pow(interval(2, 8), 1//3))
    @test issubset_interval(interval(1, 9^(1//3)), pow(interval(1, 9), 1//3))
    @test issubset_interval(interval(2^(1//3), 9^(1//3)), pow(interval(2, 9), 1//3))
    @test isequal_interval(pow(interval(-1, 8), 1//3), interval(0, 2))
    @test issubset_interval(interval(0, 2), pow(interval(-2, 8), 1//3))
    @test issubset_interval(interval(0, 9^(1//3)), pow(interval(-1, 9), 1//3))
    @test issubset_interval(interval(0, 9^(1//3)), pow(interval(-2, 9), 1//3))
    @test isequal_interval(pow(interval(1, 8), -1//3), interval(0.5, 1))
    @test issubset_interval(interval(0.5, 2^(-1//3)), pow(interval(2, 8), -1//3))
    @test issubset_interval(interval(9^(-1//3), 1), pow(interval(1, 9), -1//3))
    @test issubset_interval(interval(9^(-1//3), 2^(-1//3)), pow(interval(2, 9), -1//3))
    @test isequal_interval(pow(interval(-1, 8), -1//3), interval(0.5, Inf))
    @test issubset_interval(interval(0.5, Inf), pow(interval(-2, 8), -1//3))
    @test issubset_interval(interval(9^(-1//3), Inf), pow(interval(-1, 9), -1//3))
    @test issubset_interval(interval(9^(-1//3), Inf), pow(interval(-2, 9), -1//3))
    @test isequal_interval(pow(interval(-2, 4), 1//2), interval(0, 2))
    @test isequal_interval(pow(interval(-2, 8), 1//3), interval(0, 2))
    @test isequal_interval(pow(interval(-8, -2), 1//3), emptyinterval())
    @test isequal_interval(pow(interval(-8, -2), 1//2), emptyinterval())
    @test isequal_interval(pow(interval(-8, -2), -1//3), emptyinterval())
    @test isequal_interval(pow(interval(-8, -2), -1//2), emptyinterval())
    @test isequal_interval(pow(emptyinterval(), 2//3), emptyinterval())
    @test isequal_interval(pow(interval(1, 8), 2//3), interval(1, 4))
    @test issubset_interval(interval(2^(2//3), 4), pow(interval(2, 8), 2//3))
    @test issubset_interval(interval(1, 9^(2//3)), pow(interval(1, 9), 2//3))
    @test issubset_interval(interval(2^(2//3), 9^(2//3)), pow(interval(2, 9), 2//3))
    @test isequal_interval(pow(interval(-1, 8), 2//3), interval(0, 4))
    @test issubset_interval(interval(0, 4), pow(interval(-2, 8), 2//3))
    @test issubset_interval(interval(0, 9^(2//3)), pow(interval(-1, 9), 2//3))
    @test issubset_interval(interval(0, 9^(2//3)), pow(interval(-2, 9), 2//3))
    @test isequal_interval(pow(interval(1, 8), -2//3), interval(0.25, 1))
    @test issubset_interval(interval(0.25, 2^(-2//3)), pow(interval(2, 8), -2//3))
    @test issubset_interval(interval(9^(-2//3), 1), pow(interval(1, 9), -2//3))
    @test issubset_interval(interval(9^(-2//3), 2^(-2//3)), pow(interval(2, 9), -2//3))
    @test isequal_interval(pow(interval(-1, 8), -2//3), interval(0.25, Inf))
    @test issubset_interval(interval(0.25, Inf), pow(interval(-2, 8), -2//3))
    @test issubset_interval(interval(9^(-2//3), Inf), pow(interval(-1, 9), -2//3))
    @test issubset_interval(interval(9^(-2//3), Inf), pow(interval(-2, 9), -2//3))
    @test isequal_interval(pow(interval(-2, 4), 3//2), interval(0, 8))
    @test isequal_interval(pow(interval(-2, 8), 2//3), interval(0, 4))
    @test isequal_interval(pow(interval(-8, -2), 2//3), emptyinterval())
    @test isequal_interval(pow(interval(-8, -2), 3//2), emptyinterval())
    @test isequal_interval(pow(interval(-8, -2), -2//3), emptyinterval())
    @test isequal_interval(pow(interval(-8, -2), -3//2), emptyinterval())
    @test isequal_interval(pow(interval(-1, 1), 1000000000000000000000000000000000000000//1), interval(0, 1))
end

@testset "Interval{<:Rational}" begin
    a = interval(Rational{Int64}, 1//2, 3//4)
    b = interval(Rational{Int64}, 3//7, 9//12)

    @test issubset_interval(sqrt(a + b), interval(Int64(137482504)//142672337, Int64(46099201)//37639840))

    @test issubset_interval(sqrt(interval(1//3)), interval(Int64(29354524)//50843527, Int64(50843527)//88063572))
end

@testset "Decorations" begin
    a = interval(1, 2, IntervalArithmetic.com)
    b = sqrt(a)
    @test isequal_interval(interval(b), sqrt(interval(1, 2)))
    @test decoration(b) == IntervalArithmetic.com

    a = interval(-1, 1, IntervalArithmetic.com)
    b = sqrt(a)
    @test isequal_interval(interval(b), sqrt(interval(0, 1)))
    @test decoration(b) == IntervalArithmetic.trv

    @test isequal_interval(pown(interval(2, 3)  ,  2), interval(4, 9))
    @test isequal_interval(pown(interval(2, 3)  , -2), interval(1/9, 1/4))
    @test isequal_interval(pown(interval(-3, 2) ,  3), interval(-27, 8))
    @test isequal_interval(pown(interval(-3, -2), -3), interval(-1/8, -1/27))
    @test isequal_interval(pown(interval(0, 3)  ,  2), interval(0, 9))
    @test isequal_interval(pown(interval(0, 3)  , -2), interval(1/9, Inf, IntervalArithmetic.trv))
    @test isequal_interval(pow(interval(2, 3) , interval(0, 1)), interval(1, 3))
    @test isequal_interval(pow(interval(2, 3) , interval(0, 1)), interval(1, 3))
    @test isequal_interval(pow(interval(0, 2) , interval(0, 1)), interval(0, 2, IntervalArithmetic.trv))
    @test isequal_interval(pow(interval(0, 2) , interval(0, 1)), interval(0, 2, IntervalArithmetic.trv))
    @test isequal_interval(pow(interval(-3, 2), interval(0, 1)), interval(0, 2, IntervalArithmetic.trv))
    @test isequal_interval(pow(interval(-3, 2), interval(0, 1)), interval(0, 2, IntervalArithmetic.trv))
    @test isequal_interval(pow(interval(-3, 2), interval(-1, 1)), interval(0, Inf, IntervalArithmetic.trv))
    @test isequal_interval(pow(interval(-3, 2), interval(-1, 1)), interval(0, Inf, IntervalArithmetic.trv))
end

@testset "Complex{<:Interval}" begin
    a = interval(3 + 4im)
    b = exp(a)
    @test isequal_interval(real(b), interval(-13.12878308146216, -13.128783081462153))
    @test isequal_interval(imag(b), interval(-15.200784463067956, -15.20078446306795))

    z = exp(-im * interval(π))
    @test in_interval(-1, real(z))
    @test in_interval(0, imag(z))

    z = interval(0im)
    @test isthinzero(z ^ 2)
    @test isthinone(z ^ 0)
    @test isempty_interval(z ^ (-1))

    z = interval(0im)
    @test isthinzero(z ^ interval(2))
    @test isthinone(z ^ interval(0))
    @test isempty_interval(z ^ interval(-1))
    @test isempty_interval(z ^ emptyinterval())

    x = interval(3 + 4im)
    @test in_interval(-7 + 24im, x^2)
    @test issubset_interval(sqrt(x), x^0.5)

    a = -3.1
    @test issubset_interval(x, (x^a)^(1/a))

    z = interval(3 + 4im)
    sZ = sqrt(z)
    @test in_interval(2 + im, sZ)

    @test issubset_interval(interval(0, 1)*interval(im), sqrt(interval(-1, 0) + interval(0)*interval(im)))
    @test issubset_interval(interval(0, 1) + interval(0, 1)*interval(im), sqrt(interval(-1, 1) + interval(0)*interval(im)))
    @test issubset_interval(interval(0, Inf) + interval(-3//8, Inf)*interval(im), sqrt(interval(-9//32, Inf)*interval(im)))

    x = interval(-0.5) + interval(im) * interval(-1e-14, 1e-14)

    y = interval(1)
    @test issubset_interval(x^y, exp(y*log(x)))

    y = interval(1.5, 2.5)
    res = x^y
    ref = exp(y*log(x))
    # tighter on the real part (right half-plane)
    @test inf(real(ref)) < -0.3 < -1e-13 < inf(real(res))

    y = interval(-2, Inf)
    @test isequal_interval(x^y, exp(y*log(x)))

    @test isequal_interval(fastpown(x, 1), x^interval(1))
    @test isequal_interval(fastpown(x, 2), x^interval(2))
    @test isequal_interval(fastpown(x, 5), x^interval(5))
end

@testset "Literal powers" begin
    x = interval(-1,1)
    n = 2
    @test isguaranteed(x ^ 2)
    @test !isguaranteed(x ^ n)
    @test !isguaranteed(x ^ 2.0)
    if VERSION ≥ v"1.12-DEV" && Int != Int32
        @test isguaranteed(x ^ 2305843009213693952)
    else
        @test_broken isguaranteed(x ^ 2305843009213693952)
    end
    @test isequal_interval(x^2, interval(0,1))
    @test isequal_interval(x^3, x)
end

@testset "minimal.atan2_test" begin

    @test atan(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test atan(emptyinterval(BareInterval{Float64}), entireinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test atan(entireinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test atan(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test atan(entireinterval(BareInterval{Float64}), entireinterval(BareInterval{Float64})) === bareinterval(-0x1.921FB54442D19p1, +0x1.921FB54442D19p1)

    @test atan(bareinterval(0.0, 0.0), bareinterval(-Inf, 0.0)) === bareinterval(0x1.921FB54442D18p1, 0x1.921FB54442D19p1)

    @test atan(bareinterval(0.0, 0.0), bareinterval(0.0, Inf)) === bareinterval(0.0, 0.0)

    @test atan(bareinterval(0.0, Inf), bareinterval(0.0, 0.0)) === bareinterval(0x1.921FB54442D18p0, 0x1.921FB54442D19p0)

    @test atan(bareinterval(-Inf, 0.0), bareinterval(0.0, 0.0)) === bareinterval(-0x1.921FB54442D19p0, -0x1.921FB54442D18p0)

    @test atan(bareinterval(-0x1p-1022, 0.0), bareinterval(-0x1p-1022, -0x1p-1022)) === bareinterval(-0x1.921FB54442D19p1, +0x1.921FB54442D19p1)

    @test atan(bareinterval(1.0, 1.0), bareinterval(-1.0, -1.0)) === bareinterval(0x1.2D97C7F3321D2p1, 0x1.2D97C7F3321D3p1)

    @test atan(bareinterval(1.0, 1.0), bareinterval(1.0, 1.0)) === bareinterval(0x1.921FB54442D18p-1, 0x1.921FB54442D19p-1)

    @test atan(bareinterval(-1.0, -1.0), bareinterval(1.0, 1.0)) === bareinterval(-0x1.921FB54442D19p-1, -0x1.921FB54442D18p-1)

    @test atan(bareinterval(-1.0, -1.0), bareinterval(-1.0, -1.0)) === bareinterval(-0x1.2D97C7F3321D3p1, -0x1.2D97C7F3321D2p1)

    @test atan(bareinterval(-0x1p-1022, 0x1p-1022), bareinterval(-0x1p-1022, -0x1p-1022)) === bareinterval(-0x1.921FB54442D19p1, +0x1.921FB54442D19p1)

    @test atan(bareinterval(-0x1p-1022, 0x1p-1022), bareinterval(0x1p-1022, 0x1p-1022)) === bareinterval(-0x1.921FB54442D19p-1, +0x1.921FB54442D19p-1)

    @test atan(bareinterval(-0x1p-1022, -0x1p-1022), bareinterval(-0x1p-1022, 0x1p-1022)) === bareinterval(-0x1.2D97C7F3321D3p1, -0x1.921FB54442D18p-1)

    @test atan(bareinterval(0x1p-1022, 0x1p-1022), bareinterval(-0x1p-1022, 0x1p-1022)) === bareinterval(0x1.921FB54442D18p-1, 0x1.2D97C7F3321D3p1)

    @test atan(bareinterval(-2.0, 2.0), bareinterval(-3.0, -1.0)) === bareinterval(-0x1.921FB54442D19p1, +0x1.921FB54442D19p1)

    @test atan(bareinterval(0.0, 2.0), bareinterval(-3.0, -1.0)) === bareinterval(0x1.0468A8ACE4DF6p1, 0x1.921FB54442D19p1)

    @test atan(bareinterval(1.0, 3.0), bareinterval(-3.0, -1.0)) === bareinterval(0x1.E47DF3D0DD4Dp0, 0x1.68F095FDF593Dp1)

    @test atan(bareinterval(1.0, 3.0), bareinterval(-2.0, 0.0)) === bareinterval(0x1.921FB54442D18p0, 0x1.56C6E7397F5AFp1)

    @test atan(bareinterval(1.0, 3.0), bareinterval(-2.0, 2.0)) === bareinterval(0x1.DAC670561BB4Fp-2, 0x1.56C6E7397F5AFp1)

    @test atan(bareinterval(1.0, 3.0), bareinterval(0.0, 2.0)) === bareinterval(0x1.DAC670561BB4Fp-2, 0x1.921FB54442D19p0)

    @test atan(bareinterval(1.0, 3.0), bareinterval(1.0, 3.0)) === bareinterval(0x1.4978FA3269EE1p-2, 0x1.3FC176B7A856p0)

    @test atan(bareinterval(0.0, 2.0), bareinterval(1.0, 3.0)) === bareinterval(0x0p0, 0x1.1B6E192EBBE45p0)

    @test atan(bareinterval(-2.0, 2.0), bareinterval(1.0, 3.0)) === bareinterval(-0x1.1B6E192EBBE45p0, +0x1.1B6E192EBBE45p0)

    @test atan(bareinterval(-2.0, 0.0), bareinterval(1.0, 3.0)) === bareinterval(-0x1.1B6E192EBBE45p0, 0x0p0)

    @test atan(bareinterval(-3.0, -1.0), bareinterval(1.0, 3.0)) === bareinterval(-0x1.3FC176B7A856p0, -0x1.4978FA3269EE1p-2)

    @test atan(bareinterval(-3.0, -1.0), bareinterval(0.0, 2.0)) === bareinterval(-0x1.921FB54442D19p0, -0x1.DAC670561BB4Fp-2)

    @test atan(bareinterval(-3.0, -1.0), bareinterval(-2.0, 2.0)) === bareinterval(-0x1.56C6E7397F5AFp1, -0x1.DAC670561BB4Fp-2)

    @test atan(bareinterval(-3.0, -1.0), bareinterval(-2.0, 0.0)) === bareinterval(-0x1.56C6E7397F5AFp1, -0x1.921FB54442D18p0)

    @test atan(bareinterval(-3.0, -1.0), bareinterval(-3.0, -1.0)) === bareinterval(-0x1.68F095FDF593Dp1, -0x1.E47DF3D0DD4Dp0)

    @test atan(bareinterval(-2.0, 0.0), bareinterval(-3.0, -1.0)) === bareinterval(-0x1.921FB54442D19p1, +0x1.921FB54442D19p1)

    @test atan(bareinterval(-5.0, 0.0), bareinterval(-5.0, 0.0)) === bareinterval(-0x1.921FB54442D19p1, +0x1.921FB54442D19p1)

    @test atan(bareinterval(0.0, 5.0), bareinterval(-5.0, 0.0)) === bareinterval(0x1.921FB54442D18p0, 0x1.921FB54442D19p1)

    @test atan(bareinterval(0.0, 5.0), bareinterval(0.0, 5.0)) === bareinterval(0x0p0, 0x1.921FB54442D19p0)

    @test atan(bareinterval(-5.0, 0.0), bareinterval(0.0, 5.0)) === bareinterval(-0x1.921FB54442D19p0, 0x0p0)

end

# This file contains the functions described as "Set operations" in Section 9.3
# of the IEEE Std 1788-2015 and required for set-based flavor in Section 10.5.7
# Some other (non required) related functions are also present

_set_decoration(x::Interval, d::Decoration) = setdecoration(x, d)

function _set_decoration(x::Interval, d::Symbol)
    d === :auto    && return x
    d === :default && return setdecoration(x, min(trv, decoration(x)))
    return throw(ArgumentError("decoration option must be `:default`, `:auto` or a specific decoration"))
end

"""
    intersect_interval(x, y; dec = :default)

Returns the intersection of the intervals `x` and `y`, considered as (extended)
sets of real numbers. That is, the set that contains the points common in `x`
and `y`.

The keywork `dec` argument controls the decoration of the result. It can be
either a specific decoration, or one of two following options:
- `:default`: if at least one of the input intervals is `ill`,
  then the result is `ill`, otherwise it is `trv` (Section 11.7.1).
- `:auto`: the ouptut has the minimal decoration of the inputs.

Implement the `intersection` function of the IEEE Standard 1788-2015 (Section 9.3).
"""
function intersect_interval(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    lo = max(inf(x), inf(y))
    hi = min(sup(x), sup(y))
    if lo > hi
        return emptyinterval(BareInterval{T})
    else
        return _unsafe_bareinterval(T, lo, hi)
    end
end
intersect_interval(x::BareInterval, y::BareInterval) = intersect_interval(promote(x, y)...)

function intersect_interval(x::Interval{T}, y::Interval{S}; dec = :default) where {T<:NumTypes,S<:NumTypes}
    isnai(x) | isnai(y) && return nai(promote_type(T, S))
    r = intersect_interval(bareinterval(x), bareinterval(y))
    d = min(decoration(x), decoration(y))
    t = isguaranteed(x) & isguaranteed(y)
    return _set_decoration(_unsafe_interval(r, d, t), dec)
end

intersect_interval(x, y, z, w...; dec = :default) =
    reduce((a, b) -> intersect_interval(a, b; dec = dec), (x, y, z, w...))
intersect_interval(x::Complex, y::Complex; dec = :default) =
    complex(intersect_interval(real(x), real(y); dec = dec), intersect_interval(imag(x), imag(y); dec = dec))
intersect_interval(x::Real, y::Complex; dec = :default) =
    complex(intersect_interval(x, real(y); dec = dec), intersect_interval(zero(x), imag(y); dec = dec))
intersect_interval(x::Complex, y::Real; dec = :default) =
    complex(intersect_interval(real(x), y; dec = dec), intersect_interval(imag(x), zero(y); dec = dec))

"""
    hull(x, y; dec = :default)

Return the interval hull of the intervals `x` and `y`, considered as (extended)
sets of real numbers, i.e. the smallest interval that contains all of `x` and
`y`.

The keywork `dec` argument controls the decoration of the result. It can be
either a specific decoration, or one of two following options:
- `:default`: if at least one of the input intervals is `ill`,
  then the result is `ill`, otherwise it is `trv` (Section 11.7.1).
- `:auto`: the ouptut has the minimal decoration of the inputs.

Implement the `convexHull` function of the IEEE Standard 1788-2015 (Section 9.3).
"""
function hull(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) & isempty_interval(y) && return x
    return _unsafe_bareinterval(T, min(inf(x), inf(y)), max(sup(x), sup(y)))
end
hull(x::BareInterval, y::BareInterval) = hull(promote(x, y)...)

function hull(x::Interval{T}, y::Interval{S}; dec = :default) where {T<:NumTypes,S<:NumTypes}
    isnai(x) | isnai(y) && return nai(promote_type(T, S))
    r = hull(bareinterval(x), bareinterval(y))
    d = min(decoration(x), decoration(y))
    t = isguaranteed(x) & isguaranteed(y)
    return _set_decoration(_unsafe_interval(r, d, t), dec)
end

hull(x, y, z, w...; dec = :default) =
    reduce((a, b) -> hull(a, b; dec = dec), (x, y, z, w...))
hull(x::Complex, y::Complex; dec = :default) =
    complex(hull(real(x), real(y); dec = dec), hull(imag(x), imag(y); dec = dec))
hull(x::Real, y::Complex; dec = :default) =
    complex(hull(x, real(y); dec = dec), hull(zero(x), imag(y); dec = dec))
hull(x::Complex, y::Real; dec = :default) =
    complex(hull(real(x), y; dec = dec), hull(imag(x), zero(y); dec = dec))

"""
    union_interval(x, y, z...)

Alias of [`hull`](@ref).
"""
const union_interval = hull

"""
    interiordiff(x, y; dec = :default)

Remove the interior of `y` from `x`. If `x` and `y` are vectors, then they are
treated as multi-dimensional intervals.

The keywork `dec` argument controls the decoration of the result. It can be
either a specific decoration, or one of two following options:
- `:default`: if at least one of the input intervals is `ill`,
  then the result is `ill`, otherwise it is `trv` (Section 11.7.1).
- `:auto`: the ouptut has the minimal decoration of the inputs.
"""
interiordiff(x::BareInterval, y::BareInterval) =
    interiordiff!(Vector{promote_type(typeof(x), typeof(y))}(undef, 0), x, y)

interiordiff(x::AbstractVector{<:BareInterval}, y::AbstractVector{<:BareInterval}) =
    interiordiff!(Vector{promote_type(typeof(x), typeof(y))}(undef, 0), x, y)

interiordiff(x::Interval, y::Interval; dec = :default) =
    interiordiff!(Vector{promote_type(typeof(x), typeof(y))}(undef, 0), x, y; dec = dec)

interiordiff(x::AbstractVector{<:Interval}, y::AbstractVector{<:Interval}; dec = :default) =
    interiordiff!(Vector{promote_type(typeof(x), typeof(y))}(undef, 0), x, y; dec = dec)

"""
    interiordiff!(x, y; dec = :default)

In-place version of [`interiordiff`](@ref).
"""
function interiordiff!(v::AbstractVector, x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    if isinterior(x, y)
        empty!(v)
    elseif isdisjoint_interval(x, y)
        resize!(v, 1)
        @inbounds v[begin] = x
    else
        inter = intersect_interval(x, y)
        if issubset_interval(y, x)
            resize!(v, 2)
            @inbounds v[begin] = _unsafe_bareinterval(T, inf(x), inf(inter))
            @inbounds v[end] = _unsafe_bareinterval(T, sup(inter), sup(x))
        elseif isweakless(x, inter)
            resize!(v, 1)
            @inbounds v[begin] = _unsafe_bareinterval(T, inf(x), inf(inter))
        else
            resize!(v, 1)
            @inbounds v[begin] = _unsafe_bareinterval(T, sup(inter), sup(x))
        end
    end
    return v
end
interiordiff!(v::AbstractVector, x::BareInterval, y::BareInterval) = interiordiff!(v, promote(x, y)...)
interiordiff!(v::AbstractVector{<:AbstractVector}, x::AbstractVector{<:BareInterval}, y::AbstractVector{<:BareInterval}) =
    _interiordiff!(v, x, y, nothing)

function interiordiff!(v::AbstractVector, x::Interval{T}, y::Interval{T}; dec = :default) where {T<:NumTypes}
    if isinterior(x, y)
        empty!(v)
    elseif isdisjoint_interval(x, y)
        resize!(v, 1)
        @inbounds v[begin] = x
    else
        d = min(decoration(x), decoration(y))
        t = isguaranteed(x) & isguaranteed(y)
        inter = intersect_interval(x, y)
        if issubset_interval(y, x)
            resize!(v, 2)
            r1 = _unsafe_bareinterval(T, inf(x), inf(inter))
            @inbounds v[begin] = _set_decoration(_unsafe_interval(r1, d, t), dec)
            r2 = _unsafe_bareinterval(T, sup(inter), sup(x))
            @inbounds v[end] = _set_decoration(_unsafe_interval(r2, d, t), dec)
        elseif isweakless(x, inter)
            resize!(v, 1)
            r1 = _unsafe_bareinterval(T, inf(x), inf(inter))
            @inbounds v[begin] = _set_decoration(_unsafe_interval(r1, d, t), dec)
        else
            resize!(v, 1)
            r2 = _unsafe_bareinterval(T, sup(inter), sup(x))
            @inbounds v[begin] = _set_decoration(_unsafe_interval(r2, d, t), dec)
        end
    end
    return v
end
interiordiff!(v::AbstractVector, x::Interval, y::Interval; dec = :default) = interiordiff!(v, promote(x, y)...; dec = dec)
interiordiff!(v::AbstractVector{<:AbstractVector}, x::AbstractVector{<:Interval}, y::AbstractVector{<:Interval}; dec = :default) =
    _interiordiff!(v, x, y, dec)

function _interiordiff!(v::AbstractVector{<:AbstractVector}, x::AbstractVector, y::AbstractVector, dec)
    # start from the total overlap (in all directions); expand each direction in turn

    N = length(x)
    len = length(y)
    N == len || return throw(DimensionMismatch("x has length $N, y has length $len"))

    if any(t -> isdisjoint_interval(t[1], t[2]), zip(x, y))
        resize!(v, 1)
        @inbounds v[begin] = copy(x)
    else
        resize!(v, 2N)

        offset = 0
        x_bis = copy(x)

        @inbounds for i ∈ eachindex(x, y)
            h₁, h₂, inter = _interiordiff(x[i], y[i], dec)
            u₁ = similar(eltype(v), N)
            u₂ = similar(eltype(v), N)
            @inbounds for j ∈ eachindex(u₁)
                u₁[j] = ifelse(j == i, h₁, x_bis[j])
                u₂[j] = ifelse(j == i, h₂, x_bis[j])
            end
            v[begin+offset] = u₁
            v[begin+1+offset] = u₂
            offset += 2
            x_bis[i] = inter
        end

        filter!(z -> !any(x -> isempty_interval(x) | isnai(x), z), v)
    end

    return v
end

function _interiordiff(x::BareInterval{T}, y::BareInterval{T}, ::Nothing) where {T<:NumTypes}
    isdisjoint_interval(x, y) && return (x, emptyinterval(BareInterval{T}), emptyinterval(BareInterval{T}))

    inter = intersect_interval(x, y)
    isinterior(x, y) && return (emptyinterval(BareInterval{T}), emptyinterval(BareInterval{T}), inter)
    isequal_interval(x, y) && return (_unsafe_bareinterval(T, inf(x), inf(x)), _unsafe_bareinterval(T, sup(x), sup(x)), inter)

    inf(x) == inf(inter) && return (_unsafe_bareinterval(T, sup(inter), sup(x)), emptyinterval(BareInterval{T}), inter)
    sup(x) == sup(inter) && return (_unsafe_bareinterval(T, inf(x), inf(inter)), emptyinterval(BareInterval{T}), inter)

    return (_unsafe_bareinterval(T, inf(x), inf(y)), _unsafe_bareinterval(T, sup(y), sup(x)), inter)
end
_interiordiff(x::BareInterval, y::BareInterval, dec::Nothing) = _interiordiff(promote(x, y)..., dec)

function _interiordiff(x::Interval, y::Interval, dec)
    h₁, h₂, inter = _interiordiff(bareinterval(x), bareinterval(y), nothing)
    d = min(decoration(x), decoration(y))
    t = isguaranteed(x) & isguaranteed(y)
    return (_set_decoration(_unsafe_interval(h₁, d, t), dec), _set_decoration(_unsafe_interval(h₂, d, t), dec), _set_decoration(_unsafe_interval(inter, d, t), dec))
end

#

function interval_diff(x::Interval{T}, y::Interval) where {T<:NumTypes}
    isdisjoint_interval(x, y) && return [x]
    issubset_interval(x, y) && return Interval{T}[]

    intersection = intersect_interval(x, y)
    inf(x) == inf(intersection) && return [interval(sup(intersection), sup(x))]
    sup(x) == sup(intersection) && return [interval(inf(x), inf(intersection))]

    return [
        interval(inf(x), inf(intersection)),
        interval(sup(intersection), sup(x))
    ]
end

import LinearAlgebra

@testset "Matrix inversion" begin
    IntervalArithmetic.configure(; matmul = :slow)
    A = [interval(2) interval(1, 2) ; interval(0) interval(1)]
    @test all(isequal_interval.(inv(A), [interval(0, 1) interval(-1.25, -0.25) ; interval(-0.5, 0.5) interval(0.5, 1.5)]))
    B = [interval(2) interval(1, 2) ; interval(0) interval(0, 1)]
    @test all(isnai, inv(B))
end

@testset "Matrix multiplication" begin
    IntervalArithmetic.configure(; matmul = :fast)
    A = [interval(2, 4) interval(-2, 1) ; interval(-1, 2) interval(2, 4)]
    imA = interval(im) * A

    @test all(issubset_interval.([interval(0, 18) interval(-16, 8) ; interval(-8, 16) interval(0, 18)], A * A))
    @test all(issubset_interval.([interval(5, 12.5) interval(-8, 2) ; interval(-2, 8) interval(5, 12.5)], A * mid.(A)))
    @test all(issubset_interval.([interval(5, 12.5) interval(-8, 2) ; interval(-2, 8) interval(5, 12.5)], mid.(A) * A))

    @test all(issubset_interval.([interval(-18, 0) interval(-8, 16) ; interval(-16, 8) interval(-18, 0)], imA * imA))
    @test all(issubset_interval.(interval(im)*[interval(5, 12.5) interval(-8, 2) ; interval(-2, 8) interval(5, 12.5)], mid.(A) * imA))
    @test all(issubset_interval.(interval(im)*[interval(5, 12.5) interval(-8, 2) ; interval(-2, 8) interval(5, 12.5)], imA * mid.(A)))
end

using IntervalArithmetic.Symbols

@testset "Linear algebra" begin
    IntervalArithmetic.configure(; matmul = :slow)
    A = [interval(2, 4)  interval(-2, 1)
         interval(-1, 2) interval(2, 4)]

    b = [interval(-2, 2)
         interval(-2, 2)]

    @test all(isequal_interval.(A * b, [interval(-12, 12), interval(-12, 12)]))
    @test_throws IntervalArithmetic.InconclusiveBooleanOperation A \ b

    @test all(isequal_interval.(interval.([1 2; 3 4]) * interval(-1, 1), [interval(-1, 1) interval(-2, 2) ; interval(-3, 3) interval(-4, 4)]))
    IntervalArithmetic.configure(; matmul = :fast)
end


@testset "interiordiff" begin
    function sameset(A, B)
        length(A) != length(B) && return false
        for a ∈ A
            found = false
            for b ∈ B
                if all(isequal_interval.(a, b))
                    found = true
                    break
                end
            end
            !found && return false
        end
        return true
    end

    X = [2..4, 3..5]
    Y = [3..5, 4..6]
    @test sameset(
        interiordiff(X, Y),
        [ [3..4, 3..4],
          [2..3, 3..5] ])

    X = [2..5, 3..6]
    Y = [-10..10, 4..5]
    @test sameset(
        interiordiff(X, Y),
        [ [2..5, 3..4],
          [2..5, 5..6] ])

    X = [2..5, 3..6]
    Y = [4..6, 4..5]
    @test sameset(
        interiordiff(X, Y),
        [ [4..5, 3..4],
          [4..5, 5..6],
          [2..4, 3..6] ])

    X = [2..5, 3..6]
    Y = [3..4, 4..5]
    @test sameset(
        interiordiff(X, Y),
        [ [3..4, 3..4],
          [3..4, 5..6],
          [2..3, 3..6],
          [4..5, 3..6] ])

    X = [2..5, 3..6]
    Y = [2..4, 10..20]
    @test sameset(interiordiff(X, Y), typeof(X)[X])

    X = [2..5, 3..6]
    Y = [-10..10, -10..10]
    @test sameset(interiordiff(X, Y), typeof(X)[])

    X = [1..4, 3..6, 7..10]
    Y = [2..3, 4..5, 8..9]
    @test sameset(
        interiordiff(X, Y),
        [ [2..3, 4..5, 7..8],
          [2..3, 4..5, 9..10],
          [2..3, 3..4, 7..10],
          [2..3, 5..6, 7..10],
          [1..2, 3..6, 7..10],
          [3..4, 3..6, 7..10] ])

    X = [-Inf..Inf, 1..2]
    Y = [1..2, -1..1.5]
    @test sameset(
        interiordiff(X, Y),
        [ [-Inf..1, 1..2],
          [2..Inf, 1..2],
          [1..2, 1.5..2] ])
end

@testset "Mince and hull" begin
    ib2 = [-1..1, -1..1]
    vb2 = mince(ib2, 4)
    @test length(vb2) == 4^2
    vv = [[(-1 .. -0.5), (-1 .. -0.5)], [(-0.5 .. 0), (-1 .. -0.5)],
          [(0 .. 0.5), (-1 .. -0.5)], [(0.5 .. 1), (-1 .. -0.5)],
          [(-1 .. -0.5), (-0.5 .. 0)], [(-0.5 .. 0), (-0.5 .. 0)],
          [(0 .. 0.5), (-0.5 .. 0)], [(0.5 .. 1), (-0.5 .. 0)],
          [(-1 .. -0.5), (0 .. 0.5)], [(-0.5 .. 0), (0 .. 0.5)],
          [(0 .. 0.5), (0 .. 0.5)], [(0.5 .. 1), (0 .. 0.5)],
          [(-1 .. -0.5), (0.5 .. 1)], [(-0.5 .. 0), (0.5 .. 1)],
          [(0 .. 0.5), (0.5 .. 1)], [(0.5 .. 1), (0.5 .. 1)]]
    @test mapreduce((x, y) -> all(isequal_interval.(x, y)), &, vb2, vv)
    @test all(enumerate(ib2)) do (i, Ib)
        hulled = reduce(hull, [vb2[k][i] for k in eachindex(vb2)])
        isequal_interval(hulled, Ib)
    end
    @test mapreduce((x, y) -> all(isequal_interval.(x, y)), &, mince(ib2, (4, 4)), vb2)
    @test mapreduce((x, y) -> all(isequal_interval.(x, y)), &, mince(ib2, (1,4)),
        [[(-1 .. 1), (-1 .. -0.5)], [(-1 .. 1), (-0.5 .. 0)], [(-1 .. 1), (0 .. 0.5)], [(-1 .. 1), (0.5 .. 1)]])

    vb2bis = mince(ib2, (1,4))
    @test all(enumerate(ib2)) do (i, Ib)
        hulled = reduce(hull, [vb2bis[k][i] for k in eachindex(vb2bis)])
        isequal_interval(hulled, Ib)
    end

    ib3 = fill(-1..1, 3)
    vb3 = mince(ib3, 4)
    @test length(vb3) == 4^3
    @test all(enumerate(ib3)) do (i, Ib)
        hulled = reduce(hull, [vb3[k][i] for k in eachindex(vb3)])
        isequal_interval(hulled, Ib)
    end
    @test mapreduce((x, y) -> all(isequal_interval.(x, y)), &, mince(ib3, (4,4,4)), vb3)
    @test mapreduce((x, y) -> all(isequal_interval.(x, y)), &, mince(ib3, (2,1,1)),
        [[(-1 .. 0), (-1 .. 1), (-1 .. 1)], [(0 .. 1), (-1 .. 1), (-1 .. 1)]])
    vb3bis = mince(ib3, (2,1,1))
    @test all(enumerate(ib3)) do (i, Ib)
        hulled = reduce(hull, [vb3bis[k][i] for k in eachindex(vb3bis)])
        isequal_interval(hulled, Ib)
    end

    ib4 = fill(-1..1, 4)
    vb4 = mince(ib4, 4)
    @test length(vb4) == 4^4
    @test all(enumerate(ib4)) do (i, Ib)
        hulled = reduce(hull, [vb4[k][i] for k in eachindex(vb4)])
        isequal_interval(hulled, Ib)
    end
    @test mapreduce((x, y) -> all(isequal_interval.(x, y)), &, mince(ib4, (4,4,4,4)), vb4)
    @test mapreduce((x, y) -> all(isequal_interval.(x, y)), &, mince(ib4, (1,1,1,1)), (ib4,))
end

@testset "Bisect" begin
    v = [interval(0, 1), interval(0, 2)]
    w = bisect(v, 1, 0.5)
    @test all(isequal_interval.( w[1], [interval(0, 0.5), interval(0, 2)] )) &
          all(isequal_interval.( w[2], [interval(0.5, 1), interval(0, 2)] ))
    w = bisect(v, 2, 0.5)
    @test all(isequal_interval.( w[1], [interval(0, 1), interval(0, 1)] )) &
          all(isequal_interval.( w[2], [interval(0, 1), interval(1, 2)] ))
    w = bisect(v, 1, 0.25)
    @test all(isequal_interval.( w[1], [interval(0, 0.25), interval(0, 2)] )) &
          all(isequal_interval.( w[2], [interval(0.25, 1), interval(0, 2)] ))
    w = bisect(v, 2, 0.25)
    @test all(isequal_interval.( w[1], [interval(0, 1), interval(0, 0.5)] )) &
          all(isequal_interval.( w[2], [interval(0, 1), interval(0.5, 2)] ))
    w = bisect(v, 1)
    @test all(isequal_interval.( w[1], [interval(0, 0.5), interval(0, 2)] )) &
          all(isequal_interval.( w[2], [interval(0.5, 1), interval(0, 2)] ))
    w = bisect(v, 2)
    @test all(isequal_interval.( w[1], [interval(0, 1), interval(0, 1)] )) &
          all(isequal_interval.( w[2], [interval(0, 1), interval(1, 2)] ))

    v = [interval(-Inf, Inf), interval(-Inf, Inf)]
    w = bisect(v, 1, 0.5)
    @test all(isequal_interval.( w[1], [interval(-Inf, 0), interval(-Inf, Inf)] )) &
          all(isequal_interval.( w[2], [interval(0, Inf),  interval(-Inf, Inf)] ))
end

module IntervalArithmeticSparseArraysExt

 using IntervalArithmetic
 import SparseArrays

 SparseArrays._iszero(x::Interval) = isthinzero(x)

 SparseArrays._isnotzero(x::Interval) = !isthinzero(x)

 end

@testset "IntervalArithmeticArblibExt" begin
    Arf = Arblib.Arf
    ArfRef = Arblib.ArfRef
    Arb = Arblib.Arb
    ArbRef = Arblib.ArbRef
    Acb = Arblib.Acb
    setball = Arblib.setball

    # There is a bug in Flint before version 3.3.0 that gives NaN for
    # getinterval on balls with infinite midpoint and radius. Check if
    # we are using such a version to mark tests as broken.
    broken_getinterval = isnan(Arblib.getinterval(setball(Arb, -Inf, Inf))[2])

    @testset "Promotion rules" begin
        # Arf behaves like normal promotion with Interval
        @test promote_type(Arf, Interval{Float64}) == Interval{Arf}
        @test promote_type(Arf, Interval{BigFloat}) == Interval{Arf}
        @test promote_type(Arf, Interval{Rational{Int}}) == Interval{Arf}
        @test promote_type(ArfRef, Interval{Float64}) == Interval{Arf}
        @test promote_type(ArfRef, Interval{BigFloat}) == Interval{Arf}
        @test promote_type(ArfRef, Interval{Rational{Int}}) == Interval{Arf}
        @test promote_type(Interval{Float64}, Arf) == Interval{Arf}
        @test promote_type(Interval{BigFloat}, Arf) == Interval{Arf}
        @test promote_type(Interval{Rational{Int}}, Arf) == Interval{Arf}
        @test promote_type(Interval{Float64}, ArfRef) == Interval{Arf}
        @test promote_type(Interval{BigFloat}, ArfRef) == Interval{Arf}
        @test promote_type(Interval{Rational{Int}}, ArfRef) == Interval{Arf}



        # Promotion between Arb and Interval is not allowed
        @test_throws ArgumentError promote_type(Arb, Interval{Float64})
        @test_throws ArgumentError promote_type(Arb, Interval{BigFloat})
        @test_throws ArgumentError promote_type(Arb, Interval{Arf})
        @test_throws ArgumentError promote_type(Arb, Interval{Arb})
        @test_throws ArgumentError promote_type(ArbRef, Interval{Float64})
        @test_throws ArgumentError promote_type(ArbRef, Interval{BigFloat})
        @test_throws ArgumentError promote_type(ArbRef, Interval{Arf})
        @test_throws ArgumentError promote_type(ArbRef, Interval{Arb})
        @test_throws ArgumentError promote_type(Interval{Float64}, Arb)
        @test_throws ArgumentError promote_type(Interval{BigFloat}, Arb)
        @test_throws ArgumentError promote_type(Interval{Arf}, Arb)
        @test_throws ArgumentError promote_type(Interval{Arb}, Arb)
        @test_throws ArgumentError promote_type(Interval{Float64}, ArbRef)
        @test_throws ArgumentError promote_type(Interval{BigFloat}, ArbRef)
        @test_throws ArgumentError promote_type(Interval{Arf}, ArbRef)
        @test_throws ArgumentError promote_type(Interval{Arb}, ArbRef)
    end

    @testset "Interval from Arb" begin
        @testset "promote_numtype" begin
            @test IntervalArithmetic.promote_numtype(Arb, Arb) == BigFloat
            @test IntervalArithmetic.promote_numtype(Arb, ArbRef) == BigFloat
            @test IntervalArithmetic.promote_numtype(ArbRef, Arb) == BigFloat
            @test IntervalArithmetic.promote_numtype(ArbRef, ArbRef) == BigFloat

            @test IntervalArithmetic.promote_numtype(Arb, Float64) == BigFloat
            @test IntervalArithmetic.promote_numtype(ArbRef, Float64) == BigFloat
            @test IntervalArithmetic.promote_numtype(Arb, Rational{Int}) == BigFloat
            @test IntervalArithmetic.promote_numtype(ArbRef, Rational{Int}) == BigFloat

            @test IntervalArithmetic.promote_numtype(Arb, Arf) == Arf
            @test IntervalArithmetic.promote_numtype(ArbRef, Arf) == Arf
            @test IntervalArithmetic.promote_numtype(Arb, ArfRef) == Arf
            @test IntervalArithmetic.promote_numtype(ArbRef, ArfRef) == Arf
        end

        @testset "Single argument constructor" begin
            # Valid intervals
            xs = Arb[
                0,
                1,
                π,
                ℯ,
                1//3,
                Arb((1, 2)),
                Arb((-Inf, Inf)),
                setball(Arb, 5, Inf),
                #setball(Arb, -Inf, Inf),
                #setball(Arb, Inf, Inf),
            ]

            for x in xs
                @test interval(x) isa Interval{BigFloat}

                for T in [BigFloat, Arf, Float64, Float32]
                    y = interval(T, x)
                    @test y isa Interval{T}
                    @test !isnai(y)
                    @test isbounded(y) == isfinite(x)
                    @test Arblib.contains(Arb(y), x)
                end
            end

            # These are bugs in Flint
            # @test isequal_interval(interval(setball(Arb, -Inf, Inf)), interval(-Inf, Inf)) broken =
            #     broken_getinterval
            # @test isequal_interval(interval(setball(Arb, Inf, Inf)), interval(-Inf, Inf)) broken =
            #     broken_getinterval

            # Invalid intervals
            @test isnai(interval(Arb(-Inf)))
            @test isnai(interval(Arb(Inf)))
            @test isnai(interval(Arb(NaN)))
        end

        @testset "Two argument constructor" begin
            # Valid infs and sups
            # All <=3
            as1 = Real[0, 1, ℯ, 1//3, 0.1, BigFloat(1.1), BigInt(3)]
            # All >=3
            bs1 = Real[3, π, 7//2, BigFloat(4.1), BigInt(4)]

            for a in as1
                for b in bs1
                    a_Arb = Arb(a)
                    b_Arb = Arb(b)

                    y1 = interval(a, b_Arb)
                    y2 = interval(a_Arb, b)
                    y3 = interval(a_Arb, b_Arb)

                    @test y1 isa Interval{BigFloat}
                    @test y2 isa Interval{BigFloat}
                    @test y3 isa Interval{BigFloat}

                    @test Arblib.overlaps(Arb(y1), a_Arb)
                    @test Arblib.overlaps(Arb(y1), b_Arb)
                    @test Arblib.overlaps(Arb(y2), a_Arb)
                    @test Arblib.overlaps(Arb(y2), b_Arb)
                    @test Arblib.overlaps(Arb(y3), a_Arb)
                    @test Arblib.overlaps(Arb(y3), b_Arb)

                    # TODO: Doesn't work for Arf because it doesn't support nextfloat
                    for T in [BigFloat, Float64, Float32]
                        y1 = interval(T, a, b_Arb)
                        y2 = interval(T, a_Arb, b)
                        y3 = interval(T, a_Arb, b_Arb)

                        @test y1 isa Interval{T}
                        @test y2 isa Interval{T}
                        @test y3 isa Interval{T}

                        @test Arblib.overlaps(Arb(y1), a_Arb)
                        @test Arblib.overlaps(Arb(y1), b_Arb)
                        @test Arblib.overlaps(Arb(y2), a_Arb)
                        @test Arblib.overlaps(Arb(y2), b_Arb)
                        @test Arblib.overlaps(Arb(y3), a_Arb)
                        @test Arblib.overlaps(Arb(y3), b_Arb)
                    end
                end
            end

            # Overlapping intervals
            @test isequal_interval(
                interval(interval(1, 3), interval(2, 4)),
                interval(setball(Arb, 2, 1), setball(Arb, 3, 1)),
            )
            @test isequal_interval(
                interval(interval(1, 3), interval(0, 4)),
                interval(setball(Arb, 2, 1), setball(Arb, 2, 2)),
            )
            @test isequal_interval(
                interval(interval(1, 5), interval(2, 4)),
                interval(setball(Arb, 3, 2), setball(Arb, 3, 1)),
            )

            # Infinite, but valid, intervals
            as2 = [
                Arb(-Inf),
                # setball(Arb, -Inf, 1),
                Arb((-Inf, Inf)),
                # setball(Arb, -Inf, Inf),
                setball(Arb, 0, Inf),
                # setball(Arb, Inf, Inf),
            ]

            bs2 = [
                Arb(Inf),
                # setball(Arb, Inf, 1),
                Arb((-Inf, Inf)),
                # setball(Arb, -Inf, Inf),
                setball(Arb, 0, Inf),
                # setball(Arb, Inf, Inf),
            ]

            for a in as2
                for b in bs2
                    # This is a bug in Flint
                    broken =
                        broken_getinterval && (
                            isequal(a, setball(Arb, Inf, Inf)) ||
                            isequal(b, setball(Arb, -Inf, Inf))
                        )
                    @test isequal_interval(interval(a, b), interval(-Inf, Inf)) broken =
                        broken
                end
            end

            for a in as2
                # This is a bug in Flint
                broken = broken_getinterval && isequal(a, setball(Arb, Inf, Inf))
                @test isequal_interval(interval(a, Inf), interval(-Inf, Inf)) broken =
                    broken
            end

            for b in bs2
                # This is a bug in Flint
                broken = broken_getinterval && isequal(b, setball(Arb, -Inf, Inf))
                @test isequal_interval(interval(-Inf, b), interval(-Inf, Inf)) broken =
                    broken
            end

            # Invalid intervals

            # [-Inf, -Inf] or [Inf, Inf]
            @test isnai(interval(Arb(-Inf), Arb(-Inf)))
            @test isnai(interval(-Inf, Arb(-Inf)))
            @test isnai(interval(Arb(-Inf), -Inf))
            @test isnai(interval(setball(Arb, -Inf, 1), Arb(-Inf)))
            @test isnai(interval(Arb(-Inf), setball(Arb, -Inf, 1)))
            @test isnai(interval(Arb(Inf), Arb(Inf)))
            @test isnai(interval(Inf, Arb(Inf)))
            @test isnai(interval(Arb(Inf), Inf))
            @test isnai(interval(setball(Arb, Inf, 1), Arb(Inf)))
            @test isnai(interval(Arb(Inf), setball(Arb, Inf, 1)))

            # With NaN
            @test isnai(interval(Arb(NaN), 0))
            @test isnai(interval(setball(Arb, NaN, Inf), 0))
            @test isnai(interval(Arb(NaN), -Inf))
            @test isnai(interval(Arb(NaN), Inf))
            @test isnai(interval(0, Arb(NaN)))
            @test isnai(interval(0, setball(Arb, NaN, Inf)))
            @test isnai(interval(-Inf, Arb(NaN)))
            @test isnai(interval(Inf, Arb(NaN)))

            # A few tests to check that :midpoint constructor seems ok
            @test isequal_interval(
                interval(setball(Arb, 0, 1), format = :midpoint),
                interval(-1, 1),
            )
            @test isequal_interval(
                interval(setball(Arb, 0, 1), setball(Arb, 4, 1), format = :midpoint),
                interval(-6, 6),
            )
            @test_throws DomainError interval(0, Arb((-1, 1)), format = :midpoint)
        end

        @testset "Complex intervals" begin
            @test isequal_interval(
                interval(1 + 2im, 3 + 4im),
                interval(Acb(setball(Arb, 2, 1), setball(Arb, 3, 1))),
            )
            @test isequal_interval(
                interval(Float64, 1 + 2im, 3 + 4im),
                interval(Acb(setball(Arb, 2, 1), setball(Arb, 3, 1))),
            )

            @test isequal_interval(
                interval(1 + 2im, 3 + 4im),
                interval(Acb(1, 2), Acb(3, 4)),
            )

            @test isequal_interval(interval(1 + 2im, 3 + 4im), interval(Acb(1, 2), 3 + 4im))
            @test isequal_interval(interval(1 - 2im, 3), interval(Acb(1, -2), 3))
            @test isequal_interval(
                interval(1 - 2im, 3),
                interval(Acb(1, -2), interval(3, 3)),
            )

            @test isequal_interval(interval(1 + 2im, 3 + 4im), interval(1 + 2im, Acb(3, 4)))
            @test isequal_interval(interval(1, 3 + 2im), interval(1, Acb(3, 2)))
            @test isequal_interval(interval(1, 3 + 2im), interval(interval(1), Acb(3, 2)))
        end

        @testset "convert" begin
            @test isguaranteed(convert(Interval{Float64}, Arb(1)))
            @test isguaranteed(convert(Interval{Float64}, Acb(1)))
            @test_throws DomainError convert(Interval{Float64}, Acb(1, 1))

            @test isguaranteed(convert(Complex{Interval{Float64}}, Arb(1)))
            @test isguaranteed(convert(Complex{Interval{Float64}}, Acb(1)))
            @test isguaranteed(convert(Complex{Interval{Float64}}, Acb(1, 1)))
        end
    end

    @testset "Arb from Interval" begin
        # Check constructor
        @test isequal(Arb((0, 1)), Arb(interval(0, 1)))
        @test isequal(setball(Arb, NaN, Inf), Arb(nai(Float64)))
        @test Arblib.overlaps(Arb(π), Arb(interval(π)))
        @test Arblib.overlaps(Arb(π), Arb(interval(BigFloat, π)))
        @test isequal(Arblib.indeterminate!(Arb()), Arb(emptyinterval()))
        @test isequal(Acb(1, 2), Acb(interval(1 + 2im)))

        # Check Arblib.set!
        @test isequal(Arb((0, 1)), Arblib.set!(Arb(), interval(0, 1)))
        @test isequal(setball(Arb, NaN, Inf), Arblib.set!(Arb(), nai(Float64)))
        @test isequal(Arb(interval(π)), Arblib.set!(Arb(), interval(π)))
        @test isequal(Arb(interval(BigFloat, π)), Arblib.set!(Arb(), interval(BigFloat, π)))
        @test isequal(Arblib.indeterminate!(Arb()), Arblib.set!(Arb(), emptyinterval()))
        @test isequal(Acb(1, 2), Arblib.set!(Acb(), interval(1 + 2im)))
        # Check that prec argument works
        @test Arblib.contains_interior(
            Arblib.set!(Arb(), interval(BigFloat, π), prec = 64),
            Arb(interval(BigFloat, π)),
        )

        # Check _precision
        # One argument
        @test Arblib._precision(interval(1, 2)) == precision(Arb)
        @test Arblib._precision(interval(BigFloat, BigFloat(1, precision = 80))) == 80
        @test Arblib._precision(
            interval(BigFloat, BigFloat(1, precision = 80), BigFloat(1, precision = 64)),
        ) == 80
        @test Arblib._precision(
            interval(BigFloat, BigFloat(1, precision = 64), BigFloat(1, precision = 80)),
        ) == 80

        # Check that precision is preserved
        @test precision(
            Arb(interval(BigFloat(1, precision = 80), BigFloat(2, precision = 64))),
        ) == 80
        @test precision(Arb(interval(Arf(0, prec = 64), Arf(1, prec = 80)))) == 80
    end

    # Check that the ambiguity related changes actually work
    @testset "ExactReal" begin
        @test Arblib.Mag(exact(5)) == Arblib.Mag(5)
        @test Arf(exact(5)) == Arf(5)
        @test Arb(exact(5)) == Arb(5)

        @test promote_type(Arf, ExactReal{Float64}) == Arf
        @test promote_type(ArfRef, ExactReal{Float64}) == Arf
        @test promote_type(ExactReal{Float64}, Arf) == Arf
        @test promote_type(ExactReal{Float64}, ArfRef) == Arf

        @test promote_type(Arb, ExactReal{Float64}) == Arb
        @test promote_type(ArbRef, ExactReal{Float64}) == Arb
        @test promote_type(ExactReal{Float64}, Arb) == Arb
        @test promote_type(ExactReal{Float64}, ArbRef) == Arb
    end
end

@testset "Interval" begin
    x = emptyinterval()
    @test all(isequal_interval.(bisect(x), (x, x)))

    x = I"0.1"
    @test isatomic(x)
    @test all(isequal_interval.(bisect(x), (x, emptyinterval())))

    x = interval(0, 1)
    @test all(isequal_interval.( bisect(x, 0.5),  (interval(0, 0.5),          interval(0.5, 1)         ) ))
    @test all(isequal_interval.( bisect(x, 0.25), (interval(0, 0.25),         interval(0.25, 1)        ) ))
    @test all(isequal_interval.( bisect(x),       (interval(0.0, 0.5), interval(0.5, 1.0)) ))

    x = interval(-Inf, Inf)
    @test all(isequal_interval.( bisect(x, 0.5), (interval(-Inf, 0), interval(0, Inf)) ))
    y = bisect(x, nextfloat(0.5))
    @test sup(y[1]) == inf(y[2]) > 0
    y = bisect(x, prevfloat(0.5))
    @test sup(y[1]) == inf(y[2]) < 0
end

module Symbols

    using IntervalArithmetic
    export .., ±, ≛, ⊑, ⋤, ⪽, ⪯, ≺, ⊓, ⊔, ∅, ℝ

"""
    ..(a, b)
    a .. b

Create the interval ``[a, b]`` according to the IEEE Standard 1788-2015. This is
semantically equivalent to [`interval(a, b)`](@ref).

!!! danger
    Nothing is done to compensate for the fact that floating point literals are
    rounded to the nearest when parsed (e.g. `0.1`). In such cases, parse the
    string containing the desired value to ensure its tight enclosure.

See also: [`interval`](@ref), [`±`](@ref) and [`@I_str`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> using IntervalArithmetic.Symbols

julia> setdisplay(:full);

julia> (1//1)..π
Interval{Rational{Int64}}(1//1, 85563208//27235615, com, true)

julia> 0.1..0.3
Interval{Float64}(0.1, 0.3, com, true)
```
"""
..(a, b) = interval(a, b; format = :infsup)

"""
    ±(m, r)
    m ± r

Create the interval ``[m - r, m + r]`` according to the IEEE Standard 1788-2015.
Despite using the midpoint-radius notation, the returned interval is still an
[`Interval`](@ref) represented by its bounds.

!!! danger
    Nothing is done to compensate for the fact that floating point literals are
    rounded to the nearest when parsed (e.g. `0.1`). In such cases, parse the
    string containing the desired value to ensure its tight enclosure.

See also: [`interval`](@ref), [`..`](@ref) and [`@I_str`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> using IntervalArithmetic.Symbols

julia> setdisplay(:full);

julia> 0 ± π
Interval{Float64}(-3.1415926535897936, 3.1415926535897936, com, true)

julia> 0//1 ± π
Interval{Rational{Int64}}(-85563208//27235615, 85563208//27235615, com, true)
```
"""
±(m, r) = interval(m, r; format = :midpoint)

"""
    ≛(x, y)
    x ≛ y

Unicode alias of [`isequal_interval`](@ref).
"""
const ≛ = isequal_interval

"""
    ⊑(x, y)
    x ⊑ y

Unicode alias of [`issubset_interval`](@ref).
"""
const ⊑ = issubset_interval

"""
    ⋤(x, y)
    x ⋤ y

Unicode alias of [`isstrictsubset`](@ref).
"""
const ⋤ = isstrictsubset

"""
    ⪽(x, y)
    x ⪽ y

Unicode alias of [`isinterior`](@ref).
"""
const ⪽ = isinterior

"""
    ⪯(x, y)
    x ⪯ y

Unicode alias of [`precedes`](@ref).
"""
const ⪯ = precedes

"""
    ≺(x, y)
    x ≺ y

Unicode alias of [`strictprecedes`](@ref).
"""
const ≺ = strictprecedes

"""
    ⊔(x, y)
    x ⊔ y

Unicode alias of [`hull`](@ref).
"""
const ⊔ = hull

"""
    ⊓(x, y)
    x ⊓ y

Unicode alias of [`intersect_interval`](@ref).
"""
const ⊓ = intersect_interval

"""
    ∅

Unicode alias of `emptyinterval()` representing an empty interval of default
flavor and default bound type.

See also: [`emptyinterval`](@ref).
"""
const ∅ = emptyinterval()

"""
    ℝ

Unicode alias of `entireinterval()` representing an entire interval of default
flavor and default bound type.

See also: [`entireinterval`](@ref).
"""
const ℝ = entireinterval()

end

mutable struct DisplayOptions
    format      :: Symbol
    decorations :: Bool
    ng_flag     :: Bool
    sigdigits   :: Int
end

function Base.show(io::IO, ::MIME"text/plain", params::DisplayOptions)
    println(io, "Display options:")
    println(io, "  - format: ", params.format)
    if params.format === :full
        println(io, "  - decorations: ", params.decorations, " (ignored)")
        println(io, "  - NG flag: ", params.ng_flag, " (ignored)")
        print(io, "  - significant digits: ", params.sigdigits, " (ignored)")
    else
        println(io, "  - decorations: ", params.decorations)
        println(io, "  - NG flag: ", params.ng_flag)
        print(io, "  - significant digits: ", params.sigdigits)
    end
end

const display_options = DisplayOptions(:infsup, true, true, 6) # default

"""
    setdisplay(format::Symbol; decorations::Bool, ng_flag::Bool, sigdigits::Int)

Change the format used by `show` to display intervals.

Possible options:
- `format` can be:
    - `:infsup`: display intervals as `[a, b]`.
    - `:midpoint`: display intervals as `m ± r`.
    - `:full`: display interval bounds entirely, ignoring `sigdigits`.
- `decorations`: display the decorations or not.
- `ng_flag`: display the NG flag or not.
- `sigdigits`: number (greater or equal to 1) of significant digits to display.

Initially, the display options are set to
`setdisplay(:infsup; decorations = true, ng_flag = true, sigdigits = 6)`. If any
of `format`, `decorations`, `ng_flag` and `sigdigits` is omitted, then their
value is left unchanged.

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full)
Display options:
  - format: full
  - decorations: true (ignored)
  - NG flag: true (ignored)
  - significant digits: 6 (ignored)

julia> x = interval(0.1, 0.3)
Interval{Float64}(0.1, 0.3, com, true)

julia> setdisplay(:infsup; sigdigits = 3)
Display options:
  - format: infsup
  - decorations: true
  - NG flag: true
  - significant digits: 3

julia> x
[0.1, 0.3]_com

julia> setdisplay(; decorations = false)
Display options:
  - format: infsup
  - decorations: false
  - NG flag: true
  - significant digits: 3

julia> x
[0.1, 0.3]

julia> setdisplay(:infsup; decorations = true, ng_flag = true, sigdigits = 6) # default display options
Display options:
  - format: infsup
  - decorations: true
  - NG flag: true
  - significant digits: 6

julia> x
[0.1, 0.3]_com
```
"""
function setdisplay(format::Symbol = display_options.format;
        decorations::Bool = display_options.decorations,
        ng_flag::Bool = display_options.ng_flag,
        sigdigits::Int = display_options.sigdigits)

    format ∉ (:infsup, :midpoint, :full) && return throw(ArgumentError("`format` must be `:infsup`, `:midpoint` or `:full`"))
    sigdigits < 1 && return throw(ArgumentError("`sigdigits` must be `≥ 1`"))

    display_options.format = format
    display_options.decorations = decorations
    display_options.ng_flag = ng_flag
    display_options.sigdigits = sigdigits

    return display_options
end

# printing mechanism

Base.show(io::IO, a::Union{BareInterval,Interval,Complex{<:Interval}}) =
    print(io, _str_repr(a, display_options.format))

Base.show(io::IO, ::MIME"text/plain", a::Union{BareInterval,Interval,Complex{<:Interval}}) =
    print(io, _str_repr(a, display_options.format))

# `String` representation

function _str_repr(a::BareInterval{T}, format::Symbol) where {T<:NumTypes}
    # `format` is either `:infsup`, `:midpoint` or `:full`
    str_interval = _str_basic_repr(a, format)
    ((format === :full) & (str_interval != "∅")) && return string("BareInterval{", T, "}(", str_interval, ')')
    return _str_precision(str_interval, a, format)
end

function _str_repr(a::Interval{T}, format::Symbol) where {T<:NumTypes}
    isnai(a) && return "NaI"

    # `format` is either `:infsup`, `:midpoint` or `:full`
    str_interval = _str_basic_repr(a.bareinterval, format) # use `a.bareinterval` to not print a warning if `a` is an NaI
    if format === :full && str_interval != "∅"
        return string("Interval{", T, "}(", str_interval, ", ", decoration(a), ", ", isguaranteed(a), ')')
    else
        str_interval = _str_precision(str_interval, a, format)
        if format === :midpoint && str_interval != "∅" && T !== BigFloat && (display_options.decorations | (display_options.ng_flag & !isguaranteed(a)))
            str_interval = string('(', str_interval, ')')
        end
        str_interval = ifelse(display_options.decorations, string(str_interval, '_', decoration(a)), str_interval)
        return ifelse(display_options.ng_flag & !isguaranteed(a), string(str_interval, "_NG"), str_interval)
    end
end

function _str_repr(x::Complex{Interval{T}}, format::Symbol) where {T<:NumTypes}
    # `format` is either `:infsup`, `:midpoint` or `:full`
    str_imag = _str_repr(imag(x), format)
    if format === :full
        if !isthinzero(imag(x)) && sup(imag(x)) ≤ 0 && !isempty_interval(imag(x))
            c1, c2 = split(str_imag, ", "; limit = 2)
            l = findfirst('-', c1)
            ll = ifelse(occursin(',', c2), findfirst(',', c2), findfirst(')', c2))
            return string(_str_repr(real(x), format), " - im*", view(c1, 1:l-1), view(c2, 1+!iszero(sup(imag(x))):ll-1), ", ", view(c1, l+1:lastindex(c1)), view(c2, ll:lastindex(c2)))
        else
            return string(_str_repr(real(x), format), " + im*", str_imag)
        end
    elseif format === :midpoint
        str_real = _str_repr(real(x), format)
        if !startswith(str_real, '(')
            str_real = string('(', str_real, ')')
        end
        if !startswith(str_imag, '(')
            str_imag = string('(', str_imag, ')')
        end
        startswith(str_imag, "(-") && return string(str_real, " - im*(", view(str_imag, 3:lastindex(str_imag)))
        return string(str_real, " + im*", str_imag)
    else
        if !isthinzero(imag(x)) && sup(imag(x)) ≤ 0 && !isempty_interval(imag(x))
            c1, c2 = split(str_imag, ", ")
            l = findfirst(t -> (t == ']') | (t == ')'), c2)
            return string(_str_repr(real(x), format), " - im*", _flipl(c2[l]), view(c2, 1+!iszero(sup(imag(x))):l-1), ", ", view(c1, 3:lastindex(c1)), _flipr(c1[1]), view(c2, l+1:lastindex(c2)))
        else
            return string(_str_repr(real(x), format), " + im*", str_imag)
        end
    end
end

_flipl(char) = ifelse(char == ']', '[', '(')
_flipr(char) = ifelse(char == '[', ']', ')')

#

_str_precision(str_interval, x, format) = str_interval

function _str_precision(str_interval, x::Union{BareInterval{BigFloat},Interval{BigFloat}}, format)
    plo = precision(inf(x))
    phi = precision(sup(x))
    pstr = _subscriptify(plo)
    if format === :midpoint && str_interval != "∅"
        str_interval = string('(', str_interval, ')')
    end
    str_interval = string(str_interval, pstr)
    return ifelse(plo == phi, str_interval, string(str_interval, '_', _subscriptify(phi)))
end

#

function _str_basic_repr(a::BareInterval{<:AbstractFloat}, format::Symbol)
    # `format` is either `:infsup`, `:midpoint` or `:full`
    isempty_interval(a) && return "∅"
    lo, hi = bounds(a) # do not use `inf(a)` to avoid `-0.0`
    sigdigits = display_options.sigdigits
    if format === :full
        str_lo = string(lo)
        # str_lo = ifelse(lo ≥ 0, string('+', str_lo), str_lo)
        str_hi = string(hi)
        # str_hi = ifelse(hi ≥ 0, string('+', str_hi), str_hi)
        return string(str_lo, ", ", str_hi)
    elseif format === :midpoint
        m_d, r_d = _display_midpoint_radius(a, sigdigits)
        str_m = _round_string(m_d, sigdigits)
        # str_m = ifelse(m_d ≥ 0, string('+', str_m), str_m)
        output = string(str_m, " ± ", _round_string(r_d, sigdigits))
        return replace(output, "Inf" => '∞')
    else
        str_lo = _round_string(lo, sigdigits, RoundDown)
        # str_lo = ifelse(lo ≥ 0, string('+', str_lo), str_lo)
        str_hi = _round_string(hi, sigdigits, RoundUp)
        # str_hi = ifelse(hi ≥ 0, string('+', str_hi), str_hi)
        output = string('[', str_lo, ", ", str_hi, ']')
        return replace(output, "Inf]" => "∞)", "[-Inf" => "(-∞")
    end
end

function _str_basic_repr(a::BareInterval{Float32}, format::Symbol)
    # `format` is either `:infsup`, `:midpoint` or `:full`
    isempty_interval(a) && return "∅"
    lo, hi = bounds(a) # do not use `inf(a)` to avoid `-0.0`
    sigdigits = display_options.sigdigits
    if format === :full
        str_lo = string(lo)
        str_lo = replace(string(str_lo, "f0"), "NaNf0" => "NaN32", "Inff0" => "Inf32")
        if contains(str_lo, 'e')
            str_lo = replace(str_lo, 'e' => 'f', "f0" => "")
        end
        # str_lo = ifelse(lo ≥ 0, string('+', str_lo), str_lo)
        str_hi = string(hi)
        str_hi = replace(string(str_hi, "f0"), "NaNf0" => "NaN32", "Inff0" => "Inf32")
        if contains(str_hi, 'e')
            str_hi = replace(str_hi, 'e' => 'f', "f0" => "")
        end
        # str_hi = ifelse(hi ≥ 0, string('+', str_hi), str_hi)
        return string(str_lo, ", ", str_hi)
    elseif format === :midpoint
        m_d, r_d = _display_midpoint_radius(a, sigdigits)
        str_m = _round_string(m_d, sigdigits)
        str_m = replace(string(str_m, "f0"), "NaNf0" => "NaN32", "Inff0" => "Inf32")
        if contains(str_m, 'e')
            str_m = replace(str_m, 'e' => 'f', "f0" => "")
        end
        # str_m = ifelse(m_d ≥ 0, string('+', str_m), str_m)
        str_r = _round_string(r_d, sigdigits)
        str_r = replace(string(str_r, "f0"), "NaNf0" => "NaN32", "Inff0" => "Inf32")
        if contains(str_r, 'e')
            str_r = replace(str_r, 'e' => 'f', "f0" => "")
        end
        return string(str_m, " ± ", str_r)
    else
        str_lo = _round_string(lo, sigdigits, RoundDown)
        str_lo = replace(string('[', str_lo, "f0"), "NaNf0" => "NaN32", "[-Inff0" => "(-∞")
        if contains(str_lo, 'e')
            str_lo = replace(str_lo, 'e' => 'f', "f0" => "")
        end
        # str_lo = ifelse(lo ≥ 0, string('+', str_lo), str_lo)
        str_hi = _round_string(hi, sigdigits, RoundUp)
        str_hi = replace(string(str_hi, "f0]"), "NaNf0" => "NaN32", "Inff0]" => "∞)")
        if contains(str_hi, 'e')
            str_hi = replace(str_hi, 'e' => 'f', "f0" => "")
        end
        # str_hi = ifelse(hi ≥ 0, string('+', str_hi), str_hi)
        return string(str_lo, ", ", str_hi)
    end
end

function _str_basic_repr(a::BareInterval{Float16}, format::Symbol)
    # `format` is either `:infsup`, `:midpoint` or `:full`
    isempty_interval(a) && return "∅"
    lo, hi = bounds(a) # do not use `inf(a)` to avoid `-0.0`
    sigdigits = display_options.sigdigits
    if format === :full
        str_lo = string(lo)
        # str_lo = ifelse(lo ≥ 0, string('+', str_lo), str_lo)
        str_hi = string(hi)
        # str_hi = ifelse(hi ≥ 0, string('+', str_hi), str_hi)
        output = string("Float16(", str_lo, "), Float16(", str_hi, ')')
        return replace(output, "Float16(NaN)" => "NaN16", "Float16(-Inf)" => "-Inf16", "Float16(Inf)" => "Inf16")
    elseif format === :midpoint
        m_d, r_d = _display_midpoint_radius(a, sigdigits)
        str_m = _round_string(m_d, sigdigits)
        # str_m = ifelse(m_d ≥ 0, string('+', str_m), str_m)
        output = string("Float16(", str_m, ") ± Float16(", _round_string(r_d, sigdigits), ')')
        return replace(output, "Float16(NaN)" => "NaN16", "Float16(Inf)" => '∞')
    else
        str_lo = _round_string(lo, sigdigits, RoundDown)
        # str_lo = ifelse(lo ≥ 0, string('+', str_lo), str_lo)
        str_hi = _round_string(hi, sigdigits, RoundUp)
        # str_hi = ifelse(hi ≥ 0, string('+', str_hi), str_hi)
        output = string("[Float16(", str_lo, "), Float16(", str_hi, ")]")
        return replace(output, "Float16(NaN)" => "NaN16", "[Float16(-Inf)" => "(-∞", "Float16(Inf)]" => "∞)")
    end
end

function _str_basic_repr(a::BareInterval{<:Rational}, format::Symbol)
    # `format` is either `:infsup`, `:midpoint` or `:full`
    isempty_interval(a) && return "∅"
    if format === :midpoint
        m = mid(a)
        str_m = string(m)
        # str_m = ifelse(m ≥ 0, string('+', str_m), str_m)
        output = string(str_m, " ± ", radius(a))
        return replace(output, "1//0" => '∞')
    else
        lo, hi = bounds(a) # do not use `inf(a)` to avoid `-0.0`
        str_lo = string(lo)
        # str_lo = ifelse(lo ≥ 0, string('+', str_lo), str_lo)
        str_hi = string(hi)
        # str_hi = ifelse(hi ≥ 0, string('+', str_hi), str_hi)
        output = string(str_lo, ", ", str_hi)
        format === :full && return output
        output = string('[', output, ']')
        return replace(output, "1//0]" => "∞)", "[-1//0" => "(-∞")
    end
end

# truncate to the prescribed significant digits

function _round_string(x::AbstractFloat, sigdigits::Int)
    !isfinite(x) && return string(x)
    max_sig_digits = _count_sigdigits(string(x)) # cap, e.g. `0.1` gives `"0.1"` rather than expanding
    ndigits = min(sigdigits, max_sig_digits)
    str = Printf.@sprintf("%.*g", ndigits, x) # round to nearest, no-op if 3-arg `_round_string` was called before
    occursin(r"[eE]", str) && return replace(str, r"^([+-]?\d+)(?=[eE])" => s"\1.0", r"([eE][+-])0+(\d+)" => s"\1\2")
    !occursin(r"\.", str) && return str * ".0"
    return str
end

_round_string(x::AbstractFloat, sigdigits::Int, mode::RoundingMode) =
    _round_string(round(x, mode; sigdigits = sigdigits), sigdigits)

_count_sigdigits(s::AbstractString) = length(replace(split(s, r"[eE]")[1], '-' => "", '.' => "", r"^0+" => ""))

# compute display values `(m_d, r_d)` for the midpoint format such that
# `[m_d - r_d, m_d + r_d]` encloses the original interval, both rounded to
# `sigdigits` significant digits (`RoundNearest` for `m_d`, `RoundUp` for `r_d`)

function _display_midpoint_radius(a::BareInterval{<:AbstractFloat}, sigdigits::Int)
    m = mid(a)
    r = radius(a)
    isfinite(m) || return m, r
    m_d = round(m, RoundNearest; sigdigits = sigdigits)
    isfinite(r) || return m_d, r
    if m_d == m
        r_d = round(r, RoundUp; sigdigits = sigdigits)
    else
        lo, hi = bounds(a)
        diff_hi = sup(bareinterval(hi) - bareinterval(m_d))
        diff_lo = sup(bareinterval(m_d) - bareinterval(lo))
        r_required = max(diff_hi, diff_lo)
        r_d = ifelse(isfinite(r_required), round(r_required, RoundUp; sigdigits = sigdigits), r_required)
    end
    return m_d, r_d
end

#

function _subscriptify(n::Integer)
    if 0 ≤ n ≤ 9
        return _subscript_digit(n)
    else
        len = ndigits(n)
        x = Vector{Char}(undef, len)
        i = 0
        while n > 0
            n, d = divrem(n, 10)
            x[len-i] = _subscript_digit(d)
            i += 1
        end
        return join(x)
    end
end

function _subscript_digit(i::Integer)
    i == 0 && return '₀'
    i == 1 && return '₁'
    i == 2 && return '₂'
    i == 3 && return '₃'
    i == 4 && return '₄'
    i == 5 && return '₅'
    i == 6 && return '₆'
    i == 7 && return '₇'
    i == 8 && return '₈'
    return '₉'
end

# This file contains the `overlap` function required for set-based flavor in
# Section 10.6.4 of the IEEE Standard 1788-2015

"""
    Overlap

Module containing the enumeration constant `State` described in Section 10.6.4
of the IEEE Standard 1788-2015.
"""
module Overlap
    @enum State begin
        both_empty = 1
        first_empty
        second_empty
        before
        meets
        overlaps
        starts
        contained_by
        finishes
        equals
        finished_by
        contains
        started_by
        overlapped_by
        met_by
        after
    end
end

"""
    overlap(x::BareInterval, y::BareInterval)
    overlap(x::Interval, y::Interval)

Implement the `overlap` function of the IEEE Standard 1788-2015 (Table 10.7).
"""
function overlap(x::BareInterval, y::BareInterval)
    # at least one interval is empty
    isempty_interval(x) & isempty_interval(y) && return Overlap.both_empty
    isempty_interval(x) && return Overlap.first_empty
    isempty_interval(y) && return Overlap.second_empty

    # states with both intervals non-empty
    sup(x) < inf(y) && return Overlap.before
    (inf(x) != sup(x)) & (inf(y) != sup(y)) & (sup(x) == inf(y)) && return Overlap.meets
    (inf(x) < inf(y)) & (sup(x) < sup(y)) & (sup(x) > inf(y)) && return Overlap.overlaps
    (inf(x) == inf(y)) & (sup(x) < sup(y)) && return Overlap.starts
    (inf(y) < inf(x)) & (sup(x) < sup(y)) && return Overlap.contained_by
    (inf(y) < inf(x)) & (sup(x) == sup(y)) && return Overlap.finishes
    isequal_interval(x, y) && return Overlap.equals
    (inf(x) < inf(y)) & (sup(x) == sup(y)) && return Overlap.finished_by
    (inf(y) > inf(x)) & (sup(x) > sup(y)) && return Overlap.contains
    (inf(x) == inf(y)) & (sup(x) > sup(y)) && return Overlap.started_by
    (inf(x) > inf(y)) & (sup(x) > sup(y)) & (inf(x) < sup(y)) && return Overlap.overlapped_by
    (inf(x) != sup(x)) & (inf(y) != sup(y)) & (inf(x) == sup(y)) && return Overlap.met_by
    (sup(y) < sup(x)) && return Overlap.after
end

function overlap(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return throw(ArgumentError("overlap is not defined for NaI"))
    return overlap(bareinterval(x), bareinterval(y))
end

@testset "minimal_nums_to_interval_test" begin

    @test bareinterval(-1.0,1.0) === bareinterval(-1.0,1.0)

    @test bareinterval(-Inf,1.0) === bareinterval(-Inf,1.0)

    @test bareinterval(-1.0,Inf) === bareinterval(-1.0,Inf)

    @test bareinterval(-Inf,Inf) === bareinterval(-Inf,Inf)

    @test_logs (:warn,) @test bareinterval(NaN,NaN) === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test bareinterval(1.0,-1.0) === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test bareinterval(-Inf,-Inf) === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test bareinterval(Inf,Inf) === emptyinterval(BareInterval{Float64})

end

@testset "minimal_nums_to_decorated_interval_test" begin

    @test interval(-1.0,1.0) === interval(bareinterval(-1.0,1.0), com)

    @test interval(-Inf,1.0) === interval(bareinterval(-Inf,1.0), dac)

    @test interval(-1.0,Inf) === interval(bareinterval(-1.0,Inf), dac)

    @test interval(-Inf,Inf) === interval(bareinterval(-Inf,Inf), dac)

    @test_logs (:warn,) @test interval(NaN,NaN) === nai(Interval{Float64})

    @test_logs (:warn,) @test interval(1.0,-1.0) === nai(Interval{Float64})

    @test_logs (:warn,) @test interval(-Inf,-Inf) === nai(Interval{Float64})

    @test_logs (:warn,) @test interval(Inf,Inf) === nai(Interval{Float64})

end

@testset "minimal_text_to_interval_test" begin

    @test parse(BareInterval{Float64}, "[ Empty  ]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ Empty  ]_trv") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[  ]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[  ]_trv") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[,]") === bareinterval(-Inf,Inf)

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[,]_trv") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[ entire  ]") === bareinterval(-Inf,Inf)

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ ENTIRE ]_dac") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[ ENTIRE ]") === bareinterval(-Inf,Inf)

    @test parse(BareInterval{Float64}, "[ -inf , INF  ]") === bareinterval(-Inf,Inf)

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ -inf, INF ]_def") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[-1.0,1.0]") === bareinterval(-1.0,1.0)

    @test parse(BareInterval{Float64}, "[  -1.0  ,  1.0  ]") === bareinterval(-1.0,1.0)

    @test parse(BareInterval{Float64}, "[  -1.0  , 1.0]") === bareinterval(-1.0,1.0)

    @test parse(BareInterval{Float64}, "[-1,]") === bareinterval(-1.0,Inf)

    @test parse(BareInterval{Float64}, "[-1.0, +inf]") === bareinterval(-1.0,Inf)

    @test parse(BareInterval{Float64}, "[-1.0, +infinity]") === bareinterval(-1.0,Inf)

    @test parse(BareInterval{Float64}, "[-Inf, 1.000 ]") === bareinterval(-Inf,1.0)

    @test parse(BareInterval{Float64}, "[-Infinity, 1.000 ]") === bareinterval(-Inf,1.0)

    @test parse(BareInterval{Float64}, "[1.0E+400 ]") === bareinterval(0x1.fffffffffffffp+1023,Inf)

    @test parse(BareInterval{Float64}, "[ -4/2, 10/5 ]") === bareinterval(-2.0,2.0)

    @test parse(BareInterval{Float64}, "[ -1/10, 1/10 ]") === bareinterval(-0.1,0.1)

    @test parse(BareInterval{Float64}, "0.0?") === bareinterval(-0.05,0.05)

    @test parse(BareInterval{Float64}, "0.0?u") === bareinterval(0.0,0.05)

    @test parse(BareInterval{Float64}, "0.0?d") === bareinterval(-0.05,0.0)

    @test parse(BareInterval{Float64}, "2.5?") === bareinterval(0x1.3999999999999p+1,0x1.4666666666667p+1)

    @test parse(BareInterval{Float64}, "2.5?u") === bareinterval(2.5,0x1.4666666666667p+1)

    @test parse(BareInterval{Float64}, "2.5?d") === bareinterval(0x1.3999999999999p+1,2.5)

    @test parse(BareInterval{Float64}, "0.000?5") === bareinterval(-0.005,0.005)

    @test parse(BareInterval{Float64}, "0.000?5u") === bareinterval(0.0,0.005)

    @test parse(BareInterval{Float64}, "0.000?5d") === bareinterval(-0.005,0.0)

    @test parse(BareInterval{Float64}, "2.500?5") === bareinterval(0x1.3f5c28f5c28f5p+1,0x1.40a3d70a3d70bp+1)

    @test parse(BareInterval{Float64}, "2.500?5u") === bareinterval(2.5,0x1.40a3d70a3d70bp+1)

    @test parse(BareInterval{Float64}, "2.500?5d") === bareinterval(0x1.3f5c28f5c28f5p+1,2.5)

    @test parse(BareInterval{Float64}, "0.0??") === bareinterval(-Inf,Inf)

    @test parse(BareInterval{Float64}, "0.0??u") === bareinterval(0.0,Inf)

    @test parse(BareInterval{Float64}, "0.0??d") === bareinterval(-Inf,0.0)

    @test parse(BareInterval{Float64}, "2.5??") === bareinterval(-Inf,Inf)

    @test parse(BareInterval{Float64}, "2.5??u") === bareinterval(2.5,Inf)

    @test parse(BareInterval{Float64}, "2.5??d") === bareinterval(-Inf,2.5)

    @test parse(BareInterval{Float64}, "2.500?5e+27") === bareinterval(0x1.01fa19a08fe7fp+91,0x1.0302cc4352683p+91)

    @test parse(BareInterval{Float64}, "2.500?5ue4") === bareinterval(0x1.86ap+14,0x1.8768p+14)

    @test parse(BareInterval{Float64}, "2.500?5de-5") === bareinterval(0x1.a2976f1cee4d5p-16,0x1.a36e2eb1c432dp-16)

    @test parse(BareInterval{Float64}, "10?3") === bareinterval(7.0,13.0)

    @test parse(BareInterval{Float64}, "10?3e380") === bareinterval(0x1.fffffffffffffp+1023,Inf)

    @test parse(BareInterval{Float64}, "1.0000000000000001?1") === bareinterval(1.0,0x1.0000000000001p+0)

    @test parse(BareInterval{Float64}, "10?1800000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000") === bareinterval(-Inf,Inf)

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ Nai  ]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ Nai  ]_ill") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ Nai  ]_trv") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ Empty  ]_ill") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[  ]_com") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[,]_com") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[   Entire ]_com") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ -inf ,  INF ]_com") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[  -1.0  , 1.0]_ill") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[  -1.0  , 1.0]_fooo") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[  -1.0  , 1.0]_da") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[-1.0,]_com") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[-Inf, 1.000 ]_ill") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[-I  nf, 1.000 ]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[-Inf, 1.0  00 ]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[-Inf ]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[Inf , INF]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[ foo ]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[1.0000000000000002,1.0000000000000001]") === bareinterval(1.0,0x1.0000000000001p+0)

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[10000000000000001/10000000000000000,10000000000000002/10000000000000001]") === bareinterval(1.0,0x1.0000000000001p+0)

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[0x1.00000000000002p0,0x1.00000000000001p0]") === bareinterval(1.0,0x1.0000000000001p+0)

end

@testset "minimal_text_to_decorated_interval_test" begin

    @test parse(Interval{Float64}, "[ Empty  ]") === interval(emptyinterval(BareInterval{Float64}), trv)

    @test parse(Interval{Float64}, "[ Empty  ]_trv") === interval(emptyinterval(BareInterval{Float64}), trv)

    @test parse(Interval{Float64}, "[  ]") === interval(emptyinterval(BareInterval{Float64}), trv)

    @test parse(Interval{Float64}, "[  ]_trv") === interval(emptyinterval(BareInterval{Float64}), trv)

    @test parse(Interval{Float64}, "[,]") === interval(entireinterval(BareInterval{Float64}), dac)

    @test parse(Interval{Float64}, "[,]_trv") === interval(entireinterval(BareInterval{Float64}), trv)

    @test parse(Interval{Float64}, "[ entire  ]") === interval(entireinterval(BareInterval{Float64}), dac)

    @test parse(Interval{Float64}, "[ ENTIRE ]_dac") === interval(entireinterval(BareInterval{Float64}), dac)

    @test parse(Interval{Float64}, "[ -inf , INF  ]") === interval(entireinterval(BareInterval{Float64}), dac)

    @test parse(Interval{Float64}, "[ -inf, INF ]_def") === interval(entireinterval(BareInterval{Float64}), def)

    @test parse(Interval{Float64}, "[-1.0,1.0]") === interval(bareinterval(-1.0,1.0), com)

    @test parse(Interval{Float64}, "[  -1.0  ,  1.0  ]_com") === interval(bareinterval(-1.0,1.0), com)

    @test parse(Interval{Float64}, "[  -1.0  , 1.0]_trv") === interval(bareinterval(-1.0,1.0), trv)

    @test parse(Interval{Float64}, "[-1,]") === interval(bareinterval(-1.0,Inf), dac)

    @test parse(Interval{Float64}, "[-1.0, +inf]_def") === interval(bareinterval(-1.0,Inf), def)

    @test parse(Interval{Float64}, "[-1.0, +infinity]_def") === interval(bareinterval(-1.0,Inf), def)

    @test parse(Interval{Float64}, "[-Inf, 1.000 ]") === interval(bareinterval(-Inf,1.0), dac)

    @test parse(Interval{Float64}, "[-Infinity, 1.000 ]_trv") === interval(bareinterval(-Inf,1.0), trv)

    @test parse(Interval{Float64}, "[1.0E+400 ]_com") === interval(bareinterval(0x1.fffffffffffffp+1023,Inf), dac)

    @test parse(Interval{Float64}, "[ -4/2, 10/5 ]_com") === interval(bareinterval(-2.0,2.0), com)

    @test parse(Interval{Float64}, "[ -1/10, 1/10 ]_com") === interval(bareinterval(-0.1,0.1), com)

    @test parse(Interval{Float64}, "0.0?") === interval(bareinterval(-0.05,0.05), com)

    @test parse(Interval{Float64}, "0.0?u_trv") === interval(bareinterval(0.0,0.05), trv)

    @test parse(Interval{Float64}, "0.0?d_dac") === interval(bareinterval(-0.05,0.0), dac)

    @test parse(Interval{Float64}, "2.5?") === interval(bareinterval(0x1.3999999999999p+1,0x1.4666666666667p+1), com)

    @test parse(Interval{Float64}, "2.5?u") === interval(bareinterval(2.5,0x1.4666666666667p+1), com)

    @test parse(Interval{Float64}, "2.5?d_trv") === interval(bareinterval(0x1.3999999999999p+1,2.5), trv)

    @test parse(Interval{Float64}, "0.000?5") === interval(bareinterval(-0.005,0.005), com)

    @test parse(Interval{Float64}, "0.000?5u_def") === interval(bareinterval(0.0,0.005), def)

    @test parse(Interval{Float64}, "0.000?5d") === interval(bareinterval(-0.005,0.0), com)

    @test parse(Interval{Float64}, "2.500?5") === interval(bareinterval(0x1.3f5c28f5c28f5p+1,0x1.40a3d70a3d70bp+1), com)

    @test parse(Interval{Float64}, "2.500?5u") === interval(bareinterval(2.5,0x1.40a3d70a3d70bp+1), com)

    @test parse(Interval{Float64}, "2.500?5d") === interval(bareinterval(0x1.3f5c28f5c28f5p+1,2.5), com)

    @test parse(Interval{Float64}, "0.0??_dac") === interval(bareinterval(-Inf,Inf), dac)

    @test parse(Interval{Float64}, "0.0??u_trv") === interval(bareinterval(0.0,Inf), trv)

    @test parse(Interval{Float64}, "0.0??d") === interval(bareinterval(-Inf,0.0), dac)

    @test parse(Interval{Float64}, "2.5??") === interval(bareinterval(-Inf,Inf), dac)

    @test parse(Interval{Float64}, "2.5??u_def") === interval(bareinterval(2.5,Inf), def)

    @test parse(Interval{Float64}, "2.5??d_dac") === interval(bareinterval(-Inf,2.5), dac)

    @test parse(Interval{Float64}, "2.500?5e+27") === interval(bareinterval(0x1.01fa19a08fe7fp+91,0x1.0302cc4352683p+91), com)

    @test parse(Interval{Float64}, "2.500?5ue4_def") === interval(bareinterval(0x1.86ap+14,0x1.8768p+14), def)

    @test parse(Interval{Float64}, "2.500?5de-5") === interval(bareinterval(0x1.a2976f1cee4d5p-16,0x1.a36e2eb1c432dp-16), com)

    @test parse(Interval{Float64}, "[ Nai  ]") === nai(Interval{Float64})

    @test parse(Interval{Float64}, "10?1800000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000_com") === interval(bareinterval(-Inf,Inf), dac)

    @test parse(Interval{Float64}, "10?3_com") === interval(bareinterval(7.0,13.0), com)

    @test parse(Interval{Float64}, "10?3e380_com") === interval(bareinterval(0x1.fffffffffffffp+1023,Inf), dac)

    @test_logs (:warn,) @test parse(Interval{Float64}, "[ Nai  ]_ill") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[ Nai  ]_trv") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[ Empty  ]_ill") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[  ]_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[,]_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[   Entire ]_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[ -inf ,  INF ]_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[  -1.0  , 1.0]_ill") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[  -1.0  , 1.0]_fooo") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[  -1.0  , 1.0]_da") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[-1.0,]_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[-Inf, 1.000 ]_ill") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[-I  nf, 1.000 ]") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[-Inf, 1.0  00 ]") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[-Inf ]") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[Inf , INF]") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[ foo ]") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "0.0??_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "0.0??u_ill") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "0.0??d_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "0.0??_com") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[1.0,2.0") === nai(Interval{Float64})

    @test_logs (:warn,) @test parse(Interval{Float64}, "[1.0000000000000002,1.0000000000000001]") === interval(bareinterval(1.0,0x1.0000000000001p+0), com)

    @test_logs (:warn,) @test parse(Interval{Float64}, "[10000000000000001/10000000000000000,10000000000000002/10000000000000001]") === interval(bareinterval(1.0,0x1.0000000000001p+0), com)

    @test_logs (:warn,) @test parse(Interval{Float64}, "[0x1.00000000000002p0,0x1.00000000000001p0]") === interval(bareinterval(1.0,0x1.0000000000001p+0), com)

end

@testset "minimal_interval_part_test" begin

    @test bareinterval(interval(bareinterval(-0x1.99999A842549Ap+4,0x1.9999999999999P-4), trv)) === bareinterval(-0x1.99999A842549Ap+4,0x1.9999999999999P-4)

    @test bareinterval(interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com)) === bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4)

    @test bareinterval(interval(bareinterval(-0x1.99999A842549Ap+4,0x1.99999A0000000p-4), dac)) === bareinterval(-0x1.99999A842549Ap+4,0x1.99999A0000000p-4)

    @test bareinterval(interval(bareinterval(-0x1.99999C0000000p+4,0x1.99999A0000000p-4), def)) === bareinterval(-0x1.99999C0000000p+4,0x1.99999A0000000p-4)

    @test bareinterval(interval(bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022), trv)) === bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022)

    @test bareinterval(interval(bareinterval(-0x0.0000000000001p-1022,0x0.0000000000001p-1022), trv)) === bareinterval(-0x0.0000000000001p-1022,0x0.0000000000001p-1022)

    @test bareinterval(interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), trv)) === bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022)

    @test bareinterval(interval(bareinterval(-0x1.fffffffffffffp+1023,-0x1.fffffffffffffp+1023), trv)) === bareinterval(-0x1.fffffffffffffp+1023,-0x1.fffffffffffffp+1023)

    @test bareinterval(interval(bareinterval(-0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), trv)) === bareinterval(-0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023)

    @test bareinterval(interval(bareinterval(0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), trv)) === bareinterval(0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023)

    @test bareinterval(interval(bareinterval(-Inf,Inf), trv)) === bareinterval(-Inf,Inf)

    @test bareinterval(interval(emptyinterval(BareInterval{Float64}), trv)) === emptyinterval(BareInterval{Float64})

    @test bareinterval(interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com)) === bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4)

    @test_logs (:warn,) @test bareinterval(nai(Interval{Float64})) === emptyinterval(BareInterval{Float64})

end

@testset "minimal_new_dec_test" begin

    @test interval(bareinterval(-0x1.99999A842549Ap+4,0x1.9999999999999P-4)) === interval(bareinterval(-0x1.99999A842549Ap+4,0x1.9999999999999P-4), com)

    @test interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4)) === interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com)

    @test interval(bareinterval(-0x1.99999A842549Ap+4,0x1.99999A0000000p-4)) === interval(bareinterval(-0x1.99999A842549Ap+4,0x1.99999A0000000p-4), com)

    @test interval(bareinterval(-0x1.99999C0000000p+4,0x1.99999A0000000p-4)) === interval(bareinterval(-0x1.99999C0000000p+4,0x1.99999A0000000p-4), com)

    @test interval(bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022)) === interval(bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022), com)

    @test interval(bareinterval(-0x0.0000000000001p-1022,0x0.0000000000001p-1022)) === interval(bareinterval(-0x0.0000000000001p-1022,0x0.0000000000001p-1022), com)

    @test interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022)) === interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), com)

    @test interval(bareinterval(-0x1.fffffffffffffp+1023,-0x1.fffffffffffffp+1023)) === interval(bareinterval(-0x1.fffffffffffffp+1023,-0x1.fffffffffffffp+1023), com)

    @test interval(bareinterval(-0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023)) === interval(bareinterval(-0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), com)

    @test interval(bareinterval(0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023)) === interval(bareinterval(0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), com)

    @test interval(bareinterval(-Inf,Inf)) === interval(bareinterval(-Inf,Inf), dac)

    @test interval(emptyinterval(BareInterval{Float64})) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4)) === interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com)

end

@testset "minimal_set_dec_test" begin

    @test interval(bareinterval(-0x1.99999A842549Ap+4,0x1.9999999999999P-4), trv) === interval(bareinterval(-0x1.99999A842549Ap+4,0x1.9999999999999P-4), trv)

    @test interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com) === interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com)

    @test interval(bareinterval(-0x1.99999A842549Ap+4,0x1.99999A0000000p-4), dac) === interval(bareinterval(-0x1.99999A842549Ap+4,0x1.99999A0000000p-4), dac)

    @test interval(bareinterval(-0x1.99999C0000000p+4,0x1.99999A0000000p-4), def) === interval(bareinterval(-0x1.99999C0000000p+4,0x1.99999A0000000p-4), def)

    @test interval(bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022), trv) === interval(bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022), trv)

    @test interval(bareinterval(-0x0.0000000000001p-1022,0x0.0000000000001p-1022), def) === interval(bareinterval(-0x0.0000000000001p-1022,0x0.0000000000001p-1022), def)

    @test interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), dac) === interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), dac)

    @test interval(bareinterval(-0x1.fffffffffffffp+1023,-0x1.fffffffffffffp+1023), com) === interval(bareinterval(-0x1.fffffffffffffp+1023,-0x1.fffffffffffffp+1023), com)

    @test interval(bareinterval(-0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), def) === interval(bareinterval(-0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), def)

    @test interval(bareinterval(0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), trv) === interval(bareinterval(0x1.fffffffffffffp+1023,0x1.fffffffffffffp+1023), trv)

    @test interval(bareinterval(-Inf,Inf), dac) === interval(bareinterval(-Inf,Inf), dac)

    @test interval(emptyinterval(BareInterval{Float64}), trv) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com) === interval(bareinterval(-0x1.99999C0000000p+4,0x1.9999999999999P-4), com)

    @test interval(emptyinterval(BareInterval{Float64}), def) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test interval(emptyinterval(BareInterval{Float64}), dac) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test interval(emptyinterval(BareInterval{Float64}), com) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test interval(bareinterval(1.0,Inf), com) === interval(bareinterval(1.0,Inf), dac)

    @test interval(bareinterval(-Inf,3.0), com) === interval(bareinterval(-Inf,3.0), dac)

    @test interval(bareinterval(-Inf,Inf), com) === interval(bareinterval(-Inf,Inf), dac)

    @test_logs (:warn,) @test interval(emptyinterval(BareInterval{Float64}), ill) === nai(Interval{Float64})

    @test_logs (:warn,) @test interval(bareinterval(-Inf,3.0), ill) === nai(Interval{Float64})

    @test_logs (:warn,) @test interval(bareinterval(-1.0,3.0), ill) === nai(Interval{Float64})

end

@testset "minimal_decoration_part_test" begin

    @test decoration(nai(Interval{Float64})) === ill

    @test decoration(interval(emptyinterval(BareInterval{Float64}), trv)) === trv

    @test decoration(interval(bareinterval(-1.0,3.0), trv)) === trv

    @test decoration(interval(bareinterval(-1.0,3.0), def)) === def

    @test decoration(interval(bareinterval(-1.0,3.0), dac)) === dac

    @test decoration(interval(bareinterval(-1.0,3.0), com)) === com

end

@testset "mpfi_abs" begin

    @test abs(bareinterval(-Inf, -7.0)) === bareinterval(+7.0, +Inf)

    @test abs(bareinterval(-Inf, 0.0)) === bareinterval(0.0, +Inf)

    @test abs(bareinterval(-Inf, 0.0)) === bareinterval(0.0, +Inf)

    @test abs(bareinterval(-Inf, +8.0)) === bareinterval(0.0, +Inf)

    @test abs(entireinterval(BareInterval{Float64})) === bareinterval(0.0, +Inf)

    @test abs(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test abs(bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test abs(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test abs(bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test abs(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test abs(bareinterval(0x123456789p-16, 0x123456799p-16)) === bareinterval(0x123456789p-16, 0x123456799p-16)

    @test abs(bareinterval(-0x123456789p-16, 0x123456799p-16)) === bareinterval(0.0, 0x123456799p-16)

end

@testset "mpfi_acos" begin

    @test acos(bareinterval(-1.0, 0.0)) === bareinterval(0x3243f6a8885a3p-49, 0x1921fb54442d19p-51)

    @test acos(bareinterval(0.0, 0.0)) === bareinterval(0x3243f6a8885a3p-49, 0x1921fb54442d19p-52)

    @test acos(bareinterval(0.0, +1.0)) === bareinterval(0.0, 0x1921fb54442d19p-52)

    @test acos(bareinterval(-1.0, -0.5)) === bareinterval(0x10c152382d7365p-51, 0x1921fb54442d19p-51)

    @test acos(bareinterval(-0.75, -0.25)) === bareinterval(0x1d2cf5c7c70f0bp-52, 0x4d6749be4edb1p-49)

    @test acos(bareinterval(-0.5, 0.5)) === bareinterval(0x10c152382d7365p-52, 0x860a91c16b9b3p-50)

    @test acos(bareinterval(0.25, 0.625)) === bareinterval(0x1ca94936b98a21p-53, 0x151700e0c14b25p-52)

    @test acos(bareinterval(-1.0, 1.0)) === bareinterval(0.0, 0x1921fb54442d19p-51)

end

@testset "mpfi_acosh" begin

    @test acosh(bareinterval(+1.0, +Inf)) === bareinterval(0.0, +Inf)

    @test acosh(bareinterval(+1.5, +Inf)) === bareinterval(0x1ecc2caec51609p-53, +Inf)

    @test acosh(bareinterval(1.0, 1.5)) === bareinterval(0.0, 0xf661657628b05p-52)

    @test acosh(bareinterval(1.5, 1.5)) === bareinterval(0x1ecc2caec51609p-53, 0xf661657628b05p-52)

    @test acosh(bareinterval(2.0, 1000.0)) === bareinterval(0x544909c66010dp-50, 0x799d4ba2a13b5p-48)

end

@testset "mpfi_add" begin

    @test +(bareinterval(-Inf, -7.0), bareinterval(-1.0, +8.0)) === bareinterval(-Inf, +1.0)

    @test +(bareinterval(-Inf, 0.0), bareinterval(+8.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test +(bareinterval(-Inf, +8.0), bareinterval(0.0, +8.0)) === bareinterval(-Inf, +16.0)

    @test +(entireinterval(BareInterval{Float64}), bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test +(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(-Inf, -7.0)

    @test +(bareinterval(0.0, +8.0), bareinterval(-7.0, 0.0)) === bareinterval(-7.0, +8.0)

    @test +(bareinterval(0.0, 0.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test +(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +Inf)

    @test +(bareinterval(0.0, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(+8.0, +Inf)

    @test +(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test +(bareinterval(0.0, +8.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, +16.0)

    @test +(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test +(bareinterval(0.0, +Inf), bareinterval(-7.0, +8.0)) === bareinterval(-7.0, +Inf)

    @test +(bareinterval(-0.375, -0x10187p-256), bareinterval(-0.125, 0x1p-240)) === bareinterval(-0x1p-1, -0x187p-256)

    @test +(bareinterval(-0x1p-300, 0x123456p+28), bareinterval(-0x10000000000000p-93, 0x789abcdp0)) === bareinterval(-0x10000000000001p-93, 0x123456789abcdp0)

    @test +(bareinterval(-4.0, +7.0), bareinterval(-0x123456789abcdp-17, 3e300)) === bareinterval(-0x123456791abcdp-17, 0x8f596b3002c1bp+947)

    @test +(bareinterval(0x1000100010001p+8, 0x1p+60), bareinterval(0x1000100010001p0, 3.0e300)) === bareinterval(+0x1010101010101p+8, 0x8f596b3002c1bp+947)

    @test +(bareinterval(+4.0, +8.0), bareinterval(-4.0, -2.0)) === bareinterval(0.0, +6.0)

    @test +(bareinterval(+4.0, +8.0), bareinterval(-9.0, -8.0)) === bareinterval(-5.0, 0.0)

end

@testset "mpfi_add_d" begin

    @test +(bareinterval(-Inf, -7.0), bareinterval(-0x170ef54646d497p-107, -0x170ef54646d497p-107)) === bareinterval(-Inf, -7.0)

    @test +(bareinterval(-Inf, -7.0), bareinterval(0.0, 0.0)) === bareinterval(-Inf, -7.0)

    @test +(bareinterval(-Inf, -7.0), bareinterval(0x170ef54646d497p-107, 0x170ef54646d497p-107)) === bareinterval(-Inf, -0x1bffffffffffffp-50)

    @test +(bareinterval(-Inf, 0.0), bareinterval(-0x170ef54646d497p-106, -0x170ef54646d497p-106)) === bareinterval(-Inf, -8.0e-17)

    @test +(bareinterval(-Inf, 0.0), bareinterval(0.0, 0.0)) === bareinterval(-Inf, 0.0)

    @test +(bareinterval(-Inf, 0.0), bareinterval(0x170ef54646d497p-106, 0x170ef54646d497p-106)) === bareinterval(-Inf, 0x170ef54646d497p-106)

    @test +(bareinterval(-Inf, 8.0), bareinterval(-0x16345785d8a00000p0, -0x16345785d8a00000p0)) === bareinterval(-Inf, -0x16345785d89fff00p0)

    @test +(bareinterval(-Inf, 8.0), bareinterval(0.0, 0.0)) === bareinterval(-Inf, 8.0)

    @test +(bareinterval(-Inf, 8.0), bareinterval(0x16345785d8a00000p0, 0x16345785d8a00000p0)) === bareinterval(-Inf, 0x16345785d8a00100p0)

    @test +(entireinterval(BareInterval{Float64}), bareinterval(-0x170ef54646d497p-105, -0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test +(entireinterval(BareInterval{Float64}), bareinterval(0.0e-17, 0.0e-17)) === entireinterval(BareInterval{Float64})

    @test +(entireinterval(BareInterval{Float64}), bareinterval(+0x170ef54646d497p-105, +0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test +(bareinterval(0.0, 0.0), bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109)) === bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109)

    @test +(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test +(bareinterval(0.0, 0.0), bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109)) === bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109)

    @test +(bareinterval(0.0, 8.0), bareinterval(-0x114b37f4b51f71p-107, -0x114b37f4b51f71p-107)) === bareinterval(-0x114b37f4b51f71p-107, 8.0)

    @test +(bareinterval(0.0, 8.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 8.0)

    @test +(bareinterval(0.0, 8.0), bareinterval(0x114b37f4b51f7p-103, 0x114b37f4b51f7p-103)) === bareinterval(0x114b37f4b51f7p-103, 0x10000000000001p-49)

    @test +(bareinterval(0.0, +Inf), bareinterval(-0x50b45a75f7e81p-104, -0x50b45a75f7e81p-104)) === bareinterval(-0x50b45a75f7e81p-104, +Inf)

    @test +(bareinterval(0.0, +Inf), bareinterval(0.0, 0.0)) === bareinterval(0.0, +Inf)

    @test +(bareinterval(0.0, +Inf), bareinterval(0x142d169d7dfa03p-106, 0x142d169d7dfa03p-106)) === bareinterval(0x142d169d7dfa03p-106, +Inf)

    @test +(bareinterval(-32.0, -17.0), bareinterval(-0xfb53d14aa9c2fp-47, -0xfb53d14aa9c2fp-47)) === bareinterval(-0x1fb53d14aa9c2fp-47, -0x18353d14aa9c2fp-47)

    @test +(bareinterval(-0xfb53d14aa9c2fp-47, -17.0), bareinterval(0xfb53d14aa9c2fp-47, 0xfb53d14aa9c2fp-47)) === bareinterval(0.0, 0x7353d14aa9c2fp-47)

    @test +(bareinterval(-32.0, -0xfb53d14aa9c2fp-48), bareinterval(0xfb53d14aa9c2fp-48, 0xfb53d14aa9c2fp-48)) === bareinterval(-0x104ac2eb5563d1p-48, 0.0)

    @test +(bareinterval(0x123456789abcdfp-48, 0x123456789abcdfp-4), bareinterval(3.5, 3.5)) === bareinterval(0x15b456789abcdfp-48, 0x123456789abd17p-4)

    @test +(bareinterval(0x123456789abcdfp-56, 0x123456789abcdfp-4), bareinterval(3.5, 3.5)) === bareinterval(0x3923456789abcdp-52, 0x123456789abd17p-4)

    @test +(bareinterval(-0xffp0, 0x123456789abcdfp-52), bareinterval(256.5, 256.5)) === bareinterval(0x18p-4, 0x101a3456789abdp-44)

    @test +(bareinterval(-0x1fffffffffffffp-52, -0x1p-550), bareinterval(4097.5, 4097.5)) === bareinterval(0xfff8p-4, 0x10018p-4)

    @test +(bareinterval(0x123456789abcdfp-48, 0x123456789abcdfp-4), bareinterval(-3.5, -3.5)) === bareinterval(0xeb456789abcdfp-48, 0x123456789abca7p-4)

    @test +(bareinterval(0x123456789abcdfp-56, 0x123456789abcdfp-4), bareinterval(-3.5, -3.5)) === bareinterval(-0x36dcba98765434p-52, 0x123456789abca7p-4)

    @test +(bareinterval(-0xffp0, 0x123456789abcdfp-52), bareinterval(-256.5, -256.5)) === bareinterval(-0x1ff8p-4, -0xff5cba9876543p-44)

    @test +(bareinterval(-0x1fffffffffffffp-52, -0x1p-550), bareinterval(-4097.5, -4097.5)) === bareinterval(-0x10038p-4, -0x10018p-4)

end

@testset "mpfi_asin" begin

    @test asin(bareinterval(-1.0, 0.0)) === bareinterval(-0x1921fb54442d19p-52, 0.0)

    @test asin(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test asin(bareinterval(0.0, +1.0)) === bareinterval(0.0, 0x1921fb54442d19p-52)

    @test asin(bareinterval(-1.0, -0.5)) === bareinterval(-0x1921fb54442d19p-52, -0x10c152382d7365p-53)

    @test asin(bareinterval(-0.75, -0.25)) === bareinterval(-0x1b235315c680ddp-53, -0x102be9ce0b87cdp-54)

    @test asin(bareinterval(-0.5, 0.5)) === bareinterval(-0x860a91c16b9b3p-52, 0x860a91c16b9b3p-52)

    @test asin(bareinterval(0.25, 0.625)) === bareinterval(0x102be9ce0b87cdp-54, 0x159aad71ced00fp-53)

    @test asin(bareinterval(-1.0, 1.0)) === bareinterval(-0x1921fb54442d19p-52, 0x1921fb54442d19p-52)

end

@testset "mpfi_asinh" begin

    @test asinh(bareinterval(-Inf, -7.0)) === bareinterval(-Inf, -0x152728c91b5f1dp-51)

    @test asinh(bareinterval(-Inf, 0.0)) === bareinterval(-Inf, 0.0)

    @test asinh(bareinterval(-Inf, +8.0)) === bareinterval(-Inf, 0x58d8dc657eaf5p-49)

    @test asinh(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test asinh(bareinterval(-1.0, 0.0)) === bareinterval(-0x1c34366179d427p-53, 0.0)

    @test asinh(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test asinh(bareinterval(0.0, +1.0)) === bareinterval(0.0, 0x1c34366179d427p-53)

    @test asinh(bareinterval(0.0, +8.0)) === bareinterval(0.0, 0x58d8dc657eaf5p-49)

    @test asinh(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test asinh(bareinterval(-6.0, -4.0)) === bareinterval(-0x4fbca919fe219p-49, -0x10c1f8a6e80eebp-51)

    @test asinh(bareinterval(-2.0, -0.5)) === bareinterval(-0x2e32430627a11p-49, -0x1ecc2caec51609p-54)

    @test asinh(bareinterval(-1.0, -0.5)) === bareinterval(-0x1c34366179d427p-53, -0x1ecc2caec51609p-54)

    @test asinh(bareinterval(-0.75, -0.25)) === bareinterval(-0x162e42fefa39fp-49, -0xfd67d91ccf31bp-54)

    @test asinh(bareinterval(-0.5, 0.5)) === bareinterval(-0xf661657628b05p-53, 0xf661657628b05p-53)

    @test asinh(bareinterval(0.25, 0.625)) === bareinterval(0xfd67d91ccf31bp-54, 0x4b89d40b2fecdp-51)

    @test asinh(bareinterval(-1.0, 1.0)) === bareinterval(-0x1c34366179d427p-53, 0x1c34366179d427p-53)

    @test asinh(bareinterval(0.125, 17.0)) === bareinterval(0xff5685b4cb4b9p-55, 0xe1be0ba541ef7p-50)

    @test asinh(bareinterval(17.0, 42.0)) === bareinterval(0x1c37c174a83dedp-51, 0x8dca6976ad6bdp-49)

    @test asinh(bareinterval(-42.0, 17.0)) === bareinterval(-0x8dca6976ad6bdp-49, 0xe1be0ba541ef7p-50)

end

@testset "mpfi_atan" begin

    @test atan(bareinterval(-Inf, -7.0)) === bareinterval(-0x1921fb54442d19p-52, -0x5b7315eed597fp-50)

    @test atan(bareinterval(-Inf, 0.0)) === bareinterval(-0x1921fb54442d19p-52, 0.0)

    @test atan(bareinterval(-Inf, +8.0)) === bareinterval(-0x1921fb54442d19p-52, 0xb924fd54cb511p-51)

    @test atan(entireinterval(BareInterval{Float64})) === bareinterval(-0x1921fb54442d19p-52, 0x1921fb54442d19p-52)

    @test atan(bareinterval(-1.0, 0.0)) === bareinterval(-0x1921fb54442d19p-53, 0.0)

    @test atan(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test atan(bareinterval(0.0, +1.0)) === bareinterval(0.0, 0x1921fb54442d19p-53)

    @test atan(bareinterval(0.0, +8.0)) === bareinterval(0.0, 0xb924fd54cb511p-51)

    @test atan(bareinterval(0.0, +Inf)) === bareinterval(0.0, 0x1921fb54442d19p-52)

    @test atan(bareinterval(-6.0, -4.0)) === bareinterval(-0x167d8863bc99bdp-52, -0x54da32547a73fp-50)

    @test atan(bareinterval(-2.0, -0.5)) === bareinterval(-0x11b6e192ebbe45p-52, -0x1dac670561bb4fp-54)

    @test atan(bareinterval(-1.0, -0.5)) === bareinterval(-0x1921fb54442d19p-53, -0x1dac670561bb4fp-54)

    @test atan(bareinterval(-0.75, -0.25)) === bareinterval(-0xa4bc7d1934f71p-52, -0x1f5b75f92c80ddp-55)

    @test atan(bareinterval(-0.5, 0.5)) === bareinterval(-0x1dac670561bb5p-50, 0x1dac670561bb5p-50)

    @test atan(bareinterval(0.25, 0.625)) === bareinterval(0x1f5b75f92c80ddp-55, 0x47802eaf7bfadp-51)

    @test atan(bareinterval(-1.0, 1.0)) === bareinterval(-0x1921fb54442d19p-53, 0x1921fb54442d19p-53)

    @test atan(bareinterval(0.125, 17.0)) === bareinterval(0x1fd5ba9aac2f6dp-56, 0x1831516233f561p-52)

    @test atan(bareinterval(17.0, 42.0)) === bareinterval(0xc18a8b119fabp-47, 0x18c079f3350d27p-52)

    @test atan(bareinterval(-42.0, 17.0)) === bareinterval(-0x18c079f3350d27p-52, 0x1831516233f561p-52)

end

@testset "mpfi_atan2" begin

    @test atan(bareinterval(-Inf, -7.0), bareinterval(-1.0, +8.0)) === bareinterval(-0x6d9cc4b34bd0dp-50, -0x1700a7c5784633p-53)

    @test atan(bareinterval(-Inf, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(-0x1921fb54442d19p-52, 0.0)

    @test atan(bareinterval(-Inf, +8.0), bareinterval(0.0, +8.0)) === bareinterval(-0x1921fb54442d19p-52, 0x1921fb54442d19p-52)

    @test atan(entireinterval(BareInterval{Float64}), bareinterval(0.0, +8.0)) === bareinterval(-0x1921fb54442d19p-52, 0x1921fb54442d19p-52)

    @test atan(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51)

    @test atan(bareinterval(0.0, +8.0), bareinterval(-7.0, 0.0)) === bareinterval(0x3243f6a8885a3p-49, 0x1921fb54442d19p-51)

    @test atan(bareinterval(0.0, 0.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, 0.0)

    @test atan(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, 0x1921fb54442d19p-52)

    @test atan(bareinterval(0.0, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(0.0, 0.0)

    @test atan(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === bareinterval(0.0, 0x1921fb54442d19p-51)

    @test atan(bareinterval(0.0, +8.0), bareinterval(-7.0, +8.0)) === bareinterval(0.0, 0x1921fb54442d19p-51)

    @test atan(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test atan(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, 0x1921fb54442d19p-52)

    @test atan(bareinterval(-17.0, -5.0), bareinterval(-4002.0, -1.0)) === bareinterval(-0x191f6c4c09a81bp-51, -0x1a12a5465464cfp-52)

    @test atan(bareinterval(-17.0, -5.0), bareinterval(1.0, 4002.0)) === bareinterval(-0x1831516233f561p-52, -0xa3c20ea13f5e5p-61)

    @test atan(bareinterval(5.0, 17.0), bareinterval(1.0, 4002.0)) === bareinterval(0xa3c20ea13f5e5p-61, 0x1831516233f561p-52)

    @test atan(bareinterval(5.0, 17.0), bareinterval(-4002.0, -1.0)) === bareinterval(0x1a12a5465464cfp-52, 0x191f6c4c09a81bp-51)

    @test atan(bareinterval(-17.0, 5.0), bareinterval(-4002.0, 1.0)) === bareinterval(-0x1921fb54442d19p-51, 0x1921fb54442d19p-51)

end

@testset "mpfi_atanh" begin

    @test atanh(bareinterval(-1.0, 0.0)) === bareinterval(-Inf, 0.0)

    @test atanh(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test atanh(bareinterval(0.0, +1.0)) === bareinterval(0.0, +Inf)

    @test atanh(bareinterval(-1.0, -0.5)) === bareinterval(-Inf, -0x8c9f53d568185p-52)

    @test atanh(bareinterval(-0.75, -0.25)) === bareinterval(-0x3e44e55c64b4bp-50, -0x1058aefa811451p-54)

    @test atanh(bareinterval(-0.5, 0.5)) === bareinterval(-0x1193ea7aad030bp-53, 0x1193ea7aad030bp-53)

    @test atanh(bareinterval(0.25, 0.625)) === bareinterval(0x1058aefa811451p-54, 0x2eec3bb76c2b3p-50)

    @test atanh(bareinterval(-1.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test atanh(bareinterval(0.125, 1.0)) === bareinterval(0x1015891c9eaef7p-55, +Inf)

end

@testset "mpfi_bounded_p" begin

    @test iscommon(bareinterval(-Inf, -8.0)) === false

    @test iscommon(bareinterval(-Inf, 0.0)) === false

    @test iscommon(bareinterval(-Inf, 5.0)) === false

    @test iscommon(entireinterval(BareInterval{Float64})) === false

    @test iscommon(bareinterval(-8.0, 0.0)) === true

    @test iscommon(bareinterval(0.0, 0.0)) === true

    @test iscommon(bareinterval(0.0, 5.0)) === true

    @test iscommon(bareinterval(0.0, +Inf)) === false

    @test iscommon(bareinterval(5.0, +Inf)) === false

    @test iscommon(bareinterval(-34.0, -17.0)) === true

    @test iscommon(bareinterval(-8.0, -1.0)) === true

    @test iscommon(bareinterval(-34.0, 17.0)) === true

    @test iscommon(bareinterval(-0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === true

    @test iscommon(bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === true

    @test iscommon(bareinterval(+8.0, +0x7fffffffffffbp+51)) === true

    @test iscommon(bareinterval(+0x1fffffffffffffp-53, 2.0)) === true

end

@testset "mpfi_cbrt" begin

    @test cbrt(bareinterval(-Inf, -125.0)) === bareinterval(-Inf, -5.0)

    @test cbrt(bareinterval(-Inf, 0.0)) === bareinterval(-Inf, 0.0)

    @test cbrt(bareinterval(-Inf, +64.0)) === bareinterval(-Inf, +4.0)

    @test cbrt(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cbrt(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test cbrt(bareinterval(0.0, +27.0)) === bareinterval(0.0, +3.0)

    @test cbrt(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test cbrt(bareinterval(0x40p0, 0x7dp0)) === bareinterval(4.0, 5.0)

    @test cbrt(bareinterval(-0x1856e4be527197p-354, 0xd8p0)) === bareinterval(-0x2e5e58c0083b7bp-154, 6.0)

    @test cbrt(bareinterval(0x141a9019a2184dp-1047, 0xc29c78c66ac0fp-678)) === bareinterval(0x2b8172e535d44dp-385, 0x24cbd1c55aaa1p-258)

end

@testset "mpfi_cos" begin

    @test cos(bareinterval(-Inf, -7.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-Inf, 0.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-Inf, +8.0)) === bareinterval(-1.0, 1.0)

    @test cos(entireinterval(BareInterval{Float64})) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-1.0, 0.0)) === bareinterval(0x114a280fb5068bp-53, 1.0)

    @test cos(bareinterval(0.0, 0.0)) === bareinterval(1.0, 1.0)

    @test cos(bareinterval(0.0, +1.0)) === bareinterval(0x114a280fb5068bp-53, 1.0)

    @test cos(bareinterval(0.0, +8.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(0.0, +Inf)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-2.0, -0.5)) === bareinterval(-0x1aa22657537205p-54, 0x1c1528065b7d5p-49)

    @test cos(bareinterval(-1.0, -0.25)) === bareinterval(0x114a280fb5068bp-53, 0xf80aa4fbef751p-52)

    @test cos(bareinterval(-0.5, 0.5)) === bareinterval(0x1c1528065b7d4fp-53, 1.0)

    @test cos(bareinterval(-4.5, 0.625)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(1.0, 0x3243f6a8885a3p-48)) === bareinterval(-1.0, 0x4528a03ed41a3p-51)

    @test cos(bareinterval(0.125, 17.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(17.0, 42.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-7.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-7.0, 0.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-7.0, -1.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-7.0, -2.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-7.0, -3.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-7.0, -4.0)) === bareinterval(-0x14eaa606db24c1p-53, 1.0)

    @test cos(bareinterval(-7.0, -5.0)) === bareinterval(0x122785706b4ad9p-54, 1.0)

    @test cos(bareinterval(-7.0, -6.0)) === bareinterval(0x181ff79ed92017p-53, 1.0)

    @test cos(bareinterval(-7.0, -7.0)) === bareinterval(0x181ff79ed92017p-53, 0x181ff79ed92018p-53)

    @test cos(bareinterval(-6.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-6.0, 0.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-6.0, -1.0)) === bareinterval(-1.0, 0x1eb9b7097822f6p-53)

    @test cos(bareinterval(-6.0, -2.0)) === bareinterval(-1.0, 0x1eb9b7097822f6p-53)

    @test cos(bareinterval(-6.0, -3.0)) === bareinterval(-1.0, 0x1eb9b7097822f6p-53)

    @test cos(bareinterval(-6.0, -4.0)) === bareinterval(-0x14eaa606db24c1p-53, 0x1eb9b7097822f6p-53)

    @test cos(bareinterval(-6.0, -5.0)) === bareinterval(0x122785706b4ad9p-54, 0x1eb9b7097822f6p-53)

    @test cos(bareinterval(-6.0, -6.0)) === bareinterval(0x1eb9b7097822f5p-53, 0x1eb9b7097822f6p-53)

    @test cos(bareinterval(-5.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-5.0, 0.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-5.0, -1.0)) === bareinterval(-1.0, 0x114a280fb5068cp-53)

    @test cos(bareinterval(-5.0, -2.0)) === bareinterval(-1.0, 0x122785706b4adap-54)

    @test cos(bareinterval(-5.0, -3.0)) === bareinterval(-1.0, 0x122785706b4adap-54)

    @test cos(bareinterval(-5.0, -4.0)) === bareinterval(-0x14eaa606db24c1p-53, 0x122785706b4adap-54)

    @test cos(bareinterval(-5.0, -5.0)) === bareinterval(0x122785706b4ad9p-54, 0x122785706b4adap-54)

    @test cos(bareinterval(-4.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-4.0, 0.0)) === bareinterval(-1.0, 1.0)

    @test cos(bareinterval(-4.0, -1.0)) === bareinterval(-1.0, 0x114a280fb5068cp-53)

    @test cos(bareinterval(-4.0, -2.0)) === bareinterval(-1.0, -0x1aa22657537204p-54)

    @test cos(bareinterval(-4.0, -3.0)) === bareinterval(-1.0, -0x14eaa606db24c0p-53)

    @test cos(bareinterval(-4.0, -4.0)) === bareinterval(-0x14eaa606db24c1p-53, -0x14eaa606db24c0p-53)

end

@testset "mpfi_cosh" begin

    @test cosh(bareinterval(-Inf, -7.0)) === bareinterval(0x11228949ba3a8bp-43, +Inf)

    @test cosh(bareinterval(-Inf, 0.0)) === bareinterval(1.0, +Inf)

    @test cosh(bareinterval(-Inf, +8.0)) === bareinterval(1.0, +Inf)

    @test cosh(entireinterval(BareInterval{Float64})) === bareinterval(1.0, +Inf)

    @test cosh(bareinterval(-1.0, 0.0)) === bareinterval(1.0, 0x18b07551d9f551p-52)

    @test cosh(bareinterval(0.0, 0.0)) === bareinterval(1.0, 1.0)

    @test cosh(bareinterval(0.0, +1.0)) === bareinterval(1.0, 0x18b07551d9f551p-52)

    @test cosh(bareinterval(0.0, +8.0)) === bareinterval(1.0, 0x1749eaa93f4e77p-42)

    @test cosh(bareinterval(0.0, +Inf)) === bareinterval(1.0, +Inf)

    @test cosh(bareinterval(-0.125, 0.0)) === bareinterval(1.0, 0x10200aac16db6fp-52)

    @test cosh(bareinterval(0.0, 0x10000000000001p-53)) === bareinterval(1.0, 0x120ac1862ae8d1p-52)

    @test cosh(bareinterval(-4.5, -0.625)) === bareinterval(0x99d310a496b6dp-51, 0x1681ceb0641359p-47)

    @test cosh(bareinterval(1.0, 3.0)) === bareinterval(0x18b07551d9f55p-48, 0x1422a497d6185fp-49)

    @test cosh(bareinterval(17.0, 0xb145bb71d3dbp-38)) === bareinterval(0x1709348c0ea503p-29, 0x3ffffffffffa34p+968)

end

@testset "mpfi_cot" begin

    @test cot(bareinterval(-Inf, -7.0)) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(-Inf, 0.0)) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(-Inf, +8.0)) === entireinterval(BareInterval{Float64})

    @test cot(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(-8.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(-3.0, 0.0)) === bareinterval(-Inf, 0xe07cf2eb32f0bp-49)

    @test cot(bareinterval(-1.0, 0.0)) === bareinterval(-Inf, -0x148c05d04e1cfdp-53)

    @test cot(bareinterval(0.0, +1.0)) === bareinterval(0x148c05d04e1cfdp-53, +Inf)

    @test cot(bareinterval(0.0, +3.0)) === bareinterval(-0xe07cf2eb32f0bp-49, +Inf)

    @test cot(bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(0.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(-3.0, -2.0)) === bareinterval(0x1d4a42e92faa4dp-54, 0xe07cf2eb32f0bp-49)

    @test cot(bareinterval(-3.0, -0x1921fb54442d19p-52)) === bareinterval(0x5cb3b399d747fp-103, 0xe07cf2eb32f0bp-49)

    @test cot(bareinterval(-2.0, 0x1921fb54442d19p-52)) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(0.125, 0.5)) === bareinterval(0xea4d6bf23e051p-51, 0x1fd549f047f2bbp-50)

    @test cot(bareinterval(0.125, 0x1921fb54442d19p-52)) === bareinterval(-0x172cece675d1fdp-105, 0x1fd549f047f2bbp-50)

    @test cot(bareinterval(0x1921fb54442d19p-52, 4.0)) === entireinterval(BareInterval{Float64})

    @test cot(bareinterval(4.0, 0x3243f6a8885a3p-47)) === bareinterval(-0x1d02967c31cdb5p-1, 0x1ba35ba1c6b75dp-53)

    @test cot(bareinterval(0x13a28c59d5433bp-44, 0x9d9462ceaa19dp-43)) === bareinterval(0x148c05d04e1fb7p-53, 0x1cefdde7c84c27p-4)

end

@testset "mpfi_coth" begin

    @test coth(bareinterval(-Inf, -7.0)) === bareinterval(-0x100001be6c882fp-52, -1.0)

    @test coth(bareinterval(-Inf, 0.0)) === bareinterval(-Inf, -1.0)

    @test coth(bareinterval(-Inf, +8.0)) === entireinterval(BareInterval{Float64})

    @test coth(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test coth(bareinterval(-8.0, 0.0)) === bareinterval(-Inf, -0x1000003c6ab7e7p-52)

    @test coth(bareinterval(-3.0, 0.0)) === bareinterval(-Inf, -0x10145b3cc9964bp-52)

    @test coth(bareinterval(-1.0, 0.0)) === bareinterval(-Inf, -0x150231499b6b1dp-52)

    @test coth(bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test coth(bareinterval(0.0, +1.0)) === bareinterval(0x150231499b6b1dp-52, +Inf)

    @test coth(bareinterval(0.0, +3.0)) === bareinterval(0x10145b3cc9964bp-52, +Inf)

    @test coth(bareinterval(0.0, +8.0)) === bareinterval(0x1000003c6ab7e7p-52, +Inf)

    @test coth(bareinterval(0.0, +Inf)) === bareinterval(1.0, +Inf)

    @test coth(bareinterval(-3.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test coth(bareinterval(-10.0, -8.0)) === bareinterval(-0x1000003c6ab7e8p-52, -0x100000011b4865p-52)

    @test coth(bareinterval(7.0, 17.0)) === bareinterval(0x1000000000000fp-52, 0x100001be6c882fp-52)

    @test coth(bareinterval(0x10000000000001p-58, 0x10000000000001p-53)) === bareinterval(0x114fc6ceb099bdp-51, 0x10005554fa502fp-46)

end

@testset "mpfi_csc" begin

    @test csc(bareinterval(-Inf, -7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-Inf, 0.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-Inf, 8.0)) === entireinterval(BareInterval{Float64})

    @test csc(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-8.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 0.0)) === bareinterval(-Inf, -1.0)

    @test csc(bareinterval(-1.0, 0.0)) === bareinterval(-Inf, -0x1303aa9620b223p-52)

    @test csc(bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test csc(bareinterval(0.0, +1.0)) === bareinterval(0x1303aa9620b223p-52, +Inf)

    @test csc(bareinterval(0.0, 3.0)) === bareinterval(1.0, +Inf)

    @test csc(bareinterval(0.0, 8.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(0.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-6.0, -4.0)) === bareinterval(1.0, 0x1ca19615f903dap-51)

    @test csc(bareinterval(-6.0, -5.0)) === bareinterval(0x10af73f9df86b7p-52, 0x1ca19615f903dap-51)

    @test csc(bareinterval(-6.0, -6.0)) === bareinterval(0x1ca19615f903d9p-51, 0x1ca19615f903dap-51)

    @test csc(bareinterval(-5.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-5.0, -4.0)) === bareinterval(1.0, 0x15243e8b2f4642p-52)

    @test csc(bareinterval(-5.0, -5.0)) === bareinterval(0x10af73f9df86b7p-52, 0x10af73f9df86b8p-52)

    @test csc(bareinterval(-4.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-4.0, -4.0)) === bareinterval(0x15243e8b2f4641p-52, 0x15243e8b2f4642p-52)

    @test csc(bareinterval(-3.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-3.0, 0.0)) === bareinterval(-Inf, -1.0)

    @test csc(bareinterval(-3.0, -1.0)) === bareinterval(-0x1c583c440ab0dap-50, -1.0)

    @test csc(bareinterval(-3.0, -2.0)) === bareinterval(-0x1c583c440ab0dap-50, -0x119893a272f912p-52)

    @test csc(bareinterval(-3.0, -3.0)) === bareinterval(-0x1c583c440ab0dap-50, -0x1c583c440ab0d9p-50)

    @test csc(bareinterval(-2.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-2.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-2.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-2.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-2.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-2.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-2.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-2.0, 0.0)) === bareinterval(-Inf, -1.0)

    @test csc(bareinterval(-2.0, -1.0)) === bareinterval(-0x1303aa9620b224p-52, -1.0)

    @test csc(bareinterval(-2.0, -2.0)) === bareinterval(-0x119893a272f913p-52, -0x119893a272f912p-52)

    @test csc(bareinterval(-1.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-1.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-1.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-1.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-1.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-1.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-1.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(-1.0, 0.0)) === bareinterval(-Inf, -0x1303aa9620b223p-52)

    @test csc(bareinterval(-1.0, -1.0)) === bareinterval(-0x1303aa9620b224p-52, -0x1303aa9620b223p-52)

    @test csc(bareinterval(1.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(1.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(1.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(1.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(1.0, 3.0)) === bareinterval(1.0, 0x1c583c440ab0dap-50)

    @test csc(bareinterval(1.0, 2.0)) === bareinterval(1.0, 0x1303aa9620b224p-52)

    @test csc(bareinterval(1.0, 1.0)) === bareinterval(0x1303aa9620b223p-52, 0x1303aa9620b224p-52)

    @test csc(bareinterval(2.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(2.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(2.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(2.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(2.0, 3.0)) === bareinterval(0x119893a272f912p-52, 0x1c583c440ab0dap-50)

    @test csc(bareinterval(2.0, 2.0)) === bareinterval(0x119893a272f912p-52, 0x119893a272f913p-52)

    @test csc(bareinterval(3.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(3.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(3.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(3.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(3.0, 3.0)) === bareinterval(0x1c583c440ab0d9p-50, 0x1c583c440ab0dap-50)

    @test csc(bareinterval(4.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(4.0, 6.0)) === bareinterval(-0x1ca19615f903dap-51, -1.0)

    @test csc(bareinterval(4.0, 5.0)) === bareinterval(-0x15243e8b2f4642p-52, -1.0)

    @test csc(bareinterval(4.0, 4.0)) === bareinterval(-0x15243e8b2f4642p-52, -0x15243e8b2f4641p-52)

    @test csc(bareinterval(5.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(5.0, 6.0)) === bareinterval(-0x1ca19615f903dap-51, -0x10af73f9df86b7p-52)

    @test csc(bareinterval(5.0, 5.0)) === bareinterval(-0x10af73f9df86b8p-52, -0x10af73f9df86b7p-52)

    @test csc(bareinterval(6.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test csc(bareinterval(6.0, 6.0)) === bareinterval(-0x1ca19615f903dap-51, -0x1ca19615f903d9p-51)

    @test csc(bareinterval(7.0, 7.0)) === bareinterval(+0x185a86a4ceb06cp-52, +0x185a86a4ceb06dp-52)

end

@testset "mpfi_csch" begin

    @test csch(bareinterval(-Inf, -7.0)) === bareinterval(-0x1de16d3cffcd54p-62, 0.0)

    @test csch(bareinterval(-Inf, 0.0)) === bareinterval(-Inf, 0.0)

    @test csch(bareinterval(-Inf, +8.0)) === entireinterval(BareInterval{Float64})

    @test csch(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test csch(bareinterval(-8.0, 0.0)) === bareinterval(-Inf, -0x15fc212d92371ap-63)

    @test csch(bareinterval(-3.0, 0.0)) === bareinterval(-Inf, -0x198de80929b901p-56)

    @test csch(bareinterval(-1.0, 0.0)) === bareinterval(-Inf, -0x1b3ab8a78b90c0p-53)

    @test csch(bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test csch(bareinterval(0.0, +1.0)) === bareinterval(0x1b3ab8a78b90c0p-53, +Inf)

    @test csch(bareinterval(0.0, +3.0)) === bareinterval(0x198de80929b901p-56, +Inf)

    @test csch(bareinterval(0.0, +8.0)) === bareinterval(0x15fc212d92371ap-63, +Inf)

    @test csch(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test csch(bareinterval(-3.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test csch(bareinterval(-10.0, -8.0)) === bareinterval(-0x15fc212d92371bp-63, -0x17cd79b63733a0p-66)

    @test csch(bareinterval(7.0, 17.0)) === bareinterval(0x1639e3175a68a7p-76, 0x1de16d3cffcd54p-62)

    @test csch(bareinterval(0x10000000000001p-58, 0x10000000000001p-53)) === bareinterval(0x1eb45dc88defeap-52, 0x3fff555693e722p-48)

end

@testset "mpfi_d_div" begin

    @test /(bareinterval(-0x170ef54646d496p-107, -0x170ef54646d496p-107), bareinterval(-Inf, -7.0)) === bareinterval(0.0, 0x1a5a3ce29a1787p-110)

    @test /(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0x170ef54646d496p-107, 0x170ef54646d496p-107), bareinterval(-Inf, -7.0)) === bareinterval(-0x1a5a3ce29a1787p-110, 0.0)

    @test /(bareinterval(-0x170ef54646d497p-106, -0x170ef54646d497p-106), bareinterval(-Inf, 0.0)) === bareinterval(0.0, +Inf)

    @test /(bareinterval(0.0, 0.0), bareinterval(-Inf, 0.0)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0x170ef54646d497p-106, 0x170ef54646d497p-106), bareinterval(-Inf, 0.0)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(-0x16345785d8a00000p0, -0x16345785d8a00000p0), bareinterval(-Inf, 8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0.0, 0.0), bareinterval(-Inf, 8.0)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0x16345785d8a00000p0, 0x16345785d8a00000p0), bareinterval(-Inf, 8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-0x170ef54646d497p-105, -0x170ef54646d497p-105), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0.0e-17, 0.0e-17), entireinterval(BareInterval{Float64})) === bareinterval(0.0, 0.0)

    @test /(bareinterval(+0x170ef54646d497p-105, +0x170ef54646d497p-105), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109), bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test /(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test /(bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109), bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test /(bareinterval(-0x114b37f4b51f71p-107, -0x114b37f4b51f71p-107), bareinterval(0.0, 7.0)) === bareinterval(-Inf, -0x13c3ada9f391a5p-110)

    @test /(bareinterval(0.0, 0.0), bareinterval(0.0, 7.0)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0x114b37f4b51f71p-107, 0x114b37f4b51f71p-107), bareinterval(0.0, 7.0)) === bareinterval(0x13c3ada9f391a5p-110, +Inf)

    @test /(bareinterval(-0x50b45a75f7e81p-104, -0x50b45a75f7e81p-104), bareinterval(0.0, +Inf)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(0.0, 0.0), bareinterval(0.0, +Inf)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0x142d169d7dfa03p-106, 0x142d169d7dfa03p-106), bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test /(bareinterval(-2.5, -2.5), bareinterval(-8.0, 8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-2.5, -2.5), bareinterval(-8.0, -5.0)) === bareinterval(0x5p-4, 0.5)

    @test /(bareinterval(-2.5, -2.5), bareinterval(25.0, 40.0)) === bareinterval(-0x1999999999999ap-56, -0x1p-4)

    @test /(bareinterval(-2.5, -2.5), bareinterval(-16.0, -7.0)) === bareinterval(0x5p-5, 0x16db6db6db6db7p-54)

    @test /(bareinterval(-2.5, -2.5), bareinterval(11.0, 143.0)) === bareinterval(-0x1d1745d1745d18p-55, -0x11e6efe35b4cfap-58)

    @test /(bareinterval(33.125, 33.125), bareinterval(8.28125, 530.0)) === bareinterval(0x1p-4, 4.0)

    @test /(bareinterval(33.125, 33.125), bareinterval(-530.0, -496.875)) === bareinterval(-0x11111111111112p-56, -0x1p-4)

    @test /(bareinterval(33.125, 33.125), bareinterval(54.0, 265.0)) === bareinterval(0.125, 0x13a12f684bda13p-53)

    @test /(bareinterval(33.125, 33.125), bareinterval(52.0, 54.0)) === bareinterval(0x13a12f684bda12p-53, 0x14627627627628p-53)

end

@testset "mpfi_diam_abs" begin

    @test diam(bareinterval(-Inf, -8.0)) === +Inf

    @test diam(bareinterval(-Inf, 0.0)) === +Inf

    @test diam(bareinterval(-Inf, 5.0)) === +Inf

    @test diam(entireinterval(BareInterval{Float64})) === +Inf

    @test diam(bareinterval(-Inf, 0.0)) === +Inf

    @test diam(bareinterval(-8.0, 0.0)) === +8.0

    @test diam(bareinterval(0.0, 0.0)) === 0.0

    @test diam(bareinterval(0.0, 5.0)) === +5.0

    @test diam(bareinterval(0.0, +Inf)) === +Inf

    @test diam(bareinterval(-34.0, -17.0)) === 17.0

end

@testset "mpfi_div" begin

    @test /(bareinterval(-Inf, -7.0), bareinterval(-1.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-Inf, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(-Inf, +8.0), bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test /(entireinterval(BareInterval{Float64}), bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0.0, +8.0), bareinterval(-7.0, 0.0)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(0.0, 0.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +Inf)

    @test /(bareinterval(0.0, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0.0, +8.0), bareinterval(-7.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +Inf)

    @test /(bareinterval(-0x75bcd15p0, -0x754ep0), bareinterval(-0x11ep0, -0x9p0)) === bareinterval(0x69p0, 0xd14fadp0)

    @test /(bareinterval(-0x75bcd15p0, -0x1.489c07caba163p-4), bareinterval(-0x2.e8e36e560704ap+4, -0x9p0)) === bareinterval(0x7.0ef61537b1704p-12, 0xd14fadp0)

    @test /(bareinterval(-0x1.02f0415f9f596p+0, -0x754ep-16), bareinterval(-0x11ep0, -0x7.62ce64fbacd2cp-8)) === bareinterval(0x69p-16, 0x2.30ee5eef9c36cp+4)

    @test /(bareinterval(-0x1.02f0415f9f596p+0, -0x1.489c07caba163p-4), bareinterval(-0x2.e8e36e560704ap+0, -0x7.62ce64fbacd2cp-8)) === bareinterval(0x7.0ef61537b1704p-8, 0x2.30ee5eef9c36cp+4)

    @test /(bareinterval(-0xacbp+256, -0x6f9p0), bareinterval(-0x7p0, 0.0)) === bareinterval(0xffp0, +Inf)

    @test /(bareinterval(-0x100p0, -0xe.bb80d0a0824ep-4), bareinterval(-0x1.7c6d760a831fap+0, 0.0)) === bareinterval(0x9.e9f24790445fp-4, +Inf)

    @test /(bareinterval(-0x1.25f2d73472753p+0, -0x9.9a19fd3c1fc18p-4), bareinterval(-0x9.3b0c8074ccc18p-4, +0x4.788df5d72af78p-4)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-100.0, -15.0), bareinterval(0.0, +3.0)) === bareinterval(-Inf, -5.0)

    @test /(bareinterval(-2.0, -0x1.25f2d73472753p+0), bareinterval(0.0, +0x9.3b0c8074ccc18p-4)) === bareinterval(-Inf, -0x1.fd8457415f917p+0)

    @test /(bareinterval(-0x123456789p0, -0x754ep+4), bareinterval(0x40bp0, 0x11ep+4)) === bareinterval(-0x480b3bp0, -0x69p0)

    @test /(bareinterval(-0xd.67775e4b8588p-4, -0x754ep-53), bareinterval(0x4.887091874ffc8p+0, 0x11ep+201)) === bareinterval(-0x2.f5008d2df94ccp-4, -0x69p-254)

    @test /(bareinterval(-0x123456789p0, -0x1.b0a62934c76e9p+0), bareinterval(0x40bp-17, 0x2.761ec797697a4p-4)) === bareinterval(-0x480b3bp+17, -0xa.fc5e7338f3e4p+0)

    @test /(bareinterval(-0xd.67775e4b8588p+0, -0x1.b0a62934c76e9p+0), bareinterval(0x4.887091874ffc8p-4, 0x2.761ec797697a4p+4)) === bareinterval(-0x2.f5008d2df94ccp+4, -0xa.fc5e7338f3e4p-8)

    @test /(bareinterval(-0x75bcd15p0, 0.0), bareinterval(-0x90p0, -0x9p0)) === bareinterval(0.0, 0xd14fadp0)

    @test /(bareinterval(-0x1.4298b2138f2a7p-4, 0.0), bareinterval(-0x1p-8, -0xf.5e4900c9c19fp-12)) === bareinterval(0.0, 0x1.4fdb41a33d6cep+4)

    @test /(bareinterval(-0xeeeeeeeeep0, 0.0), bareinterval(-0xaaaaaaaaap0, 0.0)) === bareinterval(0.0, +Inf)

    @test /(bareinterval(-0x1.25f2d73472753p+0, 0.0), bareinterval(-0x9.3b0c8074ccc18p-4, +0x4.788df5d72af78p-4)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-0xeeeeeeeeep0, 0.0), bareinterval(0.0, +0x3p0)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(-0x75bcd15p0, 0.0), bareinterval(0x9p0, 0x90p0)) === bareinterval(-0xd14fadp0, 0.0)

    @test /(bareinterval(-0x1.4298b2138f2a7p-4, 0.0), bareinterval(0xf.5e4900c9c19fp-12, 0x9p0)) === bareinterval(-0x1.4fdb41a33d6cep+4, 0.0)

    @test /(bareinterval(-0x75bcd15p0, 0xa680p0), bareinterval(-0xaf6p0, -0x9p0)) === bareinterval(-0x1280p0, 0xd14fadp0)

    @test /(bareinterval(-0x12p0, 0x10p0), bareinterval(-0xbbbbbbbbbbp0, -0x9p0)) === bareinterval(-0x1.c71c71c71c71dp0, 2.0)

    @test /(bareinterval(-0x1p0, 0x754ep-16), bareinterval(-0xccccccccccp0, -0x11ep0)) === bareinterval(-0x69p-16, 0xe.525982af70c9p-12)

    @test /(bareinterval(-0xb.5b90b4d32136p-4, 0x6.e694ac6767394p+0), bareinterval(-0xdddddddddddp0, -0xc.f459be9e80108p-4)) === bareinterval(-0x8.85e40b3c3f63p+0, 0xe.071cbfa1de788p-4)

    @test /(bareinterval(-0xacbp+256, 0x6f9p0), bareinterval(-0x7p0, 0.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-0x1.25f2d73472753p+0, +0x9.9a19fd3c1fc18p-4), bareinterval(-0x9.3b0c8074ccc18p-4, +0x4.788df5d72af78p-4)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0.0, +15.0), bareinterval(-3.0, +3.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-0x754ep0, 0xd0e9dc4p+12), bareinterval(0x11ep0, 0xbbbp0)) === bareinterval(-0x69p0, 0xbaffep+12)

    @test /(bareinterval(-0x10p0, 0xd0e9dc4p+12), bareinterval(0x11ep0, 0xbbbp0)) === bareinterval(-0xe.525982af70c9p-8, 0xbaffep+12)

    @test /(bareinterval(-0x754ep0, 0x1p+10), bareinterval(0x11ep0, 0xbbbp0)) === bareinterval(-0x69p0, 0xe.525982af70c9p-2)

    @test /(bareinterval(-0x1.18333622af827p+0, 0x2.14b836907297p+0), bareinterval(0x1.263147d1f4bcbp+0, 0x111p0)) === bareinterval(-0xf.3d2f5db8ec728p-4, 0x1.cf8fa732de129p+0)

    @test /(bareinterval(0.0, 0x75bcd15p0), bareinterval(-0xap0, -0x9p0)) === bareinterval(-0xd14fadp0, 0.0)

    @test /(bareinterval(0.0, 0x1.acbf1702af6edp+0), bareinterval(-0x0.fp0, -0xe.3d7a59e2bdacp-4)) === bareinterval(-0x1.e1bb896bfda07p+0, 0.0)

    @test /(bareinterval(0.0, 0xap0), bareinterval(-0x9p0, 0.0)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(0.0, 0xap0), bareinterval(-1.0, +1.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0.0, 0x75bcd15p0), bareinterval(+0x9p0, +0xap0)) === bareinterval(0.0, 0xd14fadp0)

    @test /(bareinterval(0.0, 0x1.5f6b03dc8c66fp+0), bareinterval(+0x2.39ad24e812dcep+0, 0xap0)) === bareinterval(0.0, 0x9.deb65b02baep-4)

    @test /(bareinterval(0x754ep0, 0x75bcd15p0), bareinterval(-0x11ep0, -0x9p0)) === bareinterval(-0xd14fadp0, -0x69p0)

    @test /(bareinterval(0x754ep-16, 0x1.008a3accc766dp+4), bareinterval(-0x11ep0, -0x2.497403b31d32ap+0)) === bareinterval(-0x7.02d3edfbc8b6p+0, -0x69p-16)

    @test /(bareinterval(0x9.ac412ff1f1478p-4, 0x75bcd15p0), bareinterval(-0x1.5232c83a0e726p+4, -0x9p0)) === bareinterval(-0xd14fadp0, -0x7.52680a49e5d68p-8)

    @test /(bareinterval(0xe.1552a314d629p-4, 0x1.064c5adfd0042p+0), bareinterval(-0x5.0d4d319a50b04p-4, -0x2.d8f51df1e322ep-4)) === bareinterval(-0x5.c1d97d57d81ccp+0, -0x2.c9a600c455f5ap+0)

    @test /(bareinterval(0x754ep0, 0xeeeep0), bareinterval(-0x11ep0, 0.0)) === bareinterval(-Inf, -0x69p0)

    @test /(bareinterval(0x1.a9016514490e6p-4, 0xeeeep0), bareinterval(-0xe.316e87be0b24p-4, 0.0)) === bareinterval(-Inf, -0x1.df1cc82e6a583p-4)

    @test /(bareinterval(5.0, 6.0), bareinterval(-0x5.0d4d319a50b04p-4, 0x2.d8f51df1e322ep-4)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0x754ep0, +0xeeeeep0), bareinterval(0.0, +0x11ep0)) === bareinterval(0x69p0, +Inf)

    @test /(bareinterval(0x1.7f03f2a978865p+0, 0xeeeeep0), bareinterval(0.0, 0x1.48b08624606b9p+0)) === bareinterval(0x1.2a4fcda56843p+0, +Inf)

    @test /(bareinterval(0x5efc1492p0, 0x1ba2dc763p0), bareinterval(0x2fdd1fp0, 0x889b71p0)) === bareinterval(0xb2p0, 0x93dp0)

    @test /(bareinterval(0x1.d7c06f9ff0706p-8, 0x1ba2dc763p0), bareinterval(0x2fdd1fp-20, 0xe.3d7a59e2bdacp+0)) === bareinterval(0x2.120d75be74b54p-12, 0x93dp+20)

    @test /(bareinterval(0x5.efc1492p-4, 0x1.008a3accc766dp+0), bareinterval(0x2.497403b31d32ap+0, 0x8.89b71p+0)) === bareinterval(0xb.2p-8, 0x7.02d3edfbc8b6p-4)

    @test /(bareinterval(0x8.440e7d65be6bp-8, 0x3.99982e9eae09ep+0), bareinterval(0x8.29fa8d0659e48p-4, 0xc.13d2fd762e4a8p-4)) === bareinterval(0xa.f3518768b206p-8, 0x7.0e2acad54859cp+0)

end

@testset "mpfi_div_d" begin

    @test /(bareinterval(-Inf, -7.0), bareinterval(-7.0, -7.0)) === bareinterval(1.0, +Inf)

    @test /(bareinterval(-Inf, -7.0), bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test /(bareinterval(-Inf, -7.0), bareinterval(7.0, 7.0)) === bareinterval(-Inf, -1.0)

    @test /(bareinterval(-Inf, 0.0), bareinterval(-0x170ef54646d497p-106, -0x170ef54646d497p-106)) === bareinterval(0.0, +Inf)

    @test /(bareinterval(-Inf, 0.0), bareinterval(0x170ef54646d497p-106, 0x170ef54646d497p-106)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(-Inf, 8.0), bareinterval(-3.0, -3.0)) === bareinterval(-0x15555555555556p-51, +Inf)

    @test /(bareinterval(-Inf, 8.0), bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test /(bareinterval(-Inf, 8.0), bareinterval(3.0, 3.0)) === bareinterval(-Inf, 0x15555555555556p-51)

    @test /(entireinterval(BareInterval{Float64}), bareinterval(-0x170ef54646d497p-105, -0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test /(entireinterval(BareInterval{Float64}), bareinterval(0.0e-17, 0.0e-17)) === emptyinterval(BareInterval{Float64})

    @test /(entireinterval(BareInterval{Float64}), bareinterval(+0x170ef54646d497p-105, +0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(0.0, 0.0), bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0.0, 0.0), bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109)) === bareinterval(0.0, 0.0)

    @test /(bareinterval(0.0, 8.0), bareinterval(-0x114b37f4b51f71p-107, -0x114b37f4b51f71p-107)) === bareinterval(-0x1d9b1f5d20d556p+5, 0.0)

    @test /(bareinterval(0.0, 8.0), bareinterval(0x114b37f4b51f71p-107, 0x114b37f4b51f71p-107)) === bareinterval(0.0, 0x1d9b1f5d20d556p+5)

    @test /(bareinterval(0.0, +Inf), bareinterval(-0x50b45a75f7e81p-104, -0x50b45a75f7e81p-104)) === bareinterval(-Inf, 0.0)

    @test /(bareinterval(0.0, +Inf), bareinterval(0x142d169d7dfa03p-106, 0x142d169d7dfa03p-106)) === bareinterval(0.0, +Inf)

    @test /(bareinterval(-0x10000000000001p-20, -0x10000000000001p-53), bareinterval(-1.0, -1.0)) === bareinterval(0x10000000000001p-53, 0x10000000000001p-20)

    @test /(bareinterval(-0x10000000000002p-20, -0x10000000000001p-53), bareinterval(0x10000000000001p-53, 0x10000000000001p-53)) === bareinterval(-0x10000000000001p-19, -1.0)

    @test /(bareinterval(-0x10000000000001p-20, -0x10000020000001p-53), bareinterval(0x10000000000001p-53, 0x10000000000001p-53)) === bareinterval(-0x1p+33, -0x1000001fffffffp-52)

    @test /(bareinterval(-0x10000000000002p-20, -0x10000020000001p-53), bareinterval(0x10000000000001p-53, 0x10000000000001p-53)) === bareinterval(-0x10000000000001p-19, -0x1000001fffffffp-52)

    @test /(bareinterval(-0x123456789abcdfp-53, 0x123456789abcdfp-7), bareinterval(-0x123456789abcdfp0, -0x123456789abcdfp0)) === bareinterval(-0x1p-7, 0x1p-53)

    @test /(bareinterval(-0x123456789abcdfp-53, 0x10000000000001p-53), bareinterval(-0x123456789abcdfp0, -0x123456789abcdfp0)) === bareinterval(-0x1c200000000002p-106, 0x1p-53)

    @test /(bareinterval(-1.0, 0x123456789abcdfp-7), bareinterval(-0x123456789abcdfp0, -0x123456789abcdfp0)) === bareinterval(-0x1p-7, 0x1c200000000001p-105)

    @test /(bareinterval(-1.0, 0x10000000000001p-53), bareinterval(-0x123456789abcdfp0, -0x123456789abcdfp0)) === bareinterval(-0x1c200000000002p-106, 0x1c200000000001p-105)

end

@testset "mpfi_d_sub" begin

    @test -(bareinterval(-0x170ef54646d497p-107, -0x170ef54646d497p-107), bareinterval(-Inf, -7.0)) === bareinterval(0x1bffffffffffffp-50, +Inf)

    @test -(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(7.0, +Inf)

    @test -(bareinterval(0x170ef54646d497p-107, 0x170ef54646d497p-107), bareinterval(-Inf, -7.0)) === bareinterval(7.0, +Inf)

    @test -(bareinterval(-0x170ef54646d497p-96, -0x170ef54646d497p-96), bareinterval(-Inf, 0.0)) === bareinterval(-0x170ef54646d497p-96, +Inf)

    @test -(bareinterval(0.0, 0.0), bareinterval(-Inf, 0.0)) === bareinterval(0.0, +Inf)

    @test -(bareinterval(0x170ef54646d497p-96, 0x170ef54646d497p-96), bareinterval(-Inf, 0.0)) === bareinterval(0x170ef54646d497p-96, +Inf)

    @test -(bareinterval(-0x16345785d8a00000p0, -0x16345785d8a00000p0), bareinterval(-Inf, 8.0)) === bareinterval(-0x16345785d8a00100p0, +Inf)

    @test -(bareinterval(0.0, 0.0), bareinterval(-Inf, 8.0)) === bareinterval(-8.0, +Inf)

    @test -(bareinterval(0x16345785d8a00000p0, 0x16345785d8a00000p0), bareinterval(-Inf, 8.0)) === bareinterval(0x16345785d89fff00p0, +Inf)

    @test -(bareinterval(-0x170ef54646d497p-105, -0x170ef54646d497p-105), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test -(bareinterval(0.0e-17, 0.0e-17), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test -(bareinterval(0x170ef54646d497p-105, 0x170ef54646d497p-105), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test -(bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109), bareinterval(0.0, 0.0)) === bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109)

    @test -(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test -(bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109), bareinterval(0.0, 0.0)) === bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109)

    @test -(bareinterval(-0x114b37f4b51f71p-107, -0x114b37f4b51f71p-107), bareinterval(0.0, 8.0)) === bareinterval(-0x10000000000001p-49, -0x114b37f4b51f71p-107)

    @test -(bareinterval(0.0, 0.0), bareinterval(0.0, 8.0)) === bareinterval(-8.0, 0.0)

    @test -(bareinterval(0x114b37f4b51f71p-107, 0x114b37f4b51f71p-107), bareinterval(0.0, 8.0)) === bareinterval(-8.0, 0x114b37f4b51f71p-107)

    @test -(bareinterval(-0x50b45a75f7e81p-104, -0x50b45a75f7e81p-104), bareinterval(0.0, +Inf)) === bareinterval(-Inf, -0x50b45a75f7e81p-104)

    @test -(bareinterval(0.0, 0.0), bareinterval(0.0, +Inf)) === bareinterval(-Inf, 0.0)

    @test -(bareinterval(-0x142d169d7dfa03p-106, -0x142d169d7dfa03p-106), bareinterval(0.0, +Inf)) === bareinterval(-Inf, -0x142d169d7dfa03p-106)

    @test -(bareinterval(-0xfb53d14aa9c2fp-47, -0xfb53d14aa9c2fp-47), bareinterval(17.0, 32.0)) === bareinterval(-0x1fb53d14aa9c2fp-47, -0x18353d14aa9c2fp-47)

    @test -(bareinterval(0xfb53d14aa9c2fp-47, 0xfb53d14aa9c2fp-47), bareinterval(17.0, 0xfb53d14aa9c2fp-47)) === bareinterval(0.0, 0x7353d14aa9c2fp-47)

    @test -(bareinterval(0xfb53d14aa9c2fp-48, 0xfb53d14aa9c2fp-48), bareinterval(0xfb53d14aa9c2fp-48, 32.0)) === bareinterval(-0x104ac2eb5563d1p-48, 0.0)

    @test -(bareinterval(3.5, 3.5), bareinterval(-0x123456789abcdfp-4, -0x123456789abcdfp-48)) === bareinterval(0x15b456789abcdfp-48, 0x123456789abd17p-4)

    @test -(bareinterval(3.5, 3.5), bareinterval(-0x123456789abcdfp-4, -0x123456789abcdfp-56)) === bareinterval(0x3923456789abcdp-52, 0x123456789abd17p-4)

    @test -(bareinterval(256.5, 256.5), bareinterval(-0x123456789abcdfp-52, 0xffp0)) === bareinterval(0x18p-4, 0x101a3456789abdp-44)

    @test -(bareinterval(4097.5, 4097.5), bareinterval(0x1p-550, 0x1fffffffffffffp-52)) === bareinterval(0xfff8p-4, 0x10018p-4)

    @test -(bareinterval(-3.5, -3.5), bareinterval(-0x123456789abcdfp-4, -0x123456789abcdfp-48)) === bareinterval(0xeb456789abcdfp-48, 0x123456789abca7p-4)

    @test -(bareinterval(-3.5, -3.5), bareinterval(-0x123456789abcdfp-4, -0x123456789abcdfp-56)) === bareinterval(-0x36dcba98765434p-52, 0x123456789abca7p-4)

    @test -(bareinterval(-256.5, -256.5), bareinterval(-0x123456789abcdfp-52, 0xffp0)) === bareinterval(-0x1ff8p-4, -0xff5cba9876543p-44)

    @test -(bareinterval(-4097.5, -4097.5), bareinterval(0x1p-550, 0x1fffffffffffffp-52)) === bareinterval(-0x10038p-4, -0x10018p-4)

end

@testset "mpfi_exp" begin

    @test exp(bareinterval(-Inf, -7.0)) === bareinterval(0.0, 0x1de16b9c24a98fp-63)

    @test exp(bareinterval(-Inf, 0.0)) === bareinterval(0.0, 1.0)

    @test exp(bareinterval(-Inf, +1.0)) === bareinterval(0.0, 0x15bf0a8b14576ap-51)

    @test exp(entireinterval(BareInterval{Float64})) === bareinterval(0.0, +Inf)

    @test exp(bareinterval(0.0, 0.0)) === bareinterval(1.0, 1.0)

    @test exp(bareinterval(0.0, +1.0)) === bareinterval(1.0, 0x15bf0a8b14576ap-51)

    @test exp(bareinterval(0.0, +Inf)) === bareinterval(1.0, +Inf)

    @test exp(bareinterval(-123.0, -17.0)) === bareinterval(0x1766b45dd84f17p-230, 0x1639e3175a689dp-77)

    @test exp(bareinterval(-0.125, 0.25)) === bareinterval(0x1c3d6a24ed8221p-53, 0x148b5e3c3e8187p-52)

    @test exp(bareinterval(-0.125, 0.0)) === bareinterval(0x1c3d6a24ed8221p-53, 1.0)

    @test exp(bareinterval(0.0, 0.25)) === bareinterval(1.0, 0x148b5e3c3e8187p-52)

    @test exp(bareinterval(0xap-47, 0xbp-47)) === bareinterval(0x10000000000140p-52, 0x10000000000161p-52)

end

@testset "mpfi_exp2" begin

    @test exp2(bareinterval(-Inf, -1.0)) === bareinterval(0.0, 0.5)

    @test exp2(bareinterval(-Inf, 0.0)) === bareinterval(0.0, 1.0)

    @test exp2(bareinterval(-Inf, 1.0)) === bareinterval(0.0, 2.0)

    @test exp2(entireinterval(BareInterval{Float64})) === bareinterval(0.0, +Inf)

    @test exp2(bareinterval(0.0, 0.0)) === bareinterval(1.0, 1.0)

    @test exp2(bareinterval(0.0, +1.0)) === bareinterval(1.0, 2.0)

    @test exp2(bareinterval(0.0, +Inf)) === bareinterval(1.0, +Inf)

    @test exp2(bareinterval(-123.0, -17.0)) === bareinterval(0x1p-123, 0x1p-17)

    @test exp2(bareinterval(-7.0, 7.0)) === bareinterval(0x1p-7, 0x1p+7)

    @test exp2(bareinterval(-0.125, 0.25)) === bareinterval(0x1d5818dcfba487p-53, 0x1306fe0a31b716p-52)

    @test exp2(bareinterval(-0.125, 0.0)) === bareinterval(0x1d5818dcfba487p-53, 1.0)

    @test exp2(bareinterval(0.0, 0.25)) === bareinterval(1.0, 0x1306fe0a31b716p-52)

    @test exp2(bareinterval(0xap-47, 0xbp-47)) === bareinterval(0x100000000000ddp-52, 0x100000000000f4p-52)

end

@testset "mpfi_expm1" begin

    @test expm1(bareinterval(-Inf, -7.0)) === bareinterval(-1.0, -0x1ff887a518f6d5p-53)

    @test expm1(bareinterval(-Inf, 0.0)) === bareinterval(-1.0, 0.0)

    @test expm1(bareinterval(-Inf, 1.0)) === bareinterval(-1.0, 0x1b7e151628aed3p-52)

    @test expm1(entireinterval(BareInterval{Float64})) === bareinterval(-1.0, +Inf)

    @test expm1(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test expm1(bareinterval(0.0, 1.0)) === bareinterval(0.0, 0x1b7e151628aed3p-52)

    @test expm1(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test expm1(bareinterval(-36.0, -36.0)) === bareinterval(-0x1ffffffffffffep-53, -0x1ffffffffffffdp-53)

    @test expm1(bareinterval(-0.125, 0.25)) === bareinterval(-0x1e14aed893eef4p-56, 0x122d78f0fa061ap-54)

    @test expm1(bareinterval(-0.125, 0.0)) === bareinterval(-0x1e14aed893eef4p-56, 0.0)

    @test expm1(bareinterval(0.0, 0.25)) === bareinterval(0.0, 0x122d78f0fa061ap-54)

    @test expm1(bareinterval(0xap-47, 0xbp-47)) === bareinterval(0x140000000000c8p-96, 0x160000000000f3p-96)

end

@testset "mpfi_hypot" begin

    @test hypot(bareinterval(-Inf, -7.0), bareinterval(-1.0, 8.0)) === bareinterval(7.0, +Inf)

    @test hypot(bareinterval(-Inf, 0.0), bareinterval(8.0, +Inf)) === bareinterval(8.0, +Inf)

    @test hypot(bareinterval(-Inf, 8.0), bareinterval(0.0, 8.0)) === bareinterval(0.0, +Inf)

    @test hypot(entireinterval(BareInterval{Float64}), bareinterval(0.0, 8.0)) === bareinterval(0.0, +Inf)

    @test hypot(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(7.0, +Inf)

    @test hypot(bareinterval(0.0, 3.0), bareinterval(-4.0, 0.0)) === bareinterval(0.0, 5.0)

    @test hypot(bareinterval(0.0, 0.0), bareinterval(0.0, 8.0)) === bareinterval(0.0, 8.0)

    @test hypot(bareinterval(0.0, +Inf), bareinterval(0.0, 8.0)) === bareinterval(0.0, +Inf)

    @test hypot(bareinterval(0.0, 0.0), bareinterval(8.0, +Inf)) === bareinterval(8.0, +Inf)

    @test hypot(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === bareinterval(0.0, +Inf)

    @test hypot(bareinterval(0.0, 5.0), bareinterval(0.0, 12.0)) === bareinterval(0.0, 13.0)

    @test hypot(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test hypot(bareinterval(0.0, +Inf), bareinterval(-7.0, 8.0)) === bareinterval(0.0, +Inf)

    @test hypot(bareinterval(-12.0, -5.0), bareinterval(-35.0, -12.0)) === bareinterval(13.0, 37.0)

    @test hypot(bareinterval(6.0, 7.0), bareinterval(1.0, 24.0)) === bareinterval(0x1854bfb363dc39p-50, 25.0)

    @test hypot(bareinterval(-4.0, +7.0), bareinterval(-25.0, 3.0)) === bareinterval(0.0, 0x19f625847a5899p-48)

    @test hypot(bareinterval(0x1854bfb363dc39p-50, 0x19f625847a5899p-48), bareinterval(0x1854bfb363dc39p-50, 0x19f625847a5899p-48)) === bareinterval(0x113463fa37014dp-49, 0x125b89092b8fc0p-47)

end

@testset "mpfi_intersect" begin

    @test intersect_interval(bareinterval(-Inf, -7.0), bareinterval(-1.0, +8.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(-Inf, 0.0), bareinterval(+8.0, +Inf)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(-Inf, +8.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test intersect_interval(entireinterval(BareInterval{Float64}), bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test intersect_interval(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(0.0, +8.0), bareinterval(-7.0, 0.0)) === bareinterval(0.0, 0.0)

    @test intersect_interval(bareinterval(0.0, 0.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, 0.0)

    @test intersect_interval(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test intersect_interval(bareinterval(0.0, 0.0), bareinterval(+8.0, +Inf)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === bareinterval(0.0, 0.0)

    @test intersect_interval(bareinterval(0.0, +8.0), bareinterval(-7.0, +8.0)) === bareinterval(0.0, +8.0)

    @test intersect_interval(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test intersect_interval(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test intersect_interval(bareinterval(0x12p0, 0x90p0), bareinterval(-0x0dp0, 0x34p0)) === bareinterval(0x12p0, 0x34p0)

end

@testset "mpfi_inv" begin

    @test inv(bareinterval(-Inf, -.25)) === bareinterval(-4.0, 0.0)

    @test inv(bareinterval(-Inf, 0.0)) === bareinterval(-Inf, 0.0)

    @test inv(bareinterval(-Inf, +4.0)) === entireinterval(BareInterval{Float64})

    @test inv(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test inv(bareinterval(0.0, 0.0)) === emptyinterval(BareInterval{Float64})

    @test inv(bareinterval(0.0, +2.0)) === bareinterval(+.5, +Inf)

    @test inv(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test inv(bareinterval(-8.0, -2.0)) === bareinterval(-.5, -0.125)

    @test inv(bareinterval(0x1p-4, 0x1440c131282cd9p-53)) === bareinterval(0x1947bfce1bc417p-52, 0x10p0)

    @test inv(bareinterval(0x19f1a539c91fddp-55, +64.0)) === bareinterval(0.015625, 0x13bc205a76b3fdp-50)

    @test inv(bareinterval(-0xae83b95effd69p-52, -0x63e3cb4ed72a3p-53)) === bareinterval(-0x1480a9b5772a23p-50, -0x177887d65484c9p-52)

end

@testset "mpfi_is_neg" begin

    @test precedes(bareinterval(-Inf, -8.0), bareinterval(0.0, 0.0)) === true

    @test precedes(bareinterval(-Inf, 0.0), bareinterval(0.0, 0.0)) === true

    @test precedes(bareinterval(-Inf, 5.0), bareinterval(0.0, 0.0)) === false

    @test precedes(entireinterval(BareInterval{Float64}), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(-8.0, 0.0), bareinterval(0.0, 0.0)) === true

    @test precedes(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === true

    @test precedes(bareinterval(0.0, 5.0), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(0.0, +Inf), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(5.0, +Inf), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(-34.0, -17.0), bareinterval(0.0, 0.0)) === true

    @test precedes(bareinterval(-8.0, -1.0), bareinterval(0.0, 0.0)) === true

    @test precedes(bareinterval(-34.0, 17.0), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(-0x1921fb54442d18p-51, 0x1921fb54442d19p-51), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(+8.0, +0x7fffffffffffbp+51), bareinterval(0.0, 0.0)) === false

    @test precedes(bareinterval(+0x1fffffffffffffp-53, 2.0), bareinterval(0.0, 0.0)) === false

end

@testset "mpfi_is_nonneg" begin

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-Inf, -8.0)) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-Inf, 0.0)) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-Inf, 5.0)) === false

    @test isweakless(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-8.0, 0.0)) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === true

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(0.0, 5.0)) === true

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(0.0, +Inf)) === true

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(5.0, +Inf)) === true

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-34.0, -17.0)) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-8.0, -1.0)) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-34.0, 17.0)) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(-0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === false

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === true

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(+8.0, +0x7fffffffffffbp+51)) === true

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(+0x1fffffffffffffp-53, 2.0)) === true

end

@testset "mpfi_is_nonpos" begin

    @test isweakless(bareinterval(-Inf, -8.0), bareinterval(0.0, 0.0)) === true

    @test isweakless(bareinterval(-Inf, 0.0), bareinterval(0.0, 0.0)) === true

    @test isweakless(bareinterval(-Inf, 5.0), bareinterval(0.0, 0.0)) === false

    @test isweakless(entireinterval(BareInterval{Float64}), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(-8.0, 0.0), bareinterval(0.0, 0.0)) === true

    @test isweakless(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === true

    @test isweakless(bareinterval(0.0, 5.0), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(0.0, +Inf), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(5.0, +Inf), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(-34.0, -17.0), bareinterval(0.0, 0.0)) === true

    @test isweakless(bareinterval(-8.0, -1.0), bareinterval(0.0, 0.0)) === true

    @test isweakless(bareinterval(-34.0, 17.0), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(-0x1921fb54442d18p-51, 0x1921fb54442d19p-51), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(8.0, 0x7fffffffffffbp+51), bareinterval(0.0, 0.0)) === false

    @test isweakless(bareinterval(0x1fffffffffffffp-53, 2.0), bareinterval(0.0, 0.0)) === false

end

@testset "mpfi_is_pos" begin

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-Inf, -8.0)) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-Inf, 0.0)) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-Inf, 5.0)) === false

    @test precedes(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-8.0, 0.0)) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === true

    @test precedes(bareinterval(0.0, 0.0), bareinterval(0.0, 5.0)) === true

    @test precedes(bareinterval(0.0, 0.0), bareinterval(0.0, +Inf)) === true

    @test precedes(bareinterval(0.0, 0.0), bareinterval(5.0, +Inf)) === true

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-34.0, -17.0)) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-8.0, -1.0)) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-34.0, 17.0)) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(-0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === false

    @test precedes(bareinterval(0.0, 0.0), bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === true

    @test precedes(bareinterval(0.0, 0.0), bareinterval(+8.0, +0x7fffffffffffbp+51)) === true

    @test precedes(bareinterval(0.0, 0.0), bareinterval(+0x1fffffffffffffp-53, 2.0)) === true

end

@testset "mpfi_is_strictly_neg" begin

    @test strictprecedes(bareinterval(-Inf, -8.0), bareinterval(0.0, 0.0)) === true

    @test strictprecedes(bareinterval(-Inf, 0.0), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(-Inf, 5.0), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(entireinterval(BareInterval{Float64}), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(-8.0, 0.0), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(0.0, 5.0), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(0.0, +Inf), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(5.0, +Inf), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(-34.0, -17.0), bareinterval(0.0, 0.0)) === true

    @test strictprecedes(bareinterval(-8.0, -1.0), bareinterval(0.0, 0.0)) === true

    @test strictprecedes(bareinterval(-34.0, 17.0), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(-0x1921fb54442d18p-51, 0x1921fb54442d19p-51), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(+8.0, +0x7fffffffffffbp+51), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(+0x1fffffffffffffp-53, 2.0), bareinterval(0.0, 0.0)) === false

end

@testset "mpfi_is_strictly_pos" begin

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-Inf, -8.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-Inf, 0.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-Inf, 5.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-8.0, 0.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(0.0, 5.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(0.0, +Inf)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(5.0, +Inf)) === true

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-34.0, -17.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-8.0, -1.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-34.0, 17.0)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(-0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === false

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === true

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(+8.0, +0x7fffffffffffbp+51)) === true

    @test strictprecedes(bareinterval(0.0, 0.0), bareinterval(+0x1fffffffffffffp-53, 2.0)) === true

end

@testset "mpfi_log" begin

    @test log(bareinterval(0.0, +1.0)) === bareinterval(-Inf, 0.0)

    @test log(bareinterval(0.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test log(bareinterval(+1.0, +1.0)) === bareinterval(0.0, 0.0)

    @test log(bareinterval(0x3a2a08c23afe3p-14, 0x1463ceb440d6bdp-14)) === bareinterval(0xc6dc8a2928579p-47, 0x1a9500bc7ffcc5p-48)

    @test log(bareinterval(0xb616ab8b683b5p-52, +1.0)) === bareinterval(-0x2b9b8b1fb2fb9p-51, 0.0)

    @test log(bareinterval(+1.0, 0x8ac74d932fae3p-21)) === bareinterval(0.0, 0x5380455576989p-46)

    @test log(bareinterval(0x4c322657ec89bp-16, 0x4d68ba5f26bf1p-11)) === bareinterval(0xbdee7228cfedfp-47, 0x1b3913fc99f555p-48)

end

@testset "mpfi_log1p" begin

    @test log1p(bareinterval(-1.0, 0.0)) === bareinterval(-Inf, 0.0)

    @test log1p(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test log1p(bareinterval(0.0, 1.0)) === bareinterval(0.0, 0x162e42fefa39f0p-53)

    @test log1p(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test log1p(bareinterval(-0xb616ab8b683b5p-52, 0.0)) === bareinterval(-0x13e080325bab7bp-52, 0.0)

    @test log1p(bareinterval(0.0, 0x8ac74d932fae3p-21)) === bareinterval(0.0, 0x14e0115561569cp-48)

    @test log1p(bareinterval(0x4c322657ec89bp-16, 0x4d68ba5f26bf1p-11)) === bareinterval(0x17bdce451a337fp-48, 0x1b3913fc99f6fcp-48)

end

@testset "mpfi_log2" begin

    @test log2(bareinterval(0.0, +1.0)) === bareinterval(-Inf, 0.0)

    @test log2(bareinterval(0.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test log2(bareinterval(1.0, 1.0)) === bareinterval(0.0, 0.0)

    @test log2(bareinterval(0xb616ab8b683b5p-52, 1.0)) === bareinterval(-0x1f74cb5d105b3ap-54, 0.0)

    @test log2(bareinterval(1.0, 0x8ac74d932fae3p-21)) === bareinterval(0.0, 0x1e1ddc27c2c70fp-48)

    @test log2(bareinterval(0x4c322657ec89bp-16, 0x4d68ba5f26bf1p-11)) === bareinterval(0x112035c9390c07p-47, 0x13a3208f61f10cp-47)

end

@testset "mpfi_log10" begin

    @test log10(bareinterval(0.0, 1.0)) === bareinterval(-Inf, 0.0)

    @test log10(bareinterval(0.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test log10(bareinterval(1.0, 1.0)) === bareinterval(0.0, 0.0)

    @test log10(bareinterval(0x3a2a08c23afe3p-14, 0x1463ceb440d6bdp-14)) === bareinterval(0x159753104a9401p-49, 0x1716c01a04b570p-49)

    @test log10(bareinterval(0xb616ab8b683b5p-52, 1.0)) === bareinterval(-0x12f043ec00f8d6p-55, 0.0)

    @test log10(bareinterval(100.0, 0x8ac74d932fae3p-21)) === bareinterval(2.0, 0x1221cc590b9946p-49)

    @test log10(bareinterval(0x4c322657ec89bp-16, 0x4d68ba5f26bf1p-11)) === bareinterval(0x149f1d70168f49p-49, 0x17a543a94fb65ep-49)

end

@testset "mpfi_mag" begin

    @test mag(bareinterval(-Inf, -8.0)) === +Inf

    @test mag(bareinterval(-Inf, 0.0)) === +Inf

    @test mag(bareinterval(-Inf, 5.0)) === +Inf

    @test mag(entireinterval(BareInterval{Float64})) === +Inf

    @test mag(bareinterval(-Inf, 0.0)) === +Inf

    @test mag(bareinterval(-8.0, 0.0)) === +8.0

    @test mag(bareinterval(0.0, 0.0)) === +0.0

    @test mag(bareinterval(0.0, 5.0)) === +5.0

    @test mag(bareinterval(0.0, +Inf)) === +Inf

    @test mag(bareinterval(-34.0, -17.0)) === 34.0

end

@testset "mpfi_mid" begin

    @test mid(bareinterval(-8.0, 0.0)) === -4.0

    @test mid(bareinterval(0.0, 0.0)) === +0.0

    @test mid(bareinterval(0.0, 5.0)) === +2.5

    @test mid(bareinterval(-34.0, -17.0)) === -0x33p-1

    @test mid(bareinterval(-34.0, 17.0)) === -8.5

    @test mid(bareinterval(0.0, +0x123456789abcdp-2)) === +0x123456789abcdp-3

    @test mid(bareinterval(0x1921fb54442d18p-51, 0x1921fb54442d19p-51)) === 0x1921fb54442d18p-51

    @test mid(bareinterval(-0x1921fb54442d19p-51, -0x1921fb54442d18p-51)) === -0x1921fb54442d18p-51

    @test mid(bareinterval(-4.0, -0x7fffffffffffdp-51)) === -0x27fffffffffffbp-52

    @test mid(bareinterval(-8.0, -0x7fffffffffffbp-51)) === -0x47fffffffffffbp-52

    @test mid(bareinterval(-0x1fffffffffffffp-53, 2.0)) === 0.5

end

@testset "mpfi_mig" begin

    @test mig(bareinterval(-Inf, -8.0)) === 8.0

    @test mig(bareinterval(-Inf, 0.0)) === +0.0

    @test mig(bareinterval(-Inf, 5.0)) === +0.0

    @test mig(entireinterval(BareInterval{Float64})) === +0.0

    @test mig(bareinterval(-Inf, 0.0)) === +0.0

    @test mig(bareinterval(-8.0, 0.0)) === +0.0

    @test mig(bareinterval(0.0, 0.0)) === +0.0

    @test mig(bareinterval(0.0, 5.0)) === +0.0

    @test mig(bareinterval(0.0, +Inf)) === +0.0

    @test mig(bareinterval(-34.0, -17.0)) === 17.0

end

@testset "mpfi_mul" begin

    @test *(bareinterval(-Inf, -7.0), bareinterval(-1.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test *(bareinterval(-Inf, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(-Inf, 0.0)

    @test *(bareinterval(-Inf, +8.0), bareinterval(0.0, +8.0)) === bareinterval(-Inf, +64.0)

    @test *(entireinterval(BareInterval{Float64}), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(entireinterval(BareInterval{Float64}), bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test *(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, +8.0), bareinterval(-7.0, 0.0)) === bareinterval(-56.0, 0.0)

    @test *(bareinterval(0.0, 0.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +Inf)

    @test *(bareinterval(0.0, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, +8.0), bareinterval(-7.0, +8.0)) === bareinterval(-56.0, +64.0)

    @test *(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +Inf)

    @test *(bareinterval(-3.0, +7.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(-0x0dp0, -0x09p0), bareinterval(-0x04p0, -0x02p0)) === bareinterval(0x12p0, 0x34p0)

    @test *(bareinterval(-0x0dp0, -0xd.f0e7927d247cp-4), bareinterval(-0x04p0, -0xa.41084aff48f8p-8)) === bareinterval(0x8.ef3aa21dba748p-8, 0x34p0)

    @test *(bareinterval(-0xe.26c9e9eb67b48p-4, -0x8.237d2eb8b1178p-4), bareinterval(-0x5.8c899a0706d5p-4, -0x3.344e57a37b5e8p-4)) === bareinterval(0x1.a142a930de328p-4, 0x4.e86c3434cd924p-4)

    @test *(bareinterval(-0x37p0, -0x07p0), bareinterval(-0x01p0, 0x22p0)) === bareinterval(-0x74ep0, 0x37p0)

    @test *(bareinterval(-0xe.063f267ed51ap-4, -0x0.33p0), bareinterval(-0x01p0, 0x1.777ab178b4a1ep+0)) === bareinterval(-0x1.491df346a9f15p+0, 0xe.063f267ed51ap-4)

    @test *(bareinterval(-0x1.cb540b71699a8p+4, -0x0.33p0), bareinterval(-0x1.64dcaaa101f18p+0, 0x01p0)) === bareinterval(-0x1.cb540b71699a8p+4, 0x2.804cce4a3f42ep+4)

    @test *(bareinterval(-0x1.cb540b71699a8p+4, -0x0.33p0), bareinterval(-0x1.64dcaaa101f18p+0, 0x1.eb67a1a6ef725p+4)) === bareinterval(-0x3.71b422ce817f4p+8, 0x2.804cce4a3f42ep+4)

    @test *(bareinterval(-0x123456789ap0, -0x01p0), bareinterval(0x01p0, 0x10p0)) === bareinterval(-0x123456789a0p0, -0x01p0)

    @test *(bareinterval(-0xb.6c67d3a37d54p-4, -0x0.8p0), bareinterval(0x02p0, 0x2.0bee4e8bb3dfp+0)) === bareinterval(-0x1.7611a672948a5p+0, -0x01p0)

    @test *(bareinterval(-0x04p0, -0xa.497d533c3b2ep-8), bareinterval(0xb.d248df3373e68p-4, 0x04p0)) === bareinterval(-0x10p0, -0x7.99b990532d434p-8)

    @test *(bareinterval(-0xb.6c67d3a37d54p-4, -0xa.497d533c3b2ep-8), bareinterval(0xb.d248df3373e68p-4, 0x2.0bee4e8bb3dfp+0)) === bareinterval(-0x1.7611a672948a5p+0, -0x7.99b990532d434p-8)

    @test *(bareinterval(-0x01p0, 0x11p0), bareinterval(-0x07p0, -0x04p0)) === bareinterval(-0x77p0, 0x07p0)

    @test *(bareinterval(-0x01p0, 0xe.ca7ddfdb8572p-4), bareinterval(-0x2.3b46226145234p+0, -0x0.1p0)) === bareinterval(-0x2.101b41d3d48b8p+0, 0x2.3b46226145234p+0)

    @test *(bareinterval(-0x1.1d069e75e8741p+8, 0x01p0), bareinterval(-0x2.3b46226145234p+0, -0x0.1p0)) === bareinterval(-0x2.3b46226145234p+0, 0x2.7c0bd9877f404p+8)

    @test *(bareinterval(-0xe.ca7ddfdb8572p-4, 0x1.1d069e75e8741p+8), bareinterval(-0x2.3b46226145234p+0, -0x0.1p0)) === bareinterval(-0x2.7c0bd9877f404p+8, 0x2.101b41d3d48b8p+0)

    @test *(bareinterval(-0x01p0, 0x10p0), bareinterval(-0x02p0, 0x03p0)) === bareinterval(-0x20p0, 0x30p0)

    @test *(bareinterval(-0x01p0, 0x2.db091cea593fap-4), bareinterval(-0x2.6bff2625fb71cp-4, 0x1p-8)) === bareinterval(-0x6.ea77a3ee43de8p-8, 0x2.6bff2625fb71cp-4)

    @test *(bareinterval(-0x01p0, 0x6.e211fefc216ap-4), bareinterval(-0x1p-4, 0x1.8e3fe93a4ea52p+0)) === bareinterval(-0x1.8e3fe93a4ea52p+0, 0xa.b52fe22d72788p-4)

    @test *(bareinterval(-0x1.15e079e49a0ddp+0, 0x1p-8), bareinterval(-0x2.77fc84629a602p+0, 0x8.3885932f13fp-4)) === bareinterval(-0x8.ec5de73125be8p-4, 0x2.adfe651d3b19ap+0)

    @test *(bareinterval(-0x07p0, 0x07p0), bareinterval(0x13p0, 0x24p0)) === bareinterval(-0xfcp0, 0xfcp0)

    @test *(bareinterval(-0xa.8071f870126cp-4, 0x10p0), bareinterval(0x02p0, 0x2.3381083e7d3b4p+0)) === bareinterval(-0x1.71dc5b5607781p+0, 0x2.3381083e7d3b4p+4)

    @test *(bareinterval(-0x01p0, 0x1.90aa487ecf153p+0), bareinterval(0x01p-53, 0x1.442e2695ac81ap+0)) === bareinterval(-0x1.442e2695ac81ap+0, 0x1.fb5fbebd0cbc6p+0)

    @test *(bareinterval(-0x1.c40db77f2f6fcp+0, 0x1.8eb70bbd94478p+0), bareinterval(0x02p0, 0x3.45118635235c6p+0)) === bareinterval(-0x5.c61fcad908df4p+0, 0x5.17b7c49130824p+0)

    @test *(bareinterval(0xcp0, 0x2dp0), bareinterval(-0x679p0, -0xe5p0)) === bareinterval(-0x12345p0, -0xabcp0)

    @test *(bareinterval(0xcp0, 0x1.1833fdcab4c4ap+10), bareinterval(-0x2.4c0afc50522ccp+40, -0xe5p0)) === bareinterval(-0x2.83a3712099234p+50, -0xabcp0)

    @test *(bareinterval(0xb.38f1fb0ef4308p+0, 0x2dp0), bareinterval(-0x679p0, -0xa.4771d7d0c604p+0)) === bareinterval(-0x12345p0, -0x7.35b3c8400ade4p+4)

    @test *(bareinterval(0xf.08367984ca1cp-4, 0xa.bcf6c6cbe341p+0), bareinterval(-0x5.cbc445e9952c4p+0, -0x2.8ad05a7b988fep-8)) === bareinterval(-0x3.e3ce52d4a139cp+4, -0x2.637164cf2f346p-8)

    @test *(bareinterval(0x01p0, 0xcp0), bareinterval(-0xe5p0, 0x01p0)) === bareinterval(-0xabcp0, 0xcp0)

    @test *(bareinterval(0x123p-52, 0x1.ec24910ac6aecp+0), bareinterval(-0xa.a97267f56a9b8p-4, 0x1p+32)) === bareinterval(-0x1.47f2dbe4ef916p+0, 0x1.ec24910ac6aecp+32)

    @test *(bareinterval(0x03p0, 0x7.2bea531ef4098p+0), bareinterval(-0x01p0, 0xa.a97267f56a9b8p-4)) === bareinterval(-0x7.2bea531ef4098p+0, 0x4.c765967f9468p+0)

    @test *(bareinterval(0x0.3p0, 0xa.a97267f56a9b8p-4), bareinterval(-0x1.ec24910ac6aecp+0, 0x7.2bea531ef4098p+0)) === bareinterval(-0x1.47f2dbe4ef916p+0, 0x4.c765967f9468p+0)

    @test *(bareinterval(0x3p0, 0x7p0), bareinterval(0x5p0, 0xbp0)) === bareinterval(0xfp0, 0x4dp0)

    @test *(bareinterval(0x2.48380232f6c16p+0, 0x7p0), bareinterval(0x3.71cb6c53e68eep+0, 0xbp0)) === bareinterval(0x7.dc58fb323ad78p+0, 0x4dp0)

    @test *(bareinterval(0x3p0, 0x3.71cb6c53e68eep+0), bareinterval(0x5p-25, 0x2.48380232f6c16p+0)) === bareinterval(0xfp-25, 0x7.dc58fb323ad7cp+0)

    @test *(bareinterval(0x3.10e8a605572p-4, 0x2.48380232f6c16p+0), bareinterval(0xc.3d8e305214ecp-4, 0x2.9e7db05203c88p+0)) === bareinterval(0x2.587a32d02bc04p-4, 0x5.fa216b7c20c6cp+0)

end

@testset "mpfi_mul_d" begin

    @test *(bareinterval(-Inf, -7.0), bareinterval(-0x17p0, -0x17p0)) === bareinterval(+0xa1p0, +Inf)

    @test *(bareinterval(-Inf, -7.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(-Inf, -7.0), bareinterval(0x170ef54646d497p-107, 0x170ef54646d497p-107)) === bareinterval(-Inf, -0xa168b4ebefd020p-107)

    @test *(bareinterval(-Inf, 0.0), bareinterval(-0x170ef54646d497p-106, -0x170ef54646d497p-106)) === bareinterval(0.0, +Inf)

    @test *(bareinterval(-Inf, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(-Inf, 0.0), bareinterval(0x170ef54646d497p-106, 0x170ef54646d497p-106)) === bareinterval(-Inf, 0.0)

    @test *(bareinterval(-Inf, 8.0), bareinterval(-0x16345785d8a00000p0, -0x16345785d8a00000p0)) === bareinterval(-0xb1a2bc2ec5000000p0, +Inf)

    @test *(bareinterval(-Inf, 8.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(-Inf, 8.0), bareinterval(0x16345785d8a00000p0, 0x16345785d8a00000p0)) === bareinterval(-Inf, 0xb1a2bc2ec5000000p0)

    @test *(entireinterval(BareInterval{Float64}), bareinterval(-0x170ef54646d497p-105, -0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test *(entireinterval(BareInterval{Float64}), bareinterval(0.0e-17, 0.0e-17)) === bareinterval(0.0, 0.0)

    @test *(entireinterval(BareInterval{Float64}), bareinterval(+0x170ef54646d497p-105, +0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test *(bareinterval(0.0, 0.0), bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, 0.0), bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, 7.0), bareinterval(-0x114b37f4b51f71p-107, -0x114b37f4b51f71p-107)) === bareinterval(-0x790e87b0f3dc18p-107, 0.0)

    @test *(bareinterval(0.0, 8.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, 9.0), bareinterval(0x114b37f4b51f71p-103, 0x114b37f4b51f71p-103)) === bareinterval(0.0, 0x9ba4f79a5e1b00p-103)

    @test *(bareinterval(0.0, +Inf), bareinterval(-0x50b45a75f7e81p-104, -0x50b45a75f7e81p-104)) === bareinterval(-Inf, 0.0)

    @test *(bareinterval(0.0, +Inf), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test *(bareinterval(0.0, +Inf), bareinterval(0x142d169d7dfa03p-106, 0x142d169d7dfa03p-106)) === bareinterval(0.0, +Inf)

    @test *(bareinterval(-0x1717170p0, -0xaaaaaaaaaaaaap-123), bareinterval(-1.5, -1.5)) === bareinterval(0xfffffffffffffp-123, 0x22a2a28p0)

    @test *(bareinterval(-0xaaaaaaaaaaaaap0, 0x1717170p+401), bareinterval(-1.5, -1.5)) === bareinterval(-0x22a2a28p+401, 0xfffffffffffffp0)

    @test *(bareinterval(0x10000000000010p0, 0x888888888888p+654), bareinterval(-2.125, -2.125)) === bareinterval(-0x1222222222221p+654, -0x22000000000022p0)

    @test *(bareinterval(-0x1717170p0, -0xaaaaaaaaaaaaap-123), bareinterval(1.5, 1.5)) === bareinterval(-0x22a2a28p0, -0xfffffffffffffp-123)

    @test *(bareinterval(-0xaaaaaaaaaaaaap0, 0x1717170p+401), bareinterval(1.5, 1.5)) === bareinterval(-0xfffffffffffffp0, 0x22a2a28p+401)

    @test *(bareinterval(0x10000000000010p0, 0x888888888888p+654), bareinterval(2.125, 2.125)) === bareinterval(0x22000000000022p0, 0x1222222222221p+654)

    @test *(bareinterval(-0x1717170p+36, -0x10000000000001p0), bareinterval(-1.5, -1.5)) === bareinterval(0x18000000000001p0, 0x22a2a28p+36)

    @test *(bareinterval(-0xaaaaaaaaaaaaap0, 0x10000000000001p0), bareinterval(-1.5, -1.5)) === bareinterval(-0x18000000000002p0, 0xfffffffffffffp0)

    @test *(bareinterval(0x10000000000010p0, 0x11111111111111p0), bareinterval(-2.125, -2.125)) === bareinterval(-0x12222222222223p+1, -0x22000000000022p0)

    @test *(bareinterval(-0x10000000000001p0, -0xaaaaaaaaaaaaap-123), bareinterval(1.5, 1.5)) === bareinterval(-0x18000000000002p0, -0xfffffffffffffp-123)

    @test *(bareinterval(-0xaaaaaaaaaaaabp0, 0x1717170p+401), bareinterval(1.5, 1.5)) === bareinterval(-0x10000000000001p0, 0x22a2a28p+401)

    @test *(bareinterval(0x10000000000001p0, 0x888888888888p+654), bareinterval(2.125, 2.125)) === bareinterval(0x22000000000002p0, 0x1222222222221p+654)

    @test *(bareinterval(-0x11717171717171p0, -0xaaaaaaaaaaaaap-123), bareinterval(-1.5, -1.5)) === bareinterval(0xfffffffffffffp-123, 0x1a2a2a2a2a2a2ap0)

    @test *(bareinterval(-0x10000000000001p0, 0x1717170p+401), bareinterval(-1.5, -1.5)) === bareinterval(-0x22a2a28p+401, 0x18000000000002p0)

    @test *(bareinterval(0x10000000000001p0, 0x888888888888p+654), bareinterval(-2.125, -2.125)) === bareinterval(-0x1222222222221p+654, -0x22000000000002p0)

    @test *(bareinterval(-0x1717170p0, -0x1aaaaaaaaaaaaap-123), bareinterval(1.5, 1.5)) === bareinterval(-0x22a2a28p0, -0x27fffffffffffep-123)

    @test *(bareinterval(-0xaaaaaaaaaaaaap0, 0x11717171717171p0), bareinterval(1.5, 1.5)) === bareinterval(-0xfffffffffffffp0, 0x1a2a2a2a2a2a2ap0)

    @test *(bareinterval(0x10000000000010p0, 0x18888888888889p0), bareinterval(2.125, 2.125)) === bareinterval(0x22000000000022p0, 0x34222222222224p0)

    @test *(bareinterval(-0x11717171717171p0, -0x10000000000001p0), bareinterval(-1.5, -1.5)) === bareinterval(0x18000000000001p0, 0x1a2a2a2a2a2a2ap0)

    @test *(bareinterval(-0x10000000000001p0, 0x10000000000001p0), bareinterval(-1.5, -1.5)) === bareinterval(-0x18000000000002p0, 0x18000000000002p0)

    @test *(bareinterval(0x10000000000001p0, 0x11111111111111p0), bareinterval(-2.125, -2.125)) === bareinterval(-0x12222222222223p+1, -0x22000000000002p0)

    @test *(bareinterval(-0x10000000000001p0, -0x1aaaaaaaaaaaaap-123), bareinterval(1.5, 1.5)) === bareinterval(-0x18000000000002p0, -0x27fffffffffffep-123)

    @test *(bareinterval(-0xaaaaaaaaaaaabp0, 0x11717171717171p0), bareinterval(1.5, 1.5)) === bareinterval(-0x10000000000001p0, 0x1a2a2a2a2a2a2ap0)

    @test *(bareinterval(0x10000000000001p0, 0x18888888888889p0), bareinterval(2.125, 2.125)) === bareinterval(0x22000000000002p0, 0x34222222222224p0)

end

@testset "mpfi_neg" begin

    @test -(bareinterval(-Inf, -7.0)) === bareinterval(+7.0, +Inf)

    @test -(bareinterval(-Inf, 0.0)) === bareinterval(0.0, +Inf)

    @test -(bareinterval(-Inf, +8.0)) === bareinterval(-8.0, +Inf)

    @test -(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test -(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test -(bareinterval(0.0, +8.0)) === bareinterval(-8.0, 0.0)

    @test -(bareinterval(0.0, +Inf)) === bareinterval(-Inf, 0.0)

    @test -(bareinterval(0x123456789p-16, 0x123456799p-16)) === bareinterval(-0x123456799p-16, -0x123456789p-16)

end

@testset "mpfi_put_d" begin

    @test hull(bareinterval(0.0, 0.0), bareinterval(-8.0, -8.0)) === bareinterval(-8.0, 0.0)

    @test hull(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test hull(bareinterval(+5.0, +5.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, +5.0)

end

@testset "mpfi_sec" begin

    @test sec(bareinterval(-Inf, -7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-Inf, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-Inf, 8.0)) === entireinterval(BareInterval{Float64})

    @test sec(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-8.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-1.0, 0.0)) === bareinterval(1.0, 0x1d9cf0f125cc2ap-52)

    @test sec(bareinterval(0.0, 0.0)) === bareinterval(1.0, 1.0)

    @test sec(bareinterval(0.0, +1.0)) === bareinterval(1.0, 0x1d9cf0f125cc2ap-52)

    @test sec(bareinterval(0.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(0.0, 8.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(0.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, -4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-6.0, -5.0)) === bareinterval(0x10a9e8f3e19df1p-52, 0x1c33db0464189bp-51)

    @test sec(bareinterval(-6.0, -6.0)) === bareinterval(0x10a9e8f3e19df1p-52, 0x10a9e8f3e19df2p-52)

    @test sec(bareinterval(-5.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, -4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-5.0, -5.0)) === bareinterval(0x1c33db0464189ap-51, 0x1c33db0464189bp-51)

    @test sec(bareinterval(-4.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-4.0, -2.0)) === bareinterval(-0x133956fecf9e49p-51, -1.0)

    @test sec(bareinterval(-4.0, -3.0)) === bareinterval(-0x187a6961d2485fp-52, -1.0)

    @test sec(bareinterval(-4.0, -4.0)) === bareinterval(-0x187a6961d2485fp-52, -0x187a6961d2485ep-52)

    @test sec(bareinterval(-3.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-3.0, -2.0)) === bareinterval(-0x133956fecf9e49p-51, -0x102967b457b245p-52)

    @test sec(bareinterval(-3.0, -3.0)) === bareinterval(-0x102967b457b246p-52, -0x102967b457b245p-52)

    @test sec(bareinterval(-2.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-2.0, -2.0)) === bareinterval(-0x133956fecf9e49p-51, -0x133956fecf9e48p-51)

    @test sec(bareinterval(-1.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-1.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-1.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-1.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-1.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-1.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(-1.0, 1.0)) === bareinterval(1.0, 0x1d9cf0f125cc2ap-52)

    @test sec(bareinterval(-1.0, 0.0)) === bareinterval(1.0, 0x1d9cf0f125cc2ap-52)

    @test sec(bareinterval(-1.0, -1.0)) === bareinterval(0x1d9cf0f125cc29p-52, 0x1d9cf0f125cc2ap-52)

    @test sec(bareinterval(1.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(1.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(1.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(1.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(1.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(1.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(1.0, 1.0)) === bareinterval(0x1d9cf0f125cc29p-52, 0x1d9cf0f125cc2ap-52)

    @test sec(bareinterval(2.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(2.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(2.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(2.0, 4.0)) === bareinterval(-0x133956fecf9e49p-51, -1.0)

    @test sec(bareinterval(2.0, 3.0)) === bareinterval(-0x133956fecf9e49p-51, -0x102967b457b245p-52)

    @test sec(bareinterval(2.0, 2.0)) === bareinterval(-0x133956fecf9e49p-51, -0x133956fecf9e48p-51)

    @test sec(bareinterval(3.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(3.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(3.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(3.0, 4.0)) === bareinterval(-0x187a6961d2485fp-52, -1.0)

    @test sec(bareinterval(3.0, 3.0)) === bareinterval(-0x102967b457b246p-52, -0x102967b457b245p-52)

    @test sec(bareinterval(4.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(4.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(4.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test sec(bareinterval(4.0, 4.0)) === bareinterval(-0x187a6961d2485fp-52, -0x187a6961d2485ep-52)

    @test sec(bareinterval(5.0, 7.0)) === bareinterval(1.0, 0x1c33db0464189bp-51)

    @test sec(bareinterval(5.0, 6.0)) === bareinterval(0x10a9e8f3e19df1p-52, 0x1c33db0464189bp-51)

    @test sec(bareinterval(5.0, 5.0)) === bareinterval(0x1c33db0464189ap-51, 0x1c33db0464189bp-51)

    @test sec(bareinterval(6.0, 7.0)) === bareinterval(1.0, 0x153910a80e7db5p-52)

    @test sec(bareinterval(6.0, 6.0)) === bareinterval(0x10a9e8f3e19df1p-52, 0x10a9e8f3e19df2p-52)

    @test sec(bareinterval(7.0, 7.0)) === bareinterval(0x153910a80e7db4p-52, 0x153910a80e7db5p-52)

end

@testset "mpfi_sech" begin

    @test sech(bareinterval(-Inf, -7.0)) === bareinterval(0.0, 0x1de169fb49b339p-62)

    @test sech(bareinterval(-Inf, 0.0)) === bareinterval(0.0, 1.0)

    @test sech(bareinterval(-Inf, +8.0)) === bareinterval(0.0, 1.0)

    @test sech(entireinterval(BareInterval{Float64})) === bareinterval(0.0, 1.0)

    @test sech(bareinterval(-1.0, 0.0)) === bareinterval(0x14bcdc50ed6be7p-53, 1.0)

    @test sech(bareinterval(0.0, 0.0)) === bareinterval(1.0, 1.0)

    @test sech(bareinterval(0.0, +1.0)) === bareinterval(0x14bcdc50ed6be7p-53, 1.0)

    @test sech(bareinterval(0.0, +8.0)) === bareinterval(0x15fc20da8e18dbp-63, 1.0)

    @test sech(bareinterval(0.0, +Inf)) === bareinterval(0.0, 1.0)

    @test sech(bareinterval(-0.125, 0.0)) === bareinterval(0x1fc069fe3f72bep-53, 1.0)

    @test sech(bareinterval(0.0, 0x10000000000001p-53)) === bareinterval(0x1c60d1ff040dcfp-53, 1.0)

    @test sech(bareinterval(-4.5, -0.625)) === bareinterval(0x16bf984a9a2355p-58, 0x1aa0b464a5e24ap-53)

    @test sech(bareinterval(1.0, 3.0)) === bareinterval(0x196d8e17d88eb1p-56, 0x14bcdc50ed6be8p-53)

    @test sech(bareinterval(17.0, 0xb145bb71d3dbp-38)) === bareinterval(0x10000000000173p-1074, 0x1639e3175a6893p-76)

end

@testset "mpfi_sin" begin

    @test sin(bareinterval(-Inf, -7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-Inf, 0.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-Inf, +8.0)) === bareinterval(-1.0, 1.0)

    @test sin(entireinterval(BareInterval{Float64})) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-1.0, 0.0)) === bareinterval(-0x1aed548f090cefp-53, 0.0)

    @test sin(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test sin(bareinterval(0.0, +1.0)) === bareinterval(0.0, 0x1aed548f090cefp-53)

    @test sin(bareinterval(0.0, +8.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(0.0, +Inf)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(0.125, 17.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(0x1921fb54442d18p-52, 0x1921fb54442d19p-52)) === bareinterval(0x1fffffffffffffp-53, 1.0)

    @test sin(bareinterval(-2.0, -0.5)) === bareinterval(-1.0, -0x1eaee8744b05efp-54)

    @test sin(bareinterval(-4.5, 0.625)) === bareinterval(-1.0, 0x1f47ed3dc74081p-53)

    @test sin(bareinterval(-1.0, -0.25)) === bareinterval(-0x1aed548f090cefp-53, -0x1faaeed4f31576p-55)

    @test sin(bareinterval(-0.5, 0.5)) === bareinterval(-0x1eaee8744b05f0p-54, 0x1eaee8744b05f0p-54)

    @test sin(bareinterval(0x71p+76, 0x71p+76)) === bareinterval(0x1bde6c11cbfc46p-55, 0x1bde6c11cbfc47p-55)

    @test sin(bareinterval(-7.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, 4.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, 3.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, 2.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, 0.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, -1.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-7.0, -2.0)) === bareinterval(-0x1d18f6ead1b446p-53, 1.0)

    @test sin(bareinterval(-7.0, -3.0)) === bareinterval(-0x150608c26d0a09p-53, 1.0)

    @test sin(bareinterval(-7.0, -4.0)) === bareinterval(-0x150608c26d0a09p-53, 1.0)

    @test sin(bareinterval(-7.0, -5.0)) === bareinterval(-0x150608c26d0a09p-53, 0x1eaf81f5e09934p-53)

    @test sin(bareinterval(-7.0, -6.0)) === bareinterval(-0x150608c26d0a09p-53, 0x11e1f18ab0a2c1p-54)

    @test sin(bareinterval(-7.0, -7.0)) === bareinterval(-0x150608c26d0a09p-53, -0x150608c26d0a08p-53)

    @test sin(bareinterval(-6.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, 4.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, 3.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, 2.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, 0.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, -1.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-6.0, -2.0)) === bareinterval(-0x1d18f6ead1b446p-53, 1.0)

    @test sin(bareinterval(-6.0, -3.0)) === bareinterval(-0x1210386db6d55cp-55, 1.0)

    @test sin(bareinterval(-6.0, -4.0)) === bareinterval(0x11e1f18ab0a2c0p-54, 1.0)

    @test sin(bareinterval(-6.0, -5.0)) === bareinterval(0x11e1f18ab0a2c0p-54, 0x1eaf81f5e09934p-53)

    @test sin(bareinterval(-6.0, -6.0)) === bareinterval(0x11e1f18ab0a2c0p-54, 0x11e1f18ab0a2c1p-54)

    @test sin(bareinterval(-5.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, 4.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, 3.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, 2.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, 0.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, -1.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-5.0, -2.0)) === bareinterval(-0x1d18f6ead1b446p-53, 1.0)

    @test sin(bareinterval(-5.0, -3.0)) === bareinterval(-0x1210386db6d55cp-55, 1.0)

    @test sin(bareinterval(-5.0, -4.0)) === bareinterval(0x1837b9dddc1eaep-53, 1.0)

    @test sin(bareinterval(-5.0, -5.0)) === bareinterval(0x1eaf81f5e09933p-53, 0x1eaf81f5e09934p-53)

    @test sin(bareinterval(-4.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-4.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-4.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-4.0, 4.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-4.0, 3.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-4.0, 2.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-4.0, 1.0)) === bareinterval(-1.0, 0x1aed548f090cefp-53)

    @test sin(bareinterval(-4.0, 0.0)) === bareinterval(-1.0, 0x1837b9dddc1eafp-53)

    @test sin(bareinterval(-4.0, -1.0)) === bareinterval(-1.0, 0x1837b9dddc1eafp-53)

    @test sin(bareinterval(-4.0, -2.0)) === bareinterval(-0x1d18f6ead1b446p-53, 0x1837b9dddc1eafp-53)

    @test sin(bareinterval(-4.0, -3.0)) === bareinterval(-0x1210386db6d55cp-55, 0x1837b9dddc1eafp-53)

    @test sin(bareinterval(-4.0, -4.0)) === bareinterval(0x1837b9dddc1eaep-53, 0x1837b9dddc1eafp-53)

    @test sin(bareinterval(-3.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-3.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-3.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-3.0, 4.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-3.0, 3.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-3.0, 2.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-3.0, 1.0)) === bareinterval(-1.0, 0x1aed548f090cefp-53)

    @test sin(bareinterval(-3.0, 0.0)) === bareinterval(-1.0, 0.0)

    @test sin(bareinterval(-3.0, -1.0)) === bareinterval(-1.0, -0x1210386db6d55bp-55)

    @test sin(bareinterval(-3.0, -2.0)) === bareinterval(-0x1d18f6ead1b446p-53, -0x1210386db6d55bp-55)

    @test sin(bareinterval(-3.0, -3.0)) === bareinterval(-0x1210386db6d55cp-55, -0x1210386db6d55bp-55)

    @test sin(bareinterval(-2.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-2.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-2.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-2.0, 4.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-2.0, 3.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-2.0, 2.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-2.0, 1.0)) === bareinterval(-1.0, 0x1aed548f090cefp-53)

    @test sin(bareinterval(-2.0, 0.0)) === bareinterval(-1.0, 0.0)

    @test sin(bareinterval(-2.0, -1.0)) === bareinterval(-1.0, -0x1aed548f090ceep-53)

    @test sin(bareinterval(-2.0, -2.0)) === bareinterval(-0x1d18f6ead1b446p-53, -0x1d18f6ead1b445p-53)

    @test sin(bareinterval(-1.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-1.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-1.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(-1.0, 4.0)) === bareinterval(-0x1aed548f090cefp-53, 1.0)

    @test sin(bareinterval(-1.0, 3.0)) === bareinterval(-0x1aed548f090cefp-53, 1.0)

    @test sin(bareinterval(-1.0, 2.0)) === bareinterval(-0x1aed548f090cefp-53, 1.0)

    @test sin(bareinterval(-1.0, 1.0)) === bareinterval(-0x1aed548f090cefp-53, 0x1aed548f090cefp-53)

    @test sin(bareinterval(-1.0, 0.0)) === bareinterval(-0x1aed548f090cefp-53, 0.0)

    @test sin(bareinterval(-1.0, -1.0)) === bareinterval(-0x1aed548f090cefp-53, -0x1aed548f090ceep-53)

    @test sin(bareinterval(1.0, 7.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(1.0, 6.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(1.0, 5.0)) === bareinterval(-1.0, 1.0)

    @test sin(bareinterval(1.0, 4.0)) === bareinterval(-0x1837b9dddc1eafp-53, 1.0)

    @test sin(bareinterval(1.0, 3.0)) === bareinterval(0x1210386db6d55bp-55, 1.0)

    @test sin(bareinterval(1.0, 2.0)) === bareinterval(0x1aed548f090ceep-53, 1.0)

    @test sin(bareinterval(1.0, 1.0)) === bareinterval(0x1aed548f090ceep-53, 0x1aed548f090cefp-53)

    @test sin(bareinterval(2.0, 7.0)) === bareinterval(-1.0, 0x1d18f6ead1b446p-53)

    @test sin(bareinterval(2.0, 6.0)) === bareinterval(-1.0, 0x1d18f6ead1b446p-53)

    @test sin(bareinterval(2.0, 5.0)) === bareinterval(-1.0, 0x1d18f6ead1b446p-53)

    @test sin(bareinterval(2.0, 4.0)) === bareinterval(-0x1837b9dddc1eafp-53, 0x1d18f6ead1b446p-53)

    @test sin(bareinterval(2.0, 3.0)) === bareinterval(0x1210386db6d55bp-55, 0x1d18f6ead1b446p-53)

    @test sin(bareinterval(2.0, 2.0)) === bareinterval(0x1d18f6ead1b445p-53, 0x1d18f6ead1b446p-53)

    @test sin(bareinterval(3.0, 7.0)) === bareinterval(-1.0, 0x150608c26d0a09p-53)

    @test sin(bareinterval(3.0, 6.0)) === bareinterval(-1.0, 0x1210386db6d55cp-55)

    @test sin(bareinterval(3.0, 5.0)) === bareinterval(-1.0, 0x1210386db6d55cp-55)

    @test sin(bareinterval(3.0, 4.0)) === bareinterval(-0x1837b9dddc1eafp-53, 0x1210386db6d55cp-55)

    @test sin(bareinterval(3.0, 3.0)) === bareinterval(0x1210386db6d55bp-55, 0x1210386db6d55cp-55)

    @test sin(bareinterval(4.0, 7.0)) === bareinterval(-1.0, 0x150608c26d0a09p-53)

    @test sin(bareinterval(4.0, 6.0)) === bareinterval(-1.0, -0x11e1f18ab0a2c0p-54)

    @test sin(bareinterval(4.0, 5.0)) === bareinterval(-1.0, -0x1837b9dddc1eaep-53)

    @test sin(bareinterval(4.0, 4.0)) === bareinterval(-0x1837b9dddc1eafp-53, -0x1837b9dddc1eaep-53)

    @test sin(bareinterval(5.0, 7.0)) === bareinterval(-0x1eaf81f5e09934p-53, 0x150608c26d0a09p-53)

    @test sin(bareinterval(5.0, 6.0)) === bareinterval(-0x1eaf81f5e09934p-53, -0x11e1f18ab0a2c0p-54)

    @test sin(bareinterval(5.0, 5.0)) === bareinterval(-0x1eaf81f5e09934p-53, -0x1eaf81f5e09933p-53)

    @test sin(bareinterval(6.0, 7.0)) === bareinterval(-0x11e1f18ab0a2c1p-54, 0x150608c26d0a09p-53)

    @test sin(bareinterval(6.0, 6.0)) === bareinterval(-0x11e1f18ab0a2c1p-54, -0x11e1f18ab0a2c0p-54)

    @test sin(bareinterval(7.0, 7.0)) === bareinterval(0x150608c26d0a08p-53, 0x150608c26d0a09p-53)

end

@testset "mpfi_sinh" begin

    @test sinh(bareinterval(-Inf, -7.0)) === bareinterval(-Inf, -0x1122876ba380c9p-43)

    @test sinh(bareinterval(-Inf, 0.0)) === bareinterval(-Inf, 0.0)

    @test sinh(bareinterval(-Inf, +8.0)) === bareinterval(-Inf, 0x1749ea514eca66p-42)

    @test sinh(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test sinh(bareinterval(-1.0, 0.0)) === bareinterval(-0x12cd9fc44eb983p-52, 0.0)

    @test sinh(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test sinh(bareinterval(0.0, +1.0)) === bareinterval(0.0, 0x12cd9fc44eb983p-52)

    @test sinh(bareinterval(0.0, +8.0)) === bareinterval(0.0, 0x1749ea514eca66p-42)

    @test sinh(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test sinh(bareinterval(-0.125, 0.0)) === bareinterval(-0x100aaccd00d2f1p-55, 0.0)

    @test sinh(bareinterval(0.0, 0x10000000000001p-53)) === bareinterval(0.0, 0x10acd00fe63b98p-53)

    @test sinh(bareinterval(-4.5, -0.625)) === bareinterval(-0x168062ab5fa9fdp-47, -0x1553e795dc19ccp-53)

    @test sinh(bareinterval(1.0, 3.0)) === bareinterval(0x12cd9fc44eb982p-52, 0x140926e70949aep-49)

end

@testset "mpfi_sqr" begin

    @test pown(bareinterval(-Inf, -7.0), 2) === bareinterval(+49.0, +Inf)

    @test pown(bareinterval(-Inf, 0.0), 2) === bareinterval(0.0, +Inf)

    @test pown(bareinterval(-Inf, +8.0), 2) === bareinterval(0.0, +Inf)

    @test pown(entireinterval(BareInterval{Float64}), 2) === bareinterval(0.0, +Inf)

    @test pown(bareinterval(0.0, 0.0), 2) === bareinterval(0.0, 0.0)

    @test pown(bareinterval(0.0, +8.0), 2) === bareinterval(0.0, +64.0)

    @test pown(bareinterval(0.0, +Inf), 2) === bareinterval(0.0, +Inf)

    @test pown(bareinterval(0x8.6374d8p-4, 0x3.f1d929p+8), 2) === bareinterval(0x4.65df11464764p-4, 0xf.8f918d688891p+16)

    @test pown(bareinterval(0x6.61485c33c0b14p+4, 0x123456p0), 2) === bareinterval(0x2.8b45c3cc03ea6p+12, 0x14b66cb0ce4p0)

    @test pown(bareinterval(-0x1.64722ad2480c9p+0, 0x1p0), 2) === bareinterval(0.0, 0x1.f04dba0302d4dp+0)

    @test pown(bareinterval(0x1.6b079248747a2p+0, 0x2.b041176d263f6p+0), 2) === bareinterval(0x2.02ce7912cddf6p+0, 0x7.3a5dee779527p+0)

end

@testset "mpfi_sqrt" begin

    @test sqrt(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test sqrt(bareinterval(0.0, +9.0)) === bareinterval(0.0, +3.0)

    @test sqrt(bareinterval(0.0, +Inf)) === bareinterval(0.0, +Inf)

    @test sqrt(bareinterval(0xaaa1p0, 0x14b66cb0ce4p0)) === bareinterval(0xd1p0, 0x123456p0)

    @test sqrt(bareinterval(0xe.49ae7969e41bp-4, 0xaaa1p0)) === bareinterval(0xf.1ea42821b27a8p-4, 0xd1p0)

    @test sqrt(bareinterval(0xa.aa1p-4, 0x1.0c348f804c7a9p+0)) === bareinterval(0xd.1p-4, 0x1.06081714eef1dp+0)

    @test sqrt(bareinterval(0xe.49ae7969e41bp-4, 0x1.0c348f804c7a9p+0)) === bareinterval(0xf.1ea42821b27a8p-4, 0x1.06081714eef1dp+0)

end

@testset "mpfi_sub" begin

    @test -(bareinterval(-Inf, -7.0), bareinterval(-1.0, +8.0)) === bareinterval(-Inf, -6.0)

    @test -(bareinterval(-Inf, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(-Inf, -8.0)

    @test -(bareinterval(-Inf, +8.0), bareinterval(0.0, +8.0)) === bareinterval(-Inf, +8.0)

    @test -(entireinterval(BareInterval{Float64}), bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test -(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(+7.0, +Inf)

    @test -(bareinterval(0.0, +8.0), bareinterval(-7.0, 0.0)) === bareinterval(0.0, +15.0)

    @test -(bareinterval(0.0, 0.0), bareinterval(0.0, +8.0)) === bareinterval(-8.0, 0.0)

    @test -(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(-8.0, +Inf)

    @test -(bareinterval(0.0, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(-Inf, -8.0)

    @test -(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test -(bareinterval(0.0, +8.0), bareinterval(-7.0, +8.0)) === bareinterval(-8.0, +15.0)

    @test -(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test -(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(-8.0, +Inf)

    @test -(bareinterval(-5.0, 59.0), bareinterval(17.0, 81.0)) === bareinterval(-86.0, 42.0)

    @test -(bareinterval(-0x1p-300, 0x123456p+28), bareinterval(-0x789abcdp0, 0x10000000000000p-93)) === bareinterval(-0x10000000000001p-93, 0x123456789abcdp0)

    @test -(bareinterval(-4.0, 7.0), bareinterval(-3e300, 0x123456789abcdp-17)) === bareinterval(-0x123456791abcdp-17, 0x8f596b3002c1bp+947)

    @test -(bareinterval(-0x1000100010001p+8, 0x1p+60), bareinterval(-3e300, 0x1000100010001p0)) === bareinterval(-0x10101010101011p+4, 0x8f596b3002c1bp+947)

    @test -(bareinterval(-5.0, 1.0), bareinterval(1.0, 0x1p+70)) === bareinterval(-0x10000000000001p+18, 0.0)

    @test -(bareinterval(5.0, 0x1p+70), bareinterval(3.0, 5.0)) === bareinterval(0.0, 0x1p+70)

end

@testset "mpfi_sub_d" begin

    @test -(bareinterval(-Inf, -7.0), bareinterval(-0x170ef54646d497p-107, -0x170ef54646d497p-107)) === bareinterval(-Inf, -0x1bffffffffffffp-50)

    @test -(bareinterval(-Inf, -7.0), bareinterval(0.0, 0.0)) === bareinterval(-Inf, -7.0)

    @test -(bareinterval(-Inf, -7.0), bareinterval(0x170ef54646d497p-107, 0x170ef54646d497p-107)) === bareinterval(-Inf, -7.0)

    @test -(bareinterval(-Inf, 0.0), bareinterval(-0x170ef54646d497p-106, -0x170ef54646d497p-106)) === bareinterval(-Inf, 0x170ef54646d497p-106)

    @test -(bareinterval(-Inf, 0.0), bareinterval(0.0, 0.0)) === bareinterval(-Inf, 0.0)

    @test -(bareinterval(-Inf, 0.0), bareinterval(0x170ef54646d497p-106, 0x170ef54646d497p-106)) === bareinterval(-Inf, -8.0e-17)

    @test -(bareinterval(-Inf, 8.0), bareinterval(-0x16345785d8a00000p0, -0x16345785d8a00000p0)) === bareinterval(-Inf, 0x16345785d8a00100p0)

    @test -(bareinterval(-Inf, 8.0), bareinterval(0.0, 0.0)) === bareinterval(-Inf, 8.0)

    @test -(bareinterval(-Inf, 8.0), bareinterval(0x16345785d8a00000p0, 0x16345785d8a00000p0)) === bareinterval(-Inf, -0x16345785d89fff00p0)

    @test -(entireinterval(BareInterval{Float64}), bareinterval(-0x170ef54646d497p-105, -0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test -(entireinterval(BareInterval{Float64}), bareinterval(0.0e-17, 0.0e-17)) === entireinterval(BareInterval{Float64})

    @test -(entireinterval(BareInterval{Float64}), bareinterval(+0x170ef54646d497p-105, +0x170ef54646d497p-105)) === entireinterval(BareInterval{Float64})

    @test -(bareinterval(0.0, 0.0), bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109)) === bareinterval(+0x170ef54646d497p-109, +0x170ef54646d497p-109)

    @test -(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test -(bareinterval(0.0, 0.0), bareinterval(0x170ef54646d497p-109, 0x170ef54646d497p-109)) === bareinterval(-0x170ef54646d497p-109, -0x170ef54646d497p-109)

    @test -(bareinterval(0.0, 8.0), bareinterval(-0x114b37f4b51f71p-107, -0x114b37f4b51f71p-107)) === bareinterval(0x114b37f4b51f71p-107, 0x10000000000001p-49)

    @test -(bareinterval(0.0, 8.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 8.0)

    @test -(bareinterval(0.0, 8.0), bareinterval(0x114b37f4b51f71p-107, 0x114b37f4b51f71p-107)) === bareinterval(-0x114b37f4b51f71p-107, 8.0)

    @test -(bareinterval(0.0, +Inf), bareinterval(-0x50b45a75f7e81p-104, -0x50b45a75f7e81p-104)) === bareinterval(0x50b45a75f7e81p-104, +Inf)

    @test -(bareinterval(0.0, +Inf), bareinterval(0.0, 0.0)) === bareinterval(0.0, +Inf)

    @test -(bareinterval(0.0, +Inf), bareinterval(0x142d169d7dfa03p-106, 0x142d169d7dfa03p-106)) === bareinterval(-0x142d169d7dfa03p-106, +Inf)

    @test -(bareinterval(-32.0, -17.0), bareinterval(0xfb53d14aa9c2fp-47, 0xfb53d14aa9c2fp-47)) === bareinterval(-0x1fb53d14aa9c2fp-47, -0x18353d14aa9c2fp-47)

    @test -(bareinterval(-0xfb53d14aa9c2fp-47, -17.0), bareinterval(-0xfb53d14aa9c2fp-47, -0xfb53d14aa9c2fp-47)) === bareinterval(0.0, 0x7353d14aa9c2fp-47)

    @test -(bareinterval(-32.0, -0xfb53d14aa9c2fp-48), bareinterval(-0xfb53d14aa9c2fp-48, -0xfb53d14aa9c2fp-48)) === bareinterval(-0x104ac2eb5563d1p-48, 0.0)

    @test -(bareinterval(0x123456789abcdfp-48, 0x123456789abcdfp-4), bareinterval(-3.5, -3.5)) === bareinterval(0x15b456789abcdfp-48, 0x123456789abd17p-4)

    @test -(bareinterval(0x123456789abcdfp-56, 0x123456789abcdfp-4), bareinterval(-3.5, -3.5)) === bareinterval(0x3923456789abcdp-52, 0x123456789abd17p-4)

    @test -(bareinterval(-0xffp0, 0x123456789abcdfp-52), bareinterval(-256.5, -256.5)) === bareinterval(0x18p-4, 0x101a3456789abdp-44)

    @test -(bareinterval(-0x1fffffffffffffp-52, -0x1p-550), bareinterval(-4097.5, -4097.5)) === bareinterval(0xfff8p-4, 0x10018p-4)

    @test -(bareinterval(0x123456789abcdfp-48, 0x123456789abcdfp-4), bareinterval(3.5, 3.5)) === bareinterval(0xeb456789abcdfp-48, 0x123456789abca7p-4)

    @test -(bareinterval(0x123456789abcdfp-56, 0x123456789abcdfp-4), bareinterval(3.5, 3.5)) === bareinterval(-0x36dcba98765434p-52, 0x123456789abca7p-4)

    @test -(bareinterval(-0xffp0, 0x123456789abcdfp-52), bareinterval(256.5, 256.5)) === bareinterval(-0x1ff8p-4, -0xff5cba9876543p-44)

    @test -(bareinterval(-0x1fffffffffffffp-52, -0x1p-550), bareinterval(4097.5, 4097.5)) === bareinterval(-0x10038p-4, -0x10018p-4)

end

@testset "mpfi_tan" begin

    @test tan(bareinterval(-Inf, -7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-Inf, 0.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-Inf, +8.0)) === entireinterval(BareInterval{Float64})

    @test tan(entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, 0.0)) === bareinterval(-0x18eb245cbee3a6p-52, 0.0)

    @test tan(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test tan(bareinterval(0.0, +1.0)) === bareinterval(0.0, 0x18eb245cbee3a6p-52)

    @test tan(bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(0.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(0.125, 17.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(0x1921fb54442d18p-52, 0x1921fb54442d19p-52)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, -0.5)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.5, 0.625)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, -0.25)) === bareinterval(-0x18eb245cbee3a6p-52, -0x105785a43c4c55p-54)

    @test tan(bareinterval(-0.5, 0.5)) === bareinterval(-0x117b4f5bf3474bp-53, 0x117b4f5bf3474bp-53)

    @test tan(bareinterval(0x71p+76, 0x71p+76)) === bareinterval(-0x1c8dc87ddcc134p-55, -0x1c8dc87ddcc133p-55)

    @test tan(bareinterval(-7.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, -4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-7.0, -5.0)) === bareinterval(-0x1be2e6e13eea79p-53, 0x1b0b4b739bbb07p-51)

    @test tan(bareinterval(-7.0, -6.0)) === bareinterval(-0x1be2e6e13eea79p-53, 0x129fd86ebb95bfp-54)

    @test tan(bareinterval(-7.0, -7.0)) === bareinterval(-0x1be2e6e13eea79p-53, -0x1be2e6e13eea78p-53)

    @test tan(bareinterval(-6.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, -4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-6.0, -5.0)) === bareinterval(0x129fd86ebb95bep-54, 0x1b0b4b739bbb07p-51)

    @test tan(bareinterval(-6.0, -6.0)) === bareinterval(0x129fd86ebb95bep-54, 0x129fd86ebb95bfp-54)

    @test tan(bareinterval(-5.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, -2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, -3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, -4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-5.0, -5.0)) === bareinterval(0x1b0b4b739bbb06p-51, 0x1b0b4b739bbb07p-51)

    @test tan(bareinterval(-4.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-4.0, -2.0)) === bareinterval(-0x12866f9be4de14p-52, 0x117af62e0950f9p-51)

    @test tan(bareinterval(-4.0, -3.0)) === bareinterval(-0x12866f9be4de14p-52, 0x123ef71254b870p-55)

    @test tan(bareinterval(-4.0, -4.0)) === bareinterval(-0x12866f9be4de14p-52, -0x12866f9be4de13p-52)

    @test tan(bareinterval(-3.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-3.0, -2.0)) === bareinterval(0x123ef71254b86fp-55, 0x117af62e0950f9p-51)

    @test tan(bareinterval(-3.0, -3.0)) === bareinterval(0x123ef71254b86fp-55, 0x123ef71254b870p-55)

    @test tan(bareinterval(-2.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, 1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, 0.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, -1.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-2.0, -2.0)) === bareinterval(0x117af62e0950f8p-51, 0x117af62e0950f9p-51)

    @test tan(bareinterval(-1.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(-1.0, 1.0)) === bareinterval(-0x18eb245cbee3a6p-52, 0x18eb245cbee3a6p-52)

    @test tan(bareinterval(-1.0, 0.0)) === bareinterval(-0x18eb245cbee3a6p-52, 0.0)

    @test tan(bareinterval(-1.0, -1.0)) === bareinterval(-0x18eb245cbee3a6p-52, -0x18eb245cbee3a5p-52)

    @test tan(bareinterval(1.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(1.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(1.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(1.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(1.0, 3.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(1.0, 2.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(1.0, 1.0)) === bareinterval(0x18eb245cbee3a5p-52, 0x18eb245cbee3a6p-52)

    @test tan(bareinterval(2.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(2.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(2.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(2.0, 4.0)) === bareinterval(-0x117af62e0950f9p-51, 0x12866f9be4de14p-52)

    @test tan(bareinterval(2.0, 3.0)) === bareinterval(-0x117af62e0950f9p-51, -0x123ef71254b86fp-55)

    @test tan(bareinterval(2.0, 2.0)) === bareinterval(-0x117af62e0950f9p-51, -0x117af62e0950f8p-51)

    @test tan(bareinterval(3.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(3.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(3.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(3.0, 4.0)) === bareinterval(-0x123ef71254b870p-55, 0x12866f9be4de14p-52)

    @test tan(bareinterval(3.0, 3.0)) === bareinterval(-0x123ef71254b870p-55, -0x123ef71254b86fp-55)

    @test tan(bareinterval(4.0, 7.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(4.0, 6.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(4.0, 5.0)) === entireinterval(BareInterval{Float64})

    @test tan(bareinterval(4.0, 4.0)) === bareinterval(0x12866f9be4de13p-52, 0x12866f9be4de14p-52)

    @test tan(bareinterval(5.0, 7.0)) === bareinterval(-0x1b0b4b739bbb07p-51, 0x1be2e6e13eea79p-53)

    @test tan(bareinterval(5.0, 6.0)) === bareinterval(-0x1b0b4b739bbb07p-51, -0x129fd86ebb95bep-54)

    @test tan(bareinterval(5.0, 5.0)) === bareinterval(-0x1b0b4b739bbb07p-51, -0x1b0b4b739bbb06p-51)

    @test tan(bareinterval(6.0, 7.0)) === bareinterval(-0x129fd86ebb95bfp-54, 0x1be2e6e13eea79p-53)

    @test tan(bareinterval(6.0, 6.0)) === bareinterval(-0x129fd86ebb95bfp-54, -0x129fd86ebb95bep-54)

    @test tan(bareinterval(7.0, 7.0)) === bareinterval(0x1be2e6e13eea78p-53, 0x1be2e6e13eea79p-53)

end

@testset "mpfi_tanh" begin

    @test tanh(bareinterval(-Inf, -7.0)) === bareinterval(-1.0, -0x1ffffc832750f1p-53)

    @test tanh(bareinterval(-Inf, 0.0)) === bareinterval(-1.0, 0.0)

    @test tanh(bareinterval(-Inf, 8.0)) === bareinterval(-1.0, 0x1fffff872a91f9p-53)

    @test tanh(entireinterval(BareInterval{Float64})) === bareinterval(-1.0, +1.0)

    @test tanh(bareinterval(-1.0, 0.0)) === bareinterval(-0x185efab514f395p-53, 0.0)

    @test tanh(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test tanh(bareinterval(0.0, 1.0)) === bareinterval(0.0, 0x185efab514f395p-53)

    @test tanh(bareinterval(0.0, 8.0)) === bareinterval(0.0, 0x1fffff872a91f9p-53)

    @test tanh(bareinterval(0.0, +Inf)) === bareinterval(0.0, +1.0)

    @test tanh(bareinterval(-0.125, 0.0)) === bareinterval(-0x1fd5992bc4b835p-56, 0.0)

    @test tanh(bareinterval(0.0, 0x10000000000001p-53)) === bareinterval(0.0, 0x1d9353d7568af5p-54)

    @test tanh(bareinterval(-4.5, -0.625)) === bareinterval(-0x1ffdfa72153984p-53, -0x11bf47eabb8f95p-53)

    @test tanh(bareinterval(1.0, 3.0)) === bareinterval(0x185efab514f394p-53, 0x1fd77d111a0b00p-53)

    @test tanh(bareinterval(17.0, 18.0)) === bareinterval(0x1fffffffffffe1p-53, 0x1ffffffffffffcp-53)

end

@testset "mpfi_union" begin

    @test hull(bareinterval(-Inf, -7.0), bareinterval(-1.0, +8.0)) === bareinterval(-Inf, +8.0)

    @test hull(bareinterval(-Inf, 0.0), bareinterval(+8.0, +Inf)) === entireinterval(BareInterval{Float64})

    @test hull(bareinterval(-Inf, +8.0), bareinterval(0.0, +8.0)) === bareinterval(-Inf, +8.0)

    @test hull(entireinterval(BareInterval{Float64}), bareinterval(0.0, +8.0)) === entireinterval(BareInterval{Float64})

    @test hull(bareinterval(0.0, 0.0), bareinterval(-Inf, -7.0)) === bareinterval(-Inf, 0.0)

    @test hull(bareinterval(0.0, +8.0), bareinterval(-7.0, 0.0)) === bareinterval(-7.0, +8.0)

    @test hull(bareinterval(0.0, 0.0), bareinterval(0.0, +8.0)) === bareinterval(0.0, +8.0)

    @test hull(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +Inf)

    @test hull(bareinterval(0.0, 0.0), bareinterval(+8.0, +Inf)) === bareinterval(0.0, +Inf)

    @test hull(bareinterval(0.0, 0.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test hull(bareinterval(0.0, +8.0), bareinterval(-7.0, +8.0)) === bareinterval(-7.0, +8.0)

    @test hull(bareinterval(0.0, 0.0), bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test hull(bareinterval(0.0, +Inf), bareinterval(0.0, +8.0)) === bareinterval(0.0, +Inf)

    @test hull(bareinterval(0x12p0, 0x90p0), bareinterval(-0x0dp0, 0x34p0)) === bareinterval(-0x0dp0, 0x90p0)

end

# bound type mechanism

"""
    NumTypes

Constant for the supported types of interval bounds. This is set to
`Union{Rational,AbstractFloat}`.
"""
const NumTypes = Union{Rational,AbstractFloat}

"""
    promote_numtype(T, S)

Return the bound type used to construct intervals. The bound type is given by
`promote_type(T, S)` if `T` or `S` is a `Rational` or an `AbstractFloat`; except
when `T` is a `Rational{R}` and `S` is an `AbstractIrrational` (or vice-versa),
in which case the bound type is given by `Rational{promote_type(R, Int64)}`. In
all other cases, the bound type is given by
`promote_type(default_numtype(), T, S)`.
"""
promote_numtype(::Type{T}, ::Type{S}) where {T<:NumTypes,S<:NumTypes} = promote_type(T, S)
promote_numtype(::Type{T}, ::Type{S}) where {T<:NumTypes,S} = promote_type(numtype(T), numtype(S))
promote_numtype(::Type{T}, ::Type{S}) where {T,S<:NumTypes} = promote_type(numtype(T), numtype(S))
promote_numtype(::Type{T}, ::Type{S}) where {T,S} = promote_type(default_numtype(), numtype(T), numtype(S))

promote_numtype(::Type{Rational{T}}, ::Type{<:AbstractIrrational}) where {T<:Integer} = Rational{promote_type(T, Int64)}
promote_numtype(::Type{<:AbstractIrrational}, ::Type{Rational{T}}) where {T<:Integer} = Rational{promote_type(T, Int64)}





# bare interval, i.e. interval with no decoration

"""
    BareInterval{T<:NumTypes}

Interval type for guaranteed computation with interval arithmetic according to
the IEEE Standard 1788-2015. Unlike [`Interval`](@ref), this bare interval does
not have decorations, is not a subtype of `Real` and errors on operations mixing
`BareInterval` and `Number`.

Fields:
- `lo :: T`
- `hi :: T`

Constructor compliant with the IEEE Standard 1788-2015: [`bareinterval`](@ref).

See also: [`Interval`](@ref).
"""
struct BareInterval{T<:NumTypes}
    lo :: T
    hi :: T

    # need explicit signatures to avoid method ambiguities

    global _unsafe_bareinterval(::Type{T}, a::T, b::T) where {S<:Integer,T<:Rational{S}} =
        new{T}(_normalisezero(a), _normalisezero(b))
    _unsafe_bareinterval(::Type{T}, a::T, b::T) where {S<:Union{Int8,UInt8},T<:Rational{S}} =
        new{T}(_normalisezero(a), _normalisezero(b))
    _unsafe_bareinterval(::Type{T}, a::T, b::T) where {S<:Union{Int16,UInt16},T<:Rational{S}} =
        new{T}(_normalisezero(a), _normalisezero(b))

    _unsafe_bareinterval(::Type{T}, a::T, b::T) where {T<:AbstractFloat} =
        new{T}(_normalisezero(a), _normalisezero(b))
end

"""
    _unsafe_bareinterval(T<:NumTypes, lo, hi)

Internal constructor which assumes that `is_valid_interval(lo, hi) == true`.

!!! danger
    This constructor is **not** compliant with the IEEE Standard 1788-2015.
    Since misuse of this function can deeply corrupt code, its usage is
    **strongly discouraged** in favour of [`bareinterval`](@ref).
"""
_unsafe_bareinterval(::Type{T}, a, b) where {T<:NumTypes} =
    _unsafe_bareinterval(T, _round(T, a, RoundDown), _round(T, b, RoundUp))

_normalisezero(a) = ifelse(iszero(a), zero(a), a)
_normalisezero(a::BigFloat) = iszero(a) ? zero(a) : a # avoid allocation for BigFloat
# used only to construct intervals; needed to avoid `inf` and `sup` normalization
_inf(x::BareInterval) = x.lo
_sup(x::BareInterval) = x.hi
_inf(x::Real) = x
_sup(x::Real) = x
#

_round(::Type{T}, a, r::RoundingMode) where {T<:NumTypes} = __round(T, a, r)
# irrationals
_round(::Type{<:NumTypes}, ::AbstractIrrational, ::RoundingMode) = throw(ArgumentError("only irrationals from MathConstants are supported"))
for irr ∈ (:(:π), :(:γ), :(:catalan)) # irrationals supported by MPFR
    @eval _round(::Type{T}, a::Irrational{$irr}, r::RoundingMode) where {T<:NumTypes} =
        __round(T, BigFloat(a, r), r)
end
# irrationals not supported by MPFR, use their exact formula ℯ = exp(1), φ = (1+sqrt(5))/2
_round(::Type{T}, ::Irrational{:ℯ}, r::RoundingMode{:Down}) where {T<:NumTypes} =
    __round(T, inf(exp(bareinterval(BigFloat, 1))), r)
_round(::Type{T}, ::Irrational{:ℯ}, r::RoundingMode{:Up}) where {T<:NumTypes} =
    __round(T, sup(exp(bareinterval(BigFloat, 1))), r)
_round(::Type{T}, ::Irrational{:φ}, r::RoundingMode{:Down}) where {T<:NumTypes} =
    __round(T, inf((bareinterval(BigFloat, 1) + sqrt(bareinterval(BigFloat, 5))) / bareinterval(BigFloat, 2)), r)
_round(::Type{T}, ::Irrational{:φ}, r::RoundingMode{:Up}) where {T<:NumTypes} =
    __round(T, sup((bareinterval(BigFloat, 1) + sqrt(bareinterval(BigFloat, 5))) / bareinterval(BigFloat, 2)), r)
# floats
__round(::Type{T}, a, r::RoundingMode) where {T<:AbstractFloat} = T(a, r)
# rationals
__round(::Type{T}, a::Rational, ::RoundingMode{:Down}) where {S<:Integer,T<:Rational{S}} = T(a)
__round(::Type{T}, a::Rational, ::RoundingMode{:Up}) where {S<:Integer,T<:Rational{S}} = T(a)
__round(::Type{T}, a, r::RoundingMode{:Down}) where {S<:Integer,T<:Rational{S}} =
    rationalize(S, prevfloat(__float(S)(a, r)))
__round(::Type{T}, a, r::RoundingMode{:Up}) where {S<:Integer,T<:Rational{S}} =
    rationalize(S, nextfloat(__float(S)(a, r)))
# need the following since `float(Int8) == float(Int16) == Float64`
__float(::Type{T}) where {T<:Integer} = float(T)
__float(::Type{T}) where {T<:Union{Int8,UInt8}} = Float16
__float(::Type{T}) where {T<:Union{Int16,UInt16}} = Float32

BareInterval{T}(x::BareInterval) where {T<:NumTypes} = convert(BareInterval{T}, x)

"""
    bareinterval(T, a, b)

Create the bare interval ``[a, b]`` according to the IEEE Standard 1788-2015.
The validity of the interval is checked by [`is_valid_interval`](@ref): if
`true` then a `BareInterval{T}` is constructed, otherwise an empty interval is
returned.

!!! danger
    Nothing is done to compensate for the fact that floating point literals are
    rounded to the nearest when parsed (e.g. `0.1`). In such cases, parse the
    string containing the desired value to ensure its tight enclosure.

See also: [`interval`](@ref), [`±`](@ref), [`..`](@ref) and [`@I_str`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> bareinterval(1//1, π)
BareInterval{Rational{Int64}}(1//1, 85563208//27235615)

julia> bareinterval(Rational{Int32}, 1//1, π)
BareInterval{Rational{Int32}}(1//1, 85563208//27235615)

julia> bareinterval(1, π)
BareInterval{Float64}(1.0, 3.1415926535897936)

julia> bareinterval(BigFloat, 1, π)
BareInterval{BigFloat}(1.0, 3.141592653589793238462643383279502884197169399375105820974944592307816406286233)
```
"""
function bareinterval(::Type{T}, a, b) where {T}
    lo = _inf(_value(a))
    hi = _sup(_value(b))
    is_valid_interval(lo, hi) && return _unsafe_bareinterval(T, lo, hi)
    @warn "ill-formed bare interval [a, b] with a = $a, b = $b. Empty interval is returned"
    return emptyinterval(BareInterval{T})
end
bareinterval(a, b) = bareinterval(promote_numtype(numtype(a), numtype(b)), a, b)

bareinterval(::Type{T}, a) where {T} = bareinterval(T, a, a)
bareinterval(a) = bareinterval(promote_numtype(numtype(a), numtype(a)), a)

bareinterval(::Type{T}, a::BareInterval) where {T} =
    _unsafe_bareinterval(T, _inf(a), _sup(a)) # assumes valid interval

_value(a) = a # convenient hook, used in exact_literals.jl

# some useful extra constructor
bareinterval(::Type{T}, a::Tuple) where {T} = bareinterval(T, a...)
bareinterval(a::Tuple) = bareinterval(a...)

# promotion

Base.promote_rule(::Type{BareInterval{T}}, ::Type{BareInterval{S}}) where {T<:NumTypes,S<:NumTypes} =
    BareInterval{promote_numtype(T, S)}

# conversion

Base.convert(::Type{BareInterval{T}}, x::BareInterval) where {T<:NumTypes} =
    bareinterval(T, x)





# decorations

"""
    Decoration

Enumeration constant for the types of interval decorations described in
Section 11.2 of the IEEE Standard 1788-2015:
- `com -> 4` (common): non-empty, continuous and bounded interval.
- `dac -> 3` (defined and continuous): non-empty and continuous interval.
- `def -> 2` (defined): non-empty interval.
- `trv -> 1` (trivial): meaningless interval.
- `ill -> 0` (ill-formed): not an interval (NaI).
"""
@enum Decoration begin
    ill = 0
    trv
    def
    dac
    com
end
# note: `isless`, and hence `<`, `min` and `max`, are automatically defined

function decoration(x::BareInterval)
    isempty_interval(x) && return trv
    isunbounded(x) && return dac
    return com
end





# decorated intervals

"""
    Interval{T<:NumTypes} <: Real

Interval type for guaranteed computation with interval arithmetic according to
the IEEE Standard 1788-2015. This structure combines a [`BareInterval`](@ref)
together with a [`Decoration`](@ref).

Fields:
- `bareinterval :: BareInterval{T}`
- `decoration   :: Decoration`
- `isguaranteed :: Bool`

Constructors compliant with the IEEE Standard 1788-2015:
- [`interval`](@ref)
- [`..`](@ref)
- [`±`](@ref)
- [`@I_str`](@ref)

See also: [`±`](@ref), [`..`](@ref) and [`@I_str`](@ref).
"""
struct Interval{T<:NumTypes} <: Real
    bareinterval :: BareInterval{T}
    decoration   :: Decoration
    isguaranteed :: Bool

    global _unsafe_interval(bareinterval::BareInterval{T}, decoration::Decoration, isguaranteed::Bool) where {T<:NumTypes} =
        new{T}(bareinterval, decoration, isguaranteed)
end

"""
    _unsafe_interval(bareinterval::BareInterval, decoration::Decoration, isguaranteed::Bool)

Internal constructor which assumes that `bareinterval` and its decoration
`decoration` are compliant with the IEEE Standard 1788-2015.

!!! danger
    This constructor is **not** compliant with the IEEE Standard 1788-2015.
    Since misuse of this function can deeply corrupt code, its usage is
    **strongly discouraged** in favour of [`interval`](@ref).
"""
_unsafe_interval

# used only to construct intervals
_inf(x::Interval) = x.bareinterval.lo
_sup(x::Interval) = x.bareinterval.hi
#

function bareinterval(x::Interval)
    decoration(x) == ill && @warn "interval part of NaI"
    return x.bareinterval
end
bareinterval(::Type{T}, x::Interval) where {T} = bareinterval(T, bareinterval(x))
decoration(x::Interval) = x.decoration
decoration(x::Complex{<:Interval}) = min(decoration(real(x)), decoration(imag(x)))

"""
    setdecoration(x::Interval, d::Decoration)

Return the interval `bareinterval(x)` with decoration `d`, with the following
exceptions:
- if `d == ill`, then the output is an NaI
- if `isempty_interval(bareinterval(x))` and `d != ill`, then the output has
decoration `trv`
- if `isunbounded(bareinterval(x))` and `d == com`, then the output has
decoration `dac`

!!! danger
    Since misuse of this function can deeply corrupt code, its usage is
    **strongly discouraged**.

Implement the `setDec` function of the IEEE Standard 1788-2015 (Section 11.5.2).
"""
function setdecoration(x::Interval{T}, d::Decoration) where {T<:NumTypes}
    d == ill && return nai(T)
    bx = bareinterval(x)
    isempty_interval(bx) && return _unsafe_interval(bx, trv, isguaranteed(x))
    (isunbounded(bx) & (d == com)) && return _unsafe_interval(bx, dac, isguaranteed(x))
    return _unsafe_interval(bx, d, isguaranteed(x))
end

"""
    isguaranteed(x::BareInterval)
    isguaranteed(x::Interval)
    isguaranteed(x::Complex{<:Interval})

Test whether the interval is not guaranteed to encompass all possible numerical
errors. This happens whenever an [`Interval`](@ref) is constructed using
`convert(::Type{<:Interval}, ::Real)`, which may occur implicitly when mixing
intervals and `Real` types.

Since conversion between `BareInterval` and `Number` is prohibited, this implies
that `isguaranteed(::BareInterval) == true`.

In the case of a complex interval `x`, this is semantically equivalent to
`isguaranteed(real(x)) & isguaranteed(imag(x))`.

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> isguaranteed(bareinterval(1))
true

julia> isguaranteed(interval(1))
true

julia> isguaranteed(convert(Interval{Float64}, 1))
false

julia> isguaranteed(interval(1) + 0)
false
```
"""
isguaranteed(x::Interval) = x.isguaranteed
isguaranteed(::BareInterval) = true
isguaranteed(x::Complex{<:Interval}) = isguaranteed(real(x)) & isguaranteed(imag(x))

isguaranteed(::Number) = false

#

"""
    interval([T,] a, b, d = com; format = :infsup)

Create the interval ``[a, b]`` according to the IEEE Standard 1788-2015. The
validity of the interval is checked by [`is_valid_interval`](@ref): if `true`
then an `Interval{T}` is constructed, otherwise an NaI (Not an Interval) is
returned.

!!! danger
    Nothing is done to compensate for the fact that floating point literals are
    rounded to the nearest when parsed (e.g. `0.1`). In such cases, parse the
    string containing the desired value to ensure its tight enclosure.

See also: [`±`](@ref), [`..`](@ref) and [`@I_str`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> interval(1//1, π)
Interval{Rational{Int64}}(1//1, 85563208//27235615, com, true)

julia> interval(Rational{Int32}, 1//1, π)
Interval{Rational{Int32}}(1//1, 85563208//27235615, com, true)

julia> interval(1, π)
Interval{Float64}(1.0, 3.1415926535897936, com, true)

julia> interval(BigFloat, 1, π)
Interval{BigFloat}(1.0, 3.141592653589793238462643383279502884197169399375105820974944592307816406286233, com, true)
```
"""
function interval(::Type{T}, a, b, d::Decoration = com; format::Symbol = :infsup) where {T}
    format === :infsup && return _interval_infsup(T, _value(a), _value(b), d)
    format === :midpoint && return _interval_midpoint(T, _value(a), _value(b), d)
    return throw(ArgumentError("`format` must be `:infsup` or `:midpoint`"))
end
interval(a, b, d::Decoration = com; format::Symbol = :infsup) = interval(promote_numtype(_infer_numtype(a), _infer_numtype(b)), a, b, d; format = format)

function interval(::Type{T}, a, d::Decoration = com; format::Symbol = :infsup) where {T}
    (format === :infsup) | (format === :midpoint) && return _interval_infsup(T, _value(a), _value(a), d)
    return throw(ArgumentError("`format` must be `:infsup` or `:midpoint`"))
end
interval(a, d::Decoration = com; format::Symbol = :infsup) = interval(promote_numtype(_infer_numtype(a), _infer_numtype(a)), a, d; format = format)

interval(T::Type, d::Decoration; format::Symbol = :infsup) = throw(MethodError(interval, (T, d))) # needed to resolve ambiguity

_infer_numtype(a) = numtype(a)

# standard format

"""
    _interval_infsup(T<:NumTypes, a, b, d::Decoration)

Internal constructor for intervals described by their lower and upper bounds,
i.e. of the form ``[a, b]``.
"""
function _interval_infsup(::Type{T}, a, b, d::Decoration) where {T<:NumTypes}
    lo = _inf(a)
    hi = _sup(b)
    if !is_valid_interval(lo, hi) || d == ill
        @warn "ill-formed interval [a, b] with a = $a, b = $b and decoration d = $d. NaI is returned"
        return nai(T)
    else
        x = _unsafe_bareinterval(T, lo, hi)
        return _unsafe_interval(x, min(decoration(x), d), true)
    end
end

# needed for special warnings and propagation of `isguaranteed`
function _interval_infsup(::Type{T}, x::Union{BareInterval,Interval}, y::Union{BareInterval,Interval}, d::Decoration) where {T<:NumTypes}
    lo = _inf(x)
    hi = _sup(y)
    t = isguaranteed(x) & isguaranteed(y)
    if d == ill
        @warn "invalid interval, NaI is returned"
        return _unsafe_interval(nai(T).bareinterval, ill, t)
    elseif isempty_interval(x) && isempty_interval(y)
        return _unsafe_interval(emptyinterval(BareInterval{T}), trv, t)
    elseif !is_valid_interval(lo, hi)
        @warn "invalid interval, NaI is returned"
        return _unsafe_interval(nai(T).bareinterval, ill, t)
    else
        z = _unsafe_bareinterval(T, lo, hi)
        return _unsafe_interval(z, min(decoration(x), decoration(y), decoration(z), d), t)
    end
end
function _interval_infsup(::Type{T}, x::Union{BareInterval,Interval}, y, d::Decoration) where {T<:NumTypes}
    lo = _inf(x)
    hi = _sup(y)
    if !is_valid_interval(lo, hi) || d == ill
        @warn "invalid interval, NaI is returned"
        return nai(T)
    else
        z = _unsafe_bareinterval(T, lo, hi)
        return _unsafe_interval(z, min(decoration(x), decoration(z), d), isguaranteed(x))
    end
end
function _interval_infsup(::Type{T}, x, y::Union{BareInterval,Interval}, d::Decoration) where {T<:NumTypes}
    lo = _inf(x)
    hi = _sup(y)
    if !is_valid_interval(lo, hi) || d == ill
        @warn "invalid interval, NaI is returned"
        return nai(T)
    else
        z = _unsafe_bareinterval(T, lo, hi)
        return _unsafe_interval(z, min(decoration(y), decoration(z), d), isguaranteed(y))
    end
end

_interval_infsup(::Type{T}, a::Complex, b::Union{BareInterval,Interval}, d::Decoration) where {T<:NumTypes} =
    complex(_interval_infsup(T, real(a), real(b), d), _interval_infsup(T, imag(a), imag(b), d))
_interval_infsup(::Type{T}, a::Union{BareInterval,Interval}, b::Complex, d::Decoration) where {T<:NumTypes} =
    complex(_interval_infsup(T, real(a), real(b), d), _interval_infsup(T, imag(a), imag(b), d))

_interval_infsup(::Type{T}, a::Complex, b::Complex, d::Decoration) where {T<:NumTypes} =
    complex(_interval_infsup(T, real(a), real(b), d), _interval_infsup(T, imag(a), imag(b), d))
_interval_infsup(::Type{T}, a::Complex, b, d::Decoration) where {T<:NumTypes} =
    complex(_interval_infsup(T, real(a), real(b), d), _interval_infsup(T, imag(a), imag(b), d))
_interval_infsup(::Type{T}, a, b::Complex, d::Decoration) where {T<:NumTypes} =
    complex(_interval_infsup(T, real(a), real(b), d), _interval_infsup(T, imag(a), imag(b), d))

# some useful extra constructor

_infer_numtype(A::AbstractArray) = numtype(eltype(A))

_interval_infsup(::Type{T}, A::AbstractArray, B::AbstractArray, d::Decoration) where {T<:NumTypes} = _interval_infsup.(T, A, B, d)

# midpoint constructors

"""
    _interval_midpoint(T<:NumTypes, m, r, d::Decoration)

Internal constructor for intervals described by their midpoint and radius, i.e.
of the form ``m \\pm r``.
"""
function _interval_midpoint(::Type{T}, m, r, d::Decoration) where {T<:NumTypes}
    x = _interval_infsup(T, m, m, d)
    r = _interval_infsup(T, r, r, d)
    precedes(zero(r), r) && return _interval_infsup(T, x - r, x + r, d)
    return throw(DomainError(r, "must be positive"))
end

_interval_midpoint(::Type{T}, m::Complex, r, d::Decoration) where {T<:NumTypes} =
    complex(_interval_midpoint(T, real(m), r, d), _interval_midpoint(T, imag(m), r, d))

function _interval_midpoint(::Type{T}, m, r::Complex{<:Interval}, d::Decoration) where {T<:NumTypes}
    isthinzero(imag(r)) || return throw(DomainError(r, "imaginary part must be zero"))
    return _interval_midpoint(T, m, real(r), d)
end

function _interval_midpoint(::Type{T}, m, r::Complex, d::Decoration) where {T<:NumTypes}
    iszero(imag(r)) || return throw(DomainError(r, "imaginary part must be zero"))
    return _interval_midpoint(T, m, real(r), d)
end

function _interval_midpoint(::Type{T}, m::Complex, r::Complex{<:Interval}, d::Decoration) where {T<:NumTypes}
    isthinzero(imag(r)) || return throw(DomainError(r, "imaginary part must be zero"))
    return _interval_midpoint(T, m, real(r), d)
end

function _interval_midpoint(::Type{T}, m::Complex, r::Complex, d::Decoration) where {T<:NumTypes}
    iszero(imag(r)) || return throw(DomainError(r, "imaginary part must be zero"))
    return _interval_midpoint(T, m, real(r), d)
end

# promotion

Base.promote_rule(::Type{Interval{T}}, ::Type{Interval{S}}) where {T<:NumTypes,S<:NumTypes} =
    Interval{promote_numtype(T, S)}

Base.promote_rule(::Type{Interval{T}}, ::Type{S}) where {T<:NumTypes,S<:Real} =
    Interval{promote_numtype(T, S)}

Base.promote_rule(::Type{T}, ::Type{Interval{S}}) where {T<:Real,S<:NumTypes} =
    Interval{promote_numtype(T, S)}

# need explicit signatures to avoid method ambiguities
for S ∈ (:Bool, :BigFloat)
    @eval begin
        Base.promote_rule(::Type{Interval{T}}, ::Type{$S}) where {T<:NumTypes} =
            Interval{promote_numtype(T, $S)}
        Base.promote_rule(::Type{$S}, ::Type{Interval{T}}) where {T<:NumTypes} =
            Interval{promote_numtype($S, T)}
    end
end
Base.promote_rule(::Type{Interval{T}}, ::Type{S}) where {T<:NumTypes,S<:AbstractIrrational} =
    Interval{promote_numtype(T, S)}
Base.promote_rule(::Type{T}, ::Type{Interval{S}}) where {T<:AbstractIrrational,S<:NumTypes} =
    Interval{promote_numtype(T, S)}

# conversion

Interval{T}(x::Real) where {T<:NumTypes} = convert(Interval{T}, x)
Interval(x::Real) = Interval{promote_numtype(numtype(x), numtype(x))}(x)
Interval{T}(x::Interval) where {T<:NumTypes} = convert(Interval{T}, x) # needed to resolve method ambiguity

Base.convert(::Type{Interval{T}}, x::Interval) where {T<:NumTypes} = interval(T, x)

function Base.convert(::Type{Interval{T}}, x::Complex{<:Interval}) where {T<:NumTypes}
    isthinzero(imag(x)) || return throw(DomainError(x, "imaginary part must be zero"))
    return convert(Interval{T}, real(x))
end

Base.convert(::Type{Complex{Interval{T}}}, x::Interval) where {T<:NumTypes} =
    complex(interval(T, x))

# always guaranteed since an `AbstractIrrational` is a defined fixed constant
Base.convert(::Type{Interval{T}}, x::AbstractIrrational) where {T<:NumTypes} =
    interval(T, x)
Base.convert(::Type{Complex{Interval{T}}}, x::AbstractIrrational) where {T<:NumTypes} =
    complex(interval(T, x))

function Base.convert(::Type{Interval{T}}, x::Real) where {T<:NumTypes}
    y = interval(T, x)
    return _unsafe_interval(bareinterval(y), decoration(y), false)
end

function Base.convert(::Type{Interval{T}}, x::Complex) where {T<:NumTypes}
    iszero(imag(x)) || return throw(DomainError(x, "imaginary part must be zero"))
    return convert(Interval{T}, real(x))
end

"""
    atomic(T<:Union{Rational,AbstractFloat}, x)

Create an interval according to the IEEE Standard 1788-2015. The returned
`Interval{T}` always contains the value `x`; this is semantically equivalent
to `parse(Interval{T}, string(x))` if `x` is a `Number`.

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> x = IntervalArithmetic.atomic(Float64, 0.1)
Interval{Float64}(0.09999999999999999, 0.1, com, true)

julia> in_interval(1//10, IntervalArithmetic.atomic(Float64, 0.1))
true

julia> IntervalArithmetic.atomic(Float64, 0.3)
Interval{Float64}(0.3, 0.30000000000000004, com, true)

julia> in_interval(3//10, IntervalArithmetic.atomic(Float64, 0.3))
true
```
"""
atomic(::Type{T}, x::AbstractString) where {T<:NumTypes} = parse(Interval{T}, x)
atomic(::Type{T}, x::Interval) where {T<:NumTypes} = interval(T, x)
atomic(::Type{T}, x::Integer) where {T<:NumTypes} = interval(T, x)
atomic(::Type{T}, x::AbstractIrrational) where {T<:NumTypes} = interval(T, x)
function atomic(::Type{T}, x::Number) where {T<:NumTypes}
    str = string(x)
    return interval(T, _parse_num(T, str, RoundDown), _parse_num(T, str, RoundUp))
end
atomic(x) = atomic(default_numtype(), x)





# macro

"""
    @interval([T], expr)
    @interval([T], expr1, expr2)

Walk through an expression and wrap each argument of functions with the internal
constructor [`atomic`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> @interval sin(1) # Float64 is the default bound type
Interval{Float64}(0.8414709848078965, 0.8414709848078966, com, true)

julia> @interval Float32 sin(1)
Interval{Float32}(0.84147096f0, 0.841471f0, com, true)

julia> @interval Float64 sin(1) exp(1)
Interval{Float64}(0.8414709848078965, 2.7182818284590455, com, true)
```
"""
macro interval(expr)
    return _wrap_interval(expr)
end

macro interval(expr1, expr2)
    x = _wrap_interval(expr1)
    y = _wrap_interval(expr1, expr2)
    return :(interval($x, $y))
end

macro interval(T, expr1, expr2)
    x = _wrap_interval(T, expr1)
    y = _wrap_interval(T, expr2)
    return :(interval($x, $y))
end

_atomic(x, y) = hull(atomic(x), atomic(y); dec = :auto) # use `hull` in case `atomic(x)` is larger than `atomic(y)`
_atomic(T::Type, x) = atomic(T, x)
_atomic(::Type, T::Type) = T

_wrap_interval(x) = _wrap_interval(default_numtype(), x)

_wrap_interval(T, x) = :(_atomic($(esc(T)), $x))

_wrap_interval(T, x::Symbol) = :(_atomic($(esc(T)), $(esc(x))))

function _wrap_interval(T, expr::Expr)
    if expr.head ∈ (:(.), :ref, :macrocall) # a.i, or a[i], or BigInt
        return :(_atomic($(esc(T)), $(esc(expr))))
    end

    new_expr = copy(expr)

    first = 1 # where to start processing arguments

    if expr.head === :call
        first = 2 # skip operator
        if expr.args[1] ∉ (:+, :-, :*, :/, :^)
            new_expr.args[1] = :($(esc(expr.args[1]))) # escape functions
        end
    end

    for (i, arg) ∈ enumerate(expr.args)
        if i ≥ first
            new_expr.args[i] = _wrap_interval(T, arg)
        end
    end

    return new_expr
end

module IntervalArithmeticForwardDiffExt

using IntervalArithmetic, ForwardDiff
using IntervalArithmetic: isempty_domain, overlap_domain, intersect_domain, in_domain, leftof
using ForwardDiff: Dual, Partials, ≺, value, partials

ForwardDiff.can_dual(::Type{ExactReal}) = true

# needed to resolve method ambiguities
ForwardDiff.Dual{T}(value::ExactReal) where {T} = Dual{T}(value, ())
ForwardDiff.Dual(value::ExactReal) = Dual{Nothing}(value)
ForwardDiff.Dual{T,V,N}(x::ExactReal) where {T,V,N} = convert(Dual{T,V,N}, x)
ForwardDiff.Dual{T,V}(x::ExactReal) where {T,V} = convert(Dual{T,V}, x)

Base.convert(::Type{Dual{T,V,N}}, x::ExactReal) where {T,V,N} = Dual{T}(V(x), zero(Partials{N,V}))

Base.promote_rule(::Type{Dual{T, V, N}}, ::Type{Interval{S}}) where {T, V, N, S<:IntervalArithmetic.NumTypes} =
    Dual{T,Interval{IntervalArithmetic.promote_numtype(V, S)},N}
Base.promote_rule(::Type{Interval{S}}, ::Type{Dual{T, V, N}}) where {S<:IntervalArithmetic.NumTypes, T, V, N} =
    Dual{T,Interval{IntervalArithmetic.promote_numtype(V, S)},N}
Base.promote_rule(::Type{ExactReal{S}}, ::Type{Dual{T, V, N}}) where {S<:Real, T, V, N} =
    Dual{T,ExactReal{IntervalArithmetic.promote_numtype(V, S)},N}
Base.promote_rule(::Type{Dual{T, V, N}}, ::Type{ExactReal{S}}) where {S<:Real, T, V, N} =
    Dual{T,ExactReal{IntervalArithmetic.promote_numtype(V, S)},N}

Base.:(==)(x::Interval, y::Dual) = x == value(y)
Base.:(==)(x::Dual, y::Interval) = value(x) == y
Base.:<(x::Interval, y::Dual) = x < value(y)
Base.:<(x::Dual, y::Interval) = value(x) < y

function Base.:(^)(x::Dual{Txy,<:Interval}, y::Dual{Txy,<:Interval}) where {Txy}
    vx, vy = value(x), value(y)
    expv = vx^vy
    powval = vy * vx^(vy - interval(1))
    if all(isthinzero, values(partials(y)))
        return Dual{Txy}(expv, ForwardDiff._mul_partials(partials(x), partials(y), powval, one(expv)))
    elseif isthinzero(vx) && inf(vy) > 0
        return Dual{Txy}(expv, ForwardDiff._mul_partials(partials(x), partials(y), powval, zero(vx)))
    else
        return Dual{Txy}(expv, ForwardDiff._mul_partials(partials(x), partials(y), powval, expv * log(vx)))
    end
end

function Base.:(^)(x::Dual{Tx,<:Interval}, y::Dual{Ty,<:Interval}) where {Tx,Ty}
    if Ty ≺ Tx
        return x^value(y)
    else
        return value(x)^y
    end
end

function Base.:(^)(x::Dual{Tx,<:Interval}, y::Interval) where {Tx}
    v = value(x)
    expv = v^y
    if isthinzero(y) || all(isthinzero, values(partials(x)))
        return Dual{Tx}(expv, zero(partials(x)))
    else
        return Dual{Tx}(expv, partials(x) * y * v^(y - interval(1)))
    end
end

function Base.:(^)(x::Interval, y::Dual{Ty,<:Interval}) where {Ty}
    v = value(y)
    expv = x^v
    if isthinzero(x) && inf(v) > 0
        return Dual{Ty}(expv, zero(expv) * partials(y))
    else
        return Dual{Ty}(expv, expv * log(x) * partials(y))
    end
end

Base.:(^)(x::Dual{<:Any,I}, y::ExactReal) where {I<:Interval} = x^convert(I, y)

Base.:(^)(x::ExactReal, y::Dual{<:Any,I}) where {I<:Interval} = convert(I, x)^y

function Base.:(^)(x::Dual{Tx}, y::ExactReal) where {Tx}
    v = value(x)
    expv = v^y
    if iszero(y.value) || all(iszero, values(partials(x)))
        return Dual{Tx}(expv, zero(partials(x)))
    else
        return Dual{Tx}(expv, partials(x) * y * v^(y - 1))
    end
end

function Base.:(^)(x::ExactReal, y::Dual{<:Ty}) where {Ty}
    v = value(y)
    expv = x^v
    if iszero(x) && inf(v) > 0
        return Dual{Ty}(expv, zero(expv) * partials(y))
    else
        return Dual{Ty}(expv, expv * log(x) * partials(y))
    end
end

# Piecewise functions

function (constant::Constant)(::Dual{T,Interval{S}}) where {T, S}
    return Dual{T}(interval(S, constant.value), interval(S, 0.0))
end

function (piecewise::Piecewise)(dual::Dual{T,<:Interval}) where {T}
    X = value(dual)
    input_domain = Domain(X)
    if !overlap_domain(input_domain, piecewise)
        return Dual{T}(emptyinterval(X), emptyinterval(X) .* partials(dual))
    end

    if !in_domain(input_domain, piecewise)
        dec = trv
    elseif any(x -> in_domain(x, input_domain), discontinuities(piecewise, 1))
        dec = def
    else
        dec = com
    end

    dual_piece_outputs = []
    for (piece_domain, f) in pieces(piecewise)
        piece_input = intersect_domain(input_domain, piece_domain)
        isempty_domain(piece_input) && continue
        sub_X = interval(inf(piece_input), sup(piece_input), decoration(X))
        sub_dual = Dual{T}(sub_X, partials(dual))
        push!(dual_piece_outputs, f(sub_dual))
    end

    piece_outputs = value.(dual_piece_outputs)
    dec = min(dec, minimum(decoration.(piece_outputs)))
    primal = IntervalArithmetic.setdecoration(reduce(hull, piece_outputs), dec)

    doutputs = partials.(dual_piece_outputs)
    partial = map(zip(doutputs...)) do pp
        pdec = min(dec, minimum(decoration.(pp)))
        return IntervalArithmetic.setdecoration(reduce(hull, pp), pdec)
    end

    return Dual{T}(primal, tuple(partial...))
end

#

ForwardDiff.DiffRules._abs_deriv(x::Dual{T,<:Interval}) where {T} =
    Dual{T}(ForwardDiff.DiffRules._abs_deriv(value(x)), zero(partials(x)))

end

module IntervalArithmeticIntervalSetsExt

import IntervalSets as IS
import IntervalArithmetic as IA

IA.interval(i::IS.Interval{L,R,T}) where {L,R,T} = IA.interval(IA.promote_numtype(T, T), i)
function IA.interval(::Type{T}, i::IS.Interval{L,R}) where {T<:IA.NumTypes,L,R}
    # infinite endpoints are always open in IA, finite always closed:
    isinf(IS.leftendpoint(i)) != IS.isleftopen(i) && return IA.nai(T)
    isinf(IS.rightendpoint(i)) != IS.isrightopen(i) && return IA.nai(T)
    x = IA.interval(T, IS.endpoints(i)...)
    return IA._unsafe_interval(IA.bareinterval(x), IA.decoration(x), false)
end

function IS.Interval(i::IA.Interval)
    lo, hi = IA.bounds(i)
    # infinite endpoints are always open in IA, finite always closed:
    L = ifelse(isinf(lo), :open, :closed)
    R = ifelse(isinf(hi), :open, :closed)
    return IS.Interval{L,R}(lo, hi)
end

end

# This file contains the functions described as
# "Cancellative addition and subtraction" in Section 9.2 of the
# IEEE Standard 1788-2015 and required for set-based flavor in Section 10.5.6

"""
    cancelminus(x, y; dec = :default)

Compute the unique interval `z` such that `y + z == x`.

The keywork `dec` argument controls the decoration of the result. It can be
either a specific decoration, or one of two following options:
    - `:default`: if at least one of the input intervals is `ill`,
        then the result is `ill`, otherwise it is `trv` (Section 11.7.1).
    - `:auto`: the ouptut has the minimal decoration of the inputs.

Implement the `cancelMinus` function of the IEEE Standard 1788-2015 (Section 9.2).
"""
function cancelminus(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) & (isempty_interval(y) | !isunbounded(y)) && return emptyinterval(BareInterval{T})

    isunbounded(x) | isunbounded(y) | isempty_interval(y) && return entireinterval(BareInterval{T})

    diam(x) < diam(y) && return entireinterval(BareInterval{T})

    z_lo, z_hi = bounds(@round(T, inf(x) - inf(y), sup(x) - sup(y)))
    z_lo > z_hi && return entireinterval(BareInterval{T})

    # corner case 2 (page 62) involving unbounded z
    z_lo == typemax(T) && return _unsafe_bareinterval(T, prevfloat(z_lo), z_hi)
    z_hi == typemin(T) && return _unsafe_bareinterval(T, z_lo, nextfloat(z_hi))

    z = _unsafe_bareinterval(T, z_lo, z_hi)
    isunbounded(z) && return z

    # corner case 1 (page 62) involving finite precision for diam(x) and diam(y)
    w_lo, w_hi = bounds(@round(T, inf(y) + z_lo, sup(y) + z_hi))
    (diam(x) == diam(y)) & ((prevfloat(inf(x)) > w_lo) | (nextfloat(sup(x)) < w_hi)) && return entireinterval(BareInterval{T})

    return z
end
cancelminus(x::BareInterval, y::BareInterval) = cancelminus(promote(x, y)...)

function cancelminus(x::Interval, y::Interval; dec = :default)
    r = cancelminus(bareinterval(x), bareinterval(y))
    d = min(decoration(x), decoration(y), decoration(r))
    t = isguaranteed(x) & isguaranteed(y)
    return _set_decoration(_unsafe_interval(r, d, t), dec)
end

"""
    cancelplus(x, y; dec = :default)

Compute the unique interval `z` such that `y - z == x`; this is semantically
equivalent to `cancelminus(x, -y)`.

The keywork `dec` argument controls the decoration of the result. It can be
either a specific decoration, or one of two following options:
    - `:default`: if at least one of the input intervals is `ill`,
        then the result is `ill`, otherwise it is `trv` (Section 11.7.1).
    - `:auto`: the ouptut has the minimal decoration of the inputs.

Implement the `cancelPlus` function of the IEEE Standard 1788-2015 (Section 9.2).
"""
cancelplus(x::BareInterval, y::BareInterval) = cancelminus(x, -y)

cancelplus(x::Interval, y::Interval; dec = :default) = cancelminus(x, -y; dec = dec)

@testset "minimal_is_common_interval_test" begin

    @test iscommon(bareinterval(-27.0,-27.0)) === true

    @test iscommon(bareinterval(-27.0, 0.0)) === true

    @test iscommon(bareinterval(0.0,0.0)) === true

    @test iscommon(bareinterval(-0.0,-0.0)) === true

    @test iscommon(bareinterval(-0.0,0.0)) === true

    @test iscommon(bareinterval(0.0,-0.0)) === true

    @test iscommon(bareinterval(5.0, 12.4)) === true

    @test iscommon(bareinterval(-0x1.FFFFFFFFFFFFFp1023, 0x1.FFFFFFFFFFFFFp1023)) === true

    @test iscommon(entireinterval(BareInterval{Float64})) === false

    @test iscommon(emptyinterval(BareInterval{Float64})) === false

    @test iscommon(bareinterval(-Inf, 0.0)) === false

    @test iscommon(bareinterval(0.0, Inf)) === false

end

@testset "minimal_is_common_interval_dec_test" begin

    @test iscommon(interval(bareinterval(-27.0,-27.0), com)) === true

    @test iscommon(interval(bareinterval(-27.0, 0.0), com)) === true

    @test iscommon(interval(bareinterval(0.0,0.0), com)) === true

    @test iscommon(interval(bareinterval(-0.0,-0.0), com)) === true

    @test iscommon(interval(bareinterval(-0.0,0.0), com)) === true

    @test iscommon(interval(bareinterval(0.0,-0.0), com)) === true

    @test iscommon(interval(bareinterval(5.0, 12.4), com)) === true

    @test iscommon(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023, 0x1.FFFFFFFFFFFFFp1023), com)) === true

    @test iscommon(interval(bareinterval(-27.0,-27.0), trv)) === true

    @test iscommon(interval(bareinterval(-27.0, 0.0), def)) === true

    @test iscommon(interval(bareinterval(0.0,0.0), dac)) === true

    @test iscommon(interval(bareinterval(-0.0,-0.0), trv)) === true

    @test iscommon(interval(bareinterval(-0.0,0.0), def)) === true

    @test iscommon(interval(bareinterval(0.0,-0.0), dac)) === true

    @test iscommon(interval(bareinterval(5.0, 12.4), def)) === true

    @test iscommon(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023, 0x1.FFFFFFFFFFFFFp1023), trv)) === true

    @test iscommon(interval(entireinterval(BareInterval{Float64}), dac)) === false

    @test iscommon(nai(Interval{Float64})) === false

    @test iscommon(interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test iscommon(interval(bareinterval(-Inf, 0.0), trv)) === false

    @test iscommon(interval(bareinterval(0.0, Inf), def)) === false

end

@testset "minimal_is_singleton_test" begin

    @test isthin(bareinterval(-27.0,-27.0)) === true

    @test isthin(bareinterval(-2.0, -2.0)) === true

    @test isthin(bareinterval(12.0,12.0)) === true

    @test isthin(bareinterval(17.1, 17.1)) === true

    @test isthin(bareinterval(-0.0,-0.0)) === true

    @test isthin(bareinterval(0.0,0.0)) === true

    @test isthin(bareinterval(-0.0, 0.0)) === true

    @test isthin(bareinterval(0.0, -0.0)) === true

    @test isthin(emptyinterval(BareInterval{Float64})) === false

    @test isthin(entireinterval(BareInterval{Float64})) === false

    @test isthin(bareinterval(-1.0, 0.0)) === false

    @test isthin(bareinterval(-1.0, -0.5)) === false

    @test isthin(bareinterval(1.0, 2.0)) === false

    @test isthin(bareinterval(-Inf,-0x1.FFFFFFFFFFFFFp1023)) === false

    @test isthin(bareinterval(-1.0,Inf)) === false

end

@testset "minimal_is_singleton_dec_test" begin

    @test isthin(interval(bareinterval(-27.0,-27.0), def)) === true

    @test isthin(interval(bareinterval(-2.0, -2.0), trv)) === true

    @test isthin(interval(bareinterval(12.0,12.0), dac)) === true

    @test isthin(interval(bareinterval(17.1, 17.1), com)) === true

    @test isthin(interval(bareinterval(-0.0,-0.0), def)) === true

    @test isthin(interval(bareinterval(0.0,0.0), com)) === true

    @test isthin(interval(bareinterval(-0.0, 0.0), def)) === true

    @test isthin(interval(bareinterval(0.0, -0.0), dac)) === true

    @test isthin(interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test isthin(nai(Interval{Float64})) === false

    @test isthin(interval(entireinterval(BareInterval{Float64}), def)) === false

    @test isthin(interval(bareinterval(-1.0, 0.0), dac)) === false

    @test isthin(interval(bareinterval(-1.0, -0.5), com)) === false

    @test isthin(interval(bareinterval(1.0, 2.0), def)) === false

    @test isthin(interval(bareinterval(-Inf,-0x1.FFFFFFFFFFFFFp1023), dac)) === false

    @test isthin(interval(bareinterval(-1.0,Inf), trv)) === false

end

@testset "minimal_is_member_test" begin

    @test in_interval(-27.0, bareinterval(-27.0,-27.0)) === true

    @test in_interval(-27.0, bareinterval(-27.0, 0.0)) === true

    @test in_interval(-7.0, bareinterval(-27.0, 0.0)) === true

    @test in_interval(0.0, bareinterval(-27.0, 0.0)) === true

    @test in_interval(-0.0, bareinterval(0.0,0.0)) === true

    @test in_interval(0.0, bareinterval(0.0,0.0)) === true

    @test in_interval(0.0, bareinterval(-0.0,-0.0)) === true

    @test in_interval(0.0, bareinterval(-0.0,0.0)) === true

    @test in_interval(0.0, bareinterval(0.0,-0.0)) === true

    @test in_interval(5.0, bareinterval(5.0, 12.4)) === true

    @test in_interval(6.3, bareinterval(5.0, 12.4)) === true

    @test in_interval(12.4, bareinterval(5.0, 12.4)) === true

    @test in_interval(0.0, entireinterval(BareInterval{Float64})) === true

    @test in_interval(5.0, entireinterval(BareInterval{Float64})) === true

    @test in_interval(6.3, entireinterval(BareInterval{Float64})) === true

    @test in_interval(12.4, entireinterval(BareInterval{Float64})) === true

    @test in_interval(0x1.FFFFFFFFFFFFFp1023, entireinterval(BareInterval{Float64})) === true

    @test in_interval(-0x1.FFFFFFFFFFFFFp1023, entireinterval(BareInterval{Float64})) === true

    @test in_interval(0x1.0p-1022, entireinterval(BareInterval{Float64})) === true

    @test in_interval(-0x1.0p-1022, entireinterval(BareInterval{Float64})) === true

    @test in_interval(-71.0, bareinterval(-27.0, 0.0)) === false

    @test in_interval(0.1, bareinterval(-27.0, 0.0)) === false

    @test in_interval(-0.01, bareinterval(0.0,0.0)) === false

    @test in_interval(0.000001, bareinterval(0.0,0.0)) === false

    @test in_interval(111110.0, bareinterval(-0.0,-0.0)) === false

    @test in_interval(4.9, bareinterval(5.0, 12.4)) === false

    @test in_interval(-6.3, bareinterval(5.0, 12.4)) === false

    @test in_interval(0.0, emptyinterval(BareInterval{Float64})) === false

    @test in_interval(-4535.3, emptyinterval(BareInterval{Float64})) === false

    @test in_interval(-Inf, emptyinterval(BareInterval{Float64})) === false

    @test in_interval(Inf, emptyinterval(BareInterval{Float64})) === false

    @test in_interval(NaN, emptyinterval(BareInterval{Float64})) === false

    @test in_interval(-Inf, entireinterval(BareInterval{Float64})) === false

    @test in_interval(Inf, entireinterval(BareInterval{Float64})) === false

    @test in_interval(NaN, entireinterval(BareInterval{Float64})) === false

end

@testset "minimal_is_member_dec_test" begin

    @test in_interval(-27.0, interval(bareinterval(-27.0,-27.0), trv)) === true

    @test in_interval(-27.0, interval(bareinterval(-27.0, 0.0), def)) === true

    @test in_interval(-7.0, interval(bareinterval(-27.0, 0.0), dac)) === true

    @test in_interval(0.0, interval(bareinterval(-27.0, 0.0), com)) === true

    @test in_interval(-0.0, interval(bareinterval(0.0,0.0), trv)) === true

    @test in_interval(0.0, interval(bareinterval(0.0,0.0), def)) === true

    @test in_interval(0.0, interval(bareinterval(-0.0,-0.0), dac)) === true

    @test in_interval(0.0, interval(bareinterval(-0.0,0.0), com)) === true

    @test in_interval(0.0, interval(bareinterval(0.0,-0.0), trv)) === true

    @test in_interval(5.0, interval(bareinterval(5.0, 12.4), def)) === true

    @test in_interval(6.3, interval(bareinterval(5.0, 12.4), dac)) === true

    @test in_interval(12.4, interval(bareinterval(5.0, 12.4), com)) === true

    @test in_interval(0.0, interval(entireinterval(BareInterval{Float64}), trv)) === true

    @test in_interval(5.0, interval(entireinterval(BareInterval{Float64}), def)) === true

    @test in_interval(6.3, interval(entireinterval(BareInterval{Float64}), dac)) === true

    @test in_interval(12.4, interval(entireinterval(BareInterval{Float64}), trv)) === true

    @test in_interval(0x1.FFFFFFFFFFFFFp1023, interval(entireinterval(BareInterval{Float64}), def)) === true

    @test in_interval(-0x1.FFFFFFFFFFFFFp1023, interval(entireinterval(BareInterval{Float64}), dac)) === true

    @test in_interval(0x1.0p-1022, interval(entireinterval(BareInterval{Float64}), trv)) === true

    @test in_interval(-0x1.0p-1022, interval(entireinterval(BareInterval{Float64}), def)) === true

    @test in_interval(-71.0, interval(bareinterval(-27.0, 0.0), trv)) === false

    @test in_interval(0.1, interval(bareinterval(-27.0, 0.0), def)) === false

    @test in_interval(-0.01, interval(bareinterval(0.0,0.0), dac)) === false

    @test in_interval(0.000001, interval(bareinterval(0.0,0.0), com)) === false

    @test in_interval(111110.0, interval(bareinterval(-0.0,-0.0), trv)) === false

    @test in_interval(4.9, interval(bareinterval(5.0, 12.4), def)) === false

    @test in_interval(-6.3, interval(bareinterval(5.0, 12.4), dac)) === false

    @test in_interval(0.0, interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(0.0, interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(-4535.3, interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(-4535.3, interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(-Inf, interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(-Inf, nai(Interval{Float64})) === false

    @test in_interval(Inf, interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(Inf, nai(Interval{Float64})) === false

    @test in_interval(NaN, interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(NaN, nai(Interval{Float64})) === false

    @test in_interval(-Inf, interval(entireinterval(BareInterval{Float64}), trv)) === false

    @test in_interval(Inf, interval(entireinterval(BareInterval{Float64}), def)) === false

    @test in_interval(NaN, interval(entireinterval(BareInterval{Float64}), dac)) === false

end

@testset "minimal_overlap_test" begin

    @test overlap(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === IntervalArithmetic.Overlap.both_empty

    @test overlap(emptyinterval(BareInterval{Float64}), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.first_empty

    @test overlap(bareinterval(1.0,2.0), emptyinterval(BareInterval{Float64})) === IntervalArithmetic.Overlap.second_empty

    @test overlap(bareinterval(-Inf,2.0), bareinterval(3.0,Inf)) === IntervalArithmetic.Overlap.before

    @test overlap(bareinterval(-Inf,2.0), bareinterval(3.0,4.0)) === IntervalArithmetic.Overlap.before

    @test overlap(bareinterval(2.0,2.0), bareinterval(3.0,4.0)) === IntervalArithmetic.Overlap.before

    @test overlap(bareinterval(1.0,2.0), bareinterval(3.0,4.0)) === IntervalArithmetic.Overlap.before

    @test overlap(bareinterval(1.0,2.0), bareinterval(3.0,3.0)) === IntervalArithmetic.Overlap.before

    @test overlap(bareinterval(2.0,2.0), bareinterval(3.0,3.0)) === IntervalArithmetic.Overlap.before

    @test overlap(bareinterval(2.0,2.0), bareinterval(3.0,Inf)) === IntervalArithmetic.Overlap.before

    @test overlap(bareinterval(-Inf,2.0), bareinterval(2.0,3.0)) === IntervalArithmetic.Overlap.meets

    @test overlap(bareinterval(1.0,2.0), bareinterval(2.0,3.0)) === IntervalArithmetic.Overlap.meets

    @test overlap(bareinterval(1.0,2.0), bareinterval(2.0,Inf)) === IntervalArithmetic.Overlap.meets

    @test overlap(bareinterval(1.0,2.0), bareinterval(1.5,2.5)) === IntervalArithmetic.Overlap.overlaps

    @test overlap(bareinterval(1.0,2.0), bareinterval(1.0,Inf)) === IntervalArithmetic.Overlap.starts

    @test overlap(bareinterval(1.0,2.0), bareinterval(1.0,3.0)) === IntervalArithmetic.Overlap.starts

    @test overlap(bareinterval(1.0,1.0), bareinterval(1.0,3.0)) === IntervalArithmetic.Overlap.starts

    @test overlap(bareinterval(1.0,2.0), entireinterval(BareInterval{Float64})) === IntervalArithmetic.Overlap.contained_by

    @test overlap(bareinterval(1.0,2.0), bareinterval(-Inf,3.0)) === IntervalArithmetic.Overlap.contained_by

    @test overlap(bareinterval(1.0,2.0), bareinterval(0.0,3.0)) === IntervalArithmetic.Overlap.contained_by

    @test overlap(bareinterval(2.0,2.0), bareinterval(0.0,3.0)) === IntervalArithmetic.Overlap.contained_by

    @test overlap(bareinterval(2.0,2.0), bareinterval(0.0,Inf)) === IntervalArithmetic.Overlap.contained_by

    @test overlap(bareinterval(1.0,2.0), bareinterval(-Inf,2.0)) === IntervalArithmetic.Overlap.finishes

    @test overlap(bareinterval(1.0,2.0), bareinterval(0.0,2.0)) === IntervalArithmetic.Overlap.finishes

    @test overlap(bareinterval(2.0,2.0), bareinterval(0.0,2.0)) === IntervalArithmetic.Overlap.finishes

    @test overlap(bareinterval(1.0,2.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.equals

    @test overlap(bareinterval(1.0,1.0), bareinterval(1.0,1.0)) === IntervalArithmetic.Overlap.equals

    @test overlap(bareinterval(-Inf,1.0), bareinterval(-Inf,1.0)) === IntervalArithmetic.Overlap.equals

    @test overlap(entireinterval(BareInterval{Float64}), entireinterval(BareInterval{Float64})) === IntervalArithmetic.Overlap.equals

    @test overlap(bareinterval(3.0,4.0), bareinterval(2.0,2.0)) === IntervalArithmetic.Overlap.after

    @test overlap(bareinterval(3.0,4.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.after

    @test overlap(bareinterval(3.0,3.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.after

    @test overlap(bareinterval(3.0,3.0), bareinterval(2.0,2.0)) === IntervalArithmetic.Overlap.after

    @test overlap(bareinterval(3.0,Inf), bareinterval(2.0,2.0)) === IntervalArithmetic.Overlap.after

    @test overlap(bareinterval(2.0,3.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.met_by

    @test overlap(bareinterval(2.0,3.0), bareinterval(-Inf,2.0)) === IntervalArithmetic.Overlap.met_by

    @test overlap(bareinterval(1.5,2.5), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.overlapped_by

    @test overlap(bareinterval(1.5,2.5), bareinterval(-Inf,2.0)) === IntervalArithmetic.Overlap.overlapped_by

    @test overlap(bareinterval(1.0,Inf), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.started_by

    @test overlap(bareinterval(1.0,3.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.started_by

    @test overlap(bareinterval(1.0,3.0), bareinterval(1.0,1.0)) === IntervalArithmetic.Overlap.started_by

    @test overlap(bareinterval(-Inf,3.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.contains

    @test overlap(entireinterval(BareInterval{Float64}), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.contains

    @test overlap(bareinterval(0.0,3.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.contains

    @test overlap(bareinterval(0.0,3.0), bareinterval(2.0,2.0)) === IntervalArithmetic.Overlap.contains

    @test overlap(bareinterval(-Inf,2.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.finished_by

    @test overlap(bareinterval(0.0,2.0), bareinterval(1.0,2.0)) === IntervalArithmetic.Overlap.finished_by

    @test overlap(bareinterval(0.0,2.0), bareinterval(2.0,2.0)) === IntervalArithmetic.Overlap.finished_by

end

@testset "minimal_overlap_dec_test" begin

    @test overlap(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === IntervalArithmetic.Overlap.both_empty

    @test overlap(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(1.0,2.0), com)) === IntervalArithmetic.Overlap.first_empty

    @test overlap(interval(bareinterval(1.0,2.0), def), interval(emptyinterval(BareInterval{Float64}), trv)) === IntervalArithmetic.Overlap.second_empty

    @test overlap(interval(bareinterval(2.0,2.0), def), interval(bareinterval(3.0,4.0), def)) === IntervalArithmetic.Overlap.before

    @test overlap(interval(bareinterval(1.0,2.0), dac), interval(bareinterval(3.0,4.0), com)) === IntervalArithmetic.Overlap.before

    @test overlap(interval(bareinterval(1.0,2.0), com), interval(bareinterval(3.0,3.0), trv)) === IntervalArithmetic.Overlap.before

    @test overlap(interval(bareinterval(2.0,2.0), trv), interval(bareinterval(3.0,3.0), def)) === IntervalArithmetic.Overlap.before

    @test overlap(interval(bareinterval(1.0,2.0), def), interval(bareinterval(2.0,3.0), def)) === IntervalArithmetic.Overlap.meets

    @test overlap(interval(bareinterval(1.0,2.0), dac), interval(bareinterval(1.5,2.5), def)) === IntervalArithmetic.Overlap.overlaps

    @test overlap(interval(bareinterval(1.0,2.0), def), interval(bareinterval(1.0,3.0), com)) === IntervalArithmetic.Overlap.starts

    @test overlap(interval(bareinterval(1.0,1.0), trv), interval(bareinterval(1.0,3.0), def)) === IntervalArithmetic.Overlap.starts

    @test overlap(interval(bareinterval(1.0,2.0), def), interval(bareinterval(0.0,3.0), dac)) === IntervalArithmetic.Overlap.contained_by

    @test overlap(interval(bareinterval(2.0,2.0), trv), interval(bareinterval(0.0,3.0), def)) === IntervalArithmetic.Overlap.contained_by

    @test overlap(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(0.0,2.0), com)) === IntervalArithmetic.Overlap.finishes

    @test overlap(interval(bareinterval(2.0,2.0), def), interval(bareinterval(0.0,2.0), dac)) === IntervalArithmetic.Overlap.finishes

    @test overlap(interval(bareinterval(1.0,2.0), def), interval(bareinterval(1.0,2.0), def)) === IntervalArithmetic.Overlap.equals

    @test overlap(interval(bareinterval(1.0,1.0), dac), interval(bareinterval(1.0,1.0), dac)) === IntervalArithmetic.Overlap.equals

    @test overlap(interval(bareinterval(3.0,4.0), trv), interval(bareinterval(2.0,2.0), trv)) === IntervalArithmetic.Overlap.after

    @test overlap(interval(bareinterval(3.0,4.0), def), interval(bareinterval(1.0,2.0), def)) === IntervalArithmetic.Overlap.after

    @test overlap(interval(bareinterval(3.0,3.0), com), interval(bareinterval(1.0,2.0), dac)) === IntervalArithmetic.Overlap.after

    @test overlap(interval(bareinterval(3.0,3.0), def), interval(bareinterval(2.0,2.0), trv)) === IntervalArithmetic.Overlap.after

    @test overlap(interval(bareinterval(2.0,3.0), def), interval(bareinterval(1.0,2.0), trv)) === IntervalArithmetic.Overlap.met_by

    @test overlap(interval(bareinterval(1.5,2.5), com), interval(bareinterval(1.0,2.0), com)) === IntervalArithmetic.Overlap.overlapped_by

    @test overlap(interval(bareinterval(1.0,3.0), dac), interval(bareinterval(1.0,2.0), def)) === IntervalArithmetic.Overlap.started_by

    @test overlap(interval(bareinterval(1.0,3.0), com), interval(bareinterval(1.0,1.0), dac)) === IntervalArithmetic.Overlap.started_by

    @test overlap(interval(bareinterval(0.0,3.0), com), interval(bareinterval(1.0,2.0), dac)) === IntervalArithmetic.Overlap.contains

    @test overlap(interval(bareinterval(0.0,3.0), com), interval(bareinterval(2.0,2.0), def)) === IntervalArithmetic.Overlap.contains

    @test overlap(interval(bareinterval(0.0,2.0), def), interval(bareinterval(1.0,2.0), trv)) === IntervalArithmetic.Overlap.finished_by

    @test overlap(interval(bareinterval(0.0,2.0), dac), interval(bareinterval(2.0,2.0), def)) === IntervalArithmetic.Overlap.finished_by

end

@testset "Complex interval operations" begin
    a = interval(1im)
    b = interval(4im + 3)
    c = complex(interval(-1, 4), interval(0, 2))

    @test typeof(a) == Complex{Interval{Float64}}

    @test issubset_interval(a, c)
    @test isinterior(a, c)
    @test !issubset_interval(b, c)

    @test isequal_interval(a, complex(interval(0), interval(1)))
    @test isequal_interval(a * a, interval(-1))
    @test isequal_interval(a + a, interval(2)*interval(im))
    @test isthin(a - a, 0)
    @test isthin(a / a, 1)

    @test in_interval(3+2im, c)
    @test isequal_interval(hull(a, b), complex(interval(0, 3), interval(1, 4)))
    @test isequal_interval(intersect_interval(c, hull(a, b)), complex(interval(0, 3), interval(1, 2)))
    @test isempty_interval(intersect_interval(a, b))
    @test isdisjoint_interval(a, b)

    @test isequal_interval(interval(-1 - im, 0), interval(-1 - im, 0 + 0im))
    @test isequal_interval(interval(0, 1 + im), interval(0 + 0im, 1 + im))
end

@testset "Inverse roots of unity" begin
    for i ∈ 0:99
        if Int == Int32 && VERSION < v"1.10"
            @test issubset_interval(cispi( -interval(i)/interval(50) ), inv(cispi( interval(i)/interval(50) ))) &&
                radius( inv(cispi( interval(i)/interval(50) )) ) < 100eps()
        else
            @test issubset_interval(cispi( -interval(i)/interval(50) ), inv(cispi( interval(i)/interval(50) ))) &&
                radius( inv(cispi( interval(i)/interval(50) )) ) < 10eps()
        end
    end
end

# @testset "Complex functions" begin
#     Z = interval(3, 1e-7; format = :midpoint) + interval(4, 1e-7; format = :midpoint)*interval(im)
#     @test sin(Z) == complex(sin(real(Z)) * cosh(imag(Z)), sinh(imag(Z)) * cos(real(Z)))

#     z = exp(- interval(im) * interval(π))
#     @test in_interval(-1, real(z))
#     @test in_interval(0, imag(z))

#     sZ = sqrt(Z)
#     @test isequal_interval(sZ, complex(interval(1.99999996999999951619, 2.00000003000000070585), interval(0.99999996999999984926, 1.00000003000000048381)))
#     @test isequal_interval(sqrt(-Z), complex(imag(sZ), - real(sZ)))

#     @test isequal_interval(sqrt(interval(-1, 0) + interval(0)*interval(im)), interval(0im, im))
#     @test isequal_interval(sqrt(interval(-1, 1) + interval(0)*interval(im)), interval(0, 1) + interval(0im, 1im))
#     @test isequal_interval(sqrt(interval(-9//32, Inf)*interval(im)), complex(interval(0, Inf), interval(-3//8, Inf)))
# end

@testset "abs2 and abs" begin
    x = complex(interval(0, 3), interval(0, 4))
    @test isequal_interval(abs2(x), interval(0, 25))
    @test isequal_interval(abs(x), interval(0, 5))

    y = complex(interval(-1, 1), interval(-2, 2))
    @test inf(abs(y)) == 0
    @test inf(abs2(y)) == 0
end

@testset "real functions" begin
    x = complex(interval(0, 3), interval(0, 4))
    @test mag(x) == 5
    @test mig(x) == 0
    @test mid(x) == 1.5 + 2im
end

import ForwardDiff

@testset "BareInterval" begin
    @testset "abs" begin
        @test_throws MethodError ForwardDiff.derivative(abs, bareinterval(-1, 1))
    end
end

@testset "Interval" begin
    @testset "abs" begin
        @test ForwardDiff.derivative(abs, interval(-2, -1)) === interval(-1, -1, com)
        @test ForwardDiff.derivative(abs, interval( 1,  2)) === interval( 1,  1, com)
        @test ForwardDiff.derivative(abs, interval(   0  )) === interval(-1,  1, trv)
        @test ForwardDiff.derivative(abs, interval(-1,  0)) === interval(-1,  0, trv)
        @test ForwardDiff.derivative(abs, interval( 0,  1)) === interval( 0,  1, trv)
        @test ForwardDiff.derivative(abs, interval(-2,  2)) === interval(-1,  1, trv)

        f(x) = abs(x)^interval(2)
        @test ForwardDiff.derivative(f, interval(-1, 1)) === interval(-2,  2, trv)

        g(x) = abs(x)^2
        @test     ForwardDiff.derivative(g,             interval(-1, 1) )  ===  interval(convert(Interval{Float64}, -2), convert(Interval{Float64}, 2), trv)
        @test all(ForwardDiff.gradient(  v -> g(v[1]), [interval(-1, 1)]) .=== [interval(convert(Interval{Float64}, -2), convert(Interval{Float64}, 2), trv)])
        @test all(ForwardDiff.hessian(   v -> g(v[1]), [interval(  0  )]) .=== [interval(convert(Interval{Float64}, -2), convert(Interval{Float64}, 2), trv)])
        @test all(ForwardDiff.hessian(   v -> g(v[1]), [interval(-1, 1)]) .=== [interval(convert(Interval{Float64}, -2), convert(Interval{Float64}, 2), trv)])
    end

    @testset "sin" begin
        x, w = interval(2), interval(-0.5, 0.5)
        ϕ(t)    =  sin(x + (1+t)*w)
        ϕ′(t)   =  cos(x + (1+t)*w) * w
        ϕ′′(t)  = -sin(x + (1+t)*w) * w * w
        ϕ′′′(t) = -cos(x + (1+t)*w) * w * w * w
        dϕ(t)   = ForwardDiff.derivative(ϕ, t)
        ddϕ(t)  = ForwardDiff.derivative(dϕ, t)
        dddϕ(t) = ForwardDiff.derivative(ddϕ, t)

        @test ϕ′(0)   === dϕ(0)
        @test ϕ′′(0)  === ddϕ(0)
        @test ϕ′′′(0) === dddϕ(0)

        y = interval(1)
        ψ(t)    =  sin(x + (y+t)*w)
        ψ′(t)   =  cos(x + (y+t)*w) * w
        ψ′′(t)  = -sin(x + (y+t)*w) * w * w
        ψ′′′(t) = -cos(x + (y+t)*w) * w * w * w
        dψ(t)   = ForwardDiff.derivative(ψ, t)
        ddψ(t)  = ForwardDiff.derivative(dψ, t)
        dddψ(t) = ForwardDiff.derivative(ddψ, t)
        @test ψ′(0)   === dψ(0)   && !isguaranteed(ψ′(0))
        @test ψ′′(0)  === ddψ(0)  && !isguaranteed(ψ′′(0))
        @test ψ′′′(0) === dddψ(0) && !isguaranteed(ψ′′′(0))
        t₀ = interval(0)
        @test ψ′(t₀)   === dψ(t₀)   && isguaranteed(ψ′(t₀))
        @test ψ′′(t₀)  === ddψ(t₀)  && isguaranteed(ψ′′(t₀))
        @test ψ′′′(t₀) === dddψ(t₀) && isguaranteed(ψ′′′(t₀))
    end

    @testset "Power" begin
        fxy(xy) = xy[1]^xy[2]

        for x in [0.0, 1.1, 2.2]
            for y in [-3.3, 0.0, 4.4]
                fx(xx) = xx^y
                fxi(xx) = xx^interval(y)
                fy(yy) = x^yy
                fyi(yy) = interval(x)^yy

                dfdx = ForwardDiff.derivative(fxi, interval(x))
                dfdy = ForwardDiff.derivative(fyi, interval(y))
                grad = ForwardDiff.gradient(fxy, [interval(x), interval(y)])

                @test isguaranteed(dfdx)
                @test isguaranteed(dfdy)
                @test isguaranteed(grad[1])
                @test isguaranteed(grad[2])

                if iszero(x) && y < 0
                    @test decoration(dfdx) == trv
                else
                    @test in_interval(ForwardDiff.derivative(fx, x), dfdx)
                end

                if iszero(x) && y <= 0
                    @test decoration(dfdy) == trv
                else
                    @test in_interval(ForwardDiff.derivative(fy, y), dfdy)
                end

                if iszero(x) && iszero(y)
                    @test decoration(grad[1]) == trv
                    @test decoration(dfdx) == com
                else
                    @test isequal_interval(dfdx, grad[1])
                end
                @test isequal_interval(dfdy, grad[2])
            end
        end
    end

    @testset "ExactReal" begin
        @exact f(x) = x^2 - 2
        @test isguaranteed(ForwardDiff.derivative(f, interval(1)))

        @exact g(x) = 2^x + 6sin(x^3) - 33
        @test isguaranteed(ForwardDiff.derivative(f, interval(1)))
    end
end

using Documenter, IntervalArithmetic

DocMeta.setdocmeta!(IntervalArithmetic, :DocTestSetup, :(using IntervalArithmetic))

makedocs(;
    modules = [IntervalArithmetic],
    authors = "David P. Sanders and Luis Benet",
    sitename = "IntervalArithmetic.jl",
    format = Documenter.HTML(;
        assets = ["assets/intervalarithmetic.css"],
        prettyurls = get(ENV, "CI", "false") == "true",
        canonical = "https://juliaintervals.github.io/IntervalArithmetic.jl",
        mathengine = KaTeX(Dict(
            :macros => Dict(
                "\\bydef" => "\\stackrel{\\tiny\\text{def}}{=}"
            )
        ))
    ),
    pages = [
        "Home" => "index.md",
        "Overview" => "intro.md",
        "Philosophy" => "philosophy.md",
        "Manual" => [
            "Constructing intervals" => "manual/construction.md",
            "Guarantee and `ExactReal`" => "manual/guarantee.md",
            "Usage" => "manual/usage.md",
            "Configuration" => "manual/configuration.md",
            "Symbols" => "manual/symbols.md",
            "API" => "manual/api.md"
        ],
        "Interfaces" => [
            "Arblib.jl" => "interfaces/arblib.md"
        ],
        "Examples" => ["Rigorous computation of ``\\pi``" => "examples/pi.md"],
    ],
    warnonly = true
)

deploydocs(;
    repo = "github.com/JuliaIntervals/IntervalArithmetic.jl",
    devbranch = "master"
)

@testset "sinh" begin
    @test isequal_interval(sinh(emptyinterval()), emptyinterval())
    @test isequal_interval(sinh(interval(0.5)), interval(0.5210953054937473, 0.5210953054937474))
    @test isequal_interval(sinh(interval(0.5, 1.67)), interval(0.5210953054937473, 2.5619603657712102))
    @test isequal_interval(sinh(interval(-4.5, 0.1)), interval(-45.00301115199179, 0.10016675001984404))
    @test issubset_interval(sinh(interval(BigFloat, 0.5, 0.5)), sinh(interval(0.5)))

    @test issubset_interval(sinh(interval(BigFloat, 0.5, 1.67)), sinh(interval(0.5, 1.67)))
    @test issubset_interval(sinh(interval(BigFloat, 1.67, 3.2)), sinh(interval(1.67, 3.2)))
    @test issubset_interval(sinh(interval(BigFloat, 2.1, 5.6)), sinh(interval(2.1, 5.6)))
    @test issubset_interval(sinh(interval(BigFloat, 0.5, 8.5)), sinh(interval(0.5, 8.5)))
    @test issubset_interval(sinh(interval(BigFloat, -4.5, 0.1)), sinh(interval(-4.5, 0.1)))
    @test issubset_interval(sinh(interval(BigFloat, 1.3, 6.3)), sinh(interval(1.3, 6.3)))
end

@testset "cosh" begin
    @test isequal_interval(cosh(emptyinterval()), emptyinterval())
    @test isequal_interval(cosh(interval(0.5)), interval(1.1276259652063807, 1.127625965206381))
    @test isequal_interval(cosh(interval(0.5, 1.67)), interval(1.1276259652063807, 2.750207431409957))
    @test isequal_interval(cosh(interval(-4.5, 0.1)), interval(1.0, 45.01412014853003))

    @test issubset_interval(cosh(interval(BigFloat, 0.5, 0.5)), cosh(interval(0.5)))
    @test issubset_interval(cosh(interval(BigFloat, 0.5, 1.67)), cosh(interval(0.5, 1.67)))
    @test issubset_interval(cosh(interval(BigFloat, 1.67, 3.2)), cosh(interval(1.67, 3.2)))
    @test issubset_interval(cosh(interval(BigFloat, 2.1, 5.6)), cosh(interval(2.1, 5.6)))
    @test issubset_interval(cosh(interval(BigFloat, 0.5, 8.5)), cosh(interval(0.5, 8.5)))
    @test issubset_interval(cosh(interval(BigFloat, -4.5, 0.1)), cosh(interval(-4.5, 0.1)))
    @test issubset_interval(cosh(interval(BigFloat, 1.3, 6.3)), cosh(interval(1.3, 6.3)))
end

@testset "tanh" begin
    @test isequal_interval(tanh(emptyinterval()), emptyinterval())
    @test isequal_interval(tanh(interval(0.5)), interval(0.46211715726000974, 0.4621171572600098))
    @test isequal_interval(tanh(interval(0.5, 1.67)), interval(0.46211715726000974, 0.9315516846152083))
    @test isequal_interval(tanh(interval(-4.5, 0.1)), interval(-0.9997532108480276, 0.09966799462495583))

    @test issubset_interval(tanh(interval(BigFloat, 0.5, 0.5)), tanh(interval(0.5)))
    @test issubset_interval(tanh(interval(BigFloat, 0.5, 1.67)), tanh(interval(0.5, 1.67)))
    @test issubset_interval(tanh(interval(BigFloat, 1.67, 3.2)), tanh(interval(1.67, 3.2)))
    @test issubset_interval(tanh(interval(BigFloat, 2.1, 5.6)), tanh(interval(2.1, 5.6)))
    @test issubset_interval(tanh(interval(BigFloat, 0.5, 8.5)), tanh(interval(0.5, 8.5)))
    @test issubset_interval(tanh(interval(BigFloat, -4.5, 0.1)), tanh(interval(-4.5, 0.1)))
    @test issubset_interval(tanh(interval(BigFloat, 1.3, 6.3)), tanh(interval(1.3, 6.3)))

    @test issubset_interval(tanh(interval(-4.5, 0.1)), tanh(interval(Float32, -4.5, 0.1)))
    @test issubset_interval(tanh(interval(1.3, 6.3)), tanh(interval(Float32, 1.3, 6.3)))

    for a in [ interval(17, 19), interval(0.5, 1.2) ]
        @test issubset_interval(tanh(a), sinh(a)/cosh(a))
    end
end

@testset "tanh with Float32" begin
    @test issubset_interval(tanh(interval(0.5)), tanh(interval(Float32, 0.5, 0.5)))
    @test issubset_interval(tanh(interval(0.5, 1.67)), tanh(interval(Float32, 0.5, 1.67)))
    @test issubset_interval(tanh(interval(1.67, 3.2)), tanh(interval(Float32, 1.67, 3.2)))
    @test issubset_interval(tanh(interval(2.1, 5.6)), tanh(interval(Float32, 2.1, 5.6)))
    @test issubset_interval(tanh(interval(0.5, 8.5)), tanh(interval(Float32, 0.5, 8.5)))
end

@testset "inverse" begin
    @test issubset_interval(asinh(interval(BigFloat, 1, 1)), asinh(interval(1)))
    @test issubset_interval(asinh(interval(BigFloat, 0.9, 2)), asinh(interval(0.9, 2)))
    @test issubset_interval(asinh(interval(BigFloat, 3, 4)), asinh(interval(3, 4)))

    @test issubset_interval(acosh(interval(BigFloat, 1, 1)), acosh(interval(1)))
    @test issubset_interval(acosh(interval(BigFloat, -2, -0.9)), acosh(interval(-2, -0.9)))
    @test issubset_interval(acosh(interval(BigFloat, 3, 4)), acosh(interval(3, 4)))
end

# This file contains the functions described as "Absmax functions" in Section
# 9.1 of the IEEE Standard 1788-2015 and required for set-based flavor in
# Section 10.5.3

"""
    abs(x::BareInterval)
    abs(x::Interval)

Implement the `abs` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.abs(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    inf(x) > 0 && return x
    sup(x) < 0 && return _unsafe_bareinterval(T, -sup(x), -inf(x))
    return _unsafe_bareinterval(T, zero(T), max(-inf(x), sup(x)))
end

Base.abs(x::Interval) = _unsafe_interval(abs(bareinterval(x)), decoration(x), isguaranteed(x))

Base.abs(x::Complex{<:Interval}) = hypot(real(x), imag(x))

"""
    abs2(x::BareInterval)
    abs2(x::Interval)

Implement the square absolute value. Its behaviour depends on the current [`PowerMode`](@ref).
"""
Base.abs2(x::BareInterval) = _select_pown(x, 2) # not in the IEEE Standard 1788-2015

function Base.abs2(x::Interval)
    r = abs2(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.abs2(x::Complex{<:Interval}) = abs2(real(x)) + abs2(imag(x))

for f ∈ (:min, :max)
    @eval begin
        """
            $($f)(x::BareInterval, y::BareInterval)
            $($f)(x::Interval, y::Interval)

        Implement the `$($f)` function of the IEEE Standard 1788-2015 (Table 9.1).
        """
        function Base.$f(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
            isempty_interval(x) && return x
            isempty_interval(y) && return y
            return _unsafe_bareinterval(T, $f(inf(x), inf(y)), $f(sup(x), sup(y)))
        end
        Base.$f(x::BareInterval, y::BareInterval) = $f(promote(x, y)...)

        function Base.$f(x::Interval, y::Interval)
            r = $f(bareinterval(x), bareinterval(y))
            d = min(decoration(x), decoration(y))
            t = isguaranteed(x) & isguaranteed(y)
            return _unsafe_interval(r, d, t)
        end
    end
end

module IntervalArithmeticArblibExt

import IntervalArithmetic as IA
import Arblib

# Promotion rules

# These are needed for ambiguity reasons
Base.promote_rule(
    ::Type{IA.Interval{T}},
    ::Type{S},
) where {T<:IA.NumTypes,S<:Arblib.ArfOrRef} = IA.Interval{promote_type(T, S)}
Base.promote_rule(
    ::Type{T},
    ::Type{IA.Interval{S}},
) where {T<:Arblib.ArfOrRef,S<:IA.NumTypes} = IA.Interval{promote_type(T, S)}

Base.promote_rule(
    ::Type{IA.Interval{T}},
    ::Type{S},
) where {T<:IA.NumTypes,S<:Arblib.ArbOrRef} =
    throw(ArgumentError("promotion between Interval and Arb is purposely not supported"))
Base.promote_rule(
    ::Type{T},
    ::Type{IA.Interval{S}},
) where {T<:Arblib.ArbOrRef,S<:IA.NumTypes} =
    throw(ArgumentError("promotion between Interval and Arb is purposely not supported"))

# Construction of Arb from Interval
# Note that this automatically gives support for construction of Acb.

Arblib._precision(x::Union{IA.Interval,IA.BareInterval}) =
    Arblib._precision(IA.inf(x), IA.sup(x))

function Arblib.set!(
    res::Arblib.ArbLike,
    x::Union{IA.Interval,IA.BareInterval};
    prec::Integer = precision(res),
)
    if IA.isempty_interval(x)
        Arblib.indeterminate!(res)
    else
        Arblib.set!(res, (IA.inf(x), IA.sup(x)); prec)
    end
    return res
end

# Construction of Interval from Arb

# We essentially treat Arb as Interval{BigFloat} for the purposes of
# constructing Intervals. This means that we only have to change the
# behavior of _inf and _sup since these are called early on in the
# construction process to handle endpoints which are Intervals.

IA._inf(x::Arblib.ArbOrRef) = BigFloat(Arblib.lbound(x))
IA._sup(x::Arblib.ArbOrRef) = BigFloat(Arblib.ubound(x))

# Make promote_numtype for Arb behave like promotion with BigFloat
IA.promote_numtype(::Type{<:Arblib.ArbOrRef}, ::Type{<:Arblib.ArbOrRef}) = BigFloat
IA.promote_numtype(::Type{<:Arblib.ArbOrRef}, ::Type{S}) where {S} =
    IA.promote_numtype(BigFloat, S)
IA.promote_numtype(::Type{<:Arblib.ArbOrRef}, ::Type{S}) where {S<:IA.NumTypes} =
    IA.promote_numtype(BigFloat, S)
IA.promote_numtype(::Type{T}, ::Type{<:Arblib.ArbOrRef}) where {T} =
    IA.promote_numtype(T, BigFloat)
IA.promote_numtype(::Type{T}, ::Type{<:Arblib.ArbOrRef}) where {T<:IA.NumTypes} =
    IA.promote_numtype(T, BigFloat)

# Construction of Complex{Interval} from Acb
IA.numtype(::Type{<:Arblib.AcbOrRef}) = Arblib.Arb

# Handle Acb in the same way as Complex.
IA._interval_infsup(
    ::Type{T},
    a::Arblib.AcbOrRef,
    b::Arblib.AcbOrRef,
    d::IA.Decoration,
) where {T<:IA.NumTypes} = complex(
    IA._interval_infsup(T, real(a), real(b), d),
    IA._interval_infsup(T, imag(a), imag(b), d),
)
IA._interval_infsup(
    ::Type{T},
    a::Arblib.AcbOrRef,
    b,
    d::IA.Decoration,
) where {T<:IA.NumTypes} = complex(
    IA._interval_infsup(T, real(a), real(b), d),
    IA._interval_infsup(T, imag(a), imag(b), d),
)
IA._interval_infsup(
    ::Type{T},
    a,
    b::Arblib.AcbOrRef,
    d::IA.Decoration,
) where {T<:IA.NumTypes} = complex(
    IA._interval_infsup(T, real(a), real(b), d),
    IA._interval_infsup(T, imag(a), imag(b), d),
)

# Handle ambiguities
for S in [Union{IA.BareInterval,IA.Interval}, Complex]
    @eval IA._interval_infsup(
        ::Type{T},
        a::Arblib.AcbOrRef,
        b::$S,
        d::IA.Decoration,
    ) where {T<:IA.NumTypes} = complex(
        IA._interval_infsup(T, real(a), real(b), d),
        IA._interval_infsup(T, imag(a), imag(b), d),
    )
    @eval IA._interval_infsup(
        ::Type{T},
        a::$S,
        b::Arblib.AcbOrRef,
        d::IA.Decoration,
    ) where {T<:IA.NumTypes} = complex(
        IA._interval_infsup(T, real(a), real(b), d),
        IA._interval_infsup(T, imag(a), imag(b), d),
    )
end

# Make it so that implicit conversion from Arb to Interval doesn't set
# the NG flag.

Base.convert(::Type{IA.Interval{T}}, x::Arblib.ArbOrRef) where {T<:IA.NumTypes} =
    IA.interval(T, x)

function Base.convert(::Type{IA.Interval{T}}, x::Arblib.AcbOrRef) where {T<:IA.NumTypes}
    isreal(x) || return throw(DomainError(x, "imaginary part must be zero"))
    return convert(IA.Interval{T}, real(x))
end

Base.convert(::Type{Complex{IA.Interval{T}}}, x::Arblib.ArbOrRef) where {T<:IA.NumTypes} =
    complex(IA.interval(T, x))

# Handle ambiguities related to ExactReal

Arblib.Mag(x::IA.ExactReal) = convert(Arblib.Mag, x)
Arblib.Arf(x::IA.ExactReal) = convert(Arblib.Arf, x)
Arblib.Arb(x::IA.ExactReal) = convert(Arblib.Arb, x)

Base.promote_rule(::Type{T}, ::Type{IA.ExactReal{S}}) where {T<:Arblib.ArfOrRef,S<:Real} =
    promote_type(T, S)
Base.promote_rule(::Type{IA.ExactReal{T}}, ::Type{S}) where {T<:Real,S<:Arblib.ArfOrRef} =
    promote_type(T, S)

Base.promote_rule(::Type{T}, ::Type{IA.ExactReal{S}}) where {T<:Arblib.ArbOrRef,S<:Real} =
    promote_type(T, S)
Base.promote_rule(::Type{IA.ExactReal{T}}, ::Type{S}) where {T<:Real,S<:Arblib.ArbOrRef} =
    promote_type(T, S)

end

"""
    I"str"

Create an interval by parsing the string `"str"`; this is semantically
equivalent to `parse(Interval{default_numtype()}, "str")`.

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> I"[3, 4]"
Interval{Float64}(3.0, 4.0, com, true)

julia> I"0.1"
Interval{Float64}(0.09999999999999999, 0.1, com, true)

julia> in_interval(1//10, I"0.1")
true
```
"""
macro I_str(str)
    return _parse(str)
end

"""
    parse(T<:BareInterval, str)
    parse(T<:Interval, str)

Create an interval according to the IEEE Standard 1788-2015. In contrast with
constructors that do not use strings, this constructor guarantees that the
returned interval tightly encloses the values described by the string, including
numbers that have no exact float representation (e.g. 0.1).

Parse a string of the form `"[a, b]_dec"` as an `Interval` with decoration `dec`.
If the decoration is not specified, it is computed based on the parsed interval.
If the input is an invalid string, a warning is printed and NaI is returned. The
parser is case unsensitive.

Examples of allowed string formats:
- `I"[1.33]"` or `I"1.33"`: the interval containing ``1.33``.
- `I"[1.44, 2.78]"`: the interval ``[1.44, 2.78]``.
- `I"[empty]"`: the empty interval.
- `I"[entire]"` or `I"[,]"`: the interval ``[-\\infty, \\infty]``.
- `I"[3,]"`: the interval ``[3, \\infty]``.
- `I"6.42?2"`: the interval ``[6.4,  6.44]``. The number after `?` represents the
    uncertainty in the last digit; by default this value is `0.5`. The direction
    of the uncertainty can be given by adding `u` or `d` at the end for the error
    to only go up or down respectively (e.g. `I"4.5?5u"` represents ``[4.5, 5]``).
- `I"6.42?2e2"`: the interval ``[642, 644]``.
- `I"3??u"`: the interval ``[3, \\infty]``.
- `I"3??u"`: the interval ``[3, \\infty]``.
- `I"3??"`: the interval ``[-\\infty, \\infty]``.

For more details, see sections 9.7 and 12.11 of the IEEE Standard 1788-2015.

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> parse(BareInterval{Float64}, "[1, 2]")
BareInterval{Float64}(1.0, 2.0)

julia> parse(BareInterval{Float64}, "[1,]")
BareInterval{Float64}(1.0, Inf)

julia> parse(BareInterval{Float64}, "[,]")
BareInterval{Float64}(-Inf, Inf)

julia> parse(BareInterval{Float64}, "6.42?2e2")
BareInterval{Float64}(640.0, 644.0)

julia> parse(Interval{Float64}, "[1, 2]")
Interval{Float64}(1.0, 2.0, com, true)

julia> parse(Interval{Float64}, "[1, 2]_def")
Interval{Float64}(1.0, 2.0, def, true)

julia> parse(Interval{Float64}, "[1, 1e400]_com")
Interval{Float64}(1.0, Inf, dac, true)
```
"""
function Base.parse(::Type{BareInterval{T}}, str::AbstractString) where {T<:NumTypes}
    if '_' ∈ str
        @warn "failed to parse a decorated interval as a `BareInterval`, empty interval is returned"
        return emptyinterval(BareInterval{T})
    else
        str = lowercase(strip(str))
        x, _, isexactnai, iserror = _parse(T, str) # `isexactnai == true` for string of the form [ nai ]
        iserror && @warn "parsing error, empty interval is returned"
        isexactnai && @warn "parsed NaI, empty interval is returned"
        return x.bareinterval # use `x.bareinterval` to not print a warning if `x` is an NaI
    end
end

function Base.parse(::Type{Interval{T}}, str::AbstractString) where {T<:NumTypes}
    str = lowercase(strip(str))
    if '_' ∉ str
        x, _, _, iserror = _parse(T, str)
        iserror && @warn "parsing error, NaI is returned"
        return x
    else
        bx_str, d_str = split(str, '_'; keepempty = true, limit = 2)
        decorations = Dict{String,Decoration}("ill" => ill, "trv" => trv, "def" => def, "dac" => dac, "com" => com)
        if haskey(decorations, d_str)
            d_given = decorations[d_str]
            x, flag, _, iserror = _parse(T, bx_str) # `flag == true` if the parse interval is unbounded due to the precision
            if iserror
                @warn "parsing error, NaI is returned"
                return x
            else
                d = decoration(x)
                if d_given > d && flag
                    @warn "parsed interval $x is incompatible with parsed decoration $d_given, NaI is returned"
                    return nai(T)
                else
                    return interval(T, x, d_given) # warning is printed if `d_given == ill`
                end
            end
        else
            @warn "failed to parse the decoration, NaI is returned"
            return nai(T)
        end
    end
end

_parse(str::AbstractString) = parse(Interval{default_numtype()}, str)

function _parse(::Type{T}, str::AbstractString) where {T<:NumTypes}
    if startswith(str, '[') && endswith(str, ']')
        s = strip(view(str, 2:length(str)-1))
        if ',' ∈ s # inf-sup interval
            lo_str, hi_str = strip.(split(s, ','; keepempty = true, limit = 2))
            if isempty(lo_str)
                lo_str = "-inf"
            end
            if isempty(hi_str)
                hi_str = "inf"
            end
            try
                lo = _parse_num(T, lo_str, RoundDown)
                hi = _parse_num(T, hi_str, RoundUp)
                flag = !((isinf(lo) & !occursin("inf", lo_str)) | (isinf(hi) & !occursin("inf", hi_str)))
                x = interval(T, lo, hi)
                isatomic(x) & !isempty_interval(x) & !isthin(x) && @warn "$str is parsed as an atomic interval, something wrong may have happened"
                return x, flag, false, false
            catch
                return nai(T), false, false, true
            end
        else # point interval
            s == "nai" && return nai(T), true, true, false # no warning is printed
            (s == "empty") | isempty(s) && return emptyinterval(T), true, false, false # no warning is printed
            s == "entire" && return entireinterval(T), true, false, false # no warning is printed
            try
                lo = _parse_num(T, s, RoundDown)
                hi = _parse_num(T, s, RoundUp)
                flag = !((isinf(lo) & !occursin("inf", s)) | (isinf(hi) & !occursin("inf", s)))
                return interval(T, lo, hi), flag, false, false
            catch
                return nai(T), false, false, true
            end
        end
    elseif '?' ∈ str # uncertainty interval
        if occursin("??", str) # unbounded interval
            m, vde = split(str, "??"; keepempty = true, limit = 2)
            if vde == "d" # [-inf, m]
                lo_str = "-inf"
                hi_str = m
            elseif vde == "u" # [m, inf]
                lo_str = m
                hi_str = "inf"
            elseif isempty(vde) # [-inf, inf]
                return entireinterval(T), true, false, false # no warning is printed
            end
            try
                lo = _parse_num(T, lo_str, RoundDown)
                hi = _parse_num(T, hi_str, RoundUp)
                flag = !((isinf(lo) & !occursin("inf", lo_str)) | (isinf(hi) & !occursin("inf", hi_str)))
                return interval(T, lo, hi), flag, false, false
            catch
                return nai(T), false, false, true
            end
        else
            m, vde = split(str, '?'; keepempty = true, limit = 2)

            # ulp computation
            if '.' ∈ m # ulp is last decimal position
                ulp = inv(big(10.0) ^ length(split(m, '.')[2]))
            else # no decimal, hence ulp is unit
                ulp = big(1.0)
            end
            m = parse(BigFloat, m)

            if 'e' ∈ vde
                vd, e = split(vde, 'e')
                e = big(10.0) ^ parse(BigInt, e)
            else
                vd = vde
                e = big(1.0)
            end

            if 'u' ∈ vd || 'd' ∈ vd
                d = last(vd)
                v = vd[1:end-1]
            else
                d = 'b' # both directions
                v = vd
            end

            v = isempty(v) ? 1//2 : parse(BigInt, v)
            if d == 'd'
                lo = T((m - v * ulp) * e, RoundDown)
                hi = T(m * e, RoundUp)
            elseif d == 'u'
                lo = T(m * e, RoundDown)
                hi = T((m + v * ulp) * e, RoundUp)
            else
                lo = T((m - v * ulp) * e, RoundDown)
                hi = T((m + v * ulp) * e, RoundUp)
            end

            flag = !(isinf(lo) | isinf(hi))
            return interval(T, lo, hi), flag, false, false
        end
    else # number
        try
            lo = _parse_num(T, str, RoundDown)
            hi = _parse_num(T, str, RoundUp)
            flag = !((isinf(lo) & !occursin("inf", str)) | (isinf(hi) & !occursin("inf", str)))
            return interval(T, lo, hi), flag, false, false
        catch
            return nai(T), false, false, true
        end
    end
end

function _parse_num(::Type{T}, str::AbstractString, r::RoundingMode) where {T<:AbstractFloat}
    if '/' ∈ str
        num, denum = map(s -> parse(BigInt, s), eachsplit(str, '/'; keepempty = false))
        return T(num//denum, r)
    else
        return T(BigFloat(str, r), r)
    end
end

function _parse_num(::Type{T}, str::AbstractString, ::RoundingMode{:Down}) where {S<:Integer,T<:Rational{S}}
    '/' ∈ str && return parse(T, str)
    x = BigFloat(str, RoundDown)
    z = rationalize(S, x)
    z ≤ x && return z
    return rationalize(S, prevfloat(x))
end

function _parse_num(::Type{T}, str::AbstractString, ::RoundingMode{:Up}) where {S<:Integer,T<:Rational{S}}
    '/' ∈ str && return parse(T, str)
    x = BigFloat(str, RoundUp)
    z = rationalize(S, x)
    z ≥ x && return z
    return rationalize(S, nextfloat(x))
end

@testset "Exact literals" begin
    @test_throws MethodError convert(ExactReal{Float64}, 2)

    @test has_exact_display(0.5)
    @test !has_exact_display(0.1)

    @test (@exact 2im) isa Complex{<:ExactReal}
    @test (@exact 1.2 + 3.4im) isa Complex{<:ExactReal}
    @test_throws ArgumentError (@exact 1.2 + 3im)

    @test exact(3).value == 3
    @test_throws MethodError ExactReal{Float64}(1//3)
    @test_throws MethodError ExactReal{Float64}(1.0)
    @test_throws MethodError ExactReal(1.0)

    #

    x = @exact 0.5

    @test (2 * x) isa Float64
    @test isone(2 * x)

    @test (bareinterval(2) * x) isa BareInterval
    @test isthinone(bareinterval(2) * x)

    @test (interval(2) * x) isa Interval
    @test isthinone(interval(2) * x)
    @test isguaranteed(interval(2) * x)

    #

    @exact function f(x)
       return x^2 - 2x + 1
    end

    @test f(1.0) isa Real
    @test iszero(f(1.0))

    @test f(bareinterval(1)) isa BareInterval
    @test isthinzero(f(bareinterval(1)))

    @test f(interval(1)) isa Interval
    @test isthinzero(f(interval(1)))
    @test isguaranteed(f(interval(1)))

    #

    @test isequal_interval(promote(bareinterval(1, 2), exact(3))[2], bareinterval(3))

    @test isequal_interval(promote(interval(1, 2), exact(3))[2], interval(3))

    # Exact operations (Integers and Rationals)
    @test exact(1) + exact(2) === exact(3)
    @test exact(1) - exact(3) === exact(-2)
    @test exact(2) * exact(3) === exact(6)
    @test exact(4) / exact(2) === exact(2.0)
    @test exact(1) / exact(3) === 1/3
    @test exact(1) / exact(Int64(2)^Int64(60) + Int64(1)) === 1/Int64(2)^Int64(60)
    @test exact(-Int64(1)) / exact(typemin(Int32)) === exact(-Int64(1)/typemin(Int32))
    @test exact(-1) / exact(typemin(Int)) === -1/typemin(Int)
    if VERSION ≥ v"1.11"
        @test exact(2) ^ exact(3) === exact(8)
        @test_throws DomainError exact(2) ^ (-2)
    else
        @test_throws ArgumentError exact(2) ^ exact(3)
    end

    @test exact(1//2) + exact(1//4) === exact(3//4)
    @test exact(1//2) - exact(1//4) === exact(1//4)
    @test exact(1//2) * exact(1//2) === exact(1//4)

    # Checked Arithmetic Overflows
    @test_throws OverflowError exact(typemax(Int)) + exact(1)
    @test_throws OverflowError exact(typemin(Int)) - exact(1)
    @test_throws OverflowError exact(typemax(Int)) * exact(2)
    @test_throws OverflowError -exact(typemin(Int))

    # Bool operations
    let x = @exact 1.5
        @test (x * exact(true)) isa ExactReal
        @test (x * exact(true)) === exact(1.5)

        @test (x * exact(false)) isa ExactReal
        @test (x * exact(false)) === exact(0.0)

        @test (x / exact(true)) isa ExactReal
        @test (x / exact(true)) === exact(1.5)
    end

    # Loss of exactness
    let val = exact(1.5) + exact(2.0)
        @test val isa Float64
        @test val == 3.5
    end

    let val2 = exact(1.5) * exact(2.0)
        @test val2 isa Float64
        @test val2 == 3.0
    end
end

@testset "Exact literals with bare intervals" begin
    # `+`, `-`, `*`, `/` and `\` on a matching number type bypass the promotion to
    # a thin interval, so they must be more specific than the generic methods and
    # must return exactly what those return.
    specialized(f, S, R) = which(f, Tuple{S,R}).sig isa UnionAll
    @test all(f -> specialized(f, BareInterval{Float64}, ExactReal{Float64}), (+, -, *, /))
    @test all(f -> specialized(f, ExactReal{Float64}, BareInterval{Float64}), (+, -, *, \))

    # ... and the mixed number types must not, since the promotion is where the
    # `ExactReal` gets rounded to the interval's number type.
    @test !specialized(*, BareInterval{Float64}, ExactReal{Int})

    viapromotion(f, x, y) = f(promote(x, y)...)
    samebits(x::BareInterval, y::BareInterval) = (inf(x) === inf(y)) & (sup(x) === sup(y))

    for T ∈ (Float64, Float32, Rational{Int})
        vals = T <: Rational ?
            (zero(T), one(T), -one(T), T(1//2), T(-5//3)) :
            (zero(T), -zero(T), one(T), -one(T), T(0.5), T(-2.5), T(0.1), T(-0.1),
             floatmax(T), floatmin(T))
        ivs = (bareinterval(T, 1, 2), bareinterval(T, -2, -1), bareinterval(T, -1, 2),
               bareinterval(T, 0, 1), bareinterval(T, -1, 0), bareinterval(T, 0, 0),
               bareinterval(T(1//10), T(1//10)), bareinterval(T, -Inf, 2),
               bareinterval(T, 3, Inf), entireinterval(BareInterval{T}),
               emptyinterval(BareInterval{T}))
        for v ∈ vals, x ∈ ivs
            k = exact(v)
            @test samebits(x + k, viapromotion(+, x, k))
            @test samebits(k + x, viapromotion(+, k, x))
            @test samebits(x - k, viapromotion(-, x, k))
            @test samebits(k - x, viapromotion(-, k, x))
            @test samebits(x * k, viapromotion(*, x, k))
            @test samebits(k * x, viapromotion(*, k, x))
            @test samebits(x / k, viapromotion(/, x, k))
            @test samebits(k \ x, viapromotion(\, k, x))
        end
    end

    # A non-finite `ExactReal` has no thin interval; both routes warn and return
    # the empty interval.
    let x = bareinterval(1.0, 2.0)
        for v ∈ (Inf, -Inf, NaN)
            @test isempty_interval(@test_logs (:warn,) x + exact(v))
            @test isempty_interval(@test_logs (:warn,) x - exact(v))
            @test isempty_interval(@test_logs (:warn,) exact(v) - x)
            @test isempty_interval(@test_logs (:warn,) x * exact(v))
            @test isempty_interval(@test_logs (:warn,) x / exact(v))
        end
    end

    # Mixed number types still round through the promotion.
    @test isequal_interval(bareinterval(1.0, 2.0) * exact(2), bareinterval(2.0, 4.0))
    @test isequal_interval(bareinterval(1.0, 2.0) + exact(1//3),
                           bareinterval(1.0, 2.0) + bareinterval(Float64, 1//3))
end

x = interval(0.5)

@testset "IntervalRounding{:correct}" begin
    IntervalArithmetic.configure(rounding = :correct)
    @test isequal_interval(sin(x), interval(0.47942553860420295, 0.479425538604203))

    # https://github.com/JuliaIntervals/IntervalArithmetic.jl/issues/215
    tiny = interval(0, floatmin())
    huge = interval(floatmax(), Inf)
    @test isequal_interval(tiny * tiny, interval(0, nextfloat(0.0)))
    @test isequal_interval(huge * huge, interval(floatmax(), Inf))
    @test isequal_interval(huge / tiny, interval(floatmax(), Inf))
    @test isequal_interval(tiny / huge, interval(0, nextfloat(0.0)))
end

@testset "No rounding" begin
    IntervalArithmetic.configure(; rounding = :none)
    @test isequal_interval(sin(x), interval(0.479425538604203, 0.479425538604203))
end

# @testset "IntervalRounding{:fast}" begin
#     IntervalArithmetic.configure(rounding = :fast)
#     @test isequal_interval(interval(Float64, 0.5) + interval(Float64, 0.5), interval(0.9999999999999999, 1.0000000000000002))
#     @test isequal_interval(sqrt(interval(Float64, 9)), interval(2.9999999999999996, 3.0000000000000004))
# end

# @testset "IntervalRounding{:slow}" begin
#     IntervalArithmetic.default_rounding() = IntervalArithmetic.IntervalRounding{:slow}()
#     @test isequal_interval(sin(x), interval(0.47942553860420295, 0.479425538604203))
# end

IntervalArithmetic.configure(rounding = :correct)

setprecision(BigFloat, 256) do
    @testset "Ill-formed interval" begin
       @test sprint(show, MIME("text/plain"), interval(1, -1)) == "NaI"
    end

    @testset "BareInterval" begin
        a = bareinterval(-floatmin(Float64), 1.3)
        large_expo = bareinterval(0, big"1e123456789") # use "small" exponent, cf. JuliaLang/julia#48678


        @testset "Standard format" begin
            setdisplay(:infsup)

            @testset "6 significant digits" begin
                # `decorations` keyword has no impact for `BareInterval`
                setdisplay(; sigdigits = 6, decorations = true)

                @test sprint(show, MIME("text/plain"), emptyinterval(BareInterval{Float64})) == "∅"

                @test sprint(show, MIME("text/plain"), a) == "[-2.22508e-308, 1.3]"
                @test sprint(show, MIME("text/plain"), large_expo) ==
                    "[0.0, 1.0e+123456789]₂₅₆"
            end

            @testset "20 significant digits" begin
                # `decorations` keyword has no impact for `BareInterval`
                setdisplay(; sigdigits = 20, decorations = true)

                @test sprint(show, MIME("text/plain"), a) == "[-2.2250738585072014e-308, 1.3]"
                @test sprint(show, MIME("text/plain"), large_expo) ==
                    "[0.0, 1.0000000000000000001e+123456789]₂₅₆"
            end
        end

        @testset "Full format" begin
            # `decorations` keyword has no impact for `BareInterval`
            # `sigdigits` is not taken into account for format `:full`
            setdisplay(:full; sigdigits = 100, decorations = true)

            @test sprint(show, MIME("text/plain"), emptyinterval(BareInterval{Float64})) == "∅"

            @test sprint(show, MIME("text/plain"), a) == "BareInterval{Float64}(-2.2250738585072014e-308, 1.3)"
            @test sprint(show, MIME("text/plain"), large_expo) ==
                "BareInterval{BigFloat}(0.0, $(sup(large_expo)))"
        end

        @testset "Midpoint format" begin
            # `decorations` keyword has no impact for `BareInterval`
            setdisplay(:midpoint; sigdigits = 6, decorations = true)

            @test sprint(show, MIME("text/plain"), emptyinterval(BareInterval{Float64})) == "∅"

            @test sprint(show, MIME("text/plain"), a) == "0.65 ± 0.65"
            @test sprint(show, MIME("text/plain"), large_expo) ==
                "(5.0e+123456788 ± 5.0e+123456788)₂₅₆"
        end
    end

    @testset "Interval" begin
        a = interval(1, 2)
        a_NG = a/1
        b = interval(-floatmin(Float64), 1.3)
        b32 = interval(-floatmin(Float32), parse(Float32, "1.3"))
        b16 = interval(-floatmin(Float16), parse(Float16, "1.3"))
        br = interval(Rational{Int64}, -11//10, 13//10)
        c = interval(-1, Inf)
        cr = interval(Rational{Int64}, -1//1, 1//0)
        large_expo = interval(0, big"1e123456789") # use "small" exponent, cf. JuliaLang/julia#48678

        @testset "Standard format" begin
            setdisplay(:infsup)

            @testset "6 significant digits" begin
                setdisplay(; sigdigits = 6)

                @testset "Decorations" begin
                    setdisplay(; decorations = true)

                    @test sprint(show, MIME("text/plain"), emptyinterval()) == "∅_trv"
                    @test sprint(show, MIME("text/plain"), emptyinterval()/1) == "∅_trv_NG"

                    @test sprint(show, MIME("text/plain"), a)    == "[1.0, 2.0]_com"
                    @test sprint(show, MIME("text/plain"), a_NG) == "[1.0, 2.0]_com_NG"
                    @test sprint(show, MIME("text/plain"), b)    == "[-2.22508e-308, 1.3]_com"
                    @test sprint(show, MIME("text/plain"), b32)  == "[-1.1755f-38, 1.3f0]_com"
                    @test sprint(show, MIME("text/plain"), b16)  == "[Float16(-6.104e-5), Float16(1.3)]_com"
                    @test sprint(show, MIME("text/plain"), br)   == "[-11//10, 13//10]_com"
                    @test sprint(show, MIME("text/plain"), c)    == "[-1.0, ∞)_dac"
                    @test sprint(show, MIME("text/plain"), cr)    == "[-1//1, ∞)_dac"
                    @test sprint(show, MIME("text/plain"), large_expo) ==
                        "[0.0, 1.0e+123456789]₂₅₆_com"
                end

                @testset "No decorations" begin
                    setdisplay(; decorations = false)

                    @test sprint(show, MIME("text/plain"), emptyinterval()) == "∅"
                    @test sprint(show, MIME("text/plain"), emptyinterval()/1) == "∅_NG"

                    @test sprint(show, MIME("text/plain"), a)    == "[1.0, 2.0]"
                    @test sprint(show, MIME("text/plain"), a_NG) == "[1.0, 2.0]_NG"
                    @test sprint(show, MIME("text/plain"), b)    == "[-2.22508e-308, 1.3]"
                    @test sprint(show, MIME("text/plain"), b32)  == "[-1.1755f-38, 1.3f0]"
                    @test sprint(show, MIME("text/plain"), b16)  == "[Float16(-6.104e-5), Float16(1.3)]"
                    @test sprint(show, MIME("text/plain"), br)   == "[-11//10, 13//10]"
                    @test sprint(show, MIME("text/plain"), c)    == "[-1.0, ∞)"
                    @test sprint(show, MIME("text/plain"), cr)   == "[-1//1, ∞)"
                    @test sprint(show, MIME("text/plain"), large_expo) ==
                        "[0.0, 1.0e+123456789]₂₅₆"
                end
            end

            @testset "20 significant digits" begin
                setdisplay(; sigdigits = 20, decorations = true)

                @test sprint(show, MIME("text/plain"), a)    == "[1.0, 2.0]_com"
                @test sprint(show, MIME("text/plain"), a_NG) == "[1.0, 2.0]_com_NG"
                @test sprint(show, MIME("text/plain"), b)    == "[-2.2250738585072014e-308, 1.3]_com"
                @test sprint(show, MIME("text/plain"), b32)  == "[-1.1754944f-38, 1.3f0]_com"
                @test sprint(show, MIME("text/plain"), b16)  == "[Float16(-6.104e-5), Float16(1.3)]_com"
                @test sprint(show, MIME("text/plain"), br)   == "[-11//10, 13//10]_com"
                @test sprint(show, MIME("text/plain"), c)    == "[-1.0, ∞)_dac"
                @test sprint(show, MIME("text/plain"), cr)   == "[-1//1, ∞)_dac"
                @test sprint(show, MIME("text/plain"), large_expo) ==
                    "[0.0, 1.0000000000000000001e+123456789]₂₅₆_com"
            end
        end

        @testset "Full format" begin
            # `sigdigits` and `decorations` keywords are not taken into account for format `:full`
            setdisplay(:full; sigdigits = 100, decorations = false)

            @test sprint(show, MIME("text/plain"), emptyinterval()) == "∅"
            @test sprint(show, MIME("text/plain"), emptyinterval()/1) == "∅_NG"

            @test sprint(show, MIME("text/plain"), a)    == "Interval{Float64}(1.0, 2.0, com, true)"
            @test sprint(show, MIME("text/plain"), a_NG) == "Interval{Float64}(1.0, 2.0, com, false)"
            @test sprint(show, MIME("text/plain"), b)    == "Interval{Float64}(-2.2250738585072014e-308, 1.3, com, true)"
            @test sprint(show, MIME("text/plain"), b32)  == "Interval{Float32}(-1.1754944f-38, 1.3f0, com, true)"
            @test sprint(show, MIME("text/plain"), b16)  == "Interval{Float16}(Float16(-6.104e-5), Float16(1.3), com, true)"
            @test sprint(show, MIME("text/plain"), br)   == "Interval{Rational{Int64}}(-11//10, 13//10, com, true)"
            @test sprint(show, MIME("text/plain"), c)    == "Interval{Float64}(-1.0, Inf, dac, true)"
            @test sprint(show, MIME("text/plain"), cr)   == "Interval{Rational{Int64}}(-1//1, 1//0, dac, true)"
            @test sprint(show, MIME("text/plain"), large_expo) ==
                "Interval{BigFloat}(0.0, $(sup(large_expo)), com, true)"
        end

        @testset "Midpoint format" begin
            setdisplay(:midpoint; sigdigits = 6)

            @testset "Decorations" begin
                setdisplay(; decorations = true)

                @test sprint(show, MIME("text/plain"), emptyinterval()) == "∅_trv"
                @test sprint(show, MIME("text/plain"), emptyinterval()/1) == "∅_trv_NG"

                @test sprint(show, MIME("text/plain"), a)    == "(1.5 ± 0.5)_com"
                @test sprint(show, MIME("text/plain"), a_NG) == "(1.5 ± 0.5)_com_NG"
                @test sprint(show, MIME("text/plain"), b)    == "(0.65 ± 0.65)_com"
                @test sprint(show, MIME("text/plain"), b32)  == "(0.65f0 ± 0.65f0)_com"
                @test sprint(show, MIME("text/plain"), b16)  == "(Float16(0.65) ± Float16(0.65))_com"
                @test sprint(show, MIME("text/plain"), br)   == "(1//10 ± 6//5)_com"
                @test sprint(show, MIME("text/plain"), c)    == "(1.79769e+308 ± ∞)_dac"
                @test sprint(show, MIME("text/plain"), cr)   == "(9223372036854775807//1 ± ∞)_dac"
                @test sprint(show, MIME("text/plain"), large_expo) ==
                    "(5.0e+123456788 ± 5.0e+123456788)₂₅₆_com"
            end

            @testset "No decorations" begin
                setdisplay(; decorations = false)

                @test sprint(show, MIME("text/plain"), emptyinterval()) == "∅"
                @test sprint(show, MIME("text/plain"), emptyinterval()/1) == "∅_NG"

                @test sprint(show, MIME("text/plain"), a)    == "1.5 ± 0.5"
                @test sprint(show, MIME("text/plain"), a_NG) == "(1.5 ± 0.5)_NG"
                @test sprint(show, MIME("text/plain"), b)    == "0.65 ± 0.65"
                @test sprint(show, MIME("text/plain"), b32)  == "0.65f0 ± 0.65f0"
                @test sprint(show, MIME("text/plain"), b16)  == "Float16(0.65) ± Float16(0.65)"
                @test sprint(show, MIME("text/plain"), br)   == "1//10 ± 6//5"
                @test sprint(show, MIME("text/plain"), c)    == "1.79769e+308 ± ∞"
                @test sprint(show, MIME("text/plain"), cr)   == "9223372036854775807//1 ± ∞"
                @test sprint(show, MIME("text/plain"), large_expo) ==
                    "(5.0e+123456788 ± 5.0e+123456788)₂₅₆"
            end
        end
    end

    @testset "Complex{<:Interval}" begin
        a = complex(interval(0, 2), interval(1))
        b = complex(interval(0, 2), interval(-1))
        c = complex(interval(0, 1e-70), interval(-1e-70))

        @testset "Standard format" begin
            setdisplay(:infsup)

            @testset "6 significant digits" begin
                setdisplay(; sigdigits = 6)

                @testset "Decorations" begin
                    setdisplay(; decorations = true)

                    @test sprint(show, MIME("text/plain"), a) == "[0.0, 2.0]_com + im*[1.0, 1.0]_com"
                    @test sprint(show, MIME("text/plain"), b) == "[0.0, 2.0]_com - im*[1.0, 1.0]_com"
                    @test sprint(show, MIME("text/plain"), c) == "[0.0, 1.0e-70]_com - im*[9.9999e-71, 1.0e-70]_com"
                end

                @testset "No decorations" begin
                    setdisplay(; decorations = false)

                    @test sprint(show, MIME("text/plain"), a) == "[0.0, 2.0] + im*[1.0, 1.0]"
                    @test sprint(show, MIME("text/plain"), b) == "[0.0, 2.0] - im*[1.0, 1.0]"
                    @test sprint(show, MIME("text/plain"), c) == "[0.0, 1.0e-70] - im*[9.9999e-71, 1.0e-70]"
                end
            end
        end

        @testset "Full format" begin
            # `sigdigits` and `decorations` keywords are not taken into account for format `:full`
            setdisplay(:full; sigdigits = 100, decorations = false)

            @test sprint(show, MIME("text/plain"), a) == "Interval{Float64}(0.0, 2.0, com, true) + im*Interval{Float64}(1.0, 1.0, com, true)"
            @test sprint(show, MIME("text/plain"), b) == "Interval{Float64}(0.0, 2.0, com, true) - im*Interval{Float64}(1.0, 1.0, com, true)"
            @test sprint(show, MIME("text/plain"), c) == "Interval{Float64}(0.0, 1.0e-70, com, true) - im*Interval{Float64}(1.0e-70, 1.0e-70, com, true)"
        end

        @testset "Midpoint format" begin
            setdisplay(:midpoint; sigdigits = 6)

            @testset "Decorations" begin
                setdisplay(; decorations = true)

                @test sprint(show, MIME("text/plain"), a) == "(1.0 ± 1.0)_com + im*(1.0 ± 0.0)_com"
                @test sprint(show, MIME("text/plain"), b) == "(1.0 ± 1.0)_com - im*(1.0 ± 0.0)_com"
                @test sprint(show, MIME("text/plain"), c) == "(5.0e-71 ± 5.0e-71)_com - im*(1.0e-70 ± 0.0)_com"
            end

            @testset "No decorations" begin
                setdisplay(; decorations = false)

                @test sprint(show, MIME("text/plain"), a) == "(1.0 ± 1.0) + im*(1.0 ± 0.0)"
                @test sprint(show, MIME("text/plain"), b) == "(1.0 ± 1.0) - im*(1.0 ± 0.0)"
                @test sprint(show, MIME("text/plain"), c) == "(5.0e-71 ± 5.0e-71) - im*(1.0e-70 ± 0.0)"
            end
        end
    end

    setdisplay(:infsup; sigdigits = 6, decorations = true) # reset to default display options
end

# Construction and composability with numbers
include("construction.jl")
    export BareInterval, bareinterval, decoration, ill, trv, def, dac, com,
        Interval, interval, isguaranteed, @interval, @I_str
include("parsing.jl")
include("real_interface.jl")
    export numtype
include("exact_literals.jl")
    export ExactReal, exact, @exact, has_exact_display

# Rounding
include("rounding.jl")

# Flavor
include("flavor.jl")

# Arithmetic
include("arithmetic/absmax.jl")
include("arithmetic/basic.jl")
include("arithmetic/hyperbolic.jl")
include("arithmetic/integer.jl")
include("arithmetic/power.jl")
    export pow, pown, rootn, fastpow, fastpown
include("arithmetic/trigonometric.jl")

# Other functions
include("interval_operations/cancellative.jl")
    export cancelminus, cancelplus
include("interval_operations/constants.jl")
    export emptyinterval, entireinterval, nai
include("interval_operations/extended_div.jl")
    export extended_div
include("interval_operations/boolean.jl")
    export isequal_interval, issetequal_interval, issubset_interval, isstrictsubset, isinterior,
        isdisjoint_interval, isweakless, isstrictless, precedes, strictprecedes,
        in_interval, isempty_interval, isentire_interval, isnai, isbounded,
        isunbounded, iscommon, isatomic, isthin, isthinzero, isthinone,
        isthininteger

include("interval_operations/overlap.jl")
    export Overlap, overlap
include("interval_operations/numeric.jl")
    export inf, sup, bounds, mid, diam, radius, midradius, mag, mig, dist
include("interval_operations/set_operations.jl")
    export intersect_interval, hull, interiordiff, union_interval
include("interval_operations/bisect.jl")
    export bisect, mince, mince!

@testset "cxsc.intervaladdsub" begin

    @test +(bareinterval(10.0, 20.0), bareinterval(13.0, 17.0)) === bareinterval(23.0, 37.0)

    @test +(bareinterval(13.0, 17.0), bareinterval(10.0, 20.0)) === bareinterval(23.0, 37.0)

    @test -(bareinterval(10.0, 20.0), bareinterval(13.0, 16.0)) === bareinterval(-6.0, 7.0)

    @test -(bareinterval(13.0, 16.0), bareinterval(10.0, 20.0)) === bareinterval(-7.0, 6.0)

    @test -(bareinterval(10.0, 20.0)) === bareinterval(-20.0, -10.0)

    @test +(bareinterval(10.0, 20.0)) === bareinterval(10.0, 20.0)

end

@testset "cxsc.intervalmuldiv" begin

    @test *(bareinterval(1.0, 2.0), bareinterval(3.0, 4.0)) === bareinterval(3.0, 8.0)

    @test *(bareinterval(-1.0, 2.0), bareinterval(3.0, 4.0)) === bareinterval(-4.0, 8.0)

    @test *(bareinterval(-2.0, 1.0), bareinterval(3.0, 4.0)) === bareinterval(-8.0, 4.0)

    @test *(bareinterval(-2.0, -1.0), bareinterval(3.0, 4.0)) === bareinterval(-8.0, -3.0)

    @test *(bareinterval(1.0, 2.0), bareinterval(-3.0, 4.0)) === bareinterval(-6.0, 8.0)

    @test *(bareinterval(-1.0, 2.0), bareinterval(-3.0, 4.0)) === bareinterval(-6.0, 8.0)

    @test *(bareinterval(-2.0, 1.0), bareinterval(-3.0, 4.0)) === bareinterval(-8.0, 6.0)

    @test *(bareinterval(-2.0, -1.0), bareinterval(-3.0, 4.0)) === bareinterval(-8.0, 6.0)

    @test *(bareinterval(1.0, 2.0), bareinterval(-4.0, 3.0)) === bareinterval(-8.0, 6.0)

    @test *(bareinterval(-1.0, 2.0), bareinterval(-4.0, 3.0)) === bareinterval(-8.0, 6.0)

    @test *(bareinterval(-2.0, 1.0), bareinterval(-4.0, 3.0)) === bareinterval(-6.0, 8.0)

    @test *(bareinterval(-2.0, -1.0), bareinterval(-4.0, 3.0)) === bareinterval(-6.0, 8.0)

    @test *(bareinterval(1.0, 2.0), bareinterval(-4.0, -3.0)) === bareinterval(-8.0, -3.0)

    @test *(bareinterval(-1.0, 2.0), bareinterval(-4.0, -3.0)) === bareinterval(-8.0, 4.0)

    @test *(bareinterval(-2.0, -1.0), bareinterval(-4.0, -3.0)) === bareinterval(3.0, 8.0)

    @test /(bareinterval(1.0, 2.0), bareinterval(4.0, 8.0)) === bareinterval(0.125, 0.5)

    @test /(bareinterval(-1.0, 2.0), bareinterval(4.0, 8.0)) === bareinterval(-0.25, 0.5)

    @test /(bareinterval(-2.0, 1.0), bareinterval(4.0, 8.0)) === bareinterval(-0.5, 0.25)

    @test /(bareinterval(-2.0, -1.0), bareinterval(4.0, 8.0)) === bareinterval(-0.5, -0.125)

    @test /(bareinterval(1.0, 2.0), bareinterval(-4.0, 8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-1.0, 2.0), bareinterval(-4.0, 8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-2.0, 1.0), bareinterval(-4.0, 8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-2.0, -1.0), bareinterval(-4.0, 8.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(1.0, 2.0), bareinterval(-8.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-1.0, 2.0), bareinterval(-8.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-2.0, 1.0), bareinterval(-8.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(-2.0, -1.0), bareinterval(-8.0, 4.0)) === entireinterval(BareInterval{Float64})

    @test /(bareinterval(1.0, 2.0), bareinterval(-8.0, -4.0)) === bareinterval(-0.5, -0.125)

    @test /(bareinterval(-1.0, 2.0), bareinterval(-8.0, -4.0)) === bareinterval(-0.5, 0.25)

    @test /(bareinterval(-2.0, 1.0), bareinterval(-8.0, -4.0)) === bareinterval(-0.25, 0.5)

    @test /(bareinterval(-2.0, -1.0), bareinterval(-8.0, -4.0)) === bareinterval(0.125, 0.5)

end

@testset "cxsc.intervalsetops" begin

    @test hull(bareinterval(-2.0, 2.0), bareinterval(-4.0, -3.0)) === bareinterval(-4.0, 2.0)

    @test hull(bareinterval(-2.0, 2.0), bareinterval(-4.0, -1.0)) === bareinterval(-4.0, 2.0)

    @test hull(bareinterval(-2.0, 2.0), bareinterval(-4.0, 4.0)) === bareinterval(-4.0, 4.0)

    @test hull(bareinterval(-2.0, 2.0), bareinterval(-1.0, 1.0)) === bareinterval(-2.0, 2.0)

    @test hull(bareinterval(-2.0, 2.0), bareinterval(1.0, 4.0)) === bareinterval(-2.0, 4.0)

    @test hull(bareinterval(-2.0, 2.0), bareinterval(3.0, 4.0)) === bareinterval(-2.0, 4.0)

    @test hull(bareinterval(-4.0, -3.0), bareinterval(-2.0, 2.0)) === bareinterval(-4.0, 2.0)

    @test hull(bareinterval(-4.0, -1.0), bareinterval(-2.0, 2.0)) === bareinterval(-4.0, 2.0)

    @test hull(bareinterval(-4.0, 4.0), bareinterval(-2.0, 2.0)) === bareinterval(-4.0, 4.0)

    @test hull(bareinterval(-1.0, 1.0), bareinterval(-2.0, 2.0)) === bareinterval(-2.0, 2.0)

    @test hull(bareinterval(1.0, 4.0), bareinterval(-2.0, 2.0)) === bareinterval(-2.0, 4.0)

    @test hull(bareinterval(3.0, 4.0), bareinterval(-2.0, 2.0)) === bareinterval(-2.0, 4.0)

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(-4.0, -3.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(-4.0, -1.0)) === bareinterval(-2.0, -1.0)

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(-4.0, 4.0)) === bareinterval(-2.0, 2.0)

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(-1.0, 1.0)) === bareinterval(-1.0, 1.0)

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(1.0, 4.0)) === bareinterval(1.0, 2.0)

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(3.0, 4.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(-4.0, -3.0), bareinterval(-2.0, 2.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(-4.0, -1.0), bareinterval(-2.0, 2.0)) === bareinterval(-2.0, -1.0)

    @test intersect_interval(bareinterval(-4.0, 4.0), bareinterval(-2.0, 2.0)) === bareinterval(-2.0, 2.0)

    @test intersect_interval(bareinterval(-1.0, 1.0), bareinterval(-2.0, 2.0)) === bareinterval(-1.0, 1.0)

    @test intersect_interval(bareinterval(1.0, 4.0), bareinterval(-2.0, 2.0)) === bareinterval(1.0, 2.0)

    @test intersect_interval(bareinterval(3.0, 4.0), bareinterval(-2.0, 2.0)) === emptyinterval(BareInterval{Float64})

end

@testset "cxsc.intervalmixsetops" begin

    @test hull(bareinterval(-2.0, 2.0), bareinterval(-4.0, -4.0)) === bareinterval(-4.0, 2.0)

    @test hull(bareinterval(-2.0, 2.0), bareinterval(1.0, 1.0)) === bareinterval(-2.0, 2.0)

    @test hull(bareinterval(-2.0, 2.0), bareinterval(4.0, 4.0)) === bareinterval(-2.0, 4.0)

    @test hull(bareinterval(-4.0, -4.0), bareinterval(-2.0, 2.0)) === bareinterval(-4.0, 2.0)

    @test hull(bareinterval(1.0, 1.0), bareinterval(-2.0, 2.0)) === bareinterval(-2.0, 2.0)

    @test hull(bareinterval(4.0, 4.0), bareinterval(-2.0, 2.0)) === bareinterval(-2.0, 4.0)

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(-4.0, -4.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(1.0, 1.0)) === bareinterval(1.0, 1.0)

    @test intersect_interval(bareinterval(-2.0, 2.0), bareinterval(4.0, 4.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(-4.0, -4.0), bareinterval(-2.0, 2.0)) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(1.0, 1.0), bareinterval(-2.0, 2.0)) === bareinterval(1.0, 1.0)

    @test intersect_interval(bareinterval(4.0, 4.0), bareinterval(-2.0, 2.0)) === emptyinterval(BareInterval{Float64})

end

@testset "cxsc.scalarmixsetops" begin

    @test hull(bareinterval(-2.0, -2.0), bareinterval(-4.0, -4.0)) === bareinterval(-4.0, -2.0)

    @test hull(bareinterval(-2.0, -2.0), bareinterval(-2.0, -2.0)) === bareinterval(-2.0, -2.0)

    @test hull(bareinterval(-2.0, -2.0), bareinterval(2.0, 2.0)) === bareinterval(-2.0, 2.0)

    @test hull(bareinterval(-4.0, -4.0), bareinterval(-2.0, -2.0)) === bareinterval(-4.0, -2.0)

    @test hull(bareinterval(-2.0, -2.0), bareinterval(-2.0, -2.0)) === bareinterval(-2.0, -2.0)

    @test hull(bareinterval(2.0, 2.0), bareinterval(-2.0, -2.0)) === bareinterval(-2.0, 2.0)

end

@testset "cxsc.intervalsetcompops" begin

    @test isinterior(bareinterval(-1.0, 2.0), bareinterval(-1.0, 2.0)) === false

    @test isinterior(bareinterval(-2.0, 1.0), bareinterval(-3.0, 2.0)) === true

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(-1.0, 1.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(-1.0, 2.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(-2.0, 1.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(-2.0, 3.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(-3.0, 2.0)) === false

    @test isinterior(bareinterval(-1.0, 2.0), bareinterval(-1.0, 2.0)) === false

    @test isinterior(bareinterval(-3.0, 2.0), bareinterval(-2.0, 1.0)) === false

    @test isinterior(bareinterval(-1.0, 1.0), bareinterval(-2.0, 2.0)) === true

    @test isinterior(bareinterval(-1.0, 2.0), bareinterval(-2.0, 2.0)) === false

    @test isinterior(bareinterval(-2.0, 1.0), bareinterval(-2.0, 2.0)) === false

    @test isinterior(bareinterval(-2.0, 3.0), bareinterval(-2.0, 2.0)) === false

    @test isinterior(bareinterval(-3.0, 2.0), bareinterval(-2.0, 2.0)) === false

    @test issubset_interval(bareinterval(-1.0, 2.0), bareinterval(-1.0, 2.0)) === true

    @test issubset_interval(bareinterval(-2.0, 1.0), bareinterval(-3.0, 2.0)) === true

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(-1.0, 1.0)) === false

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(-1.0, 2.0)) === false

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(-2.0, 1.0)) === false

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(-2.0, 3.0)) === true

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(-3.0, 2.0)) === true

    @test issubset_interval(bareinterval(-3.0, 2.0), bareinterval(-2.0, 1.0)) === false

    @test issubset_interval(bareinterval(-1.0, 1.0), bareinterval(-2.0, 2.0)) === true

    @test issubset_interval(bareinterval(-1.0, 2.0), bareinterval(-2.0, 2.0)) === true

    @test issubset_interval(bareinterval(-2.0, 1.0), bareinterval(-2.0, 2.0)) === true

    @test issubset_interval(bareinterval(-2.0, 3.0), bareinterval(-2.0, 2.0)) === false

    @test issubset_interval(bareinterval(-3.0, 2.0), bareinterval(-2.0, 2.0)) === false

    @test isequal_interval(bareinterval(-1.0, 2.0), bareinterval(-1.0, 2.0)) === true

    @test isequal_interval(bareinterval(-2.0, 1.0), bareinterval(-3.0, 2.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(-1.0, 1.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(-1.0, 2.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(-2.0, 1.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(-2.0, 3.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(-3.0, 2.0)) === false

end

@testset "cxsc.intervalscalarsetcompops" begin

    @test isinterior(bareinterval(-1.0, 2.0), bareinterval(-2.0, -2.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(-2.0, -2.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(0.0, 0.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(2.0, 2.0)) === false

    @test isinterior(bareinterval(-2.0, 2.0), bareinterval(3.0, 3.0)) === false

    @test isinterior(bareinterval(-1.0, -1.0), bareinterval(1.0, 1.0)) === false

    @test isinterior(bareinterval(-1.0, -1.0), bareinterval(-1.0, -1.0)) === false

    @test isinterior(bareinterval(-2.0, -2.0), bareinterval(-1.0, 2.0)) === false

    @test isinterior(bareinterval(-2.0, -2.0), bareinterval(-2.0, 2.0)) === false

    @test isinterior(bareinterval(0.0, 0.0), bareinterval(-2.0, 2.0)) === true

    @test isinterior(bareinterval(2.0, 2.0), bareinterval(-2.0, 2.0)) === false

    @test isinterior(bareinterval(3.0, 3.0), bareinterval(-2.0, 2.0)) === false

    @test isinterior(bareinterval(1.0, 1.0), bareinterval(-1.0, -1.0)) === false

    @test isinterior(bareinterval(-1.0, -1.0), bareinterval(-1.0, -1.0)) === false

    @test issubset_interval(bareinterval(-1.0, 2.0), bareinterval(-2.0, -2.0)) === false

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(-2.0, -2.0)) === false

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(0.0, 0.0)) === false

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(2.0, 2.0)) === false

    @test issubset_interval(bareinterval(-2.0, 2.0), bareinterval(3.0, 3.0)) === false

    @test issubset_interval(bareinterval(-1.0, -1.0), bareinterval(1.0, 1.0)) === false

    @test issubset_interval(bareinterval(-1.0, -1.0), bareinterval(-1.0, -1.0)) === true

    @test issubset_interval(bareinterval(-2.0, -2.0), bareinterval(-1.0, 2.0)) === false

    @test issubset_interval(bareinterval(-2.0, -2.0), bareinterval(-2.0, 2.0)) === true

    @test issubset_interval(bareinterval(0.0, 0.0), bareinterval(-2.0, 2.0)) === true

    @test issubset_interval(bareinterval(2.0, 2.0), bareinterval(-2.0, 2.0)) === true

    @test issubset_interval(bareinterval(3.0, 3.0), bareinterval(-2.0, 2.0)) === false

    @test issubset_interval(bareinterval(1.0, 1.0), bareinterval(-1.0, -1.0)) === false

    @test issubset_interval(bareinterval(-1.0, -1.0), bareinterval(-1.0, -1.0)) === true

    @test isequal_interval(bareinterval(-1.0, 2.0), bareinterval(-2.0, -2.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(-2.0, -2.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(0.0, 0.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(2.0, 2.0)) === false

    @test isequal_interval(bareinterval(-2.0, 2.0), bareinterval(3.0, 3.0)) === false

    @test isequal_interval(bareinterval(-1.0, -1.0), bareinterval(1.0, 1.0)) === false

    @test isequal_interval(bareinterval(-1.0, -1.0), bareinterval(-1.0, -1.0)) === true

end

@testset "cxsc.intervalstdfunc" begin

    @test pown(bareinterval(11.0, 11.0), 2) === bareinterval(121.0, 121.0)

    @test pown(bareinterval(0.0, 0.0), 2) === bareinterval(0.0, 0.0)

    @test pown(bareinterval(-9.0, -9.0), 2) === bareinterval(81.0, 81.0)

    @test sqrt(bareinterval(121.0, 121.0)) === bareinterval(11.0, 11.0)

    @test sqrt(bareinterval(0.0, 0.0)) === bareinterval(0.0, 0.0)

    @test sqrt(bareinterval(81.0, 81.0)) === bareinterval(9.0, 9.0)

    @test rootn(bareinterval(27.0, 27.0), 3) === bareinterval(3.0, 3.0)

    @test rootn(bareinterval(0.0, 0.0), 4) === bareinterval(0.0, 0.0)

    @test rootn(bareinterval(1024.0, 1024.0), 10) === bareinterval(2.0, 2.0)

    @test pow(bareinterval(2.0, 2.0), bareinterval(2.0, 2.0)) === bareinterval(4.0, 4.0)

    @test pow(bareinterval(4.0, 4.0), bareinterval(5.0, 5.0)) === bareinterval(1024.0, 1024.0)

    @test pow(bareinterval(2.0, 2.0), bareinterval(3.0, 3.0)) === bareinterval(8.0, 8.0)

end

@test size(interval(1)) == () # match the `size` behaviour of `Real`

@testset "Consistency tests" begin

    a = interval(0.1, 1.1)
    b = interval(0.9, 2.0)
    c = interval(0.25, 4.0)

    @testset "Interval types and constructors" begin
        @test isa( interval(1, 2), Interval )
        @test isa( interval(0.1), Interval )
        @test isa( zero(b), Interval )

        @test isthin(zero(b), 0.0)
        @test isequal_interval(zero(b), zero(typeof(b)))
        @test isthin(one(a), 1.0)
        @test isequal_interval(one(a), one(typeof(a)))
        @test isthin(one(a), big(1.0))
        @test !isequal_interval(a, b)
        @test isequal_interval(eps(typeof(a)), eps(one(typeof(a))))
        @test isequal_interval(typemin(typeof(a)), interval(-Inf, nextfloat(-Inf)))
        @test isequal_interval(typemax(typeof(a)), interval(prevfloat(Inf), Inf))
        @test isequal_interval(typemin(a), typemin(typeof(a)))
        @test isequal_interval(typemax(a), typemax(typeof(a)))

        @test isequal_interval(a, interval(inf(a), sup(a)))
        @test isequal_interval(emptyinterval(Rational{Int}), emptyinterval())

        @test inf(zero(a) + one(b)) == 1
        @test sup(zero(a) + one(b)) == 1
        @test isequal_interval(interval(0,1) + emptyinterval(a), emptyinterval(a))
        @test isequal_interval(interval(0.25) - one(c)/interval(4), zero(c))
        @test isequal_interval(emptyinterval(a) - interval(0, 1), emptyinterval(a))
        @test isequal_interval(interval(0, 1) - emptyinterval(a), emptyinterval(a))
        @test isequal_interval(interval(0, 1) * emptyinterval(a), emptyinterval(a))
        @test isequal_interval(a * interval(0), zero(a))

        @test decoration(IntervalArithmetic.setdecoration(interval(1, 2), ill)) == ill
        @test decoration(IntervalArithmetic.setdecoration(emptyinterval(), com)) == trv
        @test decoration(IntervalArithmetic.setdecoration(interval(1, Inf), com)) == dac

        @test !isnai(IntervalArithmetic.setdecoration(interval(NaN), com))
        @test decoration(IntervalArithmetic.setdecoration(interval(NaN), com)) == trv
    end

    @testset "real interface" begin
        @test isthinzero(zero(Interval{Float64}))
        @test isthinzero(zero(Complex{Interval{Float64}}))

        @test isthinone(one(Interval{Float64}))
        @test isthinone(one(Complex{Interval{Float64}}))
    end

    @testset "inv" begin
        @test isequal_interval(inv( zero(a) ), emptyinterval())  # Only for set based flavor
        @test isequal_interval(inv( interval(0, 1) ), interval(1, Inf))
        @test isequal_interval(inv( interval(1, Inf) ), interval(0, 1))
        @test isequal_interval(inv(c), c)
        @test isequal_interval(one(b)/b, inv(b))
        @test isequal_interval(a/emptyinterval(a), emptyinterval(a))
        @test isequal_interval(emptyinterval(a)/a, emptyinterval(a))
        @test isequal_interval(inv(interval(-4.0, 0.0)), interval(-Inf, -0.25))
        @test isequal_interval(inv(interval(0.0, 4.0)), interval(0.25, Inf))
        @test isequal_interval(inv(interval(-4.0, 4.0)), entireinterval(Float64))
        @test isequal_interval(interval(0)/interval(0), emptyinterval())  # According to the standard for :set_based flavor
        @test typeof(emptyinterval()) == Interval{Float64}
    end

    @testset "fma consistency" begin
        @test isequal_interval(fma(emptyinterval(), a, b), emptyinterval())
        @test isequal_interval(fma(entireinterval(), zero(a), b), b)
        @test isequal_interval(fma(entireinterval(), one(a), b), entireinterval())
        @test isequal_interval(fma(zero(a), entireinterval(), b), b)
        @test isequal_interval(fma(one(a), entireinterval(), b), entireinterval())
        @test isequal_interval(fma(a, zero(a), c), c)
        @test isequal_interval(fma(interval(Rational{Int}, 1//2, 1//2),
            interval(Rational{Int}, 1//3, 1//3),
            interval(Rational{Int}, 1//12, 1//12)), interval(Rational{Int}, 3//12, 3//12))
    end

    @testset "in_interval tests" begin
        @test !in_interval(Inf, entireinterval())
        @test in_interval(0.1, I"0.1")
        @test in_interval(0.1, I"0.1")
        @test !in_interval(-Inf, entireinterval())
        @test !in_interval(Inf, entireinterval())

        @test_throws ArgumentError in_interval(interval(3, 4), interval(3, 4))
    end

    @testset "Inclusion tests" begin
        @test issubset_interval(b, c)
        @test issubset_interval(b, b)
        @test issubset_interval(emptyinterval(c), c)
        @test !issubset_interval(c, emptyinterval(c))

        @test isinterior(b, c)
        @test !isinterior(b, b)
        @test isinterior(emptyinterval(c), c)
        @test !isinterior(c, emptyinterval(c))
        @test isinterior(emptyinterval(c), emptyinterval(c))

        @test isdisjoint_interval(a, I"2.1")
        @test !(isdisjoint_interval(a, b))
        @test isdisjoint_interval(emptyinterval(a), a)
        @test isdisjoint_interval(emptyinterval(), emptyinterval())
        @test !isdisjoint_interval(interval(1, 2), interval(3, 4), interval(5, 6), interval(1, 2))
    end

    @testset "Comparison tests" begin
        @test isweakless(emptyinterval(), emptyinterval())
        @test !isweakless(interval(1, 2), emptyinterval())
        @test isweakless(interval(-Inf,Inf), interval(-Inf,Inf))
        @test precedes(emptyinterval(), emptyinterval())
        @test precedes(interval(3, 4), emptyinterval())
        @test !(precedes(interval(0, 2),interval(-Inf,Inf)))
        @test precedes(interval(1, 3),interval(3, 4))
        @test strictprecedes(interval(3, 4), emptyinterval())
        @test !(strictprecedes(interval(-3, -1),interval(-1, 0)))
        @test !(iscommon(emptyinterval()))
        @test !(iscommon(entireinterval()))
        @test iscommon(a)
        @test !(isunbounded(emptyinterval()))
        @test isunbounded(entireinterval())
        @test isunbounded(interval(-Inf, 0))
        @test isunbounded(interval(0, Inf))
        @test !(isunbounded(a))
    end

    @testset "Intersection tests" begin
        @test isequal_interval(emptyinterval(BareInterval{Float64}), bareinterval(Inf, -Inf))
        @test isequal_interval(intersect_interval(a, interval(-1)), emptyinterval(a))
        @test isempty_interval(intersect_interval(a, interval(-1)))
        @test !isempty_interval(a)
        @test !isequal_interval(emptyinterval(a), a)
        @test isequal_interval(emptyinterval(), emptyinterval())

        @test isequal_interval(intersect_interval(a, hull(a, b)), a)
        @test isequal_interval(hull(a, b), interval(inf(a), sup(b)))

        # n-ary intersect_interval
        @test isequal_interval(intersect_interval(interval(1.0, 2.0),
                        interval(-1.0, 5.0),
                        interval(1.8, 3.0)), interval(1.8, 2.0))
        @test isequal_interval(intersect_interval(a, emptyinterval(), b), emptyinterval())
        @test isequal_interval(intersect_interval(interval(0, 1), interval(3, 4), interval(0, 1), interval(0, 1)), emptyinterval())
    end

    @testset "hull and hull tests" begin
        @test isequal_interval(hull(interval(1, 2), interval(3, 4)), interval(1, 4))
        @test isequal_interval(hull(interval(1//3, 3//4), interval(3, 4)), interval(1/3, 4))

        @test isequal_interval(hull(interval(1, 2), interval(3, 4)), interval(1, 4))
        @test isequal_interval(hull(interval(1//3, 3//4), interval(3, 4)), interval(1/3, 4))
    end

    @testset "Special interval tests" begin
        @test isequal_interval(entireinterval(Float64), interval(-Inf, Inf))
        @test isentire_interval(entireinterval(a))
        @test isentire_interval(interval(-Inf, Inf))
        @test !isentire_interval(a)
        @test isinterior(interval(-Inf, Inf), interval(-Inf, Inf))

        @test !isequal_interval(nai(a), nai(a))
        @test isnai(interval(NaN)) & isnai(convert(Interval{Float64}, NaN))
        @test isnan(inf(nai(BigFloat)))
        @test isnai(nai())
        @test !isnai(a)

        @test inf(a) == bareinterval(a).lo
        @test sup(a) == bareinterval(a).hi
        @test inf(emptyinterval(a)) == Inf
        @test sup(emptyinterval(a)) == -Inf
        @test inf(entireinterval(a)) == -Inf
        @test sup(entireinterval(a)) == Inf
        @test isnan(sup(nai(BigFloat)))

        @test inf(2.5) == 2.5
        @test sup(2.5) == 2.5
    end

    @testset "mid" begin
        @test mid(interval(Rational{Int}, 1//2)) == 1//2
        @test mid(interval(2), 0.4969816845401611) == 2
        @test mid(interval(1, 2)) == 1.5
        @test mid(interval(0.1, 0.3)) == 0.2
        @test mid(interval(-10, 5)) == -2.5
        @test mid(interval(-Inf, 1)) == nextfloat(-Inf)
        @test mid(interval(1, Inf)) == prevfloat(Inf)
        @test isnan(mid(emptyinterval()))
    end

    @testset "mid with α" begin
        @test_throws DomainError mid(interval(1, 2), 1.2)
        @test_throws DomainError mid(interval(1, 2), -0.7)
        @test mid(interval(0, 1), 0.75) == 0.75
        @test mid(interval(0, 1000), 0.125) == 125
        @test mid(interval(1, Inf), 0.75) > 0
        @test mid(interval(-Inf, Inf), 0.75) > 0
        @test mid(interval(-Inf, Inf), 0.25) < 0
    end

    @testset "mid with large floats" begin
        @test mid(interval(0.8e308, 1.2e308)) == 1e308
        @test mid(interval(-1e308, 1e308)) == 0
        @test isfinite(mid(interval(0.8e308, 1.2e308)))
        @test isfinite(mid(interval(-1e308, 1e308)))
    end

    @testset "diam" begin
        @test diam( interval(Rational{Int}, 1//2) ) == 0//1
        @test diam( interval(1//10) ) == 0
        @test diam( I"0.1" ) == eps(0.1)
        @test isnan(diam(emptyinterval()))
        @test diam(a) == 1.0000000000000002

        @test diam(0.1) == 0
    end

    @testset "mig and mag" begin
        @test mig(interval(-2, 2)) == BigFloat(0.0)
        @test mig( interval(Rational{Int}, 1//2) ) == 1//2
        @test isnan(mig(emptyinterval()))
        @test mag(-b) == sup(b)
        @test mag( interval(Rational{Int}, 1//2) ) == 1//2
        @test isnan(mag(emptyinterval()))
    end

    @testset "cancelplus tests" begin
        x = interval(-2.0, 4.440892098500622e-16)
        y = interval(-4.440892098500624e-16, 2.0)
        @test isequal_interval(cancelminus(x, y), entireinterval(Float64))
        @test isequal_interval(cancelplus(x, y), entireinterval(Float64))
        x = interval(-big(1.0), eps(big(1.0))/4)
        y = interval(-eps(big(1.0))/2, big(1.0))
        @test isequal_interval(cancelminus(x, y), entireinterval(BigFloat))
        @test isequal_interval(cancelplus(x, y), entireinterval(BigFloat))
        x = interval(-big(1.0), eps(big(1.0))/2)
        y = interval(-eps(big(1.0))/2, big(1.0))
        @test issubset_interval(cancelminus(x, y), interval(-one(BigFloat), one(BigFloat)))
        @test isequal_interval(cancelplus(x, y), interval(zero(BigFloat), zero(BigFloat)))
        @test isequal_interval(cancelminus(emptyinterval(), emptyinterval()), emptyinterval())
        @test isequal_interval(cancelplus(emptyinterval(), emptyinterval()), emptyinterval())
        @test isequal_interval(cancelminus(emptyinterval(), interval(0.0, 5.0)), emptyinterval())
        @test isequal_interval(cancelplus(emptyinterval(), interval(0.0, 5.0)), emptyinterval())
        @test isequal_interval(cancelminus(entireinterval(), interval(0.0, 5.0)), entireinterval())
        @test isequal_interval(cancelplus(entireinterval(), interval(0.0, 5.0)), entireinterval())
        @test isequal_interval(cancelminus(interval(5.0), interval(-Inf, 0.0)), entireinterval())
        @test isequal_interval(cancelplus(interval(5.0), interval(-Inf, 0.0)), entireinterval())
        @test isequal_interval(cancelminus(interval(0.0, 5.0), emptyinterval()), entireinterval())
        @test isequal_interval(cancelplus(interval(0.0, 5.0), emptyinterval()), entireinterval())
        @test isequal_interval(cancelminus(interval(0.0), interval(0.0, 1.0)), entireinterval())
        @test isequal_interval(cancelplus(interval(0.0), interval(0.0, 1.0)), entireinterval())
        @test isequal_interval(cancelminus(interval(0.0), interval(1.0)), interval(-1.0))
        @test isequal_interval(cancelplus(interval(0.0), interval(1.0)), interval(1.0))
        @test isequal_interval(cancelminus(interval(-5.0, 0.0), interval(0.0, 5.0)), interval(-5.0))
        @test isequal_interval(cancelplus(interval(-5.0, 0.0), interval(0.0, 5.0)), interval(0.0))
    end

    @testset "mid and radius" begin
        @test radius(interval(Rational{Int}, -1//10,1//10)) == diam(interval(Rational{Int}, -1//10,1//10))/2
        @test isnan(radius(emptyinterval()))
        @test mid(c) == 2.125
        @test isnan(mid(emptyinterval()))
        @test mid(entireinterval()) == 0.0
        @test isnan(mid(nai()))
        # @test_throws InexactError nai(interval(1//2)) TODO move this test

        @test mid(2.125) == 2.125
        @test radius(2.125) == 0
    end

    @testset "abs, min, max, sign" begin
        @test isequal_interval(abs(entireinterval()), interval(0.0, Inf))
        @test isequal_interval(abs(emptyinterval()), emptyinterval())
        @test isequal_interval(abs(interval(-3.0,1.0)), interval(0.0, 3.0))
        @test isequal_interval(abs(interval(-3.0,-1.0)), interval(1.0, 3.0))
        @test isequal_interval(abs2(interval(-3.0,1.0)), interval(0.0, 9.0))
        @test isequal_interval(abs2(interval(-3.0,-1.0)), interval(1.0, 9.0))
        @test isequal_interval(min(entireinterval(), interval(3.0,4.0)), interval(-Inf, 4.0))
        @test isequal_interval(min(emptyinterval(), interval(3.0,4.0)), emptyinterval())
        @test isequal_interval(min(interval(-3.0,1.0), interval(3.0,4.0)), interval(-3.0, 1.0))
        @test isequal_interval(min(interval(-3.0,-1.0), interval(3.0,4.0)), interval(-3.0, -1.0))
        @test isequal_interval(max(entireinterval(), interval(3.0,4.0)), interval(3.0, Inf))
        @test isequal_interval(max(emptyinterval(), interval(3.0,4.0)), emptyinterval())
        @test isequal_interval(max(interval(-3.0,1.0), interval(3.0,4.0)), interval(3.0, 4.0))
        @test isequal_interval(max(interval(-3.0,-1.0), interval(3.0,4.0)), interval(3.0, 4.0))
        @test isequal_interval(sign(entireinterval()), interval(-1.0, 1.0))
        @test isequal_interval(sign(emptyinterval()), emptyinterval())
        @test isequal_interval(sign(interval(-3.0,1.0)), interval(-1.0, 1.0))
        @test isequal_interval(sign(interval(-3.0,-1.0)), interval(-1.0, -1.0))

        # Test putting functions in interval:
        @test issubset_interval(log(interval(-2, 5)), interval(-Inf, log(interval(5))))

        #

        x = interval(0, 3) + interval(0, 4)*interval(im)
        @test isequal_interval(abs2(x), interval(0, 25))
        @test isequal_interval(abs(x), interval(0, 5))

        y = interval(-1, 1) + interval(-2, 2)*interval(im)
        @test inf(abs(y)) == 0
        @test inf(abs2(y)) == 0

        @test mag(x) == 5
        @test mig(x) == 0
        @test mid(x) == 1.5 + 2im
    end

    @testset "Interval power of an interval" begin
        a = interval(1, 2)
        b = interval(3, 4)

        @test isequal_interval(pow(a, b), interval(1, 16))
        @test isequal_interval(pow(a, interval(0.5, 1)), a)
        @test isequal_interval(pow(a, interval(0.3, 0.5)), interval(1, sqrt(2)))
    end

    @testset "isatomic" begin
        @test isatomic(interval(1))
        @test isatomic(interval(2.3, 2.3))
        @test isatomic(emptyinterval())
        @test isnai(interval(Inf))

        @test !isatomic(interval(1, 2))
        @test !isatomic(interval(1, nextfloat(1.0, 2)))

    end

    @testset "isthinzero" begin
        @test isthinzero(interval(0))
        @test isthinzero(interval(Rational{Int}, 0//1))
        @test isthinzero(interval(big(0)))
        @test isthinzero(interval(-0.0))
        @test isthinzero(interval(-0.0, 0.0))

        @test !isthinzero(interval(1, 2))
        @test !isthinzero(interval(0.0, nextfloat(0.0)))
    end

    @testset "Type stability" begin
        for T ∈ (Float32, Float64, BigFloat)

            xs = [interval(3, 4), interval(0, 4), interval(0), interval(-4, 0), interval(-4, 4), interval(-Inf, 4), interval(4, Inf), interval(-Inf, Inf)]

            for x ∈ xs
                for y ∈ xs
                    xx = Interval{T}(x)
                    yy = Interval{T}(y)

                    for op ∈ (+, -, *, /, atan)
                        @inferred op(x, y)
                    end
                end

                for op ∈ (sin, cos, exp, log, tan, abs, mid, diam)
                    @inferred op(x)
                end
            end
        end
    end

    @testset "`Real` functionalities" begin
        x, y = interval(1), interval(2)

        @test !isnan(x)

        @test isone(x)
        @test !iszero(x)
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation iszero(interval(0, 1))
        @test x != y
        @test x == 1
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation interval(1, 2) != 2
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation interval(1, 2) != y
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation y != interval(1, 2)
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation interval(1, 2) == interval(1, 2)

        @test x < y
        @test x < 2
        @test !(x > y)
        @test !(x < x)
        @test !(x < 1)
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation x < interval(1, 2)

        @test isfinite(x)
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation isfinite(interval(1, Inf))

        @test isinteger(x)
        @test !isinteger(interval(1.2, 1.9))
        @test_throws IntervalArithmetic.InconclusiveBooleanOperation isinteger(interval(1.5, 2.5))

        #

        @test_throws ArgumentError intersect(x, x)
        @test_throws ArgumentError isapprox(x, x)
        @test_throws ArgumentError isdisjoint(x, x)
        @test_throws ArgumentError issubset(x, x)
        @test_throws ArgumentError issetequal(x, x)
        @test_throws ArgumentError x ∈ x
        @test_throws ArgumentError isempty(x)
        @test_throws ArgumentError union(x, x)
        @test_throws ArgumentError setdiff(x, x)
    end

end

@testset "Zero interval" begin
    @test isequal_interval(zero(Interval{Float64}), interval(0))
    @test isequal_interval(zero(interval(0, 1)), interval(0))
end

@testset "Decorations" begin
    a = interval(1, 2)
    b = interval(3, 4)

    @test dist(a, b) == 2.0

    @test isnai(interval(3, 1))
    @test isnai(interval(Inf, Inf))
    @test isnai(interval(-Inf, -Inf))
    @test isnai(interval(NaN, NaN))
    @test isnai(interval(NaN, 3))
    @test isnai(interval(3, NaN))
end

@testset "Hashing of Intervals" begin
    x = interval(Float64, 1, 2)
    y = interval(BigFloat, 1, 2)
    @test isequal_interval(x, y)
    @test hash(x) == hash(y)

    x = I"0.1"
    y = interval(BigFloat, x)
    @test isequal_interval(x, y)
    @test hash(x) == hash(y)

    x = interval(1, 2)
    y = interval(1, 3)
    @test !isequal_interval(x, y)
    @test hash(x) != hash(y)
end

@testset "Complex" begin
    a = interval(1im)
    b = interval(4im + 3)
    c = interval(-1, 4) + interval(0, 2)*interval(im)

    @test isinterior(a, c)
    @test issubset_interval(a, c)
    @test isinterior(a, c)
    @test !isinterior(b, c)
    @test !issubset_interval(b, c)

    @test typeof(a) == Complex{Interval{Float64}}
    @test isequal_interval(a, interval(0) + interval(1)*interval(im))
    @test isequal_interval(a * a, interval(-1))
    @test isequal_interval(a + a, interval(2)*interval(im))
    @test isthinzero(a - a)
    @test isthinone(a / a)

    @test in_interval(3+2im, c)
    @test isequal_interval(hull(a, b), interval(0, 3) + interval(1, 4)*interval(im))
    @test isequal_interval(intersect_interval(c, hull(a, b)), interval(0, 3) + interval(1, 2)*interval(im))
    @test isequal_interval(intersect_interval(a, b), emptyinterval() + emptyinterval()*interval(im))
    @test isdisjoint_interval(a, b)
end

# This file contains the functions described as "Hyperbolic functions" in
# Section 9.1 of the IEEE Standard 1788-2015 and required for set-based flavor
# in Section 10.5.3

for f ∈ (:sinh, :tanh, :asinh)
    @eval begin
        """
            $($f)(::BareInterval)
            $($f)(::Interval)

        Implement the `$($f)` function of the IEEE Standard 1788-2015 (Table 9.1).
        """
        function Base.$f(x::BareInterval{T}) where {T<:AbstractFloat}
            isempty_interval(x) && return x
            return @round(T, $f(inf(x)), $f(sup(x)))
        end

        Base.$f(x::BareInterval{<:Rational}) = $f(float(x))

        function Base.$f(x::Interval)
            r = $f(bareinterval(x))
            d = min(decoration(x), decoration(r))
            return _unsafe_interval(r, d, isguaranteed(x))
        end
    end
end

Base.sinh(x::Complex{Interval{T}}) where {T<:NumTypes} = (exp(x) - exp(-x)) / interval(T, 2)

Base.tanh(x::Complex{<:Interval}) = sinh(x) / cosh(x)

"""
    cosh(::BareInterval)
    cosh(::Interval)

Implement the `cosh` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.cosh(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    return @round(T, cosh(mig(x)), cosh(mag(x)))
end

Base.cosh(x::BareInterval{<:Rational}) = cosh(float(x))

function Base.cosh(x::Interval)
    r = cosh(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.cosh(x::Complex{Interval{T}}) where {T<:NumTypes} = (exp(x) + exp(-x)) / interval(T, 2)

"""
    coth(::BareInterval)
    coth(::Interval)

Implement the `coth` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.coth(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    isthinzero(x) && return emptyinterval(BareInterval{T})
    lo, hi = bounds(x)
    if lo < 0 < hi
        return entireinterval(BareInterval{T})
    elseif lo == 0
        return @round(T, coth(hi), typemax(T))
    elseif hi == 0
        return @round(T, typemin(T), coth(lo))
    else
        return @round(T, coth(hi), coth(lo))
    end
end

Base.coth(x::BareInterval{<:Rational}) = coth(float(x))

function Base.coth(x::Interval)
    bx = bareinterval(x)
    r = coth(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(in_interval(0, bx), trv, d))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    sech(::BareInterval)
    sech(::Interval)

Implement the `sech` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.sech(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    lo, hi = bounds(x)
    if lo ≥ 0 # decreasing function
        return @round(T, sech(hi), sech(lo))
    elseif hi ≤ 0 # increasing function
        return @round(T, sech(lo), sech(hi))
    else
        return @round(T, min(sech(lo), sech(hi)), one(T))
    end
end

Base.sech(x::BareInterval{<:Rational}) = sech(float(x))

function Base.sech(x::Interval)
    r = sech(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    csch(::BareInterval)
    csch(::Interval)

Implement the `csch` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.csch(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    isthinzero(x) && return emptyinterval(BareInterval{T})
    lo, hi = bounds(x)
    if lo < 0 < hi
        return entireinterval(BareInterval{T})
    elseif lo == 0
        return @round(T, csch(hi), typemax(T))
    elseif hi == 0
        return @round(T, typemin(T), csch(lo))
    else
        return @round(T, csch(hi), csch(lo))
    end
end

Base.csch(x::BareInterval{<:Rational}) = csch(float(x))

function Base.csch(x::Interval)
    bx = bareinterval(x)
    r = csch(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(in_interval(0, bx), trv, d))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    acosh(::BareInterval)
    acosh(::Interval)

Implement the `acosh` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.acosh(x::BareInterval{T}) where {T<:AbstractFloat}
    domain = _unsafe_bareinterval(T, one(T), typemax(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) && return x
    return @round(T, acosh(inf(x)), acosh(sup(x)))
end

Base.acosh(x::BareInterval{<:Rational}) = acosh(float(x))

function Base.acosh(x::Interval{T}) where {T<:NumTypes}
    domain = _unsafe_bareinterval(T, one(T), typemax(T))
    bx = bareinterval(x)
    r = acosh(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(issubset_interval(bx, domain), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    atanh(::BareInterval)
    atanh(::Interval)

Implement the `atanh` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.atanh(x::BareInterval{T}) where {T<:AbstractFloat}
    domain = _unsafe_bareinterval(T, -one(T), one(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) && return x
    lo, hi = bounds(x)
    res_lo, res_hi = bounds(@round(T, atanh(lo), atanh(hi)))
    return bareinterval(T, res_lo, res_hi)
end

Base.atanh(x::BareInterval{<:Rational}) = atanh(float(x))

function Base.atanh(x::Interval{T}) where {T<:NumTypes}
    domain = _unsafe_bareinterval(T, -one(T), one(T))
    bx = bareinterval(x)
    r = atanh(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(isinterior(bx, domain), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    acoth(::BareInterval)
    acoth(::Interval)

Implement the `acoth` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.acoth(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    singular_domain = _unsafe_bareinterval(T, -one(T), one(T))
    issubset_interval(x, singular_domain) && return emptyinterval(BareInterval{T})
    lo, hi = bounds(x)
    if lo ≤ -1 && 1 ≤ hi
        return entireinterval(BareInterval{T})
    elseif lo < -1 < hi || lo < 1 < hi
        return emptyinterval(BareInterval{T})
    elseif lo == 1
        return @round(T, acoth(hi), typemax(T))
    elseif hi == -1
        return @round(T, typemin(T), acoth(lo))
    else
        return @round(T, acoth(hi), acoth(lo))
    end
end

Base.acoth(x::BareInterval{<:Rational}) = acoth(float(x))

function Base.acoth(x::Interval{T}) where {T<:NumTypes}
    singular_domain = _unsafe_bareinterval(T, -one(T), one(T))
    bx = bareinterval(x)
    r = acoth(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(isempty_interval(intersect_interval(bx, singular_domain)), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

@testset "minimal_is_empty_test" begin

    @test isempty_interval(emptyinterval(BareInterval{Float64})) === true

    @test isempty_interval(bareinterval(-Inf,+Inf)) === false

    @test isempty_interval(bareinterval(1.0,2.0)) === false

    @test isempty_interval(bareinterval(-1.0,2.0)) === false

    @test isempty_interval(bareinterval(-3.0,-2.0)) === false

    @test isempty_interval(bareinterval(-Inf,2.0)) === false

    @test isempty_interval(bareinterval(-Inf,0.0)) === false

    @test isempty_interval(bareinterval(-Inf,-0.0)) === false

    @test isempty_interval(bareinterval(0.0,Inf)) === false

    @test isempty_interval(bareinterval(-0.0,Inf)) === false

    @test isempty_interval(bareinterval(-0.0,0.0)) === false

    @test isempty_interval(bareinterval(0.0,-0.0)) === false

    @test isempty_interval(bareinterval(0.0,0.0)) === false

    @test isempty_interval(bareinterval(-0.0,-0.0)) === false

end

@testset "minimal_is_empty_dec_test" begin

    @test isempty_interval(nai(Interval{Float64})) === false

    @test isempty_interval(interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test isempty_interval(interval(bareinterval(-Inf,+Inf), def)) === false

    @test isempty_interval(interval(bareinterval(1.0,2.0), com)) === false

    @test isempty_interval(interval(bareinterval(-1.0,2.0), trv)) === false

    @test isempty_interval(interval(bareinterval(-3.0,-2.0), dac)) === false

    @test isempty_interval(interval(bareinterval(-Inf,2.0), trv)) === false

    @test isempty_interval(interval(bareinterval(-Inf,0.0), trv)) === false

    @test isempty_interval(interval(bareinterval(-Inf,-0.0), trv)) === false

    @test isempty_interval(interval(bareinterval(0.0,Inf), def)) === false

    @test isempty_interval(interval(bareinterval(-0.0,Inf), trv)) === false

    @test isempty_interval(interval(bareinterval(-0.0,0.0), com)) === false

    @test isempty_interval(interval(bareinterval(0.0,-0.0), trv)) === false

    @test isempty_interval(interval(bareinterval(0.0,0.0), trv)) === false

    @test isempty_interval(interval(bareinterval(-0.0,-0.0), trv)) === false

end

@testset "minimal_is_entire_test" begin

    @test isentire_interval(emptyinterval(BareInterval{Float64})) === false

    @test isentire_interval(bareinterval(-Inf,+Inf)) === true

    @test isentire_interval(bareinterval(1.0,2.0)) === false

    @test isentire_interval(bareinterval(-1.0,2.0)) === false

    @test isentire_interval(bareinterval(-3.0,-2.0)) === false

    @test isentire_interval(bareinterval(-Inf,2.0)) === false

    @test isentire_interval(bareinterval(-Inf,0.0)) === false

    @test isentire_interval(bareinterval(-Inf,-0.0)) === false

    @test isentire_interval(bareinterval(0.0,Inf)) === false

    @test isentire_interval(bareinterval(-0.0,Inf)) === false

    @test isentire_interval(bareinterval(-0.0,0.0)) === false

    @test isentire_interval(bareinterval(0.0,-0.0)) === false

    @test isentire_interval(bareinterval(0.0,0.0)) === false

    @test isentire_interval(bareinterval(-0.0,-0.0)) === false

end

@testset "minimal_is_entire_dec_test" begin

    @test isentire_interval(nai(Interval{Float64})) === false

    @test isentire_interval(interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test isentire_interval(interval(bareinterval(-Inf,+Inf), trv)) === true

    @test isentire_interval(interval(bareinterval(-Inf,+Inf), def)) === true

    @test isentire_interval(interval(bareinterval(-Inf,+Inf), dac)) === true

    @test isentire_interval(interval(bareinterval(1.0,2.0), com)) === false

    @test isentire_interval(interval(bareinterval(-1.0,2.0), trv)) === false

    @test isentire_interval(interval(bareinterval(-3.0,-2.0), dac)) === false

    @test isentire_interval(interval(bareinterval(-Inf,2.0), trv)) === false

    @test isentire_interval(interval(bareinterval(-Inf,0.0), trv)) === false

    @test isentire_interval(interval(bareinterval(-Inf,-0.0), trv)) === false

    @test isentire_interval(interval(bareinterval(0.0,Inf), def)) === false

    @test isentire_interval(interval(bareinterval(-0.0,Inf), trv)) === false

    @test isentire_interval(interval(bareinterval(-0.0,0.0), com)) === false

    @test isentire_interval(interval(bareinterval(0.0,-0.0), trv)) === false

    @test isentire_interval(interval(bareinterval(0.0,0.0), trv)) === false

    @test isentire_interval(interval(bareinterval(-0.0,-0.0), trv)) === false

end

@testset "minimal_is_nai_dec_test" begin

    @test isnai(nai(Interval{Float64})) === true

    @test isnai(interval(bareinterval(-Inf,+Inf), trv)) === false

    @test isnai(interval(bareinterval(-Inf,+Inf), def)) === false

    @test isnai(interval(bareinterval(-Inf,+Inf), dac)) === false

    @test isnai(interval(bareinterval(1.0,2.0), com)) === false

    @test isnai(interval(bareinterval(-1.0,2.0), trv)) === false

    @test isnai(interval(bareinterval(-3.0,-2.0), dac)) === false

    @test isnai(interval(bareinterval(-Inf,2.0), trv)) === false

    @test isnai(interval(bareinterval(-Inf,0.0), trv)) === false

    @test isnai(interval(bareinterval(-Inf,-0.0), trv)) === false

    @test isnai(interval(bareinterval(0.0,Inf), def)) === false

    @test isnai(interval(bareinterval(-0.0,Inf), trv)) === false

    @test isnai(interval(bareinterval(-0.0,0.0), com)) === false

    @test isnai(interval(bareinterval(0.0,-0.0), trv)) === false

    @test isnai(interval(bareinterval(0.0,0.0), trv)) === false

    @test isnai(interval(bareinterval(-0.0,-0.0), trv)) === false

end

@testset "minimal_equal_test" begin

    @test isequal_interval(bareinterval(1.0,2.0), bareinterval(1.0,2.0)) === true

    @test isequal_interval(bareinterval(1.0,2.1), bareinterval(1.0,2.0)) === false

    @test isequal_interval(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test isequal_interval(emptyinterval(BareInterval{Float64}), bareinterval(1.0,2.0)) === false

    @test isequal_interval(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === true

    @test isequal_interval(bareinterval(1.0,2.4), bareinterval(-Inf,+Inf)) === false

    @test isequal_interval(bareinterval(1.0,Inf), bareinterval(1.0,Inf)) === true

    @test isequal_interval(bareinterval(1.0,2.4), bareinterval(1.0,Inf)) === false

    @test isequal_interval(bareinterval(-Inf,2.0), bareinterval(-Inf,2.0)) === true

    @test isequal_interval(bareinterval(-Inf,2.4), bareinterval(-Inf,2.0)) === false

    @test isequal_interval(bareinterval(-2.0,0.0), bareinterval(-2.0,0.0)) === true

    @test isequal_interval(bareinterval(-0.0,2.0), bareinterval(0.0,2.0)) === true

    @test isequal_interval(bareinterval(-0.0,-0.0), bareinterval(0.0,0.0)) === true

    @test isequal_interval(bareinterval(-0.0,0.0), bareinterval(0.0,0.0)) === true

    @test isequal_interval(bareinterval(0.0,-0.0), bareinterval(0.0,0.0)) === true

end

@testset "minimal_equal_dec_test" begin

    @test isequal_interval(interval(bareinterval(1.0,2.0), def), interval(bareinterval(1.0,2.0), trv)) === true

    @test isequal_interval(interval(bareinterval(1.0,2.1), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test isequal_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test isequal_interval(interval(emptyinterval(BareInterval{Float64}), trv), nai(Interval{Float64})) === false

    @test isequal_interval(nai(Interval{Float64}), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test isequal_interval(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test isequal_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test isequal_interval(nai(Interval{Float64}), interval(bareinterval(1.0,2.0), trv)) === false

    @test isequal_interval(interval(bareinterval(-Inf,+Inf), def), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test isequal_interval(interval(bareinterval(1.0,2.4), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test isequal_interval(interval(bareinterval(1.0,Inf), trv), interval(bareinterval(1.0,Inf), trv)) === true

    @test isequal_interval(interval(bareinterval(1.0,2.4), def), interval(bareinterval(1.0,Inf), trv)) === false

    @test isequal_interval(interval(bareinterval(-Inf,2.0), trv), interval(bareinterval(-Inf,2.0), trv)) === true

    @test isequal_interval(interval(bareinterval(-Inf,2.4), def), interval(bareinterval(-Inf,2.0), trv)) === false

    @test isequal_interval(interval(bareinterval(-2.0,0.0), trv), interval(bareinterval(-2.0,0.0), trv)) === true

    @test isequal_interval(interval(bareinterval(-0.0,2.0), def), interval(bareinterval(0.0,2.0), trv)) === true

    @test isequal_interval(interval(bareinterval(-0.0,-0.0), trv), interval(bareinterval(0.0,0.0), trv)) === true

    @test isequal_interval(interval(bareinterval(-0.0,0.0), def), interval(bareinterval(0.0,0.0), trv)) === true

    @test isequal_interval(interval(bareinterval(0.0,-0.0), trv), interval(bareinterval(0.0,0.0), trv)) === true

end

@testset "minimal_subset_test" begin

    @test issubset_interval(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test issubset_interval(emptyinterval(BareInterval{Float64}), bareinterval(0.0,4.0)) === true

    @test issubset_interval(emptyinterval(BareInterval{Float64}), bareinterval(-0.0,4.0)) === true

    @test issubset_interval(emptyinterval(BareInterval{Float64}), bareinterval(-0.1,1.0)) === true

    @test issubset_interval(emptyinterval(BareInterval{Float64}), bareinterval(-0.1,0.0)) === true

    @test issubset_interval(emptyinterval(BareInterval{Float64}), bareinterval(-0.1,-0.0)) === true

    @test issubset_interval(emptyinterval(BareInterval{Float64}), bareinterval(-Inf,+Inf)) === true

    @test issubset_interval(bareinterval(0.0,4.0), emptyinterval(BareInterval{Float64})) === false

    @test issubset_interval(bareinterval(-0.0,4.0), emptyinterval(BareInterval{Float64})) === false

    @test issubset_interval(bareinterval(-0.1,1.0), emptyinterval(BareInterval{Float64})) === false

    @test issubset_interval(bareinterval(-Inf,+Inf), emptyinterval(BareInterval{Float64})) === false

    @test issubset_interval(bareinterval(0.0,4.0), bareinterval(-Inf,+Inf)) === true

    @test issubset_interval(bareinterval(-0.0,4.0), bareinterval(-Inf,+Inf)) === true

    @test issubset_interval(bareinterval(-0.1,1.0), bareinterval(-Inf,+Inf)) === true

    @test issubset_interval(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === true

    @test issubset_interval(bareinterval(1.0,2.0), bareinterval(1.0,2.0)) === true

    @test issubset_interval(bareinterval(1.0,2.0), bareinterval(0.0,4.0)) === true

    @test issubset_interval(bareinterval(1.0,2.0), bareinterval(-0.0,4.0)) === true

    @test issubset_interval(bareinterval(0.1,0.2), bareinterval(0.0,4.0)) === true

    @test issubset_interval(bareinterval(0.1,0.2), bareinterval(-0.0,4.0)) === true

    @test issubset_interval(bareinterval(-0.1,-0.1), bareinterval(-4.0, 3.4)) === true

    @test issubset_interval(bareinterval(0.0,0.0), bareinterval(-0.0,-0.0)) === true

    @test issubset_interval(bareinterval(-0.0,-0.0), bareinterval(0.0,0.0)) === true

    @test issubset_interval(bareinterval(-0.0,0.0), bareinterval(0.0,0.0)) === true

    @test issubset_interval(bareinterval(-0.0,0.0), bareinterval(0.0,-0.0)) === true

    @test issubset_interval(bareinterval(0.0,-0.0), bareinterval(0.0,0.0)) === true

    @test issubset_interval(bareinterval(0.0,-0.0), bareinterval(-0.0,0.0)) === true

end

@testset "minimal_subset_dec_test" begin

    @test issubset_interval(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test issubset_interval(nai(Interval{Float64}), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test issubset_interval(nai(Interval{Float64}), interval(bareinterval(0.0,4.0), trv)) === false

    @test issubset_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(0.0,4.0), trv)) === true

    @test issubset_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-0.0,4.0), def)) === true

    @test issubset_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-0.1,1.0), trv)) === true

    @test issubset_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-0.1,0.0), trv)) === true

    @test issubset_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-0.1,-0.0), trv)) === true

    @test issubset_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test issubset_interval(interval(bareinterval(0.0,4.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test issubset_interval(interval(bareinterval(-0.0,4.0), def), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test issubset_interval(interval(bareinterval(-0.1,1.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test issubset_interval(interval(bareinterval(-Inf,+Inf), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test issubset_interval(interval(bareinterval(0.0,4.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test issubset_interval(interval(bareinterval(-0.0,4.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test issubset_interval(interval(bareinterval(-0.1,1.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test issubset_interval(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test issubset_interval(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(1.0,2.0), trv)) === true

    @test issubset_interval(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(0.0,4.0), trv)) === true

    @test issubset_interval(interval(bareinterval(1.0,2.0), def), interval(bareinterval(-0.0,4.0), def)) === true

    @test issubset_interval(interval(bareinterval(0.1,0.2), trv), interval(bareinterval(0.0,4.0), trv)) === true

    @test issubset_interval(interval(bareinterval(0.1,0.2), trv), interval(bareinterval(-0.0,4.0), def)) === true

    @test issubset_interval(interval(bareinterval(-0.1,-0.1), trv), interval(bareinterval(-4.0, 3.4), trv)) === true

    @test issubset_interval(interval(bareinterval(0.0,0.0), trv), interval(bareinterval(-0.0,-0.0), trv)) === true

    @test issubset_interval(interval(bareinterval(-0.0,-0.0), trv), interval(bareinterval(0.0,0.0), def)) === true

    @test issubset_interval(interval(bareinterval(-0.0,0.0), trv), interval(bareinterval(0.0,0.0), trv)) === true

    @test issubset_interval(interval(bareinterval(-0.0,0.0), trv), interval(bareinterval(0.0,-0.0), trv)) === true

    @test issubset_interval(interval(bareinterval(0.0,-0.0), def), interval(bareinterval(0.0,0.0), trv)) === true

    @test issubset_interval(interval(bareinterval(0.0,-0.0), trv), interval(bareinterval(-0.0,0.0), trv)) === true

end

@testset "minimal_less_test" begin

    @test isweakless(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test isweakless(bareinterval(1.0,2.0), emptyinterval(BareInterval{Float64})) === false

    @test isweakless(emptyinterval(BareInterval{Float64}), bareinterval(1.0,2.0)) === false

    @test isweakless(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === true

    @test isweakless(bareinterval(1.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test isweakless(bareinterval(0.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test isweakless(bareinterval(-0.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test isweakless(bareinterval(-Inf,+Inf), bareinterval(1.0,2.0)) === false

    @test isweakless(bareinterval(-Inf,+Inf), bareinterval(0.0,2.0)) === false

    @test isweakless(bareinterval(-Inf,+Inf), bareinterval(-0.0,2.0)) === false

    @test isweakless(bareinterval(0.0,2.0), bareinterval(0.0,2.0)) === true

    @test isweakless(bareinterval(0.0,2.0), bareinterval(-0.0,2.0)) === true

    @test isweakless(bareinterval(0.0,2.0), bareinterval(1.0,2.0)) === true

    @test isweakless(bareinterval(-0.0,2.0), bareinterval(1.0,2.0)) === true

    @test isweakless(bareinterval(1.0,2.0), bareinterval(1.0,2.0)) === true

    @test isweakless(bareinterval(1.0,2.0), bareinterval(3.0,4.0)) === true

    @test isweakless(bareinterval(1.0,3.5), bareinterval(3.0,4.0)) === true

    @test isweakless(bareinterval(1.0,4.0), bareinterval(3.0,4.0)) === true

    @test isweakless(bareinterval(-2.0,-1.0), bareinterval(-2.0,-1.0)) === true

    @test isweakless(bareinterval(-3.0,-1.5), bareinterval(-2.0,-1.0)) === true

    @test isweakless(bareinterval(0.0,0.0), bareinterval(-0.0,-0.0)) === true

    @test isweakless(bareinterval(-0.0,-0.0), bareinterval(0.0,0.0)) === true

    @test isweakless(bareinterval(-0.0,0.0), bareinterval(0.0,0.0)) === true

    @test isweakless(bareinterval(-0.0,0.0), bareinterval(0.0,-0.0)) === true

    @test isweakless(bareinterval(0.0,-0.0), bareinterval(0.0,0.0)) === true

    @test isweakless(bareinterval(0.0,-0.0), bareinterval(-0.0,0.0)) === true

end

@testset "minimal_less_dec_test" begin

    @test isweakless(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test isweakless(interval(emptyinterval(BareInterval{Float64}), trv), nai(Interval{Float64})) === false

    @test isweakless(interval(bareinterval(1.0,2.0), trv), nai(Interval{Float64})) === false

    @test isweakless(nai(Interval{Float64}), interval(bareinterval(1.0,2.0), def)) === false

    @test isweakless(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test isweakless(interval(bareinterval(1.0,2.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test isweakless(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test isweakless(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test isweakless(interval(bareinterval(1.0,2.0), def), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test isweakless(interval(bareinterval(0.0,2.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test isweakless(interval(bareinterval(-0.0,2.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test isweakless(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test isweakless(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(0.0,2.0), def)) === false

    @test isweakless(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-0.0,2.0), trv)) === false

    @test isweakless(interval(bareinterval(0.0,2.0), trv), interval(bareinterval(0.0,2.0), trv)) === true

    @test isweakless(interval(bareinterval(0.0,2.0), trv), interval(bareinterval(-0.0,2.0), trv)) === true

    @test isweakless(interval(bareinterval(0.0,2.0), def), interval(bareinterval(1.0,2.0), def)) === true

    @test isweakless(interval(bareinterval(-0.0,2.0), trv), interval(bareinterval(1.0,2.0), trv)) === true

    @test isweakless(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(1.0,2.0), trv)) === true

    @test isweakless(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(3.0,4.0), def)) === true

    @test isweakless(interval(bareinterval(1.0,3.5), trv), interval(bareinterval(3.0,4.0), trv)) === true

    @test isweakless(interval(bareinterval(1.0,4.0), trv), interval(bareinterval(3.0,4.0), trv)) === true

    @test isweakless(interval(bareinterval(-2.0,-1.0), trv), interval(bareinterval(-2.0,-1.0), trv)) === true

    @test isweakless(interval(bareinterval(-3.0,-1.5), trv), interval(bareinterval(-2.0,-1.0), trv)) === true

    @test isweakless(interval(bareinterval(0.0,0.0), trv), interval(bareinterval(-0.0,-0.0), trv)) === true

    @test isweakless(interval(bareinterval(-0.0,-0.0), trv), interval(bareinterval(0.0,0.0), def)) === true

    @test isweakless(interval(bareinterval(-0.0,0.0), trv), interval(bareinterval(0.0,0.0), trv)) === true

    @test isweakless(interval(bareinterval(-0.0,0.0), trv), interval(bareinterval(0.0,-0.0), trv)) === true

    @test isweakless(interval(bareinterval(0.0,-0.0), def), interval(bareinterval(0.0,0.0), trv)) === true

    @test isweakless(interval(bareinterval(0.0,-0.0), trv), interval(bareinterval(-0.0,0.0), trv)) === true

end

@testset "minimal_precedes_test" begin

    @test precedes(emptyinterval(BareInterval{Float64}), bareinterval(3.0,4.0)) === true

    @test precedes(bareinterval(3.0,4.0), emptyinterval(BareInterval{Float64})) === true

    @test precedes(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test precedes(bareinterval(1.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test precedes(bareinterval(0.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test precedes(bareinterval(-0.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test precedes(bareinterval(-Inf,+Inf), bareinterval(1.0,2.0)) === false

    @test precedes(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === false

    @test precedes(bareinterval(1.0,2.0), bareinterval(3.0,4.0)) === true

    @test precedes(bareinterval(1.0,3.0), bareinterval(3.0,4.0)) === true

    @test precedes(bareinterval(-3.0, -1.0), bareinterval(-1.0,0.0)) === true

    @test precedes(bareinterval(-3.0, -1.0), bareinterval(-1.0,-0.0)) === true

    @test precedes(bareinterval(1.0,3.5), bareinterval(3.0,4.0)) === false

    @test precedes(bareinterval(1.0,4.0), bareinterval(3.0,4.0)) === false

    @test precedes(bareinterval(-3.0, -0.1), bareinterval(-1.0,0.0)) === false

    @test precedes(bareinterval(0.0,0.0), bareinterval(-0.0,-0.0)) === true

    @test precedes(bareinterval(-0.0,-0.0), bareinterval(0.0,0.0)) === true

    @test precedes(bareinterval(-0.0,0.0), bareinterval(0.0,0.0)) === true

    @test precedes(bareinterval(-0.0,0.0), bareinterval(0.0,-0.0)) === true

    @test precedes(bareinterval(0.0,-0.0), bareinterval(0.0,0.0)) === true

    @test precedes(bareinterval(0.0,-0.0), bareinterval(-0.0,0.0)) === true

end

@testset "minimal_precedes_dec_test" begin

    @test precedes(nai(Interval{Float64}), interval(bareinterval(3.0,4.0), def)) === false

    @test precedes(interval(bareinterval(3.0,4.0), trv), nai(Interval{Float64})) === false

    @test precedes(nai(Interval{Float64}), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test precedes(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test precedes(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(3.0,4.0), def)) === true

    @test precedes(interval(bareinterval(3.0,4.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test precedes(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test precedes(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test precedes(interval(bareinterval(0.0,2.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test precedes(interval(bareinterval(-0.0,2.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test precedes(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test precedes(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test precedes(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(3.0,4.0), trv)) === true

    @test precedes(interval(bareinterval(1.0,3.0), trv), interval(bareinterval(3.0,4.0), def)) === true

    @test precedes(interval(bareinterval(-3.0, -1.0), def), interval(bareinterval(-1.0,0.0), trv)) === true

    @test precedes(interval(bareinterval(-3.0, -1.0), trv), interval(bareinterval(-1.0,-0.0), trv)) === true

    @test precedes(interval(bareinterval(1.0,3.5), trv), interval(bareinterval(3.0,4.0), trv)) === false

    @test precedes(interval(bareinterval(1.0,4.0), trv), interval(bareinterval(3.0,4.0), trv)) === false

    @test precedes(interval(bareinterval(-3.0, -0.1), trv), interval(bareinterval(-1.0,0.0), trv)) === false

    @test precedes(interval(bareinterval(0.0,0.0), trv), interval(bareinterval(-0.0,-0.0), trv)) === true

    @test precedes(interval(bareinterval(-0.0,-0.0), trv), interval(bareinterval(0.0,0.0), def)) === true

    @test precedes(interval(bareinterval(-0.0,0.0), trv), interval(bareinterval(0.0,0.0), trv)) === true

    @test precedes(interval(bareinterval(-0.0,0.0), def), interval(bareinterval(0.0,-0.0), trv)) === true

    @test precedes(interval(bareinterval(0.0,-0.0), trv), interval(bareinterval(0.0,0.0), trv)) === true

    @test precedes(interval(bareinterval(0.0,-0.0), trv), interval(bareinterval(-0.0,0.0), trv)) === true

end

@testset "minimal_interior_test" begin

    @test isinterior(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test isinterior(emptyinterval(BareInterval{Float64}), bareinterval(0.0,4.0)) === true

    @test isinterior(bareinterval(0.0,4.0), emptyinterval(BareInterval{Float64})) === false

    @test isinterior(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === true

    @test isinterior(bareinterval(0.0,4.0), bareinterval(-Inf,+Inf)) === true

    @test isinterior(emptyinterval(BareInterval{Float64}), bareinterval(-Inf,+Inf)) === true

    @test isinterior(bareinterval(-Inf,+Inf), bareinterval(0.0,4.0)) === false

    @test isinterior(bareinterval(0.0,4.0), bareinterval(0.0,4.0)) === false

    @test isinterior(bareinterval(1.0,2.0), bareinterval(0.0,4.0)) === true

    @test isinterior(bareinterval(-2.0,2.0), bareinterval(-2.0,4.0)) === false

    @test isinterior(bareinterval(-0.0,-0.0), bareinterval(-2.0,4.0)) === true

    @test isinterior(bareinterval(0.0,0.0), bareinterval(-2.0,4.0)) === true

    @test isinterior(bareinterval(0.0,0.0), bareinterval(-0.0,-0.0)) === false

    @test isinterior(bareinterval(0.0,4.4), bareinterval(0.0,4.0)) === false

    @test isinterior(bareinterval(-1.0,-1.0), bareinterval(0.0,4.0)) === false

    @test isinterior(bareinterval(2.0,2.0), bareinterval(-2.0,-1.0)) === false

end

@testset "minimal_interior_dec_test" begin

    @test isinterior(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test isinterior(nai(Interval{Float64}), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test isinterior(nai(Interval{Float64}), interval(bareinterval(0.0,4.0), trv)) === false

    @test isinterior(interval(bareinterval(0.0,4.0), def), nai(Interval{Float64})) === false

    @test isinterior(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test isinterior(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(0.0,4.0), trv)) === true

    @test isinterior(interval(bareinterval(0.0,4.0), def), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test isinterior(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test isinterior(interval(bareinterval(0.0,4.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test isinterior(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test isinterior(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(0.0,4.0), trv)) === false

    @test isinterior(interval(bareinterval(0.0,4.0), trv), interval(bareinterval(0.0,4.0), trv)) === false

    @test isinterior(interval(bareinterval(1.0,2.0), def), interval(bareinterval(0.0,4.0), trv)) === true

    @test isinterior(interval(bareinterval(-2.0,2.0), trv), interval(bareinterval(-2.0,4.0), def)) === false

    @test isinterior(interval(bareinterval(-0.0,-0.0), trv), interval(bareinterval(-2.0,4.0), trv)) === true

    @test isinterior(interval(bareinterval(0.0,0.0), def), interval(bareinterval(-2.0,4.0), trv)) === true

    @test isinterior(interval(bareinterval(0.0,0.0), trv), interval(bareinterval(-0.0,-0.0), trv)) === false

    @test isinterior(interval(bareinterval(0.0,4.4), trv), interval(bareinterval(0.0,4.0), trv)) === false

    @test isinterior(interval(bareinterval(-1.0,-1.0), trv), interval(bareinterval(0.0,4.0), def)) === false

    @test isinterior(interval(bareinterval(2.0,2.0), def), interval(bareinterval(-2.0,-1.0), trv)) === false

end

@testset "minimal_strictly_less_test" begin

    @test isstrictless(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test isstrictless(bareinterval(1.0,2.0), emptyinterval(BareInterval{Float64})) === false

    @test isstrictless(emptyinterval(BareInterval{Float64}), bareinterval(1.0,2.0)) === false

    @test isstrictless(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === true

    @test isstrictless(bareinterval(1.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test isstrictless(bareinterval(-Inf,+Inf), bareinterval(1.0,2.0)) === false

    @test isstrictless(bareinterval(1.0,2.0), bareinterval(1.0,2.0)) === false

    @test isstrictless(bareinterval(1.0,2.0), bareinterval(3.0,4.0)) === true

    @test isstrictless(bareinterval(1.0,3.5), bareinterval(3.0,4.0)) === true

    @test isstrictless(bareinterval(1.0,4.0), bareinterval(3.0,4.0)) === false

    @test isstrictless(bareinterval(0.0,4.0), bareinterval(0.0,4.0)) === false

    @test isstrictless(bareinterval(-0.0,4.0), bareinterval(0.0,4.0)) === false

    @test isstrictless(bareinterval(-2.0,-1.0), bareinterval(-2.0,-1.0)) === false

    @test isstrictless(bareinterval(-3.0,-1.5), bareinterval(-2.0,-1.0)) === true

end

@testset "minimal_strictly_less_dec_test" begin

    @test isstrictless(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test isstrictless(interval(emptyinterval(BareInterval{Float64}), trv), nai(Interval{Float64})) === false

    @test isstrictless(interval(bareinterval(1.0,2.0), trv), nai(Interval{Float64})) === false

    @test isstrictless(nai(Interval{Float64}), interval(bareinterval(1.0,2.0), def)) === false

    @test isstrictless(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test isstrictless(interval(bareinterval(1.0,2.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test isstrictless(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(1.0,2.0), def)) === false

    @test isstrictless(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-Inf,+Inf), trv)) === true

    @test isstrictless(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test isstrictless(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test isstrictless(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test isstrictless(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(3.0,4.0), trv)) === true

    @test isstrictless(interval(bareinterval(1.0,3.5), def), interval(bareinterval(3.0,4.0), trv)) === true

    @test isstrictless(interval(bareinterval(1.0,4.0), trv), interval(bareinterval(3.0,4.0), def)) === false

    @test isstrictless(interval(bareinterval(0.0,4.0), trv), interval(bareinterval(0.0,4.0), def)) === false

    @test isstrictless(interval(bareinterval(-0.0,4.0), def), interval(bareinterval(0.0,4.0), trv)) === false

    @test isstrictless(interval(bareinterval(-2.0,-1.0), def), interval(bareinterval(-2.0,-1.0), def)) === false

    @test isstrictless(interval(bareinterval(-3.0,-1.5), trv), interval(bareinterval(-2.0,-1.0), trv)) === true

end

@testset "minimal_strictly_precedes_test" begin

    @test strictprecedes(emptyinterval(BareInterval{Float64}), bareinterval(3.0,4.0)) === true

    @test strictprecedes(bareinterval(3.0,4.0), emptyinterval(BareInterval{Float64})) === true

    @test strictprecedes(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test strictprecedes(bareinterval(1.0,2.0), bareinterval(-Inf,+Inf)) === false

    @test strictprecedes(bareinterval(-Inf,+Inf), bareinterval(1.0,2.0)) === false

    @test strictprecedes(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === false

    @test strictprecedes(bareinterval(1.0,2.0), bareinterval(3.0,4.0)) === true

    @test strictprecedes(bareinterval(1.0,3.0), bareinterval(3.0,4.0)) === false

    @test strictprecedes(bareinterval(-3.0,-1.0), bareinterval(-1.0,0.0)) === false

    @test strictprecedes(bareinterval(-3.0,-0.0), bareinterval(0.0,1.0)) === false

    @test strictprecedes(bareinterval(-3.0,0.0), bareinterval(-0.0,1.0)) === false

    @test strictprecedes(bareinterval(1.0,3.5), bareinterval(3.0,4.0)) === false

    @test strictprecedes(bareinterval(1.0,4.0), bareinterval(3.0,4.0)) === false

    @test strictprecedes(bareinterval(-3.0,-0.1), bareinterval(-1.0,0.0)) === false

end

@testset "minimal_strictly_precedes_dec_test" begin

    @test strictprecedes(nai(Interval{Float64}), interval(bareinterval(3.0,4.0), trv)) === false

    @test strictprecedes(interval(bareinterval(3.0,4.0), def), nai(Interval{Float64})) === false

    @test strictprecedes(nai(Interval{Float64}), interval(emptyinterval(BareInterval{Float64}), trv)) === false

    @test strictprecedes(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test strictprecedes(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(3.0,4.0), trv)) === true

    @test strictprecedes(interval(bareinterval(3.0,4.0), def), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test strictprecedes(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test strictprecedes(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test strictprecedes(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(1.0,2.0), trv)) === false

    @test strictprecedes(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test strictprecedes(interval(bareinterval(1.0,2.0), trv), interval(bareinterval(3.0,4.0), trv)) === true

    @test strictprecedes(interval(bareinterval(1.0,3.0), def), interval(bareinterval(3.0,4.0), trv)) === false

    @test strictprecedes(interval(bareinterval(-3.0,-1.0), trv), interval(bareinterval(-1.0,0.0), def)) === false

    @test strictprecedes(interval(bareinterval(-3.0,-0.0), def), interval(bareinterval(0.0,1.0), trv)) === false

    @test strictprecedes(interval(bareinterval(-3.0,0.0), trv), interval(bareinterval(-0.0,1.0), trv)) === false

    @test strictprecedes(interval(bareinterval(1.0,3.5), trv), interval(bareinterval(3.0,4.0), trv)) === false

    @test strictprecedes(interval(bareinterval(1.0,4.0), trv), interval(bareinterval(3.0,4.0), def)) === false

    @test strictprecedes(interval(bareinterval(-3.0,-0.1), trv), interval(bareinterval(-1.0,0.0), trv)) === false

end

@testset "minimal_disjoint_test" begin

    @test isdisjoint_interval(emptyinterval(BareInterval{Float64}), bareinterval(3.0,4.0)) === true

    @test isdisjoint_interval(bareinterval(3.0,4.0), emptyinterval(BareInterval{Float64})) === true

    @test isdisjoint_interval(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === true

    @test isdisjoint_interval(bareinterval(3.0,4.0), bareinterval(1.0,2.0)) === true

    @test isdisjoint_interval(bareinterval(0.0,0.0), bareinterval(-0.0,-0.0)) === false

    @test isdisjoint_interval(bareinterval(0.0,-0.0), bareinterval(-0.0,0.0)) === false

    @test isdisjoint_interval(bareinterval(3.0,4.0), bareinterval(1.0,7.0)) === false

    @test isdisjoint_interval(bareinterval(3.0,4.0), bareinterval(-Inf,+Inf)) === false

    @test isdisjoint_interval(bareinterval(-Inf,+Inf), bareinterval(1.0,7.0)) === false

    @test isdisjoint_interval(bareinterval(-Inf,+Inf), bareinterval(-Inf,+Inf)) === false

end

@testset "minimal_disjoint_dec_test" begin

    @test isdisjoint_interval(nai(Interval{Float64}), interval(bareinterval(3.0,4.0), def)) === false

    @test isdisjoint_interval(interval(bareinterval(3.0,4.0), trv), nai(Interval{Float64})) === false

    @test isdisjoint_interval(interval(emptyinterval(BareInterval{Float64}), trv), nai(Interval{Float64})) === false

    @test isdisjoint_interval(nai(Interval{Float64}), nai(Interval{Float64})) === false

    @test isdisjoint_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(3.0,4.0), def)) === true

    @test isdisjoint_interval(interval(bareinterval(3.0,4.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test isdisjoint_interval(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === true

    @test isdisjoint_interval(interval(bareinterval(3.0,4.0), trv), interval(bareinterval(1.0,2.0), def)) === true

    @test isdisjoint_interval(interval(bareinterval(0.0,0.0), trv), interval(bareinterval(-0.0,-0.0), trv)) === false

    @test isdisjoint_interval(interval(bareinterval(0.0,-0.0), trv), interval(bareinterval(-0.0,0.0), trv)) === false

    @test isdisjoint_interval(interval(bareinterval(3.0,4.0), def), interval(bareinterval(1.0,7.0), def)) === false

    @test isdisjoint_interval(interval(bareinterval(3.0,4.0), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

    @test isdisjoint_interval(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(1.0,7.0), trv)) === false

    @test isdisjoint_interval(interval(bareinterval(-Inf,+Inf), trv), interval(bareinterval(-Inf,+Inf), trv)) === false

end

# This file contains the functions described as "Numeric functions" in Section
# 9.4 of the IEEE Std 1788-2015 and required for set-based flavor in Section
# 10.5.9
# See also Section 12.12.8

"""
    inf(x)

Lower bound, or infimum, of `x`. For a zero `AbstractFloat` lower bound, a
negative zero is returned.

Implement the `inf` function of the IEEE Standard 1788-2015 (Table 9.2).

See also: [`sup`](@ref), [`bounds`](@ref), [`mid`](@ref), [`diam`](@ref),
[`radius`](@ref) and [`midradius`](@ref).
"""
inf(x::BareInterval{T}) where {T<:AbstractFloat} = ifelse(isnan(x.lo), typemax(T), ifelse(iszero(x.lo), copysign(x.lo, -1), x.lo))
function inf(x::BareInterval{T}) where {T<:BigFloat}
    isnan(x.lo) && return typemax(T) # typemax(x.lo)
    iszero(x.lo) && return copysign(x.lo, -1)
    return x.lo
end

inf(x::BareInterval{<:Rational}) = x.lo

function inf(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return convert(T, NaN)
    return inf(bareinterval(x))
end
function inf(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the infimum of an NaI; cannot return a `Rational` NaN"))
    return inf(bareinterval(x))
end

inf(x::Real) = inf(interval(x))

"""
    sup(x)

Upper bound, or supremum, of `x`.

Implement the `sup` function of the IEEE Standard 1788-2015 (Table 9.2).

See also: [`inf`](@ref), [`bounds`](@ref), [`mid`](@ref), [`diam`](@ref),
[`radius`](@ref) and [`midradius`](@ref).
"""
sup(x::BareInterval{T}) where {T<:AbstractFloat} = ifelse(isnan(x.hi), typemin(T), x.hi)
function sup(x::BareInterval{T}) where {T<:BigFloat}
    isnan(x.hi) && return typemin(T) # typemin(x.hi)
    return x.hi
end

sup(x::BareInterval{<:Rational}) = x.hi

function sup(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return convert(T, NaN)
    return sup(bareinterval(x))
end
function sup(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the supremum of an NaI; cannot return a `Rational` NaN"))
    return sup(bareinterval(x))
end

sup(x::Real) = sup(interval(x))

"""
    bounds(x)

Bounds of `x` given as a tuple. Unlike [`inf`](@ref), this function does
not normalize the infimum of the interval.

See also: [`inf`](@ref), [`sup`](@ref), [`mid`](@ref), [`diam`](@ref),
[`radius`](@ref) and [`midradius`](@ref).
"""
bounds(x::BareInterval{T}) where {T<:AbstractFloat} = (ifelse(isnan(x.lo), typemax(T), x.lo), sup(x))
bounds(x::BareInterval{<:Rational}) = (inf(x), sup(x))

function bounds(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return (convert(T, NaN), convert(T, NaN))
    return bounds(bareinterval(x))
end
function bounds(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the bounds of an NaI; cannot return a `Rational` NaN"))
    return bounds(bareinterval(x))
end

bounds(x::Real) = bounds(interval(x))

"""
    mid(x, α = 0.5)

Relative midpoint of `x`, for `α` between 0 and 1 such that `mid(x, 0)` is the
lower bound of the interval, `mid(x, 1)` its upper bound, and `mid(x, 0.5)` its
midpoint.

Implement the `mid` function of the IEEE Standard 1788-2015 (Table 9.2).

See also: [`inf`](@ref), [`sup`](@ref), [`bounds`](@ref), [`diam`](@ref),
[`radius`](@ref) and [`midradius`](@ref).
"""
function mid(x::BareInterval{T}, α = 0.5) where {T<:AbstractFloat}
    0 ≤ α ≤ 1 || return throw(DomainError(α, "α must be between 0 and 1"))
    isempty_interval(x) && return convert(T, NaN)
    if isentire_interval(x)
        α == 0.5 && return zero(T)
        α > 0.5 && return prevfloat(typemax(T))
        return nextfloat(typemin(T))
    else
        lo, hi = bounds(x)
        lo == typemin(T) && return nextfloat(lo) # cf. Section 12.12.8
        hi == typemax(T) && return prevfloat(hi) # cf. Section 12.12.8
        β = convert(T, α)
        midpoint = β * (hi + lo * (1/β - 1)) # exactly 0.5 * (hi + lo) for β = 0.5
        midpoint = ifelse(isfinite(midpoint), midpoint, (1 - β) * lo + β * hi)
        midpoint = ifelse(midpoint < lo, lo, midpoint)
        midpoint = ifelse(midpoint > hi, hi, midpoint)
        return _normalisezero(midpoint)
    end
end
function mid(x::BareInterval{Rational{T}}, α = 1//2) where {T<:Integer}
    0 ≤ α ≤ 1 || return throw(DomainError(α, "α must be between 0 and 1"))
    isempty_interval(x) && return throw(ArgumentError("cannot compute the midpoint of empty intervals; cannot return a `Rational` NaN"))
    if isentire_interval(x)
        α == 0.5 && return zero(Rational{T})
        α > 0.5 && return convert(Rational{T}, typemax(T))
        return convert(Rational{T}, typemin(T))
    else
        lo, hi = bounds(x)
        lo == typemin(Rational{T}) && return convert(Rational{T}, typemin(T)) # cf. Section 12.12.8
        hi == typemax(Rational{T}) && return convert(Rational{T}, typemax(T)) # cf. Section 12.12.8
        β = convert(Rational{T}, α)
        return _normalisezero((1 - β) * lo + β * hi)
    end
end

function mid(x::Interval{T}, α = 0.5) where {T<:AbstractFloat}
    0 ≤ α ≤ 1 || return throw(DomainError(α, "α must be between 0 and 1"))
    isnai(x) && return convert(T, NaN)
    return mid(bareinterval(x), α)
end
function mid(x::Interval{<:Rational}, α = 1//2)
    0 ≤ α ≤ 1 || return throw(DomainError(α, "α must be between 0 and 1"))
    isnai(x) && return throw(ArgumentError("cannot compute the midpoint of an NaI; cannot return a `Rational` NaN"))
    return mid(bareinterval(x), α)
end

mid(x::Real, α = 0.5) = mid(interval(x), α)
mid(x::Complex, α = 0.5) = complex(mid(real(x), α), mid(imag(x), α))

mid(x::AbstractArray, α = 0.5) = mid.(x, α)

"""
    diam(x)

Diameter of `x`. If `x` is complex, then the diameter is the maximum diameter
between its real and imaginary parts.

Implement the `wid` function of the IEEE Standard 1788-2015 (Table 9.2).

See also: [`inf`](@ref), [`sup`](@ref), [`bounds`](@ref), [`mid`](@ref),
[`radius`](@ref) and [`midradius`](@ref).
"""
function diam(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return convert(T, NaN)
    return _fround(-, sup(x), inf(x), RoundUp) # cf. Section 12.12.8
end
function diam(x::BareInterval{<:Rational})
    isempty_interval(x) && return throw(ArgumentError("cannot compute the diameter of empty intervals; cannot return a `Rational` NaN"))
    return _fround(-, sup(x), inf(x), RoundUp) # cf. Section 12.12.8
end

function diam(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return convert(T, NaN)
    return diam(bareinterval(x))
end
function diam(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the diameter of an NaI; cannot return a `Rational` NaN"))
    return diam(bareinterval(x))
end

diam(x::Real) = diam(interval(x))
diam(x::Complex) = max(diam(real(x)), diam(imag(x)))

"""
    radius(x)

Radius of `x`, such that `issubset_interval(x, mid(x) ± radius(x))`. If `x` is
complex, then the radius is the maximum radius between its real and imaginary
parts.

Implement the `rad` function of the IEEE Standard 1788-2015 (Table 9.2).

See also: [`inf`](@ref), [`sup`](@ref), [`bounds`](@ref), [`mid`](@ref),
[`diam`](@ref) and [`midradius`](@ref).
"""
function radius(x::BareInterval)
    _, r = midradius(x)
    return r
end

function radius(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return convert(T, NaN)
    return radius(bareinterval(x))
end
function radius(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the radius of an NaI; cannot return a `Rational` NaN"))
    return radius(bareinterval(x))
end

radius(x::Real) = radius(interval(x))
radius(x::Complex) = max(radius(real(x)), radius(imag(x)))

"""
    midradius(x)

Midpoint and radius of `x`.

Function required by the IEEE Standard 1788-2015 in Section 10.5.9 for the
set-based flavor.

See also: [`inf`](@ref), [`sup`](@ref), [`bounds`](@ref), [`mid`](@ref),
[`mid`](@ref) and [`radius`](@ref).
"""
function midradius(x::BareInterval)
    m = mid(x)
    return m, max(m - inf(x), sup(x) - m)
end
function midradius(x::BareInterval{<:Rational}) # needed to avoid integer overflow error
    m = mid(x)
    isbounded(x) && return m, max(m - inf(x), sup(x) - m)
    return m, typemax(numtype(x))
end

function midradius(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return (convert(T, NaN), convert(T, NaN))
    return midradius(bareinterval(x))
end
function midradius(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the midpoint and radius of an NaI; cannot return a `Rational` NaN"))
    return midradius(bareinterval(x))
end

midradius(x::Real) = midradius(interval(x))
midradius(x::Complex) = (mid(x), radius(x))

"""
    mag(x)

Magnitude of `x`.

Implement the `mag` function of the IEEE Standard 1788-2015 (Table 9.2).

See also: [`mig`](@ref).
"""
function mag(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return convert(T, NaN)
    return max(abs(inf(x)), abs(sup(x)))
end
function mag(x::BareInterval{<:Rational})
    isempty_interval(x) && return throw(ArgumentError("cannot compute the magnitude of empty intervals; cannot return a `Rational` NaN"))
    return max(abs(inf(x)), abs(sup(x)))
end

function mag(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return convert(T, NaN)
    return mag(bareinterval(x))
end
function mag(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the magnitude of an NaI; cannot return a `Rational` NaN"))
    return mag(bareinterval(x))
end

mag(x::Real) = mag(interval(x))
mag(x::Complex) = sup(abs(interval(x)))

"""
    mig(x)

Mignitude of `x`.

Implement the `mig` function of the IEEE Standard 1788-2015 (Table 9.2).

See also: [`mag`](@ref).
"""
function mig(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return convert(T, NaN)
    in_interval(0, x) && return zero(T)
    return min(abs(inf(x)), abs(sup(x)))
end
function mig(x::BareInterval{T}) where {T<:Rational}
    isempty_interval(x) && return throw(ArgumentError("cannot compute the mignitude of empty intervals; cannot return a `Rational` NaN"))
    in_interval(0, x) && return zero(T)
    return min(abs(inf(x)), abs(sup(x)))
end

function mig(x::Interval{T}) where {T<:AbstractFloat}
    isnai(x) && return convert(T, NaN)
    return mig(bareinterval(x))
end
function mig(x::Interval{<:Rational})
    isnai(x) && return throw(ArgumentError("cannot compute the mignitude of an NaI; cannot return a `Rational` NaN"))
    return mig(bareinterval(x))
end

mig(x::Real) = mig(interval(x))
mig(x::Complex) = inf(abs(interval(x)))

"""
    dist(x, y)

Distance between `x` and `y`.
"""
function dist(x::BareInterval{T}, y::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) | isempty_interval(y) && return convert(T, NaN)
    return max(abs(inf(x) - inf(y)), abs(sup(x) - sup(y)))
end
function dist(x::BareInterval{T}, y::BareInterval{T}) where {T<:Rational}
    isempty_interval(x) | isempty_interval(y) && return throw(ArgumentError("cannot compute the distance of empty intervals; cannot return a `Rational` NaN"))
    return max(abs(inf(x) - inf(y)), abs(sup(x) - sup(y)))
end
dist(x::BareInterval, y::BareInterval) = dist(promote(x, y)...)

function dist(x::Interval{T}, y::Interval{T}) where {T<:AbstractFloat}
    isnai(x) | isnai(y) && return convert(T, NaN)
    return dist(bareinterval(x), bareinterval(y))
end
function dist(x::Interval{T}, y::Interval{T}) where {T<:Rational}
    isnai(x) | isnai(y) && return throw(ArgumentError("cannot compute the distance of an NaI; cannot return a `Rational` NaN"))
    return dist(bareinterval(x), bareinterval(y))
end
dist(x::Interval, y::Interval) = dist(promote(x, y)...)

# This file contains the functions described as "Basic arithmetic functions" in
# Section 9.1 of the IEEE Standard 1788-2015 and required for set-based flavor
# in Section 10.5.3

Base.:+(x::BareInterval) = x # not in the IEEE Standard 1788-2015

Base.:+(x::Interval) = x

"""
    +(x::BareInterval, y::BareInterval)
    +(x::Interval, y::Interval)

Implement the `add` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.:+(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    isempty_interval(y) && return y
    return @round(T, inf(x) + inf(y), sup(x) + sup(y))
end
Base.:+(x::BareInterval, y::BareInterval) = +(promote(x, y)...)

function Base.:+(x::Interval, y::Interval)
    @inline r = bareinterval(x) + bareinterval(y)
    d = min(decoration(x), decoration(y), decoration(r))
    t = isguaranteed(x) & isguaranteed(y)
    return _unsafe_interval(r, d, t)
end

"""
    -(x::BareInterval)
    -(x::Interval)

Implement the `neg` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.:-(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    return _unsafe_bareinterval(T, -sup(x), -inf(x))
end

Base.:-(x::Interval) = _unsafe_interval(-bareinterval(x), decoration(x), isguaranteed(x))

"""
    -(x::BareInterval, y::BareInterval)
    -(x::Interval, y::Interval)

Implement the `sub` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.:-(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    isempty_interval(y) && return y
    return @round(T, inf(x) - sup(y), sup(x) - inf(y))
end
Base.:-(x::BareInterval, y::BareInterval) = -(promote(x, y)...)

function Base.:-(x::Interval, y::Interval)
    @inline r = bareinterval(x) - bareinterval(y)
    d = min(decoration(x), decoration(y), decoration(r))
    t = isguaranteed(x) & isguaranteed(y)
    return _unsafe_interval(r, d, t)
end

"""
    *(x::BareInterval, y::BareInterval)
    *(x::Interval, y::Interval)

Implement the `mul` function of the IEEE Standard 1788-2015 (Table 9.1).

!!! note
    The behavior of `*` is flavor dependent for some edge cases.
"""
function Base.:*(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    isempty_interval(y) && return y
    isthinzero(x) && return x
    isthinzero(y) && return y
    isbounded(x) & isbounded(y) && return _mult(*, x, y)
    return _mult(_unbounded_mul, x, y)
end
Base.:*(x::BareInterval, y::BareInterval) = *(promote(x, y)...)

function Base.:*(x::Interval, y::Interval)
    @inline r = bareinterval(x) * bareinterval(y)
    d = min(decoration(x), decoration(y), decoration(r))
    t = isguaranteed(x) & isguaranteed(y)
    return _unsafe_interval(r, d, t)
end

# helper functions for multiplication

function _unbounded_mul(x::T, y::T, r::RoundingMode) where {T<:NumTypes}
    iszero(x) && return sign(y) * zero_times_infinity(T)
    iszero(y) && return sign(x) * zero_times_infinity(T)
    return _fround(*, x, y, r)
end

for f ∈ (:_unbounded_mul, :*)
    @eval function _mult(::typeof($f), x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
        if inf(y) ≥ 0
            inf(x) ≥ 0 && return @round(T, $f(inf(x), inf(y)), $f(sup(x), sup(y)))
            sup(x) ≤ 0 && return @round(T, $f(inf(x), sup(y)), $f(sup(x), inf(y)))
            return @round(T, inf(x)*sup(y), sup(x)*sup(y))
        elseif sup(y) ≤ 0
            inf(x) ≥ 0 && return @round(T, $f(sup(x), inf(y)), $f(inf(x), sup(y)))
            sup(x) ≤ 0 && return @round(T, $f(sup(x), sup(y)), $f(inf(x), inf(y)))
            return @round(T, sup(x)*inf(y), inf(x)*inf(y))
        else
            inf(x) > 0 && return @round(T, $f(sup(x), inf(y)), $f(sup(x), sup(y)))
            sup(x) < 0 && return @round(T, $f(inf(x), sup(y)), $f(inf(x), inf(y)))
            return @round(T, min( $f(inf(x), sup(y)), $f(sup(x), inf(y)) ),
                             max( $f(inf(x), inf(y)), $f(sup(x), sup(y)) ))
        end
    end
end

"""
    inv(x::BareInterval)
    inv(x::Interval)

Implement the `recip` function of the IEEE Standard 1788-2015 (Table 9.1).

!!! note
    The behavior of `inv` is flavor dependent for some edge cases.
"""
function Base.inv(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    if in_interval(0, x)
        inf(x) < 0 == sup(x) && return @round(T, typemin(T), inv(inf(x)))
        inf(x) == 0 < sup(x) && return @round(T, inv(sup(x)), typemax(T))
        inf(x) < 0 < sup(x) && return entireinterval(BareInterval{T})
        # isthinzero(x)
        return div_by_thin_zero(_unsafe_bareinterval(T, one(T), one(T)))
    end
    return @round(T, inv(sup(x)), inv(inf(x)))
end

function Base.inv(x::Interval)
    bx = bareinterval(x)
    r = inv(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(in_interval(0, bx), trv, d))
    return _unsafe_interval(r, d, isguaranteed(x))
end

function Base.inv(x::Complex{<:Interval})
    d = abs2(x)
    return complex(real(x) / d, -imag(x) / d)
end

"""
    /(x::BareInterval, y::BareInterval)
    /(x::Interval, y::Interval)

Implement the `div` function of the IEEE Standard 1788-2015 (Table 9.1).

!!! note
    The behavior of `/` is flavor dependent for some edge cases.
"""
function Base.:/(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    isempty_interval(y) && return y
    isthinzero(y) && return div_by_thin_zero(x)
    if inf(y) > 0
        inf(x) ≥ 0 && return @round(T, inf(x)/sup(y), sup(x)/inf(y))
        sup(x) ≤ 0 && return @round(T, inf(x)/inf(y), sup(x)/sup(y))
        return @round(T, inf(x)/inf(y), sup(x)/inf(y))
    elseif sup(y) < 0
        inf(x) ≥ 0 && return @round(T, sup(x)/sup(y), inf(x)/inf(y))
        sup(x) ≤ 0 && return @round(T, sup(x)/inf(y), inf(x)/sup(y))
        return @round(T, sup(x)/sup(y), inf(x)/sup(y))
    else
        isthinzero(x) && return x
        if iszero(inf(y))
            inf(x) ≥ 0 && return @round(T, inf(x)/sup(y), typemax(T))
            sup(x) ≤ 0 && return @round(T, typemin(T), sup(x)/sup(y))
            return entireinterval(BareInterval{T})
        elseif sup(y) == 0
            inf(x) ≥ 0 && return @round(T, typemin(T), inf(x)/inf(y))
            sup(x) ≤ 0 && return @round(T, sup(x)/inf(y), typemax(T))
            return entireinterval(BareInterval{T})
        else
            return entireinterval(BareInterval{T})
        end
    end
end
Base.:/(x::BareInterval, y::BareInterval) = /(promote(x, y)...)

function Base.:/(x::Interval, y::Interval)
    by = bareinterval(y)
    @inline r = bareinterval(x) / by
    d = min(decoration(x), decoration(y), decoration(r))
    d = min(d, ifelse(in_interval(0, by), trv, d))
    t = isguaranteed(x) & isguaranteed(y)
    return _unsafe_interval(r, d, t)
end

Base.:/(x::Complex{<:Interval}, y::Complex{<:Interval}) = x * inv(y)
Base.:/(x::Complex{<:Interval}, y::Interval) = x * inv(y)
Base.:/(x::Interval, y::Complex{<:Interval}) = x * inv(y)

Base.:\(x::BareInterval, y::BareInterval) = /(y, x)

"""
    muladd(x::BareInterval, y::BareInterval z::BareInterval)
    muladd(x::Interval, y::Interval z::Interval)

Implement the combined multiply-add; this is semantically equivalent to `x * y + z`.
"""
Base.muladd(x::BareInterval{T}, y::BareInterval{T}, z::BareInterval{T}) where {T<:NumTypes} = x * y + z # not in the IEEE Standard 1788-2015
Base.muladd(x::BareInterval, y::BareInterval, z::BareInterval) = muladd(promote(x, y, z)...)

function Base.muladd(x::Interval, y::Interval, z::Interval)
    r = muladd(bareinterval(x), bareinterval(y), bareinterval(z))
    d = min(decoration(x), decoration(y), decoration(z), decoration(r))
    t = isguaranteed(x) & isguaranteed(y) & isguaranteed(z)
    return _unsafe_interval(r, d, t)
end

"""
    fma(x::BareInterval, y::BareInterval, z::BareInterval)
    fma(x::Interval, y::Interval, z::Interval)

Implement the `fma` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
Base.fma(x::BareInterval{T}, y::BareInterval{T}, z::BareInterval{T}) where {T<:NumTypes} = x * y + z
Base.fma(x::BareInterval, y::BareInterval, z::BareInterval) = fma(promote(x, y, z)...)

function Base.fma(x::Interval, y::Interval, z::Interval)
    r = fma(bareinterval(x), bareinterval(y), bareinterval(z))
    d = min(decoration(x), decoration(y), decoration(z), decoration(r))
    t = isguaranteed(x) & isguaranteed(y) & isguaranteed(z)
    return _unsafe_interval(r, d, t)
end

"""
    sqrt(x::BareInterval)
    sqrt(x::Interval)

Implement the `sqrt` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.sqrt(x::BareInterval{T}) where {T<:AbstractFloat}
    sup(x) < 0 && return emptyinterval(BareInterval{T})
    lo = _cut_negative_domain(x)
    return @round(T, sqrt(lo), sqrt(sup(x)))
end
_cut_negative_domain(x::BareInterval{T}) where {T<:AbstractFloat} = ifelse(inf(x) < 0, zero(T), inf(x))
_cut_negative_domain(x::BareInterval{T}) where {T<:BigFloat} = inf(x) < 0 ? zero(T) : inf(x)

Base.sqrt(x::BareInterval{<:Rational}) = sqrt(float(x))

function Base.sqrt(x::Interval{T}) where {T<:NumTypes}
    domain = _unsafe_bareinterval(T, zero(T), typemax(T))
    bx = bareinterval(x)
    r = sqrt(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(issubset_interval(bx, domain), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.sqrt(x::Complex{Interval{T}}) where {T<:NumTypes} = x ^ interval(1//2)

module IntervalArithmeticDiffRulesExt

using IntervalArithmetic
import DiffRules

function DiffRules._abs_deriv(x::Interval{T}) where {T<:IntervalArithmetic.NumTypes}
    r = ifelse(isthinzero(x), bareinterval(-one(T), one(T)), sign(bareinterval(x)))
    d = decoration(x)
    d = min(d, ifelse(in_interval(0, x), trv, d)) # if `x` contains 0, then `trv` decoration
    return IntervalArithmetic._unsafe_interval(r, d, isguaranteed(x))
end

end

@testset "BareInterval" begin
    for T ∈ (Float16, Float32, Float64, BigFloat)
        @test isequal_interval(parse(BareInterval{T}, "[1, 2]"), bareinterval(T, 1, 2))
        if T != BigFloat
            @test isequal_interval(parse(BareInterval{T}, "[1e-324, 1e400]"), bareinterval(T, 0, Inf))
        else
            @test isequal_interval(parse(BareInterval{BigFloat}, "[1e-324, 1e400]"), bareinterval(BigFloat("1e-324", RoundDown), BigFloat("1e400", RoundUp)))
        end
        @test isequal_interval(parse(BareInterval{T}, "[2,infinity]"), bareinterval(T, 2, Inf))
        @test isempty_interval(parse(BareInterval{T}, "[foobar]"))
    end

    @test isequal_interval(parse(BareInterval{Rational{Int64}}, "0.1"), bareinterval(Rational{Int64}, 1//10))
    @test isequal_interval(parse(BareInterval{Rational{Int64}}, "[0.1, 0.3]"), bareinterval(Rational{Int64}, 1//10, 3//10))
end

@testset "Interval" begin
    for T ∈ (Float16, Float32, Float64, BigFloat)
        @test isequal_interval(parse(Interval{T}, "[1, 2]"), interval(T, 1, 2))
        if T != BigFloat
            @test isequal_interval(parse(Interval{T}, "[1e-324, 1e400]"), interval(T, 0, Inf))
        else
            @test isequal_interval(parse(Interval{BigFloat}, "[1e-324, 1e400]"), interval(BigFloat("1e-324", RoundDown), BigFloat("1e400", RoundUp)))
        end
        @test isequal_interval(parse(Interval{T}, "[2,infinity]"), interval(T, 2, Inf))
        @test isnai(parse(Interval{T}, "[foobar]"))

        x = parse(Interval{T}, "[1, 2]_com")
        y = parse(Interval{T}, "[1, 2]")
        z = interval(T, 1, 2)
        @test isequal_interval(x, y, z) & (decoration(x) == decoration(y) == decoration(z))
    end

    @test isequal_interval(parse(Interval{Rational{Int64}}, "0.1"), interval(Rational{Int64}, 1//10))
    @test isequal_interval(parse(Interval{Rational{Int64}}, "[0.1, 0.3]"), interval(Rational{Int64}, 1//10, 3//10))
end

@testset "String macro" begin
    @test typeof(I"0.1") == Interval{Float64}

    @test isequal_interval(I"[2/3, 1.1]", interval(0.6666666666666666, 1.1))
    @test isequal_interval(I"[1]", interval(1))
    @test isequal_interval(I"[-0x1.3p-1, 2/3]", interval(-0.59375, 0.6666666666666667))
    @test isequal_interval(I"123412341234123412341241234", interval(1.234123412341234e26, 1.2341234123412342e26))
    @test isequal_interval(interval(big"3"), interval(3))
    @test isequal_interval(interval(Float64, big"1e10000"), interval(Float64, big(10)^10000), interval(prevfloat(Inf), Inf))

    @test in_interval(1//10, I"[0.1, 0.2]") && in_interval(2//10, I"[0.1, 0.2]")
    @test issubset_interval(I"[0.1, 0.2]", interval(prevfloat(0.1), nextfloat(0.2)))

    @test nextfloat(inf(I"0.1")) == sup(I"0.1")

    @test isequal_interval(interval(0.5), interval(1//2), I"0.5")

    @test inf(I"1e300") == 9.999999999999999e299 && sup(I"1e300") == 1.0e300
    @test inf(I"-1e307") == -1.0000000000000001e307 && sup(I"-1e307") == -1.0e307
    # corner case for enclosure, `0.100000000000000006` rounds down to `0.1` for `Float64`
    @test in_interval(big"0.100000000000000006", I"0.100000000000000006")
end

# This file contains the functions described as "Boolean functions of intervals"
# in Section 9.5 of the IEEE Standard 1788-2015 and required for set-based
# flavor in Section 10.5.9
# Some other (non required) related functions are also present, as well as some
# of the "Recommended operations" (Section 10.6.3)
# The requirement for decorated intervals are described in Chapter 12,
# mostly sections 12.12.9 and 12.13.3.

# used internally, equivalent to `<` but with `(Inf < Inf) == true`
_strictlessprime(x::Real, y::Real) = (x < y) | ((isinf(x) | isinf(y)) & (x == y))

"""
    isequal_interval(x, y)

Test whether `x` and `y` are identical.

Implement the `equal` function of the IEEE Standard 1788-2015
(Tables 9.3 and 10.3, and Sections 9.5, 10.5.10 and 12.12.9).
"""
isequal_interval(x::BareInterval, y::BareInterval) = (inf(x) == inf(y)) & (sup(x) == sup(y))

function isequal_interval(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return isequal_interval(bareinterval(x), bareinterval(y))
end
isequal_interval(x::Complex{<:Interval}, y::Complex{<:Interval}) = isequal_interval(real(x), real(y)) & isequal_interval(imag(x), imag(y))
isequal_interval(x::Complex{<:Interval}, y::Interval) = isequal_interval(real(x), y) & isthinzero(imag(x))
isequal_interval(x::Interval, y::Complex{<:Interval}) = isequal_interval(x, real(y)) & isthinzero(imag(y))

function isequal_interval(x::AbstractVector, y::AbstractVector)
    n = length(x)
    m = length(y)
    n == m || return throw(DimensionMismatch("dimensions must match: x has length $n, y has length $m"))
    return all(t -> isequal_interval(t[1], t[2]), zip(x, y))
end

isequal_interval(x, y, z, w...) = isequal_interval(x, y) & isequal_interval(y, z, w...)

isequal_interval(x) = Base.Fix2(isequal_interval, x)

"""
    issetequal_interval(x, y)

Return whether the two interval are identical when considered as sets.

Alias of the [`isequal_interval`](@ref) function.
"""
const issetequal_interval = isequal_interval

"""
    issubset_interval(x, y)

Test whether `x` is contained in `y`.

Implement the `subset` function of the IEEE Standard 1788-2015
(Tables 9.3 and 10.3, and Sections 9.5, 10.5.10 and 12.12.9).

See also: [`isstrictsubset`](@ref) and [`isinterior`](@ref).
"""
issubset_interval(x::BareInterval, y::BareInterval) = (inf(y) ≤ inf(x)) & (sup(x) ≤ sup(y))

function issubset_interval(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return issubset_interval(bareinterval(x), bareinterval(y))
end
issubset_interval(x::Complex{<:Interval}, y::Complex{<:Interval}) = issubset_interval(real(x), real(y)) & issubset_interval(imag(x), imag(y))
issubset_interval(x::Complex{<:Interval}, y::Interval) = issubset_interval(real(x), y) & isthinzero(imag(x))
issubset_interval(x::Interval, y::Complex{<:Interval}) = issubset_interval(x, real(y)) & in_interval(0, imag(y))

function issubset_interval(x::AbstractVector, y::AbstractVector)
    n = length(x)
    m = length(y)
    n == m || return throw(DimensionMismatch("dimensions must match: x has length $n, y has length $m"))
    return all(t -> issubset_interval(t[1], t[2]), zip(x, y))
end

issubset_interval(x, y, z, w...) = issubset_interval(x, y) & issubset_interval(y, z, w...)

"""
    isstrictsubset(x, y)

Test whether `x` is a subset of, but not equal to, `y`. If `x` and `y` are
vectors, `x` must be a subset of `y` with at least one of their component being
a strict subset.

See also: [`issubset_interval`](@ref) and [`isinterior`](@ref).
"""
isstrictsubset(x::BareInterval, y::BareInterval) = issubset_interval(x, y) & !isequal_interval(x, y)

isstrictsubset(x::Interval, y::Interval) = issubset_interval(x, y) & !isequal_interval(x, y)
isstrictsubset(x::Complex{<:Interval}, y::Complex{<:Interval}) =
    (isstrictsubset(real(x), real(y)) & issubset_interval(imag(x), imag(y))) | (issubset_interval(real(x), real(y)) & isstrictsubset(imag(x), imag(y)))
isstrictsubset(x::Complex{<:Interval}, y::Interval) = isstrictsubset(real(x), y) & isthinzero(imag(x))
isstrictsubset(x::Interval, y::Complex{<:Interval}) = isstrictsubset(x, real(y)) & in_interval(0, imag(y))

isstrictsubset(x::AbstractVector, y::AbstractVector) = issubset_interval(x, y) & any(t -> isstrictsubset(t[1], t[2]), zip(x, y))

isstrictsubset(x, y, z, w...) = isstrictsubset(x, y) & isstrictsubset(y, z, w...)

isstrictsubset(x) = Base.Fix2(isstrictsubset, x)

"""
    isinterior(x, y)

Test whether `x` is in the interior of `y`.

Implement the `interior` function of the IEEE Standard 1788-2015
(Tables 9.3 and 10.3, and Sections 9.5, 10.5.10 and 12.12.9).

See also: [`issubset_interval`](@ref) and [`isstrictsubset`](@ref).
"""
isinterior(x::BareInterval, y::BareInterval) =
    _strictlessprime(inf(y), inf(x)) & _strictlessprime(sup(x), sup(y))

function isinterior(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return isinterior(bareinterval(x), bareinterval(y))
end
isinterior(x::Complex{<:Interval}, y::Complex{<:Interval}) = isinterior(real(x), real(y)) & isinterior(imag(x), imag(y))
isinterior(::Complex{<:Interval}, ::Interval) = false
isinterior(x::Interval, y::Complex{<:Interval}) = isinterior(x, real(y)) & isinterior(zero(x), imag(y))

function isinterior(x::AbstractVector, y::AbstractVector)
    n = length(x)
    m = length(y)
    n == m || return throw(DimensionMismatch("dimensions must match: x has length $n, y has length $m"))
    return all(t -> isinterior(t[1], t[2]), zip(x, y))
end

isinterior(x, y, z, w...) = isinterior(x, y) & isinterior(y, z, w...)

"""
    isdisjoint_interval(x, y, z...)

Test whether the given intervals have no common elements.

Implement the `disjoint` function of the IEEE Standard 1788-2015.
(Tables 9.3 and 10.3, and Sections 9.5, 10.5.10 and 12.12.9).
"""
isdisjoint_interval(x::BareInterval, y::BareInterval) =
    isempty_interval(x) | isempty_interval(y) | _strictlessprime(sup(y), inf(x)) | _strictlessprime(sup(x), inf(y))

function isdisjoint_interval(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return isdisjoint_interval(bareinterval(x), bareinterval(y))
end
isdisjoint_interval(x::Complex{<:Interval}, y::Complex{<:Interval}) = isdisjoint_interval(real(x), real(y)) | isdisjoint_interval(imag(x), imag(y))
isdisjoint_interval(x::Complex{<:Interval}, y::Interval) = isdisjoint_interval(real(x), y) | !in_interval(0, imag(x))
isdisjoint_interval(x::Interval, y::Complex{<:Interval}) = isdisjoint_interval(x, real(y)) | !in_interval(0, imag(y))

function isdisjoint_interval(x::AbstractVector, y::AbstractVector)
    n = length(x)
    m = length(y)
    n == m || return throw(DimensionMismatch("dimensions must match: x has length $n, y has length $m"))
    return any(t -> isdisjoint_interval(t[1], t[2]), zip(x, y))
end

isdisjoint_interval(x, y, z, w...) = _isdisjoint_interval(x, y, z, w...)

_isdisjoint_interval(x) = true
_isdisjoint_interval(x, y) = isdisjoint_interval(x, y)
_isdisjoint_interval(x, y, z, w...) = _isdisjoint_interval(x, y) && _isdisjoint_interval(x, z) && _isdisjoint_interval(x, w...) && _isdisjoint_interval(y, z, w...)

"""
    isweakless(x, y)

Test whether `inf(x) ≤ inf(y)` and `sup(x) ≤ sup(y)`, where `<` is replaced by
`≤` for infinite values.

Implement the `less` function of the IEEE Standard 1788-2015
(Table 10.3, and Sections 10.5.10 and 12.12.9).
"""
isweakless(x::BareInterval, y::BareInterval) = (inf(x) ≤ inf(y)) & (sup(x) ≤ sup(y))

function isweakless(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return isweakless(bareinterval(x), bareinterval(y))
end

"""
    isstrictless(x, y)

Test whether `inf(x) < inf(y)` and `sup(x) < sup(y)`, where `<` is replaced by
`≤` for infinite values.

Implement the `strictLess` function of the IEEE Standard 1788-2015
(Table 10.3, and Sections 10.5.10 and 12.12.9).
"""
isstrictless(x::BareInterval, y::BareInterval) = # this may be flavor dependent? Should _strictlessprime be < for cset flavor?
    _strictlessprime(inf(x), inf(y)) & _strictlessprime(sup(x), sup(y))

function isstrictless(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return isstrictless(bareinterval(x), bareinterval(y))
end

"""
    precedes(x, y)

Test whether any element of `x` is lesser or equal to every elements of `y`.

Implement the `precedes` function of the IEEE Standard 1788-2015
(Table 10.3, and Sections 10.5.10 and 12.12.9).
"""
precedes(x::BareInterval, y::BareInterval) = sup(x) ≤ inf(y)

function precedes(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return precedes(bareinterval(x), bareinterval(y))
end

"""
    strictprecedes(x, y)

Test whether any element of `x` is strictly lesser than every elements of `y`.

Implement the `strictPrecedes` function of the IEEE Standard 1788-2015
(Table 10.3, and Sections 10.5.10 and 12.12.9).
"""
strictprecedes(x::BareInterval, y::BareInterval) = isempty_interval(x) | isempty_interval(y) | (sup(x) < inf(y))

function strictprecedes(x::Interval, y::Interval)
    isnai(x) | isnai(y) && return false
    return strictprecedes(bareinterval(x), bareinterval(y))
end

"""
    in_interval(x, y)

Test whether `x` is an element of `y`.

Implement the `isMember` function of the IEEE Standard 1788-2015
(Sections 10.6.3 and 12.13.3).
"""
function in_interval(x::Number, y::BareInterval)
    isinf(x) && return contains_infinity(y)
    return inf(y) ≤ x ≤ sup(y)
end
in_interval(x::Complex, y::BareInterval) = in_interval(real(x), y) & iszero(imag(x))
in_interval(x::Interval, y::BareInterval) = throw(MethodError(in_interval, (x, y)))
in_interval(::BareInterval, ::BareInterval) =
    throw(ArgumentError("`in_interval` is purposely not supported for two interval arguments. See instead `issubset_interval`"))

function in_interval(x::Number, y::Interval)
    isnai(y) && return false
    return in_interval(x, bareinterval(y))
end
in_interval(x::Number, y::Complex{<:Interval}) = in_interval(x, real(y)) & in_interval(0, imag(y))
in_interval(x::Complex, y::Complex{<:Interval}) = in_interval(real(x), real(y)) & in_interval(imag(x), imag(y))
in_interval(::Interval, ::Interval) =
    throw(ArgumentError("`in_interval` is purposely not supported for two interval arguments. See instead `issubset_interval`"))

in_interval(x) = Base.Fix2(in_interval, x)

"""
    isempty_interval(x)

Test whether `x` contains no elements.

Implement the `isEmpty` function of the IEEE Standard 1788-2015
(Sections 10.5.10 and 12.12.9).
"""
isempty_interval(x::BareInterval{T}) where {T<:NumTypes} = (inf(x) == typemax(T)) & (sup(x) == typemin(T))

function isempty_interval(x::Interval)
    isnai(x) && return false
    return isempty_interval(bareinterval(x))
end
isempty_interval(x::Complex{<:Interval}) = isempty_interval(real(x)) | isempty_interval(imag(x))

isempty_interval(x::AbstractVector) = any(isempty_interval, x)

"""
    isentire_interval(x)

Test whether `x` is the entire real line.

Implement the `isEntire` function of the IEEE Standard 1788-2015
(Sections 10.5.10 and 12.12.9).
"""
isentire_interval(x::BareInterval{T}) where {T<:NumTypes} = (inf(x) == typemin(T)) & (sup(x) == typemax(T))

function isentire_interval(x::Interval)
    isnai(x) && return false
    return isentire_interval(bareinterval(x))
end
isentire_interval(x::Complex{<:Interval}) = isentire_interval(real(x)) & isentire_interval(imag(x))

"""
    isnai(x)

Test whether `x` is an NaI (Not an Interval).

Implement the `isNaI` function of the IEEE Standard 1788-2015 (Section 12.12.9).
"""
isnai(::BareInterval) = false

isnai(x::Interval) = decoration(x) == ill
isnai(x::Complex{<:Interval}) = isnai(real(x)) & isnai(imag(x))

"""
    isbounded(x)

Test whether `x` is empty or has finite bounds.
"""
isbounded(x::BareInterval) = (isfinite(inf(x)) & isfinite(sup(x))) | isempty_interval(x)

function isbounded(x::Interval)
    isnai(x) && return false
    return isbounded(bareinterval(x))
end
isbounded(x::Complex{<:Interval}) = isbounded(real(x)) & isbounded(imag(x))

"""
    isunbounded(x)

Test whether `x` is not empty and has infinite bounds.
"""
isunbounded(x::BareInterval) = !isbounded(x)

function isunbounded(x::Interval)
    isnai(x) && return false
    return isunbounded(bareinterval(x))
end
isunbounded(x::Complex{<:Interval}) = isunbounded(real(x)) | isunbounded(imag(x))

"""
    iscommon(x)

Test whether `x` is not empty and bounded.

Implement the `isCommonInterval` function of the IEEE Standard 1788-2015
(Sections 10.6.3 and 12.13.3).

!!! note
    This does not take into consideration the decoration of the interval.
"""
iscommon(x::BareInterval) = !(isentire_interval(x) | isempty_interval(x) | isunbounded(x))

function iscommon(x::Interval)
    isnai(x) && return false
    return iscommon(bareinterval(x))
end
iscommon(x::Complex{<:Interval}) = iscommon(real(x)) & iscommon(imag(x))

"""
    isatomic(x)

Test whether `x` is unable to be split. This occurs if the interval is empty,
or if its lower and upper bounds are equal, or if the bounds are consecutive
floating-point numbers.
"""
isatomic(x::BareInterval{<:AbstractFloat}) = isempty_interval(x) | (inf(x) == sup(x)) | (sup(x) == nextfloat(inf(x)))
isatomic(x::BareInterval{<:Rational}) = isempty_interval(x) | (inf(x) == sup(x))

function isatomic(x::Interval)
    isnai(x) && return false
    return isatomic(bareinterval(x))
end
isatomic(x::Complex{<:Interval}) = isatomic(real(x)) & isatomic(imag(x))

"""
    isthin(x)

Test whether `x` contains only a real.

Implement the `isSingleton` function of the IEEE Standard 1788-2015
(Sections 10.6.3 and 12.13.3).
"""
isthin(x::BareInterval) = inf(x) == sup(x)

function isthin(x::Interval)
    isnai(x) && return false
    return isthin(bareinterval(x))
end
isthin(x::Complex{<:Interval}) = isthin(real(x)) & isthin(imag(x))

"""
    isthin(x, y)

Test whether `x` contains only `y`.
"""
isthin(x::BareInterval, y::Number) = inf(x) == sup(x) == y
isthin(x::BareInterval, y::Complex) = isthin(x, real(y)) & iszero(imag(y))
isthin(::BareInterval, ::Interval) =
    throw(ArgumentError("`isthin` is purposely not supported for intervals. See instead `isequal_interval`"))

function isthin(x::Interval, y::Number)
    isnai(x) && return false
    return isthin(bareinterval(x), y)
end
isthin(x::Complex{<:Interval}, y::Number) = isthin(real(x), y) & isthinzero(imag(x))
isthin(x::Complex{<:Interval}, y::Complex) = isthin(real(x), real(y)) & isthin(imag(x), imag(y))

"""
    isthinzero(x)

Test whether `x` contains only zero.
"""
isthinzero(x::BareInterval) = iszero(inf(x)) & iszero(sup(x))

function isthinzero(x::Interval)
    isnai(x) && return false
    return isthinzero(bareinterval(x))
end
isthinzero(x::Complex{<:Interval}) = isthinzero(real(x)) & isthinzero(imag(x))

"""
    isthinone(x)

Test whether `x` contains only one.
"""
isthinone(x::BareInterval) = isone(inf(x)) & isone(sup(x))

function isthinone(x::Interval)
    isnai(x) && return false
    return isthinone(bareinterval(x))
end
isthinone(x::Complex{<:Interval}) = isthinone(real(x)) & isthinzero(imag(x))

"""
    isthininteger(x)

Test whether `x` contains only an integer.
"""
isthininteger(x::BareInterval) = (inf(x) == sup(x)) & isinteger(inf(x))

function isthininteger(x::Interval)
    isnai(x) && return false
    return isthininteger(bareinterval(x))
end
isthininteger(x::Complex{<:Interval}) = isthininteger(real(x)) & isthinzero(imag(x))

"""
    IntervalRounding

Interval rounding type.

Available rounding types:
- `:correct`: rounding via [RoundingEmulator.jl](https://github.com/JuliaIntervals/RoundingEmulator.jl)
and [CRlibm.jl](https://github.com/JuliaInterval/IntervalArithmetic.jl).
- `:none`: no rounding (non-rigorous numerics).
"""
struct IntervalRounding{T} end

#

_fround(f::Function, x, y, r) = _fround(f, default_rounding(), x, y, r)
_fround(f::Function, x, r)    = _fround(f, default_rounding(), x, r)

#

for (f, fname) ∈ ((:+, :add), (:-, :sub), (:*, :mul), (:/, :div))
    @eval begin
        _fround(::typeof($f), ::IntervalRounding, x::T, y::T, ::RoundingMode) where {T<:Rational} = $f(x, y) # exact operation

        _fround(::typeof($f), ::IntervalRounding{:correct}, x::T, y::T, ::RoundingMode{:Down}) where {T<:Union{Float32,Float64}} =
            RoundingEmulator.$(Symbol(fname, :_down))(x, y)
        _fround(::typeof($f), ::IntervalRounding{:correct}, x::T, y::T, ::RoundingMode{:Up}) where {T<:Union{Float32,Float64}} =
            RoundingEmulator.$(Symbol(fname, :_up))(x, y)
        function _fround(::typeof($f), ::IntervalRounding{:correct}, x::T, y::T, r::RoundingMode) where {T<:AbstractFloat}
            prec = max(precision(x), precision(y))
            bigx = BigFloat(x; precision = prec)
            bigy = BigFloat(y; precision = prec)
            bigz = BigFloat(; precision = prec)
            @ccall Base.MPFR.libmpfr.$(Symbol(:mpfr_, fname))(
                bigz::Ref{BigFloat},
                bigx::Ref{BigFloat},
                bigy::Ref{BigFloat},
                r::Base.MPFR.MPFRRoundingMode
            )::Int32
            return bigz
        end

        _fround(::typeof($f), ::IntervalRounding{:none}, x::T, y::T, ::RoundingMode) where {T<:AbstractFloat} = $f(x, y)
    end
end

#

_fround(::typeof(^), ::IntervalRounding, x::T, y::T, ::RoundingMode) where {T<:Rational} = ^(x, y) # exact operation
_fround(::typeof(^), ::IntervalRounding, x::Rational, n::Integer, ::RoundingMode) = ^(x, n) # exact operation

_fround(::typeof(^), ir::IntervalRounding, x::AbstractFloat, n::Integer, r::RoundingMode) =
    _fround(^, ir, promote(x, n)..., r)

function _fround(::typeof(^), ::IntervalRounding{:correct}, x::T, y::T, r::RoundingMode) where {T<:AbstractFloat}
    prec = max(precision(x), precision(y))
    bigx = BigFloat(x; precision = prec)
    bigy = BigFloat(y; precision = prec)
    bigz = BigFloat(; precision = prec)
    @ccall Base.MPFR.libmpfr.mpfr_pow(
        bigz::Ref{BigFloat},
        bigx::Ref{BigFloat},
        bigy::Ref{BigFloat},
        r::Base.MPFR.MPFRRoundingMode
    )::Int32
    return bigz
end

_fround(::typeof(^), ::IntervalRounding{:none}, x::T, y::T, ::RoundingMode) where {T<:AbstractFloat} = ^(x, y)

#

_fround(::typeof(inv), ::IntervalRounding, x::Rational, ::RoundingMode) = inv(x) # exact operation

_fround(::typeof(inv), ::IntervalRounding{:correct}, x::Union{Float32,Float64}, ::RoundingMode{:Down}) =
    RoundingEmulator.div_down(one(x), x)
_fround(::typeof(inv), ::IntervalRounding{:correct}, x::Union{Float32,Float64}, ::RoundingMode{:Up}) =
    RoundingEmulator.div_up(one(x), x)
function _fround(::typeof(inv), ::IntervalRounding{:correct}, x::AbstractFloat, r::RoundingMode)
    prec = precision(x)
    bigx = BigFloat(x; precision = prec)
    bigz = BigFloat(; precision = prec)
    @ccall Base.MPFR.libmpfr.mpfr_div(
        bigz::Ref{BigFloat},
        one(bigx)::Ref{BigFloat},
        bigx::Ref{BigFloat},
        r::Base.MPFR.MPFRRoundingMode
    )::Int32
    return bigz
end

_fround(::typeof(inv), ::IntervalRounding{:none}, x::AbstractFloat, ::RoundingMode) = inv(x)

#

_fround(::typeof(sqrt), ::IntervalRounding{:correct}, x::Union{Float32,Float64}, ::RoundingMode{:Down}) =
    RoundingEmulator.sqrt_down(x)
_fround(::typeof(sqrt), ::IntervalRounding{:correct}, x::Union{Float32,Float64}, ::RoundingMode{:Up}) =
    RoundingEmulator.sqrt_up(x)
function _fround(::typeof(sqrt), ::IntervalRounding{:correct}, x::AbstractFloat, r::RoundingMode)
    prec = precision(x)
    bigx = BigFloat(x; precision = prec)
    bigz = BigFloat(; precision = prec)
    @ccall Base.MPFR.libmpfr.mpfr_sqrt(
        bigz::Ref{BigFloat},
        bigx::Ref{BigFloat},
        r::Base.MPFR.MPFRRoundingMode
    )::Int32
    return bigz
end

_fround(::typeof(sqrt), ::IntervalRounding{:none}, x::AbstractFloat, ::RoundingMode) = sqrt(x)

#

function rootn end # defined in arithmetic/power.jl

function _fround(::typeof(rootn), ::IntervalRounding{:correct}, x::AbstractFloat, n::Integer, r::RoundingMode)
    prec = precision(x)
    bigx = BigFloat(x; precision = prec)
    bigz = BigFloat(; precision = prec)
    @ccall Base.MPFR.libmpfr.mpfr_rootn_ui(
        bigz::Ref{BigFloat},
        bigx::Ref{BigFloat},
        n::Culong,
        r::Base.MPFR.MPFRRoundingMode
    )::Int32
    return bigz
end

_fround(::typeof(rootn), ::IntervalRounding{:none}, x::AbstractFloat, n::Integer, ::RoundingMode) = x^(1//n)

#

function _fround(::typeof(atan), ::IntervalRounding{:correct}, x::T, y::T, r::RoundingMode) where {T<:AbstractFloat}
    prec = max(precision(x), precision(y))
    bigx = BigFloat(x; precision = prec)
    bigy = BigFloat(y; precision = prec)
    bigz = BigFloat(; precision = prec)
    @ccall Base.MPFR.libmpfr.mpfr_atan2(
        bigz::Ref{BigFloat},
        bigx::Ref{BigFloat},
        bigy::Ref{BigFloat},
        r::Base.MPFR.MPFRRoundingMode
    )::Int32
    return bigz
end

_fround(::typeof(atan), ::IntervalRounding{:none}, x::T, y::T, ::RoundingMode) where {T<:AbstractFloat} = atan(x, y)

#

for f ∈ (:cbrt, :exp2, :exp10, :cot, :sec, :csc, :tanh, :coth, :sech, :csch, :asinh, :acosh, :atanh)
    @eval begin
        function _fround(::typeof($f), ::IntervalRounding{:correct}, x::AbstractFloat, r::RoundingMode)
            prec = precision(x)
            bigx = BigFloat(x; precision = prec)
            bigz = BigFloat(; precision = prec)
            @ccall Base.MPFR.libmpfr.$(Symbol(:mpfr_, f))(
                bigz::Ref{BigFloat},
                bigx::Ref{BigFloat},
                r::Base.MPFR.MPFRRoundingMode
            )::Int32
            return bigz
        end

        _fround(::typeof($f), ::IntervalRounding{:none}, x::AbstractFloat, ::RoundingMode) = $f(x)
    end
end

for (f, g) ∈ ((:acot, :atan), (:acoth, :atanh))
    @eval begin
        function _fround(::typeof($f), ir::IntervalRounding{:correct}, x::AbstractFloat, r::RoundingMode{:Down})
            prec = precision(x)
            bigx = BigFloat(x; precision = prec + 10)
            bigz = BigFloat(; precision = prec + 10)
            @ccall Base.MPFR.libmpfr.mpfr_div(
                bigz::Ref{BigFloat},
                one(bigx)::Ref{BigFloat},
                bigx::Ref{BigFloat},
                RoundUp::Base.MPFR.MPFRRoundingMode
            )::Int32
            bigw = _fround($g, ir, bigz, r)
            return BigFloat(bigw, r; precision = prec)
        end
        function _fround(::typeof($f), ir::IntervalRounding{:correct}, x::AbstractFloat, r::RoundingMode{:Up})
            prec = precision(x)
            bigx = BigFloat(x; precision = prec + 32)
            bigz = BigFloat(; precision = prec + 32)
            @ccall Base.MPFR.libmpfr.mpfr_div(
                bigz::Ref{BigFloat},
                one(bigx)::Ref{BigFloat},
                bigx::Ref{BigFloat},
                RoundDown::Base.MPFR.MPFRRoundingMode
            )::Int32
            bigw = _fround($g, ir, bigz, r)
            return BigFloat(bigw, r; precision = prec)
        end

        _fround(::typeof($f), ::IntervalRounding{:none}, x::AbstractFloat, ::RoundingMode) = $f(x)
    end
end

# CRlibm functions

for f ∈ CRlibm.functions
    if f !== :atanpi # currently not defined in IntervalArithmetic
        @eval begin
            _fround(::typeof($f), ::IntervalRounding{:correct}, x::AbstractFloat, r::RoundingMode) = CRlibm.$f(x, r)

            _fround(::typeof($f), ::IntervalRounding{:none}, x::AbstractFloat, r::RoundingMode) = $f(x)
        end
    end
end





"""
    @round(T, ex1, ex2)

Macro for internal use that creates an interval by rounding down `ex1` and
rounding up `ex2`. Each expression may consist of only a *single* operation that
needs rounding, e.g. `a.lo + b.lo` or `sin(a.lo)`. It also handles `min(...)`
and `max(...)`, where the arguments are each themselves single operations.

The macro uses the internal `_round_expr` function to transform e.g. `a + b` into
`+(a, b, RoundDown)`.
"""
macro round(T, ex1, ex2)
    return :(_unsafe_bareinterval($(esc(T)), $(_round_expr(ex1, RoundDown)), $(_round_expr(ex2, RoundUp))))
end

"""
    _round_expr(ex::Expr, rounding_mode::RoundingMode)

Transforms a single expression by applying a rounding mode, e.g.

- `a + b` into `+(a, b, RoundDown)`
- `sin(a)` into `sin(a, RoundDown)`
"""
function _round_expr(ex::Expr, r::RoundingMode)
    if ex.head == :call
        op = ex.args[1]
        if op ∈ (:min, :max)
            mapped_args = _round_expr.(ex.args[2:end], r)
            return :( $op($(mapped_args...)) )
        elseif op ∈ (:typemin, :typemax, :one, :zero)
            return :( $(esc(ex)) )
        elseif length(ex.args) == 3 # binary operator
            if op == :_unbounded_mul
                return :( _unbounded_mul($(esc(ex.args[2])), $(esc(ex.args[3])), $r) )
            else
                return :( _fround($op, $(esc(ex.args[2])), $(esc(ex.args[3])), $r) )
            end
        elseif op ∈ (:+, :-) # unary operator that does not need rounding
            return :( $(esc(ex)) )
        else # unary operator
            return :( _fround($op, $(esc(ex.args[2])), $r) )
        end
    else
        return :( $(esc(ex)) )
    end
end

_round_expr(ex, _) = ex

module IntervalArithmeticRecipesBaseExt

using IntervalArithmetic, RecipesBase

@recipe function f(v::AbstractVector{<:Interval})
    if length(v) == 2

        seriestype := :shape
        seriesalpha --> 0.5

        x, y = v

        return [inf(x), sup(x), sup(x), inf(x), inf(x)], [inf(y), inf(y), sup(y), sup(y), inf(y)]

    elseif length(v) == 3

        @series begin
            seriestype := :path
            linecolor --> :gray
            linewidth --> 0.5

            x, y, z = v

            xe = [inf(x), sup(x), sup(x), inf(x), inf(x), inf(x), inf(x), inf(x), inf(x), inf(x), sup(x), sup(x), sup(x), sup(x), sup(x), sup(x), inf(x)]
            ye = [inf(y), inf(y), inf(y), inf(y), inf(y), sup(y), sup(y), inf(y), inf(y), sup(y), sup(y), inf(y), sup(y), sup(y), inf(y), sup(y), sup(y)]
            ze = [inf(z), inf(z), sup(z), sup(z), inf(z), inf(z), sup(z), sup(z), inf(z), inf(z), inf(z), inf(z), inf(z), sup(z), sup(z), sup(z), sup(z)]

            return xe, ye, ze
        end

        @series begin
            seriestype := :mesh3d
            primary := false
            connections --> [(1,2,3), (4,2,3), (4,7,8), (7,5,6), (2,4,7), (1,6,2), (2,7,6), (7,8,5), (4,8,5), (4,5,3), (1,6,3), (6,3,5)]
            proj_type --> :persp
            seriesalpha --> 0.5
            linewidth --> -1.0

            x, y, z = v

            xp = [inf(x), inf(x), inf(x), inf(x), sup(x), sup(x), sup(x), sup(x)]
            yp = [inf(y), sup(y), inf(y), sup(y), inf(y), inf(y), sup(y), sup(y)]
            zp = [inf(z), inf(z), sup(z), sup(z), sup(z), inf(z), inf(z), sup(z)]

            return xp, yp, zp
        end

    else
        return throw(ArgumentError("length must 2 or 3"))
    end
end

@recipe function f(v::AbstractVector{<:AbstractVector{<:Interval}})
    if all(vᵢ -> length(vᵢ) == 2, v)

        seriestype := :shape
        seriesalpha --> 0.5

        xs = Float64[]
        ys = Float64[]

        for vᵢ ∈ v
            x, y = vᵢ
            append!(xs, [inf(x), sup(x), sup(x), inf(x), inf(x), NaN])
            append!(ys, [inf(y), inf(y), sup(y), sup(y), inf(y), NaN])
        end

        return xs, ys

    elseif all(vᵢ -> length(vᵢ) == 3, v)

        @series begin
            seriestype := :path
            linecolor --> :gray
            linewidth --> 0.5

            xs = Float64[]
            ys = Float64[]
            zs = Float64[]

            for vᵢ ∈ v
                x, y, z = vᵢ
                xe = [inf(x), sup(x), sup(x), inf(x), inf(x), inf(x), inf(x), inf(x), inf(x), inf(x), sup(x), sup(x), sup(x), sup(x), sup(x), sup(x), inf(x)]
                ye = [inf(y), inf(y), inf(y), inf(y), inf(y), sup(y), sup(y), inf(y), inf(y), sup(y), sup(y), inf(y), sup(y), sup(y), inf(y), sup(y), sup(y)]
                ze = [inf(z), inf(z), sup(z), sup(z), inf(z), inf(z), sup(z), sup(z), inf(z), inf(z), inf(z), inf(z), inf(z), sup(z), sup(z), sup(z), sup(z)]
                append!(xs, xe)
                append!(ys, ye)
                append!(zs, ze)
            end

            return xs, ys, zs
        end

        @series begin
            seriestype := :mesh3d
            primary := false
            connections --> [(1,2,3), (4,2,3), (4,7,8), (7,5,6), (2,4,7), (1,6,2), (2,7,6), (7,8,5), (4,8,5), (4,5,3), (1,6,3), (6,3,5)]
            proj_type --> :persp
            seriesalpha --> 0.5
            linewidth --> -1.0

            xs = Vector{Float64}[]
            ys = Vector{Float64}[]
            zs = Vector{Float64}[]

            for vᵢ ∈ v
                x, y, z = vᵢ
                push!(xs, [inf(x), inf(x), inf(x), inf(x), sup(x), sup(x), sup(x), sup(x)])
                push!(ys, [inf(y), sup(y), inf(y), sup(y), inf(y), inf(y), sup(y), sup(y)])
                push!(zs, [inf(z), inf(z), sup(z), sup(z), sup(z), inf(z), inf(z), sup(z)])
            end

            return xs, ys, zs
        end

    else
        return throw(ArgumentError("length must 2 or 3"))
    end
end

end

@testset "minimal_intersection_test" begin

    @test intersect_interval(bareinterval(1.0,3.0), bareinterval(2.1,4.0)) === bareinterval(2.1,3.0)

    @test intersect_interval(bareinterval(1.0,3.0), bareinterval(3.0,4.0)) === bareinterval(3.0,3.0)

    @test intersect_interval(bareinterval(1.0,3.0), emptyinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(entireinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test intersect_interval(bareinterval(1.0,3.0), entireinterval(BareInterval{Float64})) === bareinterval(1.0,3.0)

end

@testset "minimal_intersection_dec_test" begin

    @test intersect_interval(interval(bareinterval(1.0,3.0), com), interval(bareinterval(2.1,4.0), com)) === interval(bareinterval(2.1,3.0), trv)

    @test intersect_interval(interval(bareinterval(1.0,3.0), dac), interval(bareinterval(3.0,4.0), def)) === interval(bareinterval(3.0,3.0), trv)

    @test intersect_interval(interval(bareinterval(1.0,3.0), def), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test intersect_interval(interval(entireinterval(BareInterval{Float64}), dac), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test intersect_interval(interval(bareinterval(1.0,3.0), dac), interval(entireinterval(BareInterval{Float64}), dac)) === interval(bareinterval(1.0,3.0), trv)

end

@testset "minimal_convex_hull_test" begin

    @test hull(bareinterval(1.0,3.0), bareinterval(2.1,4.0)) === bareinterval(1.0,4.0)

    @test hull(bareinterval(1.0,1.0), bareinterval(2.1,4.0)) === bareinterval(1.0,4.0)

    @test hull(bareinterval(1.0,3.0), emptyinterval(BareInterval{Float64})) === bareinterval(1.0,3.0)

    @test hull(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test hull(bareinterval(1.0,3.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

end

@testset "minimal_convex_hull_dec_test" begin

    @test hull(interval(bareinterval(1.0,3.0), trv), interval(bareinterval(2.1,4.0), trv)) === interval(bareinterval(1.0,4.0), trv)

    @test hull(interval(bareinterval(1.0,1.0), trv), interval(bareinterval(2.1,4.0), trv)) === interval(bareinterval(1.0,4.0), trv)

    @test hull(interval(bareinterval(1.0,3.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(bareinterval(1.0,3.0), trv)

    @test hull(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test hull(interval(bareinterval(1.0,3.0), trv), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

end

using BenchmarkTools
using IntervalArithmetic

import MPFI
import Random

MPFI.BigInterval(x::ExactReal) = MPFI.BigInterval(x.value)
Base.:(^)(x::MPFI.BigInterval, y::ExactReal) = x^y.value

Random.seed!(0)

basic_arithmetic = [+, *, -, /]
basic_functions = [exp, cosh, sinh, tanh, inv, sqrt, abs, log, sin, cos, tan, acos, asin, atan]

interval_constructors = Dict(
    "bareinterval" => bareinterval,
    "interval" => interval,
    "BigFloat bareinterval" => (x, y) -> bareinterval(BigFloat, x, y),
    "BigFloat interval" => (x, y) -> interval(BigFloat, x, y),
    "BigFloat MPFI" => MPFI.BigInterval
)

suites = ["basics", "Dietmar-Ratz"]

bounds = map(range(0.01, 10 ; length = 100)) do i
    x = i * randn()
    y = i * randn()
    x > y && return (y, x)
    return (x, y)
end

SUITE = BenchmarkGroup()

for (name, T) in interval_constructors
    xx = [T(x, y) for (x, y) in bounds]
    yy = reverse(xx)

    SUITE[name] = BenchmarkGroup(split(name))
    SUITE[name]["basics"] = BenchmarkGroup(["arithmetic"])
    SUITE[name]["Dietmar-Ratz"] = BenchmarkGroup(["arithmetic"])

    for f in basic_functions
        SUITE[name]["basics"][string(f)] = @benchmarkable ($f).($xx)
    end

    for op in basic_arithmetic
        SUITE[name]["basics"][string(op)] = @benchmarkable ($op).($xx, $yy)
    end
end

using Test
using IntervalArithmetic
using Aqua

@testset "Aqua tests (performance)" begin
    # This tests that we don't accidentally run into
    # https://github.com/JuliaLang/julia/issues/29393
    # Aqua.test_unbound_args(IntervalArithmetic)
    ua = Aqua.detect_unbound_args_recursively(IntervalArithmetic)
    @test length(ua) == 0

    # See: https://github.com/SciML/OrdinaryDiffEq.jl/issues/1750
    # Test that we're not introducing method ambiguities across deps
    ambs = Aqua.detect_ambiguities(IntervalArithmetic; recursive = true)
    pkg_match(pkgname, pkdir::Nothing) = false
    pkg_match(pkgname, pkdir::AbstractString) = occursin(pkgname, pkdir)
    filter!(x -> pkg_match("IntervalArithmetic", pkgdir(last(x).module)), ambs)
    for method_ambiguity ∈ ambs
        @show method_ambiguity
    end
    @test length(ambs) == 0
end

@testset "Aqua tests (additional)" begin
    Aqua.test_all(IntervalArithmetic; ambiguities = VERSION ≥ v"1.11")
end

"""
    Domain{LeftBound, RightBound}(lo, hi)

The domain of a function.

`LeftBound` and `RightBound` must be symbols and are either `:closed` or
`:open` determining if the corresponding endpoint is (respectively)
included or not in the domain.

If `hi > lo`, the domain is considered to be empty.
"""
struct Domain{L, R, T, S}
    lo::T
    hi::S

    function Domain{L, R, T, S}(lo::T, hi::S) where {L, R, T, S}
        (!(L in (:open, :closed)) || !(R in (:open, :closed))) && throw(ErrorException(
            "Domain bound must be either :open or :closed, got $L and $R instead"
        ))
        return new{L, R, T, S}(lo, hi)
    end
end

Domain{L, R}(lo::T, hi::S) where {T, S, L, R} = Domain{L, R, T, S}(lo, hi)
Domain(lo::Tuple, hi::Tuple) = Domain{lo[2], hi[2]}(lo[1], hi[1])
Domain(X::Interval) = Domain{:closed, :closed}(inf(X), sup(X))
Domain() = Domain{:open, :open}(Inf, -Inf)

lowerbound(x::Domain{L, R}) where {L, R} = (x.lo, L)
upperbound(x::Domain{L, R}) where {L, R} = (x.hi, R)

inf(x::Domain) = x.lo
sup(x::Domain) = x.hi

"""
    rightof(val, lowerbound)

Determine if a value is on the right of a lower bound.
"""
function rightof(x::Real, (val, bound))
    bound == :closed && return val <= x
    return val < x
end

function rightof((val1, bound1), (val2, bound2))
    if val1 < val2 || (val1 == val2 && bound1 == bound2 == :closed)
        return false
    end

    return true
end

"""
    leftof(val, upperbound)

Determine if a value is on the left of an upper bound.
"""
function leftof(x::Real, (val, bound))
    bound == :closed && return x <= val
    return x < val
end

function leftof((val1, bound1), (val2, bound2))
    if val2 < val1 || (val1 == val2 && bound1 == bound2 == :closed)
        return false
    end

    return true
end

function leftof(d1::Domain, d2::Domain)
    val1, bound1 = upperbound(d1)
    val2, bound2 = lowerbound(d2)

    val1 == val2 && return !(bound1 == bound2 == :closed)
    return val1 < val2
end

in_domain(x::Real, domain::Domain) = rightof(x, lowerbound(domain)) && leftof(x, upperbound(domain))

function intersect_domain(d1::Domain, d2::Domain)
    left = max(lowerbound(d1), lowerbound(d2))
    right = min(upperbound(d1), upperbound(d2))

    left > right && return Domain()
    return Domain(left, right)
end

function isempty_domain(domain::Domain)
    lo, lobound = lowerbound(domain)
    hi, hibound = upperbound(domain)

    lo == hi && return !(lobound == hibound == :closed)
    return lo > hi
end

"""
    Constant(value)

A constant function compatible with interval arithmetic.

Return an interval containing only the value for an interval input,
and the value directly otherwise.

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> c = Constant(1.2)
Constant{Float64}(1.2)

julia> c(22.2)
1.2

julia> c(interval(0, 1.3))
Interval{Float64}(1.2, 1.2, com, true)
```

Note that this is not equivalent to `Returns(value)` from base,
which always outputs `value`, even for an interval input.
This can shortcircuit the propagation of intervals in the computation
and lose the associated guarantee of correctness.
"""
struct Constant{T}
    value::T
end

(constant::Constant)(::Any) = constant.value
(constant::Constant)(::Interval) = interval(constant.value)

"""
    Piecewise(pairs... ; continuity = fill(-1, length(pairs) - 1))

A function defined by pieces (each associating a domain to a function).
Support both intervals and standard numbers.

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> myabs = Piecewise(
          Domain{:open, :closed}(-Inf, 0) => x -> -x,
          Domain{:open, :open}(0, Inf) => identity
       );

julia> myabs(-22.3)
22.3

julia> myabs(interval(-5, 5))
Interval{Float64}(0.0, 5.0, def, true)
```

For constant pieces, it is recommended to use `Constant`
for full compatibility with intervals.

The domains must be specified in increasing order and must not overlap.

The `continuity` optional argument takes a vector of `N - 1` integers
(where  `N` is the number of domains)
determining how the piecewise function behaves at the endpoints between
the subdomains.
The possibility are:
- `-1` : the function is discontinuous between the domains.
- `0` : the function is continuous but not differentiable between the domains.
- `n > 0` : the function is `n` times continuously differentiable between the
    domains. This only matter when using `ForwardDiff` to compute derivative
    of the function.

This information is used to determine the decoration of intervals that
covers the endpoint of several domains.

If an input interval goes outside the domain of definition of the piecewise
function, the output will always have the trivial (`trv`) decoration.
For standard number, it throws a `DomainError`.

The piecewise function can have a gap between two pieces.
In this case, the `continuity` optional argument is ignored,
and interval spanning over the gap always as the `trv` decoration.
"""
struct Piecewise{N, M, D<:NTuple{N, Domain}, F<:NTuple{N, Any}, S<:NTuple{M, Real}}
    domains::D
    fs::F
    continuity::NTuple{M, Int}
    singularities::S

    function Piecewise(
            domains::NTuple{N, Domain},
            fs::NTuple{N, Any},
            continuity::NTuple{M, Int},
            singularities::NTuple{M, Real}) where {N, M}

        N != M + 1 && throw(ArgumentError(
                "a Piecewise function with N pieces must have N - 1 singularities. " *
                "Given: $N pieces and $M singularities."
        ))

        return new{N, M, typeof(domains), typeof(fs), typeof(singularities)}(domains, fs, continuity, singularities)
    end
end

function Piecewise(
        domains::NTuple{N, Domain},
        fs::NTuple{N, Any},
        continuity::NTuple{M, Int} = ntuple(i -> -1, Vla(N-1))) where {N, M}

    if length(domains) != length(fs)
        throw(ArgumentError("the number of domains and the number of functions don't match"))
    end

    if length(domains) - 1 != length(continuity)
        n = length(domains)
        throw(ArgumentError("$(length(sub)) junction points but $(n - 1) are expected based on the number of domains ($n)"))
    end

    for k in 1:length(domains) - 1
        s1 = domains[k]
        s2 = domains[k + 1]

        if !leftof(s1, s2)
           throw(ArgumentError("domains are either not ordered or not disjoint"))
        end
    end

    singularities = sup.(domains[1:end-1])

    return Piecewise(Tuple(domains), Tuple(fs), Tuple(continuity), Tuple(singularities))
end

function Piecewise(
        pairs::Vararg{Pair, N} ;
        continuity = ntuple(i -> -1, Val(N - 1))) where N

    return Piecewise(first.(pairs), last.(pairs), Tuple(continuity))
end

domains(piecewise::Piecewise) = piecewise.domains
pieces(piecewise::Piecewise) = zip(domains(piecewise), piecewise.fs)

function discontinuities(piecewise::Piecewise, order = 0)
    return [s for (s, C) in zip(piecewise.singularities, piecewise.continuity) if C .< order]
end

function domain_string(domain::Domain{L, R}) where {L, R}
    left = (L == :closed) ? "[" : "("
    right = (R == :closed) ? "]" : ")"

    return "$left$(domain.lo), $(domain.hi)$right"
end

function domain_string(piecewise::Piecewise)
    join(domain_string.(domains(piecewise)), " ∪ ")
end

function Base.show(io::IO, ::MIME"text/plain", piecewise::Piecewise)
    n = length(pieces(piecewise))
    print(io, "Piecewise function with $n pieces:")

    for (domain, f) in pieces(piecewise)
        println(io)
        print(io, "  $(domain_string(domain)) -> $(repr(f))")
    end
end

function in_domain(domain, piecewise)
    rightof(upperbound(domain), upperbound(domains(piecewise)[end])) && return false

    # This relies on the fact that domains are ordered
    lo = lowerbound(domain)

    for domain in domains(piecewise)
        if !rightof(lo, lowerbound(domain))
            return false
        end

        val, bound = upperbound(domain)

        val > upperbound(domain)[1] && break

        if bound == :closed
            lo = (val, :open)
        else
            lo = (val, :closed)
        end
    end

    return true
end

overlap_domain(domain, piecewise) = any(!isempty_domain, intersect_domain.(Ref(domain), domains(piecewise)))

function (piecewise::Piecewise)(X::Interval{T}) where {T}
    input_domain = Domain(X)
    !overlap_domain(input_domain, piecewise) && return emptyinterval(T)

    if !in_domain(input_domain, piecewise)
        dec = trv
    elseif any(x -> in_domain(x, input_domain), discontinuities(piecewise))
        dec = def
    else
        dec = com
    end

    piece_outputs = Interval{T}[]
    for (piece_domain, f) in pieces(piecewise)
        piece_input = intersect_domain(input_domain, piece_domain)
        isempty_domain(piece_input) && continue
        push!(piece_outputs, f(interval(inf(piece_input), sup(piece_input), decoration(X))))
    end

    dec = min(dec, minimum(decoration.(piece_outputs)))
    return IntervalArithmetic.setdecoration(reduce(hull, piece_outputs), dec)
end

function (piecewise::Piecewise)(x::Real)
    for (domain, f) in pieces(piecewise)
        (in_domain(x, domain)) && return f(x)
    end
    throw(DomainError(x, "piecewise function was called outside of its domain $(domain_string(piecewise))"))
end

@testset "rad2deg/deg2rad" begin
    @test issubset_interval(interval(180, 360), rad2deg(interval(π, 2π)))
    @test issubset_interval(interval(π, interval(2)*interval(π)), deg2rad(interval(180, 360)))
end

@testset "sin" begin
    @test isequal_interval(sin(interval(0.5)), interval(0.47942553860420295, 0.47942553860420301))
    @test isequal_interval(sin(interval(0.5, 1.67)), interval(4.7942553860420295e-01, 1.0))
    @test isequal_interval(sin(interval(1.67, 3.2)), interval(-5.8374143427580093e-02, 9.9508334981018021e-01))
    @test isequal_interval(sin(interval(2.1, 5.6)), interval(-1.0, 0.8632093666488738))
    @test isequal_interval(sin(interval(0.5, 8.5)), interval(-1.0, 1.0))
    @test isequal_interval(sin(interval(Float64, -4.5, 0.1)), interval(-1.0, 0.9775301176650971))
    @test isequal_interval(sin(interval(Float64, 1.3, 6.3)), interval(-1.0, 1.0))

    @test issubset_interval(sin(interval(BigFloat, 0.5, 0.5)), sin(interval(0.5)))
    @test issubset_interval(sin(interval(BigFloat, 0.5, 1.67)), sin(interval(0.5, 1.67)))
    @test issubset_interval(sin(interval(BigFloat, 1.67, 3.2)), sin(interval(1.67, 3.2)))
    @test issubset_interval(sin(interval(BigFloat, 2.1, 5.6)), sin(interval(2.1, 5.6)))
    @test issubset_interval(sin(interval(BigFloat, 0.5, 8.5)), sin(interval(0.5, 8.5)))
    @test issubset_interval(sin(interval(BigFloat, -4.5, 0.1)), sin(interval(-4.5, 0.1)))
    @test issubset_interval(sin(interval(BigFloat, 1.3, 6.3)), sin(interval(1.3, 6.3)))

    #

    z = interval(3, 1e-7; format = :midpoint) + interval(4, 1e-7; format = :midpoint) * interval(im)
    @test issubset_interval(sin(z), complex(sin(real(z)) * cosh(imag(z)), sinh(imag(z)) * cos(real(z))))
end

@testset "cos" begin
    @test isequal_interval(cos(interval(0.5)), interval(0.87758256189037265, 0.87758256189037276))
    @test isequal_interval(cos(interval(2.1, 5.6)), interval(-1.0, 0.7755658785102496))
    @test isequal_interval(cos(interval(0.5, 8.5)), interval(-1.0, 1.0))
    @test isequal_interval(cos(interval(1.67, 3.2)), interval(-1.0, -0.09904103659872801))

    @test issubset_interval(cos(interval(BigFloat, 0.5, 0.5)), cos(interval(0.5)))
    @test issubset_interval(cos(interval(BigFloat, 0.5, 1.67)), cos(interval(0.5, 1.67)))
    @test issubset_interval(cos(interval(BigFloat, 1.67, 3.2)), cos(interval(1.67, 3.2)))
    @test issubset_interval(cos(interval(BigFloat, 2.1, 5.6)), cos(interval(2.1, 5.6)))
    @test issubset_interval(cos(interval(BigFloat, 0.5, 8.5)), cos(interval(0.5, 8.5)))
    @test issubset_interval(cos(interval(BigFloat, -4.5, 0.1)), cos(interval(-4.5, 0.1)))
    @test issubset_interval(cos(interval(BigFloat, 1.3, 6.3)), cos(interval(1.3, 6.3)))

    k = [interval(0.0,0.0625), interval(0.0625,0.125), interval(0.0,0.125)]
    x = (k[1] * 4 + k[2] * 4 + k[3] * 4)
    @test isequal_interval(cos(2 * π * x), interval(-1, 1))
    @test isequal_interval(cospi(2x), interval(-1, 1))
end

@testset "sinpi" begin
    @test isempty_interval(sinpi(emptyinterval()))
    @test issubset_interval(interval(-1 , 0), sinpi(interval(1, 2)))
    @test isequal_interval(sinpi(interval(0.5, 1.5)), interval(-1 , 1))
    @test issubset_interval(interval(1/sqrt(2) , 1), sinpi(interval(0.25, 0.75)))
    @test issubset_interval(interval(-1/sqrt(2) , 1/sqrt(2)), sinpi(interval(-0.25, 0.25)))
    if Int == Int32 && VERSION < v"1.10"
        @test in_interval(0, sinpi(interval(1.0)))
        @test in_interval(0, sinpi(interval(2.0)))
        @test in_interval(1, sinpi(interval(0.5)))
        @test in_interval(-1, sinpi(interval(1.5)))
    else
        @test isthin(sinpi(interval(1.0)), 0)
        @test isthin(sinpi(interval(2.0)), 0)
        @test isthin(sinpi(interval(0.5)), 1)
        @test isthin(sinpi(interval(1.5)), -1)
    end
end

@testset "sind" begin
    @test isempty_interval(sind(emptyinterval()))
    @test issubset_interval(interval(-1 , 0), sind(interval(180, 360)))
    @test isequal_interval(sind(interval(90, 270)), interval(-1 , 1))
    @test issubset_interval(interval(1/sqrt(2) , 1), sind(interval(45, 135)))
    @test issubset_interval(interval(-1/sqrt(2) , 1/sqrt(2)), sind(interval(-45, 45)))
    if Int == Int32 && VERSION < v"1.10"
        @test in_interval(0, sind(interval(180)))
        @test in_interval(0, sind(interval(360)))
        @test in_interval(1, sind(interval(90)))
        @test in_interval(-1, sind(interval(270)))
    else
        @test isthin(sind(interval(180)), 0)
        @test isthin(sind(interval(360)), 0)
        @test isthin(sind(interval(90)), 1)
        @test isthin(sind(interval(270)), -1)
    end
end

@testset "cospi" begin
    @test isempty_interval(cospi(emptyinterval()))
    @test isequal_interval(cospi(interval(1, 2)), interval(-1 , 1))
    @test issubset_interval(interval(-1 , 0), cospi(interval(0.5, 1.5)))
    @test issubset_interval(interval(-1/sqrt(2) , 1/sqrt(2)), cospi(interval(0.25, 0.75)))
    @test isequal_interval(cospi(interval(-0.25, 0.25)), interval(1/sqrt(2) , 1))
    if Int == Int32 && VERSION < v"1.10"
        @test in_interval(-1, cospi(interval(1.0)))
        @test in_interval(1, cospi(interval(2.0)))
        @test in_interval(0, cospi(interval(0.5)))
        @test in_interval(0, cospi(interval(1.5)))
    else
        @test isthin(cospi(interval(1.0)), -1)
        @test isthin(cospi(interval(2.0)), 1)
        @test isthin(cospi(interval(0.5)), 0)
        @test isthin(cospi(interval(1.5)), 0)
    end
end

@testset "cosd" begin
    @test isempty_interval(cosd(emptyinterval()))
    @test isequal_interval(cosd(interval(180, 360)), interval(-1 , 1))
    @test issubset_interval(interval(-1 , 0), cosd(interval(90, 270)))
    @test issubset_interval(interval(-1/sqrt(2) , 1/sqrt(2)), cosd(interval(45, 135)))
    @test isequal_interval(cosd(interval(-45, 45)), interval(1/sqrt(2) , 1))
    if Int == Int32 && VERSION < v"1.10"
        @test in_interval(-1, cosd(interval(180)))
        @test in_interval(1, cosd(interval(360)))
        @test in_interval(0, cosd(interval(90)))
        @test in_interval(0, cosd(interval(270)))
    else
        @test isthin(cosd(interval(180)), -1)
        @test isthin(cosd(interval(360)), 1)
        @test isthin(cosd(interval(90)), 0)
        @test isthin(cosd(interval(270)), 0)
    end
end

@testset "sincospi" begin
    x = sincospi(emptyinterval())
    @test isempty_interval(x[1]) & isempty_interval(x[2])
    x = sincospi(interval(1, 2))
    @test issubset_interval(interval(-1, 0), x[1]) & isequal_interval(x[2], interval(-1, 1))
    x = sincospi(interval(0.5, 1.5))
    @test isequal_interval(x[1], interval(-1, 1)) & issubset_interval(interval(-1, 0), x[2])
    x = sincospi(interval(0.25, 0.75))
    @test issubset_interval(interval(1/sqrt(2), 1), x[1]) & issubset_interval(interval(-1/sqrt(2), 1/sqrt(2)), x[2])
    x = sincospi(interval(-0.25, 0.25))
    @test issubset_interval(interval(-1/sqrt(2), 1/sqrt(2)), x[1]) & isequal_interval(x[2], interval(1/sqrt(2), 1))
end

@testset "sincosd" begin
    x = sincosd(emptyinterval())
    @test isempty_interval(x[1]) & isempty_interval(x[2])
    x = sincosd(interval(180, 380))
    @test issubset_interval(interval(-1, 0), x[1]) & isequal_interval(x[2], interval(-1, 1))
    x = sincosd(interval(90, 270))
    @test isequal_interval(x[1], interval(-1, 1)) & issubset_interval(interval(-1, 0), x[2])
    x = sincosd(interval(45, 135))
    @test issubset_interval(interval(1/sqrt(2), 1), x[1]) & issubset_interval(interval(-1/sqrt(2), 1/sqrt(2)), x[2])
    x = sincosd(interval(-45, 45))
    @test issubset_interval(interval(-1/sqrt(2), 1/sqrt(2)), x[1]) & isequal_interval(x[2], interval(1/sqrt(2), 1))
end

@testset "tan" begin
    @test isequal_interval(tan(interval(0.5)), interval(0.54630248984379048, 0.5463024898437906))
    @test isequal_interval(tan(interval(0.5, 1.67)), entireinterval())
    @test isequal_interval(tan(interval(1.67, 3.2)), interval(-10.047182299210307, 0.05847385445957865))
    @test isequal_interval(tan(interval(6.638314112824137, 8.38263151220128)), entireinterval())  # https://github.com/JuliaIntervals/IntervalArithmetic.jl/pull/20

    @test issubset_interval(tan(interval(BigFloat, 0.5, 0.5)), tan(interval(0.5)))
    @test isequal_interval(tan(interval(BigFloat, 0.5, 1.67)), entireinterval(BigFloat))
    @test issubset_interval(tan(interval(BigFloat, 0.5, 1.67)), tan(interval(0.5, 1.67)))
    @test issubset_interval(tan(interval(BigFloat, 1.67, 3.2)), tan(interval(1.67, 3.2)))
    @test issubset_interval(tan(interval(BigFloat, 2.1, 5.6)), tan(interval(2.1, 5.6)))
    @test issubset_interval(tan(interval(BigFloat, 0.5, 8.5)), tan(interval(0.5, 8.5)))
    @test issubset_interval(tan(interval(BigFloat, -4.5, 0.1)), tan(interval(-4.5, 0.1)))
    @test issubset_interval(tan(interval(BigFloat, 1.3, 6.3)), tan(interval(1.3, 6.3)))

end

@testset "Inverse trig" begin
    @test isequal_interval(asin(interval(1)), interval(π)/interval(2))
    @test isequal_interval(asin(interval(0.9, 2)), asin(interval(0.9, 1)))
    @test isequal_interval(asin(interval(3, 4)), emptyinterval())

    @test issubset_interval(asin(interval(BigFloat, 1, 1)), asin(interval(1)))
    @test issubset_interval(asin(interval(BigFloat, 0.9, 2)), asin(interval(0.9, 2)))
    @test issubset_interval(asin(interval(BigFloat, 3, 4)), asin(interval(3, 4)))

    @test isequal_interval(acos(interval(1)), interval(0., 0.))
    @test isequal_interval(acos(interval(-2, -0.9)), acos(interval(-1, -0.9)))
    @test isequal_interval(acos(interval(3, 4)), emptyinterval())

    @test issubset_interval(acos(interval(BigFloat, 1, 1)), acos(interval(1)))
    @test issubset_interval(acos(interval(BigFloat, -2, -0.9)), acos(interval(-2, -0.9)))
    @test issubset_interval(acos(interval(BigFloat, 3, 4)), acos(interval(3, 4)))

    @test isequal_interval(atan(interval(-1,1)),
        interval(-interval(sup(interval(Float64, π)))/interval(4), interval(sup(interval(Float64, π)))/interval(4)))
    @test isequal_interval(atan(interval(0)), interval(0.0, 0.0))
    @test issubset_interval(atan(interval(BigFloat, -1, 1)), atan(interval(-1, 1)))
end

@testset "atan" begin
    @test isequal_interval(atan(emptyinterval(), entireinterval()), emptyinterval())
    @test isequal_interval(atan(entireinterval(), emptyinterval()), emptyinterval())
    @test isequal_interval(atan(interval(0.0, 1.0), interval(BigFloat, 0.0, 0.0)), interval(BigFloat, π)/interval(2))
    @test isequal_interval(atan(interval(0.0, 1.0), interval(0.0)), interval(π)/interval(2))
    @test isequal_interval(atan(interval(-1.0, -0.1), interval(0.0)), -interval(π)/interval(2))
    @test isequal_interval(atan(interval(-1.0, 1.0), interval(0.0)), interval(-0.5, 0.5) * interval(π))
    @test isequal_interval(atan(interval(0.0), interval(0.1, 1.0)), interval(0.0))
    @test issubset_interval(atan(interval(BigFloat, 0.0, 0.1), interval(BigFloat, 0.1, 1.0)),
        atan(interval(0.0, 0.1), interval(0.1, 1.0)))
    @test isequal_interval(atan(interval(0.0, 0.1), interval(0.1, 1.0)),
        interval(0.0, 0.7853981633974484))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.0), interval(BigFloat, 0.1, 1.0)),
        atan(interval(-0.1, 0.0), interval(0.1, 1.0)))
    @test isequal_interval(atan(interval(-0.1, 0.0), interval(0.1, 1.0)),
        interval(-0.7853981633974484, 0.0))
    @test issubset_interval(atan(interval(BigFloat, -0.1, -0.1), interval(BigFloat, 0.1, Inf)),
        atan(interval(-0.1, -0.1), interval(0.1, Inf)))
    @test isequal_interval(atan(interval(-0.1, 0.0), interval(0.1, Inf)),
        interval(-0.7853981633974484, 0.0))
    @test issubset_interval(atan(interval(BigFloat, 0.0, 0.1), interval(BigFloat, -2.0, -0.1)),
        atan(interval(0.0, 0.1), interval(-2.0, -0.1)))
    @test isequal_interval(atan(interval(0.0, 0.1), interval(-2.0, -0.1)),
        interval(2.356194490192345, 3.1415926535897936))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.0), interval(BigFloat, -2.0, -0.1)),
        atan(interval(-0.1, 0.0), interval(-2.0, -0.1)))
    @test isequal_interval(atan(interval(-0.1, 0.0), interval(-2.0, -0.1)),
        interval(-1, 1) * interval(π))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.1), interval(BigFloat, -Inf, -0.1)),
        atan(interval(-0.1, 0.1), interval(-Inf, -0.1)))
    @test isequal_interval(atan(interval(-0.1, 0.1), interval(-Inf, -0.1)),
        interval(-1, 1) * interval(π))

    @test issubset_interval(atan(interval(BigFloat, 0.0, 0.0), interval(BigFloat, -2.0, 0.0)),
        atan(interval(0.0, 0.0), interval(-2.0, 0.0)))
    @test isequal_interval(atan(interval(-0.0, 0.0), interval(-2.0, 0.0)),
        interval(3.141592653589793, 3.1415926535897936))
    @test issubset_interval(atan(interval(BigFloat, 0.0, 0.1), interval(BigFloat, -0.1, 0.0)),
        atan(interval(0.0, 0.1), interval(-0.1, 0.0)))
    @test isequal_interval(atan(interval(-0.0, 0.1), interval(-0.1, 0.0)),
        interval(1.5707963267948966, 3.1415926535897936))
    @test issubset_interval(atan(interval(BigFloat, -0.1, -0.1), interval(BigFloat, -0.1, 0.0)),
        atan(interval(-0.1, -0.1), interval(-0.1, 0.0)))
    @test isequal_interval(atan(interval(-0.1, -0.1), interval(-0.1, 0.0)),
        interval(-2.3561944901923453, -1.5707963267948966))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.1), interval(BigFloat, -2.0, 0.0)),
        atan(interval(-0.1, 0.1), interval(-2.0, 0.0)))
    @test isequal_interval(atan(interval(-0.1, 0.1), interval(-2.0, 0.0)),
        interval(-1, 1) * interval(π))

    @test issubset_interval(atan(interval(BigFloat, 0.0, 0.0), interval(BigFloat, -2.0, 0.0)),
        atan(interval(0.0, 0.0), interval(-2.0, 0.0)))
    @test isequal_interval(atan(interval(-0.0, 0.0), interval(-2.0, 0.0)),
        interval(3.141592653589793, 3.1415926535897936))
    @test issubset_interval(atan(interval(BigFloat, 0.0, 0.1), interval(BigFloat, -0.1, 0.0)),
        atan(interval(0.0, 0.1), interval(-0.1, 0.0)))
    @test isequal_interval(atan(interval(-0.0, 0.1), interval(-0.1, 0.0)),
        interval(1.5707963267948966, 3.1415926535897936))
    @test issubset_interval(atan(interval(BigFloat, -0.1, -0.1), interval(BigFloat, -0.1, 0.0)),
        atan(interval(-0.1, -0.1), interval(-0.1, 0.0)))
    @test isequal_interval(atan(interval(-0.1, -0.1), interval(-0.1, 0.0)),
        interval(-2.3561944901923453, -1.5707963267948966))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.1), interval(BigFloat, -2.0, 0.0)),
        atan(interval(-0.1, 0.1), interval(-2.0, 0.0)))
    @test isequal_interval(atan(interval(-0.1, 0.1), interval(-2.0, 0.0)),
        interval(-1, 1) * interval(π))
    @test issubset_interval(atan(interval(BigFloat, 0.0, 0.1), interval(BigFloat, -2.0, 0.1)),
        atan(interval(0.0, 0.1), interval(-2.0, 0.1)))
    @test isequal_interval(atan(interval(-0.0, 0.1), interval(-2.0, 0.1)),
        interval(0.0, 3.1415926535897936))
    @test issubset_interval(atan(interval(BigFloat, -0.1, -0.1), interval(BigFloat, -0.1, 0.1)),
        atan(interval(-0.1, -0.1), interval(-0.1, 0.1)))
    @test isequal_interval(atan(interval(-0.1, -0.1), interval(-0.1, 0.1)),
        interval(-2.3561944901923453, Float64(-big(pi)/4, RoundUp)))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.1), interval(BigFloat, -2.0, 0.1)),
        atan(interval(-0.1, 0.1), interval(-2.0, 0.1)))
    @test isequal_interval(interval(-1, 1) * interval(π), atan(interval(-0.1, 0.1), interval(-2.0, 0.1)))

    @test isequal_interval(atan(interval(-0.1, 0.1), interval(0.1, 0.1)),
        interval(-0.7853981633974484, 0.7853981633974484))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.1), interval(BigFloat, 0.1, 0.1)),
        atan(interval(-0.1, 0.1), interval(0.1, 0.1)))
    @test isequal_interval(atan(interval(0.0), interval(-0.0, 0.1)), interval(0.0))
    @test isequal_interval(atan(interval(0.0, 0.1), interval(-0.0, 0.1)),
        interval(0.0, 1.5707963267948968))
    @test isequal_interval(atan(interval(-0.1, 0.0), interval(0.0, 0.1)),
        interval(-1.5707963267948968, 0.0))
    @test isequal_interval(atan(interval(-0.1, 0.1), interval(-0.0, 0.1)),
        interval(-1.5707963267948968, 1.5707963267948968))
    @test issubset_interval(atan(interval(BigFloat, -0.1, 0.1), interval(BigFloat, -0.0, 0.1)),
        atan(interval(-0.1, 0.1), interval(0.0, 0.1)))

    @test isequal_interval(atan(interval(Float32, -0.1, 0.1), interval(Float32, 0.1, 0.1)),
        interval(-0.78539824f0, 0.78539824f0))
    @test issubset_interval(atan(interval(-0.1, 0.1), interval(0.1, 0.1)),
        atan(interval(Float32, -0.1, 0.1), interval(Float32, 0.1, 0.1)))
    @test isequal_interval(atan(interval(Float32, 0.0, 0.0), interval(Float32, -0.0, 0.1)),
        interval(Float32, 0.0, 0.0))
    @test isequal_interval(atan(interval(Float32, 0.0, 0.1), interval(Float32, -0.0, 0.1)),
        interval(0.0, 1.5707964f0))
    @test isequal_interval(atan(interval(Float32, -0.1, 0.0), interval(Float32, 0.0, 0.1)),
        interval(-1.5707964f0, 0.0))
    @test isequal_interval(atan(interval(Float32, -0.1, 0.1), interval(Float32, -0.0, 0.1)),
        interval(-1.5707964f0, 1.5707964f0))
    @test issubset_interval(atan(interval(-0.1, 0.1), interval(-0.0, 0.1)),
        atan(interval(Float32, -0.1, 0.1), interval(Float32, 0.0, 0.1)))
end

@testset "Trig" begin
    for a in ( interval(17, 19), interval(0.5, 1.2) )
        @test issubset_interval(tan(a), sin(a)/cos(a))
    end

    @test isequal_interval(sin(interval(-pi/2, 3pi/2)), interval(-1, 1))
    @test isequal_interval(cos(interval(-pi/2, 3pi/2)), interval(-1, 1))
end

@testset "Trig with large arguments" begin
    x = pown(interval(2.), 1000)
    @test diam(x) == 0.0

    @test isequal_interval(sin(x), interval(-0.15920170308624246, -0.15920170308624243))
    @test isequal_interval(cos(x), interval(0.9872460775989135, 0.9872460775989136))
    @test isequal_interval(tan(x), interval(-0.16125837995065806, -0.16125837995065803))

    x = interval(prevfloat(Inf), Inf)
    @test isequal_interval(sin(x), interval(-1, 1))
    @test isequal_interval(cos(x), interval(-1, 1))
    @test isequal_interval(tan(x), interval(-Inf, Inf))
end

module IntervalArithmeticIrrationalConstantsExt

import IntervalArithmetic as IA
import IrrationalConstants as IC

# Parse expressions defining the constant and use interval arithmetic to
# produce the correctly rounded intervals for the constants.

const _INTERVAL_IRRATIONAL_FUNCS = (:+, :-, :*, :/, :sqrt, :log, :inv)

_intervalize(x) = x
_intervalize(x::Number) = :(IA.bareinterval(BigFloat, $x))
_intervalize(x::Symbol) =
    x in _INTERVAL_IRRATIONAL_FUNCS ? x : :(IA.bareinterval(BigFloat, $x))
function _intervalize(ex::Expr)
    ex.head === :call || return ex
    return Expr(:call, _intervalize(ex.args[1]), map(_intervalize, ex.args[2:end])...)
end

macro interval_irrational(sym, def)
    constant = Expr(:., :IC, QuoteNode(sym))
    interval_def = _intervalize(def)
    return esc(quote
        IA._round(::Type{T}, ::typeof($constant), r::RoundingMode{:Down}) where {T<:IA.NumTypes} =
            IA.__round(T, IA.inf($interval_def), r)
        IA._round(::Type{T}, ::typeof($constant), r::RoundingMode{:Up}) where {T<:IA.NumTypes} =
            IA.__round(T, IA.sup($interval_def), r)
    end)
end

# Unfortunately we cannot extract the expression for the constant from the type,
# so we are essentially forced to repeat IrrationalConstants.jl here.

@interval_irrational twoπ 2 * π
@interval_irrational fourπ 4 * π
@interval_irrational halfπ π / 2
@interval_irrational quartπ π / 4

@interval_irrational invπ 1 / π
@interval_irrational inv2π 1 / (2 * π)
@interval_irrational inv4π 1 / (4 * π)
@interval_irrational fourinvπ 4 / π
@interval_irrational twoinvπ 2 / π

@interval_irrational sqrt2 sqrt(2)
@interval_irrational sqrt3 sqrt(3)
@interval_irrational sqrtπ sqrt(π)
@interval_irrational sqrt2π sqrt(2 * π)
@interval_irrational sqrt4π sqrt(4 * π)
@interval_irrational sqrthalfπ sqrt(π / 2)

@interval_irrational invsqrt2 1 / sqrt(2)
@interval_irrational invsqrtπ 1 / sqrt(π)
@interval_irrational invsqrt2π 1 / sqrt(2 * π)

@interval_irrational logtwo log(2)
@interval_irrational logten log(10)
@interval_irrational loghalf log(1 / 2)
@interval_irrational logπ log(π)
@interval_irrational log2π log(2 * π)
@interval_irrational log4π log(4 * π)

end

# This file contains the functions described as "Integer functions" in Section
# 9.1 of the IEEE Standard 1788-2015 and required for set-based flavor in
# Section 10.5.3

"""
    sign(x::BareInterval)
    sign(x::Interval)

Implement the `sign` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.sign(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    lo, hi = bounds(x)
    return _unsafe_bareinterval(T, sign(lo), sign(hi))
end

function Base.sign(x::Interval)
    r = sign(bareinterval(x))
    d = decoration(x)
    d = min(d, ifelse(isthin(r), d, def))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    ceil(x::BareInterval)
    ceil(x::Interval)

Implement the `ceil` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.ceil(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    lo, hi = bounds(x)
    return _unsafe_bareinterval(T, ceil(lo), ceil(hi))
end

function Base.ceil(x::Interval)
    r = ceil(bareinterval(x))
    d = decoration(x)
    d = min(d, ifelse(isinteger(sup(x)), dac, d))
    d = min(d, ifelse(isthin(r), d, def))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    floor(x::BareInterval)
    floor(x::Interval)

Implement the `floor` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.floor(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    lo, hi = bounds(x)
    return _unsafe_bareinterval(T, floor(lo), floor(hi))
end

function Base.floor(x::Interval)
    r = floor(bareinterval(x))
    d = decoration(x)
    d = min(d, ifelse(isinteger(sup(x)), dac, d))
    d = min(d, ifelse(isthin(r), d, def))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    trunc(x::BareInterval)
    trunc(x::Interval)

Implement the `trunc` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.trunc(x::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(x) && return x
    lo, hi = bounds(x)
    return _unsafe_bareinterval(T, trunc(lo), trunc(hi))
end

function Base.trunc(x::Interval)
    r = trunc(bareinterval(x))
    d = decoration(x)
    d = min(d, ifelse((isinteger(inf(x)) & (inf(x) < 0)) | (isinteger(sup(x)) & (sup(x) > 0)), dac, d))
    d = min(d, ifelse(isthin(r), d, def))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    round(x::BareInterval, [RoundingMode])
    round(x::Interval, [RoundingMode])

Return an interval with the bounds of `x` rounded to an integer.

Implement the functions `roundTiesToEven` and `roundTiesToAway` of the IEEE Standard 1788-2015.
"""
Base.round(x::Union{BareInterval,Interval}) = round(x, RoundNearest)
Base.round(x::Union{BareInterval,Interval}, ::RoundingMode{:ToZero}) = trunc(x)
Base.round(x::Union{BareInterval,Interval}, ::RoundingMode{:Up}) = ceil(x)
Base.round(x::Union{BareInterval,Interval}, ::RoundingMode{:Down}) = floor(x)

for (S, R) ∈ ((:(:Nearest), :RoundNearest), (:(:NearestTiesAway), :RoundNearestTiesAway))
    @eval begin
        function Base.round(x::BareInterval{T}, ::RoundingMode{$S}) where {T<:NumTypes}
            isempty_interval(x) && return x
            lo, hi = bounds(x)
            return _unsafe_bareinterval(T, round(lo, $R), round(hi, $R))
        end

        function Base.round(x::Interval, ::RoundingMode{$S})
            r = round(bareinterval(x), $R)
            d = decoration(x)
            d = min(d, ifelse(isinteger(2*inf(x)) | isinteger(2*sup(x)), dac, d))
            d = min(d, ifelse(isthin(r), d, def))
            return _unsafe_interval(r, d, isguaranteed(x))
        end
    end
end

@testset "minimal_cancel_plus_test" begin

    @test cancelplus(bareinterval(-Inf, -1.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-1.0, Inf), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(entireinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-Inf, -1.0), bareinterval(-5.0,1.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-1.0, Inf), bareinterval(-5.0,1.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(entireinterval(BareInterval{Float64}), bareinterval(-5.0,1.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-Inf, -1.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-1.0, Inf), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(emptyinterval(BareInterval{Float64}), bareinterval(1.0, Inf)) === entireinterval(BareInterval{Float64})

    @test cancelplus(emptyinterval(BareInterval{Float64}), bareinterval(-Inf,1.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(emptyinterval(BareInterval{Float64}), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-1.0,5.0), bareinterval(1.0,Inf)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-1.0,5.0), bareinterval(-Inf,1.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-1.0,5.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(entireinterval(BareInterval{Float64}), bareinterval(1.0,Inf)) === entireinterval(BareInterval{Float64})

    @test cancelplus(entireinterval(BareInterval{Float64}), bareinterval(-Inf,1.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(entireinterval(BareInterval{Float64}), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-5.0, -1.0), bareinterval(1.0,5.1)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-5.0, -1.0), bareinterval(0.9,5.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-5.0, -1.0), bareinterval(0.9,5.1)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-10.0, 5.0), bareinterval(-5.0,10.1)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-10.0, 5.0), bareinterval(-5.1,10.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-10.0, 5.0), bareinterval(-5.1,10.1)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(1.0, 5.0), bareinterval(-5.0,-0.9)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(1.0, 5.0), bareinterval(-5.1,-1.0)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(1.0, 5.0), bareinterval(-5.1,-0.9)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-10.0, -1.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-10.0, 5.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(1.0, 5.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelplus(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test cancelplus(emptyinterval(BareInterval{Float64}), bareinterval(1.0,10.0)) === emptyinterval(BareInterval{Float64})

    @test cancelplus(emptyinterval(BareInterval{Float64}), bareinterval(-5.0,10.0)) === emptyinterval(BareInterval{Float64})

    @test cancelplus(emptyinterval(BareInterval{Float64}), bareinterval(-5.0,-1.0)) === emptyinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-5.1,-0.0), bareinterval(0.0,5.0)) === bareinterval(-0x1.999999999998P-4,0.0)

    @test cancelplus(bareinterval(-5.1,-1.0), bareinterval(1.0,5.0)) === bareinterval(-0x1.999999999998P-4,0.0)

    @test cancelplus(bareinterval(-5.0,-0.9), bareinterval(1.0,5.0)) === bareinterval(0.0, 0x1.9999999999998P-4)

    @test cancelplus(bareinterval(-5.1,-0.9), bareinterval(1.0,5.0)) === bareinterval(-0x1.999999999998P-4,0x1.9999999999998P-4)

    @test cancelplus(bareinterval(-5.0,-1.0), bareinterval(1.0,5.0)) === bareinterval(0.0,0.0)

    @test cancelplus(bareinterval(-10.1, 5.0), bareinterval(-5.0,10.0)) === bareinterval(-0x1.999999999998P-4,0.0)

    @test cancelplus(bareinterval(-10.0, 5.1), bareinterval(-5.0,10.0)) === bareinterval(0.0,0x1.999999999998P-4)

    @test cancelplus(bareinterval(-10.1, 5.1), bareinterval(-5.0,10.0)) === bareinterval(-0x1.999999999998P-4,0x1.999999999998P-4)

    @test cancelplus(bareinterval(-10.0, 5.0), bareinterval(-5.0,10.0)) === bareinterval(0.0,0.0)

    @test cancelplus(bareinterval(0.9, 5.0), bareinterval(-5.0,-1.0)) === bareinterval(-0x1.9999999999998P-4,0.0)

    @test cancelplus(bareinterval(1.0, 5.1), bareinterval(-5.0,-1.0)) === bareinterval(0.0,0x1.999999999998P-4)

    @test cancelplus(bareinterval(0.0, 5.1), bareinterval(-5.0,-0.0)) === bareinterval(0.0,0x1.999999999998P-4)

    @test cancelplus(bareinterval(0.9, 5.1), bareinterval(-5.0,-1.0)) === bareinterval(-0x1.9999999999998P-4,0x1.999999999998P-4)

    @test cancelplus(bareinterval(1.0, 5.0), bareinterval(-5.0,-1.0)) === bareinterval(0.0,0.0)

    @test cancelplus(bareinterval(0.0, 5.0), bareinterval(-5.0,-0.0)) === bareinterval(0.0,0.0)

    @test cancelplus(bareinterval(0x1.FFFFFFFFFFFFP+0,0x1.FFFFFFFFFFFFP+0), bareinterval(-0x1.999999999999AP-4,-0x1.999999999999AP-4)) === bareinterval(0x1.E666666666656P+0,0x1.E666666666657P+0)

    @test cancelplus(bareinterval(-0x1.999999999999AP-4,0x1.FFFFFFFFFFFFP+0), bareinterval(-0x1.999999999999AP-4,0.01)) === bareinterval(-0x1.70A3D70A3D70BP-4,0x1.E666666666657P+0)

    @test cancelplus(bareinterval(0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023)) === bareinterval(0x1.FFFFFFFFFFFFFp1023,Inf)

    @test cancelplus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023)) === bareinterval(0.0,0.0)

    @test cancelplus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023)) === bareinterval(0.0,0x1P+971)

    @test cancelplus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023)) === bareinterval(-0x1P+971,0.0)

    @test cancelplus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023)) === entireinterval(BareInterval{Float64})

    @test cancelplus(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFFP-53), bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFEP-53)) === bareinterval(-0x1.FFFFFFFFFFFFFP-1,-0x1.FFFFFFFFFFFFEP-1)

    @test cancelplus(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFEP-53), bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFFP-53)) === entireinterval(BareInterval{Float64})

end

@testset "minimal_cancel_plus_dec_test" begin

    @test cancelplus(interval(bareinterval(-Inf, -1.0), dac), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-1.0, Inf), def), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(entireinterval(BareInterval{Float64}), def), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-Inf, -1.0), dac), interval(bareinterval(-5.0,1.0), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-1.0, Inf), trv), interval(bareinterval(-5.0,1.0), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(entireinterval(BareInterval{Float64}), dac), interval(bareinterval(-5.0,1.0), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-Inf, -1.0), dac), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-1.0, Inf), def), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(1.0, Inf), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-Inf,1.0), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(emptyinterval(BareInterval{Float64}), trv), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-1.0,5.0), dac), interval(bareinterval(1.0,Inf), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-1.0,5.0), def), interval(bareinterval(-Inf,1.0), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-1.0,5.0), com), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(entireinterval(BareInterval{Float64}), dac), interval(bareinterval(1.0,Inf), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(entireinterval(BareInterval{Float64}), dac), interval(bareinterval(-Inf,1.0), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(entireinterval(BareInterval{Float64}), dac), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-5.0, -1.0), com), interval(bareinterval(1.0,5.1), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-5.0, -1.0), dac), interval(bareinterval(0.9,5.0), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-5.0, -1.0), def), interval(bareinterval(0.9,5.1), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-10.0, 5.0), trv), interval(bareinterval(-5.0,10.1), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-10.0, 5.0), com), interval(bareinterval(-5.1,10.0), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-10.0, 5.0), dac), interval(bareinterval(-5.1,10.1), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(1.0, 5.0), def), interval(bareinterval(-5.0,-0.9), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(1.0, 5.0), trv), interval(bareinterval(-5.1,-1.0), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(1.0, 5.0), dac), interval(bareinterval(-5.1,-0.9), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-10.0, -1.0), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-10.0, 5.0), def), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(1.0, 5.0), com), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(1.0,10.0), dac)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-5.0,10.0), def)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-5.0,-1.0), com)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-5.1,-0.0), com), interval(bareinterval(0.0,5.0), com)) === interval(bareinterval(-0x1.999999999998P-4,0.0), trv)

    @test cancelplus(interval(bareinterval(-5.1,-1.0), com), interval(bareinterval(1.0,5.0), dac)) === interval(bareinterval(-0x1.999999999998P-4,0.0), trv)

    @test cancelplus(interval(bareinterval(-5.0,-0.9), com), interval(bareinterval(1.0,5.0), def)) === interval(bareinterval(0.0, 0x1.9999999999998P-4), trv)

    @test cancelplus(interval(bareinterval(-5.1,-0.9), dac), interval(bareinterval(1.0,5.0), trv)) === interval(bareinterval(-0x1.999999999998P-4,0x1.9999999999998P-4), trv)

    @test cancelplus(interval(bareinterval(-5.0,-1.0), dac), interval(bareinterval(1.0,5.0), com)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelplus(interval(bareinterval(-10.1, 5.0), dac), interval(bareinterval(-5.0,10.0), dac)) === interval(bareinterval(-0x1.999999999998P-4,0.0), trv)

    @test cancelplus(interval(bareinterval(-10.0, 5.1), def), interval(bareinterval(-5.0,10.0), def)) === interval(bareinterval(0.0,0x1.999999999998P-4), trv)

    @test cancelplus(interval(bareinterval(-10.1, 5.1), def), interval(bareinterval(-5.0,10.0), trv)) === interval(bareinterval(-0x1.999999999998P-4,0x1.999999999998P-4), trv)

    @test cancelplus(interval(bareinterval(-10.0, 5.0), def), interval(bareinterval(-5.0,10.0), com)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelplus(interval(bareinterval(0.9, 5.0), trv), interval(bareinterval(-5.0,-1.0), dac)) === interval(bareinterval(-0x1.9999999999998P-4,0.0), trv)

    @test cancelplus(interval(bareinterval(1.0, 5.1), trv), interval(bareinterval(-5.0,-1.0), def)) === interval(bareinterval(0.0,0x1.999999999998P-4), trv)

    @test cancelplus(interval(bareinterval(0.0, 5.1), trv), interval(bareinterval(-5.0,-0.0), trv)) === interval(bareinterval(0.0,0x1.999999999998P-4), trv)

    @test cancelplus(interval(bareinterval(0.9, 5.1), com), interval(bareinterval(-5.0,-1.0), com)) === interval(bareinterval(-0x1.9999999999998P-4,0x1.999999999998P-4), trv)

    @test cancelplus(interval(bareinterval(1.0, 5.0), dac), interval(bareinterval(-5.0,-1.0), dac)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelplus(interval(bareinterval(0.0, 5.0), def), interval(bareinterval(-5.0,-0.0), trv)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelplus(interval(bareinterval(0x1.FFFFFFFFFFFFP+0,0x1.FFFFFFFFFFFFP+0), com), interval(bareinterval(-0x1.999999999999AP-4,-0x1.999999999999AP-4), com)) === interval(bareinterval(0x1.E666666666656P+0,0x1.E666666666657P+0), trv)

    @test cancelplus(interval(bareinterval(-0x1.999999999999AP-4,0x1.FFFFFFFFFFFFP+0), dac), interval(bareinterval(-0x1.999999999999AP-4,0.01), com)) === interval(bareinterval(-0x1.70A3D70A3D70BP-4,0x1.E666666666657P+0), trv)

    @test cancelplus(interval(bareinterval(0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(bareinterval(0x1.FFFFFFFFFFFFFp1023,Inf), trv)

    @test cancelplus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelplus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), dac), interval(bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(bareinterval(0.0,0x1P+971), trv)

    @test cancelplus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), dac), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023), com)) === interval(bareinterval(-0x1P+971,0.0), trv)

    @test cancelplus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelplus(interval(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFFP-53), dac), interval(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFEP-53), com)) === interval(bareinterval(-0x1.FFFFFFFFFFFFFP-1,-0x1.FFFFFFFFFFFFEP-1), trv)

    @test cancelplus(interval(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFEP-53), def), interval(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFFP-53), com)) === interval(entireinterval(BareInterval{Float64}), trv)

end

@testset "minimal_cancel_minus_test" begin

    @test cancelminus(bareinterval(-Inf, -1.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-1.0, Inf), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(entireinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-Inf, -1.0), bareinterval(-1.0,5.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-1.0, Inf), bareinterval(-1.0,5.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(entireinterval(BareInterval{Float64}), bareinterval(-1.0,5.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-Inf, -1.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-1.0, Inf), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(emptyinterval(BareInterval{Float64}), bareinterval(-Inf, -1.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(emptyinterval(BareInterval{Float64}), bareinterval(-1.0, Inf)) === entireinterval(BareInterval{Float64})

    @test cancelminus(emptyinterval(BareInterval{Float64}), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-1.0,5.0), bareinterval(-Inf, -1.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-1.0,5.0), bareinterval(-1.0, Inf)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-1.0,5.0), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(entireinterval(BareInterval{Float64}), bareinterval(-Inf, -1.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(entireinterval(BareInterval{Float64}), bareinterval(-1.0, Inf)) === entireinterval(BareInterval{Float64})

    @test cancelminus(entireinterval(BareInterval{Float64}), entireinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-5.0, -1.0), bareinterval(-5.1,-1.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-5.0, -1.0), bareinterval(-5.0,-0.9)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-5.0, -1.0), bareinterval(-5.1,-0.9)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-10.0, 5.0), bareinterval(-10.1, 5.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-10.0, 5.0), bareinterval(-10.0, 5.1)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-10.0, 5.0), bareinterval(-10.1, 5.1)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(1.0, 5.0), bareinterval(0.9, 5.0)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(1.0, 5.0), bareinterval(1.0, 5.1)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(1.0, 5.0), bareinterval(0.9, 5.1)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-10.0, -1.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-10.0, 5.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(1.0, 5.0), emptyinterval(BareInterval{Float64})) === entireinterval(BareInterval{Float64})

    @test cancelminus(emptyinterval(BareInterval{Float64}), emptyinterval(BareInterval{Float64})) === emptyinterval(BareInterval{Float64})

    @test cancelminus(emptyinterval(BareInterval{Float64}), bareinterval(-10.0, -1.0)) === emptyinterval(BareInterval{Float64})

    @test cancelminus(emptyinterval(BareInterval{Float64}), bareinterval(-10.0, 5.0)) === emptyinterval(BareInterval{Float64})

    @test cancelminus(emptyinterval(BareInterval{Float64}), bareinterval(1.0, 5.0)) === emptyinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-5.1,-0.0), bareinterval(-5.0, 0.0)) === bareinterval(-0x1.999999999998P-4,0.0)

    @test cancelminus(bareinterval(-5.1,-1.0), bareinterval(-5.0, -1.0)) === bareinterval(-0x1.999999999998P-4,0.0)

    @test cancelminus(bareinterval(-5.0,-0.9), bareinterval(-5.0, -1.0)) === bareinterval(0.0, 0x1.9999999999998P-4)

    @test cancelminus(bareinterval(-5.1,-0.9), bareinterval(-5.0, -1.0)) === bareinterval(-0x1.999999999998P-4,0x1.9999999999998P-4)

    @test cancelminus(bareinterval(-5.0,-1.0), bareinterval(-5.0, -1.0)) === bareinterval(0.0,0.0)

    @test cancelminus(bareinterval(-10.1, 5.0), bareinterval(-10.0, 5.0)) === bareinterval(-0x1.999999999998P-4,0.0)

    @test cancelminus(bareinterval(-10.0, 5.1), bareinterval(-10.0, 5.0)) === bareinterval(0.0,0x1.999999999998P-4)

    @test cancelminus(bareinterval(-10.1, 5.1), bareinterval(-10.0, 5.0)) === bareinterval(-0x1.999999999998P-4,0x1.999999999998P-4)

    @test cancelminus(bareinterval(-10.0, 5.0), bareinterval(-10.0, 5.0)) === bareinterval(0.0,0.0)

    @test cancelminus(bareinterval(0.9, 5.0), bareinterval(1.0, 5.0)) === bareinterval(-0x1.9999999999998P-4,0.0)

    @test cancelminus(bareinterval(-0.0, 5.1), bareinterval(0.0, 5.0)) === bareinterval(0.0,0x1.999999999998P-4)

    @test cancelminus(bareinterval(1.0, 5.1), bareinterval(1.0, 5.0)) === bareinterval(0.0,0x1.999999999998P-4)

    @test cancelminus(bareinterval(0.9, 5.1), bareinterval(1.0, 5.0)) === bareinterval(-0x1.9999999999998P-4,0x1.999999999998P-4)

    @test cancelminus(bareinterval(1.0, 5.0), bareinterval(1.0, 5.0)) === bareinterval(0.0,0.0)

    @test cancelminus(bareinterval(-5.0, 1.0), bareinterval(-1.0, 5.0)) === bareinterval(-4.0,-4.0)

    @test cancelminus(bareinterval(-5.0, 0.0), bareinterval(-0.0, 5.0)) === bareinterval(-5.0,-5.0)

    @test cancelminus(bareinterval(0x1.FFFFFFFFFFFFP+0,0x1.FFFFFFFFFFFFP+0), bareinterval(0x1.999999999999AP-4,0x1.999999999999AP-4)) === bareinterval(0x1.E666666666656P+0,0x1.E666666666657P+0)

    @test cancelminus(bareinterval(-0x1.999999999999AP-4,0x1.FFFFFFFFFFFFP+0), bareinterval(-0.01,0x1.999999999999AP-4)) === bareinterval(-0x1.70A3D70A3D70BP-4,0x1.E666666666657P+0)

    @test cancelminus(bareinterval(0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,-0x1.FFFFFFFFFFFFFp1023)) === bareinterval(0x1.FFFFFFFFFFFFFp1023,Inf)

    @test cancelminus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023)) === bareinterval(0.0,0.0)

    @test cancelminus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023)) === bareinterval(0.0,0x1P+971)

    @test cancelminus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023)) === bareinterval(-0x1P+971,0.0)

    @test cancelminus(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023), bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022)) === bareinterval(0.0,0.0)

    @test cancelminus(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022)) === bareinterval(0x0.0000000000002p-1022,0x0.0000000000002p-1022)

    @test cancelminus(bareinterval(0x1P-1022,0x1.0000000000002P-1022), bareinterval(0x1P-1022,0x1.0000000000001P-1022)) === bareinterval(0.0,0x0.0000000000001P-1022)

    @test cancelminus(bareinterval(0x1P-1022,0x1.0000000000001P-1022), bareinterval(0x1P-1022,0x1.0000000000002P-1022)) === entireinterval(BareInterval{Float64})

    @test cancelminus(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFFP-53), bareinterval(-0x1.FFFFFFFFFFFFEP-53,0x1P+0)) === bareinterval(-0x1.FFFFFFFFFFFFFP-1,-0x1.FFFFFFFFFFFFEP-1)

    @test cancelminus(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFEP-53), bareinterval(-0x1.FFFFFFFFFFFFFP-53,0x1P+0)) === entireinterval(BareInterval{Float64})

end

@testset "minimal_cancel_minus_dec_test" begin

    @test cancelminus(interval(bareinterval(-Inf, -1.0), dac), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-1.0, Inf), def), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(entireinterval(BareInterval{Float64}), dac), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-Inf, -1.0), trv), interval(bareinterval(-1.0,5.0), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-1.0, Inf), dac), interval(bareinterval(-1.0,5.0), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(entireinterval(BareInterval{Float64}), dac), interval(bareinterval(-1.0,5.0), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-Inf, -1.0), def), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-1.0, Inf), trv), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-Inf, -1.0), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-1.0, Inf), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(emptyinterval(BareInterval{Float64}), trv), interval(entireinterval(BareInterval{Float64}), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-1.0,5.0), dac), interval(bareinterval(-Inf, -1.0), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-1.0,5.0), def), interval(bareinterval(-1.0, Inf), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-1.0,5.0), com), interval(entireinterval(BareInterval{Float64}), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(entireinterval(BareInterval{Float64}), dac), interval(bareinterval(-Inf, -1.0), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(entireinterval(BareInterval{Float64}), dac), interval(bareinterval(-1.0, Inf), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(entireinterval(BareInterval{Float64}), dac), interval(entireinterval(BareInterval{Float64}), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-5.0, -1.0), com), interval(bareinterval(-5.1,-1.0), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-5.0, -1.0), dac), interval(bareinterval(-5.0,-0.9), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-5.0, -1.0), def), interval(bareinterval(-5.1,-0.9), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-10.0, 5.0), trv), interval(bareinterval(-10.1, 5.0), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-10.0, 5.0), com), interval(bareinterval(-10.0, 5.1), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-10.0, 5.0), dac), interval(bareinterval(-10.1, 5.1), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(1.0, 5.0), def), interval(bareinterval(0.9, 5.0), def)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(1.0, 5.0), trv), interval(bareinterval(1.0, 5.1), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(1.0, 5.0), com), interval(bareinterval(0.9, 5.1), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-10.0, -1.0), com), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-10.0, 5.0), dac), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(1.0, 5.0), def), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(emptyinterval(BareInterval{Float64}), trv), interval(emptyinterval(BareInterval{Float64}), trv)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-10.0, -1.0), com)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(-10.0, 5.0), dac)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(emptyinterval(BareInterval{Float64}), trv), interval(bareinterval(1.0, 5.0), def)) === interval(emptyinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-5.1,-0.0), com), interval(bareinterval(-5.0, 0.0), com)) === interval(bareinterval(-0x1.999999999998P-4,0.0), trv)

    @test cancelminus(interval(bareinterval(-5.1,-1.0), dac), interval(bareinterval(-5.0, -1.0), com)) === interval(bareinterval(-0x1.999999999998P-4,0.0), trv)

    @test cancelminus(interval(bareinterval(-5.0,-0.9), def), interval(bareinterval(-5.0, -1.0), com)) === interval(bareinterval(0.0, 0x1.9999999999998P-4), trv)

    @test cancelminus(interval(bareinterval(-5.1,-0.9), trv), interval(bareinterval(-5.0, -1.0), com)) === interval(bareinterval(-0x1.999999999998P-4,0x1.9999999999998P-4), trv)

    @test cancelminus(interval(bareinterval(-5.0,-1.0), com), interval(bareinterval(-5.0, -1.0), dac)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelminus(interval(bareinterval(-10.1, 5.0), dac), interval(bareinterval(-10.0, 5.0), dac)) === interval(bareinterval(-0x1.999999999998P-4,0.0), trv)

    @test cancelminus(interval(bareinterval(-10.0, 5.1), def), interval(bareinterval(-10.0, 5.0), dac)) === interval(bareinterval(0.0,0x1.999999999998P-4), trv)

    @test cancelminus(interval(bareinterval(-10.1, 5.1), trv), interval(bareinterval(-10.0, 5.0), def)) === interval(bareinterval(-0x1.999999999998P-4,0x1.999999999998P-4), trv)

    @test cancelminus(interval(bareinterval(-10.0, 5.0), com), interval(bareinterval(-10.0, 5.0), def)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelminus(interval(bareinterval(0.9, 5.0), dac), interval(bareinterval(1.0, 5.0), def)) === interval(bareinterval(-0x1.9999999999998P-4,0.0), trv)

    @test cancelminus(interval(bareinterval(-0.0, 5.1), def), interval(bareinterval(0.0, 5.0), def)) === interval(bareinterval(0.0,0x1.999999999998P-4), trv)

    @test cancelminus(interval(bareinterval(1.0, 5.1), trv), interval(bareinterval(1.0, 5.0), trv)) === interval(bareinterval(0.0,0x1.999999999998P-4), trv)

    @test cancelminus(interval(bareinterval(0.9, 5.1), com), interval(bareinterval(1.0, 5.0), trv)) === interval(bareinterval(-0x1.9999999999998P-4,0x1.999999999998P-4), trv)

    @test cancelminus(interval(bareinterval(1.0, 5.0), dac), interval(bareinterval(1.0, 5.0), com)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelminus(interval(bareinterval(-5.0, 1.0), def), interval(bareinterval(-1.0, 5.0), def)) === interval(bareinterval(-4.0,-4.0), trv)

    @test cancelminus(interval(bareinterval(-5.0, 0.0), trv), interval(bareinterval(-0.0, 5.0), trv)) === interval(bareinterval(-5.0,-5.0), trv)

    @test cancelminus(interval(bareinterval(0x1.FFFFFFFFFFFFP+0,0x1.FFFFFFFFFFFFP+0), com), interval(bareinterval(0x1.999999999999AP-4,0x1.999999999999AP-4), com)) === interval(bareinterval(0x1.E666666666656P+0,0x1.E666666666657P+0), trv)

    @test cancelminus(interval(bareinterval(-0x1.999999999999AP-4,0x1.FFFFFFFFFFFFP+0), def), interval(bareinterval(-0.01,0x1.999999999999AP-4), dac)) === interval(bareinterval(-0x1.70A3D70A3D70BP-4,0x1.E666666666657P+0), trv)

    @test cancelminus(interval(bareinterval(0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,-0x1.FFFFFFFFFFFFFp1023), com)) === interval(bareinterval(0x1.FFFFFFFFFFFFFp1023,Inf), trv)

    @test cancelminus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelminus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023), com)) === interval(bareinterval(0.0,0x1P+971), trv)

    @test cancelminus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(bareinterval(-0x1P+971,0.0), trv)

    @test cancelminus(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFEP+1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-0x1.FFFFFFFFFFFFEP+1023,0x1.FFFFFFFFFFFFFp1023), com), interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,0x1.FFFFFFFFFFFFFp1023), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), com), interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), com)) === interval(bareinterval(0.0,0.0), trv)

    @test cancelminus(interval(bareinterval(0x0.0000000000001p-1022,0x0.0000000000001p-1022), com), interval(bareinterval(-0x0.0000000000001p-1022,-0x0.0000000000001p-1022), dac)) === interval(bareinterval(0x0.0000000000002p-1022,0x0.0000000000002p-1022), trv)

    @test cancelminus(interval(bareinterval(0x1P-1022,0x1.0000000000002P-1022), dac), interval(bareinterval(0x1P-1022,0x1.0000000000001P-1022), dac)) === interval(bareinterval(0.0,0x0.0000000000001P-1022), trv)

    @test cancelminus(interval(bareinterval(0x1P-1022,0x1.0000000000001P-1022), def), interval(bareinterval(0x1P-1022,0x1.0000000000002P-1022), com)) === interval(entireinterval(BareInterval{Float64}), trv)

    @test cancelminus(interval(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFFP-53), com), interval(bareinterval(-0x1.FFFFFFFFFFFFEP-53,0x1P+0), dac)) === interval(bareinterval(-0x1.FFFFFFFFFFFFFP-1,-0x1.FFFFFFFFFFFFEP-1), trv)

    @test cancelminus(interval(bareinterval(-0x1P+0,0x1.FFFFFFFFFFFFEP-53), def), interval(bareinterval(-0x1.FFFFFFFFFFFFFP-53,0x1P+0), dac)) === interval(entireinterval(BareInterval{Float64}), trv)

end

@testset "Interval loop tests" begin
    i = 1

    @test inf(interval(i, i)) == 1
    @test inf(interval(i)) == 1


    for i in 1:10
        a = interval(i)
        @test inf(a) == i
    end
end


## Calculate pi by summing 1/i^2 to give pi^2/6:

function calc_pi1(N)
    S1 = interval(0)

    for i in 1:N
        S1 += inv(interval(i)^2)
    end
    S1 += interval(inv(interval(N+1)), inv(interval(N)))

    return sqrt(interval(6)*S1)
end

function calc_pi2(N)
    S2 = interval(0)

    for i in 1:N
        S2 += interval(1 / i^2)
    end
    S2 += interval(inv(interval(N+1)), inv(interval(N)))

    return sqrt(interval(6)*S2)
end

function calc_pi3(N)
    S3 = interval(0)

    for i in 1:N
        S3 += interval(1 / i^2)
    end
    S3 += parse(Interval{Float64}, "[1/$(N+1), 1/$N]")

    return sqrt(interval(6)*S3)
end

function calc_pi4(N)
    S4 = interval(0)
    II = interval(1)

    for i in N:-1:1
        S4 += II / interval(i^2)
    end
    S4 += II / interval(N, N+1)

    return sqrt(interval(6)*S4)
end

function calc_pi5(N)
    S5 = interval(0)

    for i in N:-1:1
        S5 += interval(1 // i^2)
    end
    S5 += inv(interval(N, N+1))

    return sqrt(interval(6)*S5)
end

@testset "Pi tests" begin
    big_pi = setprecision(256) do
        big(π)
    end

    N = 10000
    pi1 = calc_pi1(N)
    pi2 = calc_pi2(N)
    pi3 = calc_pi3(N)
    pi4 = calc_pi4(N)
    pi5 = calc_pi5(N)


    @test in_interval(big_pi, pi1)
    @test in_interval(big_pi, pi2)
    @test in_interval(big_pi, pi3)
    @test in_interval(big_pi, pi4)
    @test in_interval(big_pi, pi5)

    @test isequal_interval(pi1, pi2)
    @test isequal_interval(pi2, pi3)
end

using Test
using IntervalArithmetic

# Define properties to be checked
function degenerate_interval(a)
    x = interval(a)
    y = interval(a, a)
    x === y
end

@testset "Float tests" begin
    # Define number generators
    floatgen = Data.Floats()

    # Check properties
    @check max_examples=1000 degenerate_interval(floatgen)
end

@testset "Rational tests" begin
    # Define number generators
    intgen = Data.Integers(typemin(Int)+1,typemax(Int)) # Don't allow typemin(Int) to avoid overflow
    rationalgen = @composed function generate_rational(num=intgen, den=intgen)
        assume!(!(iszero(num) && iszero(den)))
        return num // den
    end

    # Check properties
    @check max_examples = 1000 degenerate_interval(rationalgen)
end

@testset "Brodcasting" begin
    x = interval(1, 2)

    for f ∈ (+, -, *, /)
        @test isequal_interval(f.(x, x), f(x, x))
    end
end

@testset "Numeric tests" begin
    a = interval(0.1, 1.1)
    b = interval(0.9, 2.0)
    c = interval(0.25, 4.0)


    ## Basic arithmetic
    @test isequal_interval(+a, a)
    @test isequal_interval(-a, interval(-sup(a), -inf(a)))
    for f in (:+, :-, :*, :/)
        @eval begin
            @test isequal_interval($f(interval(Float64, pi), interval(Float32, pi)),
                $f(interval(Float64, pi), Interval{Float64}(interval(Float32, pi))))
        end
    end
    @test isequal_interval(interval(Rational{Int}, 1//4, 1//2) + interval(Rational{Int}, 2//3), interval(Rational{Int}, 11//12, 7//6))
    @test isequal_interval(interval(Rational{Int}, 1//4, 1//2) - interval(Rational{Int}, 2//3), interval(Rational{Int}, -5//12, -1//6))

    @test isequal_interval(interval(-30.0,-15.0) / interval(-5.0,-3.0), interval(3.0, 10.0))
    @test isequal_interval(interval(-30,-15) / interval(-5,-3), interval(3.0, 10.0))
    @test isequal_interval(a/c, interval(0.025, 4.4))
    @test isequal_interval(c/interval(4.0), interval(6.25e-02, 1e+00))
    @test isequal_interval(c/zero(c), emptyinterval(c))
    @test isequal_interval(interval(0.0, 1.0)/interval(0.0,1.0), interval(0.0, Inf))
    @test isequal_interval(interval(-1.0, 1.0)/interval(0.0,1.0), entireinterval(c))
    @test isequal_interval(interval(-1.0, 1.0)/interval(-1.0,1.0), entireinterval(c))

    @test all(isequal_interval.(extended_div(interval(-30.0,-15.0), interval(-5.0,-3.0)), (interval(3.0, 10.0), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(interval(-30,-15) , interval(-5,-3)), (interval(3.0, 10.0), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(interval(1.0, 2.0), interval(0.1, 1.0)), (interval(1, 20.0), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(a, c), (interval(0.025, 4.4e+00), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(c, interval(4.0)), (interval(6.25e-02, 1e+00), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(c, zero(c)), (emptyinterval(c), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(interval(0.0, 1.0), interval(0.0,1.0)), (entireinterval(c), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(interval(-1.0, 1.0), interval(0.0,1.0)), (entireinterval(c), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(interval(-1.0, 1.0), interval(-1.0,1.0)), (entireinterval(c), emptyinterval(c))))
    @test all(isequal_interval.(extended_div(interval(1.0, 2.0), interval(-4.0, 4.0)), (interval(-Inf, -0.25), interval(0.25, Inf))))
    @test all(isequal_interval.(extended_div(interval(-2.0, -1.0), interval(-2.0, 4.0)), (interval(-Inf, -0.25), interval(0.5, Inf))))
    @test all(isequal_interval.(extended_div(interval(0.0, 0.0), interval(-1.0, 1.0)), (entireinterval(c), emptyinterval(c))))

    @test isequal_interval(interval(0, Inf) * interval(-1, Inf), interval(-Inf, Inf))

    result = interval(1.1) * interval(2) + interval(3)
    @test isequal_interval(muladd(interval(1.1), interval(2), interval(3)), result)
    @test isequal_interval(muladd(interval(1.1), interval(Float32, 2), interval(3)), result)

end

@testset "Arithmetic with constants" begin
    x = interval(1, 2)

    @test isequal_interval(interval(0.1) + x, interval(1.0999999999999999, 2.1))
    @test isequal_interval(interval(3.0) - x, x)
    @test isequal_interval(interval(3.1) - x, interval(1.1, 2.1))
    @test isequal_interval(interval(0.1) * interval(1), interval(0.1, 0.1))
    @test isequal_interval(interval(0.0) * interval(1), interval(0.0, 0.0))
    @test isequal_interval(interval(1) / interval(10.0), interval(0.09999999999999999, 0.1))
end

@testset "Arithmetic with irrational" begin
    @test isequal_interval(interval(1) * interval(π), interval(π))
    @test isequal_interval(interval(π) * interval(1), interval(π))
    @test isequal_interval(interval(π) + interval(0), interval(π))
    @test isequal_interval(interval(0) + interval(π), interval(π))
    @test isequal_interval(interval(π) - interval(0), interval(π))
    @test isequal_interval(interval(0) - interval(π), -interval(π))
end

@testset "Power tests" begin
    @test isequal_interval(pown(interval(2,3)  , 2), interval(4, 9))
    @test isequal_interval(pown(interval(0,3)  , 2), interval(0, 9))
    @test isequal_interval(pown(interval(-3,0) , 2), interval(0, 9))
    @test isequal_interval(pown(interval(-3,-2), 2), interval(4, 9))
    @test isequal_interval(pown(interval(-3,2) , 2), interval(0, 9))
    @test isequal_interval(pown(interval(0,3)  , 3), interval(0, 27))
    @test isequal_interval(pown(interval(2,3)  , 3), interval(8, 27))
    @test isequal_interval(pown(interval(-3,0) , 3), interval(-27., 0.))
    @test isequal_interval(pown(interval(-3,-2), 3), interval(-27, -8))
    @test isequal_interval(pown(interval(-3,2) , 3), interval(-27., 8.))
    @test isequal_interval(pown(interval(0,3)  , -2), interval(1/9, Inf))
    @test isequal_interval(pown(interval(-3,0) , -2), interval(1/9, Inf))
    @test isequal_interval(pown(interval(-3,2) , -2), interval(1/9, Inf))
    @test isequal_interval(pown(interval(2,3)  , -2), interval(1/9, 1/4))
    @test isequal_interval(pown(interval(1,2)  , -3), interval(1/8, 1.0))
    @test isequal_interval(pown(interval(0,3)  , -3), interval(1/27, Inf))
    @test isequal_interval(pown(interval(-1,2) , -3), entireinterval())
    @test isequal_interval(pown(interval(-3,2) ,  3), interval(-27, 8))
    @test isequal_interval(pow(interval(0.0), interval(1.1)), interval(0))
    @test isequal_interval(pown(interval(0.0)  , 0), interval(1))
    @test isequal_interval(pow(interval(0.0), interval(1//10)), interval(0))
    @test isequal_interval(pow(interval(0.0), interval(-1//10)), emptyinterval())
    @test isequal_interval(pown(emptyinterval(), 0), emptyinterval())
    @test isequal_interval(pown(interval(2.5) , 3), interval(15.625, 15.625))
    @test isequal_interval(pown(interval(5//2), 3), interval(125//8))

    x = interval(-3, 2)
    @test isequal_interval(pown(x, 3), interval(-27, 8))

    @test isequal_interval(pow(interval(-3, 4), interval(0.5)), interval(0, 2))
    @test isequal_interval(pow(interval(-3, 4), interval(0.5)), pow(interval(-3, 4), (1//2)))
    @test isequal_interval(pown(interval(-3, 2), 2), interval(0.0, 9.0))
    @test isequal_interval(pow(interval(-3, 4), interval(0.5)), interval(0, 2))
    @test isequal_interval(pow(interval(BigFloat, -3, 4), interval(0.5)), interval(BigFloat, 0, 2))

    @test dist(pow(interval(1, 27), interval(1/3)), interval(1, 3)) < 2*inf(eps(interval(1, 3)))
    @test dist(pow(interval(1, 27), interval(1/3)), interval(1, 3)) < 2*inf(eps(interval(1, 3)))
    @test issubset_interval(interval(1, 3), pow(interval(1, 27), interval(1//3)))
    @test isequal_interval(pow(interval(0.1, 0.7), interval(1//3)), interval(0.46415888336127786, 0.8879040017426008))
    @test dist(pow(interval(0.1, 0.7), interval(1/3)),
        interval(0.46415888336127786, 0.8879040017426008)) < 2*inf(eps(pow(interval(0.1, 0.7), interval(1/3))))

    x = interval(BigFloat, 27)
    y = pow(x, interval(1//3))
    @test diam(y) == 0
    x = interval(BigFloat, 9.595703125)
    y = pow(x, interval(1//3))
    @test diam(y) == 0
    x = interval(BigFloat, 0.1)
    y = pow(x, interval(1//3))
    @test (0 <= diam(y) < 1e-76)
end

@testset "Exp and log tests" begin
    @test issubset_interval(exp(interval(BigFloat, 1//2)), exp(interval(1//2)))
    @test in_interval(exp(big(1//2)), exp(interval(1//2)))
    @test issubset_interval(exp(interval(BigFloat, 0.1)), exp(interval(0.1)))
    @test isequal_interval(exp(interval(0.1)), interval(1.1051709180756475e+00, 1.1051709180756477e+00))
    @test diam(exp(interval(0.1))) == eps(exp(0.1))

    @test issubset_interval(log(interval(BigFloat, 1//2)), log(interval(1//2)))
    @test in_interval(log(big(1//2)), log(interval(1//2)))
    @test issubset_interval(log(interval(BigFloat, 0.1)), log(interval(0.1)))
    @test isequal_interval(log(interval(0.1)), interval(-2.3025850929940459e+00, -2.3025850929940455e+00))
    @test diam(log(interval(0.1))) == eps(log(0.1))

    @test issubset_interval(exp2(interval(BigFloat, 1//2)), exp2(interval(1//2)))
    @test isequal_interval(exp2(interval(1024.0)), interval(1.7976931348623157e308, Inf))
    @test issubset_interval(exp10(interval(BigFloat, 1//2)), exp10(interval(1//2)))
    @test isequal_interval(exp10(interval(308.5)), interval(1.7976931348623157e308, Inf))

    @test issubset_interval(log2(interval(BigFloat, 1//2)), log2(interval(1//2)))
    @test isequal_interval(log2(interval(0.25, 0.5)), interval(-2.0, -1.0))
    @test in_interval(log10(big(1//10)), log10(interval(1//10)))

    @test isequal_interval(log1p(interval(-10.0)), emptyinterval())
end

@testset "Comparison tests" begin
    d = interval(0.1, 2)

    @test isstrictless(d, interval(3))
    @test isweakless(d, interval(2))
    @test isstrictless(interval(-1), d)

    # abs
    @test isequal_interval(abs(interval(0.1, 0.2)), interval(0.1, 0.2))
    @test isequal_interval(abs(interval(-1, 2)), interval(0, 2))

    # real
    @test isequal_interval(real(interval(-1, 1)), interval(-1, 1))
end

@testset "Rational tests" begin
    f = 1 // 3
    g = 1 // 3
    @test isequal_interval(interval(f*g), interval(1//9))
    @test isequal_interval(interval(1//9), interval(1//9, 1//9))
    @test isequal_interval(interval(f, g) - interval(1//1), interval(-2 // 3, -2 // 3))
    @test issubset_interval(interval(f*g), interval(1)/interval(9))
end

@testset "Floor etc. tests" begin
    a = interval(0.1)
    b = interval(0.1, 0.1)
    @test dist(a, b) <= inf(eps(a))

    @test isequal_interval(floor(interval(0.1, 1.1)), interval(0, 1))
    @test isequal_interval(round(interval(0.1, 1.1), RoundDown), interval(0, 1))
    @test isequal_interval(ceil(interval(0.1, 1.1)), interval(1, 2))
    @test isequal_interval(round(interval(0.1, 1.1), RoundUp), interval(1, 2))
    @test isequal_interval(sign(interval(0.1, 1.1)), interval(1.0))
    @test isequal_interval(trunc(interval(0.1, 1.1)), interval(0.0, 1.0))
    @test isequal_interval(round(interval(0.1, 1.1), RoundToZero), interval(0.0, 1.0))
    @test isequal_interval(round(interval(0.1, 1.1)), interval(0.0, 1.0))
    @test isequal_interval(round(interval(0.1, 1.5)), interval(0.0, 2.0))
    @test isequal_interval(round(interval(-1.5, 0.1)), interval(-2.0, 0.0))
    @test isequal_interval(round(interval(-2.5, 0.1)), interval(-2.0, 0.0))
    @test isequal_interval(round(interval(0.1, 1.1), RoundNearest), interval(0.0, 1.0))
    @test isequal_interval(round(interval(0.1, 1.5), RoundNearest), interval(0.0, 2.0))
    @test isequal_interval(round(interval(-1.5, 0.1), RoundNearest), interval(-2.0, 0.0))
    @test isequal_interval(round(interval(-2.5, 0.1), RoundNearest), interval(-2.0, 0.0))
    @test isequal_interval(round(interval(0.1, 1.1), RoundNearestTiesAway), interval(0.0, 1.0))
    @test isequal_interval(round(interval(0.1, 1.5), RoundNearestTiesAway), interval(0.0, 2.0))
    @test isequal_interval(round(interval(-1.5, 0.1), RoundNearestTiesAway), interval(-2.0, 0.0))
    @test isequal_interval(round(interval(-2.5, 0.1), RoundNearestTiesAway), interval(-3.0, 0.0))
end

@testset "Fast power" begin

    @testset "Fast integer powers" begin
        x = interval(1, 2)
        @test isequal_interval(fastpow(x, 2), interval(1, 4))
        @test isequal_interval(fastpow(x, 3), interval(1, 8))
        @test isempty_interval(fastpow(-x, 3))

        @test isequal_interval(fastpow(interval(-1, 2), 2), interval(0, 4))
        @test isequal_interval(fastpow(interval(-1, 2), 3), interval(0, 8))
        @test isequal_interval(fastpow(interval(-1, 2), 4), interval(0, 16))

        @test isempty_interval(fastpow(interval(-2, -1), interval(-1, -1)))

        @test isequal_interval(fastpow(interval(BigFloat, -1, 2), 2), interval(0, 4))
        @test isequal_interval(fastpow(interval(BigFloat, -1, 2), 3), interval(0, 8))
        @test isequal_interval(fastpow(interval(BigFloat, 1, 2), 2), interval(1, 4))

        x = interval(π)
        @test isinterior(pow(x, 100), fastpow(x, 100))
        @test isinterior(pow(x, 50), fastpow(x, 50))
        @test isinterior(pow(x, 50), fastpow(x, 50))

        x = interval(2)
        @test isequal_interval(fastpow(x, 2000), interval(floatmax(), Inf))
    end

    @testset "Fast real powers" begin
        x = interval(1, 2)
        @test isequal_interval(fastpow(x, 0.5), interval(1.0, 1.4142135623730951))
        @test isequal_interval(fastpow(x, 0.5), pow(x, interval(0.5)))

        y = interval(2, 3)
        @test isequal_interval(fastpow(y, -0.5), interval(0.5773502691896257, 0.7071067811865476))

        y = interval(-2, 3)
        @test isequal_interval(fastpow(y, 2.1), interval(0.0, 10.045108566305146))
        @test issubset_interval(pow(y, interval(2.1)), fastpow(y, 2.1))
    end

    @testset "Fast interval powers" begin
        x = interval(1, 2)
        @test isequal_interval(pow(x, interval(-1.5, 2.5)), interval(0.35355339059327373, 5.656854249492381))

        y = interval(-2, 3)
        @test isequal_interval(fastpow(y, 2.1), interval(0.0, 10.045108566305146))
        @test isequal_interval(fastpow(y, interval(-2, 3)), interval(0, Inf))

        @test isequal_interval(fastpow(y, interval(2.1)), interval(0.0, 10.045108566305146))
    end

    @testset "sqrt" begin
        @test isequal_interval(sqrt(interval(2, 3)), interval(1.414213562373095, 1.7320508075688774))

        @test isequal_interval(sqrt(big(interval(2, 3))), interval(big"1.414213562373095048801688724209698078569671875376948073176679737990732478462102", big"1.732050807568877293527446341505872366942805253810380628055806979451933016908815"))
    end

    @testset "cbrt" begin
        @test isequal_interval(cbrt(interval(2, 3)), interval(1.259921049894873, 1.4422495703074085))
        @test isequal_interval(cbrt(big(interval(2, 3))), interval(big"1.259921049894873164767210607278228350570251464701507980081975112155299676513956", big"1.442249570307408382321638310780109588391869253499350577546416194541687596830003"))
        @test issubset_interval(cbrt(big(interval(2, 3))), cbrt(interval(2, 3)))
        @test issubset_interval(Interval{Float64}(cbrt(big(interval(3, 4)))), cbrt(interval(3, 4)))
        @test isequal_interval(cbrt(interval(2f0, 3f0)), interval(1.259921f0, 1.4422497f0))
        @test issubset_interval(cbrt(interval(2, 3)), cbrt(interval(2f0, 3f0)))
    end

    @testset "inv" begin
        @test isequal_interval(inv(interval(2, 3)), interval(0.3333333333333333, 0.5))
        @test isequal_interval(inv(big(interval(2, 3))), interval(big"3.333333333333333333333333333333333333333333333333333333333333333333333333333305e-01", big"5.0e-01"))
    end

    @testset "Float32 intervals" begin

        a = interval(Float32, 1e38)
        b = interval(Float32, 1e2)
        @test isequal_interval(a * b, interval(Float32, floatmax(Float32), Inf))
        @test isequal_interval(pow(interval(1.0f0), interval(1.0f0)), interval(1.0f0)) # test for PR #482
    end



end

@testset "Mince for `Interval`s" begin
    II = interval(-1, 1)
    v = mince(II, 4)
    @test all(isequal_interval.(v, [interval(-1, -0.5), interval(-0.5, 0), interval(0, 0.5), interval(0.5, 1)]))
    @test isequal_interval(hull(v...), II)
    v = mince(II, 8)
    @test length(v) == 8
    @test isequal_interval(hull(v...), II)
end

@testset "rootn test" begin
    @test isequal_interval(rootn(emptyinterval(), 3),  emptyinterval())
    @test isequal_interval(rootn(emptyinterval(), 4), emptyinterval())
    @test isequal_interval(rootn(emptyinterval(), -3), emptyinterval())
    @test isequal_interval(rootn(emptyinterval(), -4), emptyinterval())
    @test isequal_interval(rootn(interval(1, 2), 0), emptyinterval())
    @test isequal_interval(rootn(interval(5, 8), 0), emptyinterval())
    @test isequal_interval(rootn(interval(1, 7), 0), emptyinterval())
    @test isequal_interval(rootn(interval(8, 27), 3), interval(2, 3))
    @test isequal_interval(rootn(interval(0, 27), 3), interval(0, 3))
    @test isequal_interval(rootn(interval(-27, 0), 3), interval(-3, 0))
    @test isequal_interval(rootn(interval(-27, 27), 3), interval(-3, 3))
    @test isequal_interval(rootn(interval(-27, -8), 3), interval(-3, -2))
    @test isequal_interval(rootn(interval(16, 81), 4), interval(2, 3))
    @test isequal_interval(rootn(interval(0, 81), 4), interval(0, 3))
    @test isequal_interval(rootn(interval(-81, 0), 4), interval(0))
    @test isequal_interval(rootn(interval(-81, 81), 4), interval(0, 3))
    @test isequal_interval(rootn(interval(-81, -16), 4), emptyinterval())
    @test isequal_interval(rootn(interval(8, 27), -3), interval(1/3, 1/2))
    @test isequal_interval(rootn(interval(0, 27), -3), interval(1/3, Inf))
    @test isequal_interval(rootn(interval(-27, 0), -3), interval(-Inf, -1/3))
    @test isequal_interval(rootn(interval(-27, 27), -3), interval(-Inf, Inf))
    @test isequal_interval(rootn(interval(-27, -8), -3), interval(-1/2, -1/3))
    @test isequal_interval(rootn(interval(16, 81), -4), interval(1/3, 1/2))
    @test isequal_interval(rootn(interval(0, 81), -4), interval(1/3, Inf))
    @test isequal_interval(rootn(interval(-81, 0), -4), emptyinterval())
    @test isequal_interval(rootn(interval(-81, 1), 1), interval(-81, 1))
    @test isequal_interval(rootn(interval(-81, 81), -4), interval(1/3, Inf))
    @test isequal_interval(rootn(interval(-81, -16), -4), emptyinterval())
    @test isequal_interval(rootn(interval(-81, -16), 1), interval(-81, -16))
    @test isequal_interval(rootn(interval(BigFloat, 16, 81), 4), interval(BigFloat, 2, 3))
    @test isequal_interval(rootn(interval(BigFloat, 0, 81), 4), interval(BigFloat, 0, 3))
    @test isequal_interval(rootn(interval(BigFloat, -81, 0), 4), interval(BigFloat, 0, 0))
    @test isequal_interval(rootn(interval(BigFloat, -81, 81), 4), interval(BigFloat, 0, 3))
    @test isequal_interval(rootn(interval(BigFloat, -27, 27), -3), interval(BigFloat, -Inf, Inf))
    @test isequal_interval(rootn(interval(BigFloat, -81, -16), -4), emptyinterval())
    @test isequal_interval(rootn(interval(BigFloat, -81, -16), 1), interval(BigFloat, -81, -16))
end

"""
    Flavor{F}

A flavor defining how an interval behaves in edge cases. For instance, infinity
may or not be considered part of unbounded intervals.

Some flavors `F` include:
- `:set_based` (default): elements of an interval are real numbers. In
    particular, infinity is never part of an interval. This flavor is described
    and required in Part 2 of the IEEE Standard 1788-2015.
    Edge cases:
        - any unbounded interval does not contain infinity.
        - ``[0, 0] / [0, 0] = \\emptyset``.
        - ``x / [0, 0] = \\emptyset`` for any interval ``x``.
        - ``x \\times [0, 0] = [0, 0]`` for any interval ``x``.
- `:cset`: elements of an interval are either real numbers,
    or ``\\pm \\infty``, applying standard rule for arithmetic with infinity.
    Edge cases:
        - any unbounded interval contains infinity.
        - ``[0, 0] / [0, 0] = [-\\infty, \\infty]``.
        - ``x / [0, 0] = [-\\infty, \\infty]`` for any interval ``x``.
        - ``x \\times [0, 0] = [-\\infty, \\infty]`` for any unbounded interval
          ``x``.

!!! note
    Currently only the flavor `:set_based` is supported and implemented.

# Examples

```jldoctest
julia> IntervalArithmetic.is_valid_interval(Inf, Inf)
false

julia> isempty_interval(bareinterval(0)/bareinterval(0))
true

julia> isempty_interval(bareinterval(1)/bareinterval(0))
true

julia> isempty_interval(bareinterval(-Inf, Inf)/bareinterval(0))
true

julia> isthinzero(bareinterval(0)*bareinterval(-Inf, Inf))
true
```
"""
struct Flavor{F} end

#

"""
    zero_times_infinity([F::Flavor,] T<:NumTypes)

For the given flavor `F`, return ``0 \\times \\infty`` as an instance of type
`T`.
"""
zero_times_infinity(::Flavor{:set_based}, ::Type{T}) where {T<:NumTypes} = zero(T)
zero_times_infinity(::Type{T}) where {T<:NumTypes} = zero_times_infinity(default_flavor(), T)

"""
    div_by_thin_zero([F::Flavor,] x::BareInterval)

For the given flavor `F`, divide `x` by the interval containing only ``0``.
"""
div_by_thin_zero(::Flavor{:set_based}, ::BareInterval{T}) where {T<:NumTypes} =
    emptyinterval(BareInterval{T})
div_by_thin_zero(x::BareInterval) = div_by_thin_zero(default_flavor(), x)

"""
    contains_infinity([F::Flavor,] x::BareInterval)

For the given flavor `F`, test whether `x` contains infinity.
"""
contains_infinity(::Flavor{:set_based}, ::BareInterval) = false
contains_infinity(x::BareInterval) = contains_infinity(default_flavor(), x)

"""
    is_valid_interval([F::Flavor,] a::Real, b::Real)

For the given flavor `F`, test whether ``[a, b]`` is a valid interval.
"""
is_valid_interval(::Flavor{:set_based}, a::Real, b::Real) = ifelse(a == b, !isinf(a), b > a)
# to prevent issues with division by zero, e.g. `is_valid_interval(1//0, 1//0)`
is_valid_interval(::Flavor{:set_based}, a::Rational, b::Rational) =
    !((a > b) | (a == typemax(typeof(a))) | (b == typemin(typeof(b))))
is_valid_interval(a::Real, b::Real) = is_valid_interval(default_flavor(), a, b)

"""
    IntervalArithmetic

Library for validated numerics using interval arithmetic. It provides tools for
performing numerical calculations with guaranteed bounds by representing values
as intervals: computed results enclose the true value. It is well-suited for
computer-assisted proofs, and any context requiring certified numerics.

Learn more: https://github.com/JuliaIntervals/IntervalArithmetic.jl.

## Configuration options

The behavior and performance of the library can be customized through the
following parameters. All defaults can be modified using
[`IntervalArithmetic.configure`](@ref).

- **Bound Type**: The default numerical type used for interval endpoints. The
  default is `Float64`, but any subtype of [`IntervalArithmetic.NumTypes`](@ref)
  may be used to adjust precision, or specific numerical requirements.

- **Flavor**: The interval interpretation according to the IEEE Standard
  1788-2015. The default is the *set-based flavor*, which excludes infinity
  from intervals. Learn more: [`IntervalArithmetic.Flavor`](@ref).

- **Interval Rounding**: The rounding behavior for interval arithmetic
  operations. By default, the library employs *correct rounding* to ensure that
  bounds are computed as tightly as possible. Learn more:
  [`IntervalArithmetic.IntervalRounding`](@ref).

- **Power mode**: The performance setting for computing powers. The default is
  an efficient algorithm prioritizing performance over precision. Learn more:
  [`IntervalArithmetic.PowerMode`](@ref).

- **Matrix Multiplication mode**: The performance setting for computing matrix
  multiplications. The default is an efficient algorithm prioritizing
  performance over precision. Learn more:
  [`IntervalArithmetic.MatMulMode`](@ref).

## Display settings

The display of intervals is controlled by [`setdisplay`](@ref). By default, the
intervals are shown using the standard mathematical notation ``[a, b]``, along
with decorations and up to 6 significant digits.
"""
module IntervalArithmetic

import RoundingEmulator, CRlibm, CoreMath, Base.MPFR

using MacroTools: MacroTools, prewalk, postwalk, @capture

#

include("intervals/intervals.jl")
# convenient alias
const RealOrComplexI{T} = Union{Interval{T},Complex{Interval{T}}}
const ComplexI{T} = Complex{Interval{T}}
const RealIntervalType{T} = Union{BareInterval{T},Interval{T}}
    export RealOrComplexI, ComplexI, RealIntervalType

#

include("piecewise.jl")
    export Domain, Constant, Piecewise, domains, discontinuities, pieces

#

import Printf

include("display.jl")
    export setdisplay

#

mutable struct ConfigurationOptions
    numtype  :: Type{<:NumTypes}
    flavor   :: Symbol
    rounding :: Symbol
    power    :: Symbol
    matmul   :: Symbol
    nthreads :: Union{Nothing,Integer}
end

function Base.show(io::IO, ::MIME"text/plain", params::ConfigurationOptions)
    println(io, "Configuration options:")
    println(io, "  - bound type: ", params.numtype)
    println(io, "  - flavor: ", params.flavor)
    println(io, "  - interval rounding: ", params.rounding)
    println(io, "  - power mode: ", params.power)
    isnothing(params.nthreads) && return print(io, "  - matrix multiplication mode: ", params.matmul)
    println(io, "  - matrix multiplication mode: ", params.matmul)
    return print(io,   "  - number of threads for `:fast` matrix multiplication mode: ", params.nthreads)
end

const configuration_options = ConfigurationOptions(Float64, :set_based, :correct, :fast, :fast, nothing) # default

function configure_numtype(numtype::Type{<:NumTypes})
    @eval default_numtype() = $numtype
    return numtype
end

function configure_flavor(flavor::Symbol)
    flavor == :set_based || return throw(ArgumentError("only the interval flavor `:set_based` is supported and implemented"))
    @eval default_flavor() = Flavor{$(QuoteNode(flavor))}()
    return flavor
end

function configure_rounding(rounding::Symbol)
    rounding ∈ (:correct, :ulp, :none) || return throw(ArgumentError("only the rounding mode `:correct`, `:ulp` and `:none` are available"))
    @eval default_rounding() = IntervalRounding{$(QuoteNode(rounding))}()
    return rounding
end

function configure_power(power::Symbol)
    power ∈ (:slow, :fast) || return throw(ArgumentError("only the power mode `:slow` and `:fast` are available"))
    @eval default_power() = PowerMode{$(QuoteNode(power))}()
    return power
end

# algorithms are defined in the package extension for LinearAlgebra

"""
    MatMulMode{T}

Matrix multiplication mode type.

Available mode types:
- `:fast` (default): Rump's algorithm.
- `:slow` (always used for high-precision number types, e.g., `BigFloat`): generic algorithm.
"""
struct MatMulMode{T} end

function configure_matmul(matmul)
    matmul ∈ (:slow, :fast) || return throw(ArgumentError("only the matrix multiplication mode `:slow` and `:fast` are available"))
    @eval default_matmul() = MatMulMode{$(QuoteNode(matmul))}()
    return matmul
end

configure_threads(::Nothing) = nothing

"""
    configure(; numtype=Float64, flavor=:set_based, rounding=:correct, power=:fast, matmul=:fast)

Configure the default behavior for:

- **Bound Type**: The default numerical type used for interval endpoints. The
  default is `Float64`, but any subtype of [`IntervalArithmetic.NumTypes`](@ref)
  may be used to adjust precision, or specific numerical requirements.

- **Flavor**: The interval interpretation according to the IEEE Standard
  1788-2015. The default is the *set-based flavor*, which excludes infinity
  from intervals. Learn more: [`IntervalArithmetic.Flavor`](@ref).

- **Interval Rounding**: The rounding behavior for interval arithmetic
  operations. By default, the library employs *correct rounding* to ensure that
  bounds are computed as tightly as possible. Learn more:
  [`IntervalArithmetic.IntervalRounding`](@ref).

- **Power mode**: The performance setting for computing powers. The default is
  an efficient algorithm prioritizing performance over precision. Learn more:
  [`IntervalArithmetic.PowerMode`](@ref).

- **Matrix Multiplication mode**: The performance setting for computing matrix
  multiplications. The default is an efficient algorithm prioritizing
  performance over precision. Learn more:
  [`IntervalArithmetic.MatMulMode`](@ref).

- **Number of threads**: The number of threads used by the custom BLAS library
  backing fast interval matrix multiplication. By default (`nothing`) the thread
  count is left unchanged. Setting it requires `LinearAlgebra` to be loaded and
  is unavailable on 32-bit systems.
"""
function configure(; numtype::Type{<:NumTypes}=configuration_options.numtype,
        flavor::Symbol=configuration_options.flavor,
        rounding::Symbol=configuration_options.rounding,
        power::Symbol=configuration_options.power,
        matmul::Symbol=configuration_options.matmul,
        nthreads::Union{Nothing,Integer}=nothing)

    if configuration_options.numtype !== numtype
        configure_numtype(numtype)
        configuration_options.numtype = numtype
    end
    if configuration_options.flavor !== flavor
        configure_flavor(flavor)
        configuration_options.flavor = flavor
    end
    if configuration_options.rounding !== rounding
        configure_rounding(rounding)
        configuration_options.rounding = rounding
    end
    if configuration_options.power !== power
        configure_power(power)
        configuration_options.power = power
    end
    if configuration_options.matmul !== matmul
        configure_matmul(matmul)
        configuration_options.matmul = matmul
    end
    configuration_options.nthreads = configure_threads(nthreads)
    return configuration_options
end

configure_numtype(configuration_options.numtype)
configure_flavor(configuration_options.flavor)
configure_rounding(configuration_options.rounding)
configure_power(configuration_options.power)
configure_matmul(configuration_options.matmul)

#

include("symbols.jl")

# in 1.10, having two standard libraries as package extensions yields circular
# dependencies. We keep LinearAlgebra as a weak dependency and add Random as a
# dependency (cf. https://github.com/JuliaLang/julia/issues/52511)

import Random

Random.rand(rng::Random.AbstractRNG, ::Random.SamplerType{Interval{T}}) where {T<:IntervalArithmetic.NumTypes} =
    interval(rand(rng, T))

sample(x::Interval) = sample(Random.default_rng(), x)

function sample(rng::Random.AbstractRNG, x::Interval{T}) where {T<:NumTypes}
    lo, hi = bounds(x)
    β = rand(rng, float(T))
    lo = ifelse(lo == typemin(T), _value_min(T), lo)
    hi = ifelse(hi == typemax(T), _value_max(T), hi)
    val = convert(T, (1 - β) * lo + β * hi)
    val = ifelse(val < lo, lo, val)
    val = ifelse(val > hi, hi, val)
    return val
end

_value_min(::Type{T}) where {T<:AbstractFloat} = floatmin(T)
_value_max(::Type{T}) where {T<:AbstractFloat} = floatmax(T)

_value_min(::Type{Rational{T}}) where {T<:Integer} = convert(Rational{T}, typemin(T))
_value_max(::Type{Rational{T}}) where {T<:Integer} = convert(Rational{T}, typemax(T))

    export sample

#

bareinterval(::Type{BigFloat}, a::AbstractIrrational) = _unsafe_bareinterval(BigFloat, a, a)

# Note: generated functions must be defined after all the methods they use
@generated function bareinterval(::Type{T}, a::AbstractIrrational) where {T<:NumTypes}
    x = _unsafe_bareinterval(T, a(), a()) # precompute the interval
    return :($x) # set body of the function to return the precomputed result
end

end

# This file contains the functions described as "Trigonometric functions" in
# Section 9.1 of the IEEE Standard 1788-2015 and required for set-based flavor
# in Section 10.5.3

# helper functions

_big_pi(::T) where {T<:AbstractFloat} =
    _unsafe_bareinterval(BigFloat, BigFloat(π, RoundDown; precision = 256), BigFloat(π, RoundUp; precision = 256))

_big_pi(x::BigFloat) =
    _unsafe_bareinterval(BigFloat, BigFloat(π, RoundDown; precision = precision(x)+32), BigFloat(π, RoundUp; precision = precision(x)+32))

function _quadrant(f, x::T) where {T<:AbstractFloat}
    PI = bareinterval(T, π)
    PI_LO, PI_HI = bounds(PI)
    x2 = 2x # should be exact for floats
    if abs(x) ≤ PI_LO # (-π, π)
        x2 ≤ -PI_HI && return 2       # (-π, -π/2)
        x2 < -PI_LO && return f(2, 3) # (-π, -π/2) or [-π/2, 0)
        x2 <  0     && return 3       # [-π/2, 0)
        x2 ≤  PI_LO && return 0       # [0, π/2)
        x2 <  PI_HI && return f(0, 1) # [0, π/2) or [π/2, π)
        return 1 # [π/2, π)
    else
        k = bareinterval(BigFloat, x2) / _big_pi(x)
        fk = floor(k)
        lfk, hfk = bounds(fk)
        return Int(mod(f(lfk, hfk), 4))
    end
end

function _quadrantpi(x::AbstractFloat) # used in `sinpi` and `cospi`
    r = rem(x, 2) # [-2, 2], should be exact for floats
    2r < -3 && return 0 # [-2π, -3π/2)
    r  < -1 && return 1 # [-3π/2, -π)
    2r < -1 && return 2 # [-π, -π/2)
    r  <  0 && return 3 # [-π/2, 0)
    2r <  1 && return 0 # [0, π/2)
    r  <  1 && return 1 # [π/2, π)
    2r <  3 && return 2 # [π, 3π/2)
    return 3 # [3π/2, 2π]
end

# not in the IEEE Standard 1788-2015

Base.rad2deg(x::BareInterval{T}) where {T<:NumTypes} = (x * bareinterval(T, 180)) / bareinterval(T, π)
Base.rad2deg(x::Interval{T}) where {T<:NumTypes} = (x * interval(T, 180)) / interval(T, π)

Base.deg2rad(x::BareInterval{T}) where {T<:NumTypes} = (x / bareinterval(T, 180)) * bareinterval(T, π)
Base.deg2rad(x::Interval{T}) where {T<:NumTypes} = (x / interval(T, 180)) * interval(T, π)

Base.sincospi(x::BareInterval) = (sinpi(x), cospi(x))
Base.sincospi(x::Interval) = (sinpi(x), cospi(x))

Base.sind(x::BareInterval{T}) where {T<:NumTypes} = sinpi(x / bareinterval(T, 180))
Base.sind(x::Interval{T}) where {T<:NumTypes} = sinpi(x / interval(T, 180))

Base.cosd(x::BareInterval{T}) where {T<:NumTypes} = cospi(x / bareinterval(T, 180))
Base.cosd(x::Interval{T}) where {T<:NumTypes} = cospi(x / interval(T, 180))

#

"""
    sin(::BareInterval)
    sin(::Interval)

Implement the `sin` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.sin(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x

    PI_HI = sup(bareinterval(T, π))
    d = diam(x)
    d ≥ 2PI_HI && return _unsafe_bareinterval(T, -one(T), one(T))

    lo, hi = bounds(x)

    lo_quadrant = _quadrant(min, lo)
    hi_quadrant = _quadrant(max, hi)

    if lo_quadrant == hi_quadrant
        d ≥ PI_HI && return _unsafe_bareinterval(T, -one(T), one(T)) # diameter ≥ 2π
        (lo_quadrant == 1) | (lo_quadrant == 2) && return @round(T, sin(hi), sin(lo)) # decreasing
        return @round(T, sin(lo), sin(hi))

    elseif lo_quadrant == 3 && hi_quadrant == 0
        d ≥ PI_HI && return _unsafe_bareinterval(T, -one(T), one(T)) # diameter ≥ 3π/2
        return @round(T, sin(lo), sin(hi)) # increasing

    elseif lo_quadrant == 1 && hi_quadrant == 2
        d ≥ PI_HI && return _unsafe_bareinterval(T, -one(T), one(T)) # diameter ≥ 3π/2
        return @round(T, sin(hi), sin(lo)) # decreasing

    elseif (lo_quadrant == 0 || lo_quadrant == 3) && (hi_quadrant == 1 || hi_quadrant == 2)
        return @round(T, min(sin(lo), sin(hi)), one(T))

    elseif (lo_quadrant == 1 || lo_quadrant == 2) && (hi_quadrant == 3 || hi_quadrant == 0)
        return @round(T, -one(T), max(sin(lo), sin(hi)))

    else # (lo_quadrant == 0 && hi_quadrant == 3) || (lo_quadrant == 2 && hi_quadrant == 1)
        return _unsafe_bareinterval(T, -one(T), one(T))

    end
end

Base.sin(x::BareInterval{<:Rational}) = sin(float(x))

function Base.sin(x::Interval)
    @inline r = sin(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.sin(x::Complex{Interval{T}}) where {T<:NumTypes} = complex(sin(real(x)) * cosh(imag(x)), cos(real(x)) * sinh(imag(x)))

# not in the IEEE Standard 1788-2015

if Int == Int32 && VERSION < v"1.10"
    Base.sinpi(x::BareInterval{T}) where {T<:AbstractFloat} = sin(x * bareinterval(T, π))
else
    function Base.sinpi(x::BareInterval{T}) where {T<:AbstractFloat}
        isempty_interval(x) && return x

        d = diam(x)
        d ≥ 2 && return _unsafe_bareinterval(T, -one(T), one(T))

        lo, hi = bounds(x)

        lo_quadrant = _quadrantpi(lo)
        hi_quadrant = _quadrantpi(hi)

        if lo_quadrant == hi_quadrant
            d ≥ 1 && return _unsafe_bareinterval(T, -one(T), one(T))
            (lo_quadrant == 1) | (lo_quadrant == 2) && return @round(T, sinpi(hi), sinpi(lo)) # decreasing
            return @round(T, sinpi(lo), sinpi(hi))

        elseif lo_quadrant == 3 && hi_quadrant == 0
            return @round(T, sinpi(lo), sinpi(hi)) # increasing

        elseif lo_quadrant == 1 && hi_quadrant == 2
            return @round(T, sinpi(hi), sinpi(lo)) # decreasing

        elseif (lo_quadrant == 0 || lo_quadrant == 3) && (hi_quadrant == 1 || hi_quadrant == 2)
            return @round(T, min(sinpi(lo), sinpi(hi)), one(T))

        elseif (lo_quadrant == 1 || lo_quadrant == 2) && (hi_quadrant == 3 || hi_quadrant == 0)
            return @round(T, -one(T), max(sinpi(lo), sinpi(hi)))

        else # (lo_quadrant == 0 && hi_quadrant == 3) || (lo_quadrant == 2 && hi_quadrant == 1)
            return _unsafe_bareinterval(T, -one(T), one(T))

        end
    end
end

Base.sinpi(x::BareInterval{<:Rational}) = sinpi(float(x))

function Base.sinpi(x::Interval)
    r = sinpi(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.sinpi(x::Complex{Interval{T}}) where {T<:NumTypes} =
    complex(sinpi(real(x)) * cosh(imag(x) * interval(T, π)), cospi(real(x)) * sinh(imag(x) * interval(T, π)))

"""
    cos(::BareInterval)
    cos(::Interval)

Implement the `cos` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.cos(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x

    PI_HI = sup(bareinterval(T, π))
    d = diam(x)
    d ≥ 2PI_HI && return _unsafe_bareinterval(T, -one(T), one(T))

    lo, hi = bounds(x)

    lo_quadrant = _quadrant(min, lo)
    hi_quadrant = _quadrant(max, hi)

    if lo_quadrant == hi_quadrant
        d ≥ PI_HI && return _unsafe_bareinterval(T, -one(T), one(T)) # diameter ≥ 2π
        (lo_quadrant == 2) | (lo_quadrant == 3) && return @round(T, cos(lo), cos(hi)) # increasing
        return @round(T, cos(hi), cos(lo))

    elseif lo_quadrant == 2 && hi_quadrant == 3
        d ≥ PI_HI && return _unsafe_bareinterval(T, -one(T), one(T)) # diameter ≥ 3π/2
        return @round(T, cos(lo), cos(hi))

    elseif lo_quadrant == 0 && hi_quadrant == 1
        d ≥ PI_HI && return _unsafe_bareinterval(T, -one(T), one(T)) # diameter ≥ 3π/2
        return @round(T, cos(hi), cos(lo))

    elseif (lo_quadrant == 2 || lo_quadrant == 3) && (hi_quadrant == 0 || hi_quadrant == 1)
        return @round(T, min(cos(lo), cos(hi)), one(T))

    elseif (lo_quadrant == 0 || lo_quadrant == 1) && (hi_quadrant == 2 || hi_quadrant == 3)
        return @round(T, -one(T), max(cos(lo), cos(hi)))

    else # (lo_quadrant == 3 && hi_quadrant == 2) || (lo_quadrant == 1 && hi_quadrant == 0)
        return _unsafe_bareinterval(T, -one(T), one(T))

    end
end

Base.cos(x::BareInterval{<:Rational}) = cos(float(x))

function Base.cos(x::Interval)
    @inline r = cos(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.cos(x::Complex{Interval{T}}) where {T<:NumTypes} = complex(cos(real(x)) * cosh(imag(x)), -sin(real(x)) * sinh(imag(x)))

# not in the IEEE Standard 1788-2015

if Int == Int32 && VERSION < v"1.10"
    Base.cospi(x::BareInterval{T}) where {T<:AbstractFloat} = cos(x * bareinterval(T, π))
else
    function Base.cospi(x::BareInterval{T}) where {T<:AbstractFloat}
        isempty_interval(x) && return x

        d = diam(x)
        d ≥ 2 && return _unsafe_bareinterval(T, -one(T), one(T))

        lo, hi = bounds(x)

        isthin(x) & !isinteger(lo) & isinteger(2lo) && return zero(BareInterval{T}) # by-pass rounding to improve accuracy for 32 bit systems

        lo_quadrant = _quadrantpi(lo)
        hi_quadrant = _quadrantpi(hi)

        if lo_quadrant == hi_quadrant
            d ≥ 1 && return _unsafe_bareinterval(T, -one(T), one(T))
            (lo_quadrant == 2) | (lo_quadrant == 3) && return @round(T, cospi(lo), cospi(hi)) # increasing
            return @round(T, cospi(hi), cospi(lo))

        elseif lo_quadrant == 2 && hi_quadrant == 3
            return @round(T, cospi(lo), cospi(hi))

        elseif lo_quadrant == 0 && hi_quadrant == 1
            return @round(T, cospi(hi), cospi(lo))

        elseif (lo_quadrant == 2 || lo_quadrant == 3) && (hi_quadrant == 0 || hi_quadrant == 1)
            return @round(T, min(cospi(lo), cospi(hi)), one(T))

        elseif (lo_quadrant == 0 || lo_quadrant == 1) && (hi_quadrant == 2 || hi_quadrant == 3)
            return @round(T, -one(T), max(cospi(lo), cospi(hi)))

        else # (lo_quadrant == 3 && hi_quadrant == 2) || (lo_quadrant == 1 && hi_quadrant == 0)
            return _unsafe_bareinterval(T, -one(T), one(T))

        end
    end
end

Base.cospi(x::BareInterval{<:Rational}) = cospi(float(x))

function Base.cospi(x::Interval)
    r = cospi(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.cospi(x::Complex{Interval{T}}) where {T<:NumTypes} =
    complex(cospi(real(x)) * cosh(imag(x) * interval(T, π)), -sinpi(real(x)) * sinh(imag(x) * interval(T, π)))

"""
    tan(::BareInterval)
    tan(::Interval)

Implement the `tan` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.tan(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x

    diam(x) > sup(bareinterval(T, π)) && return entireinterval(BareInterval{T})

    lo, hi = bounds(x)

    lo_quadrant = _quadrant(min, lo)
    hi_quadrant = _quadrant(max, hi)
    lo_quadrant_mod = mod(lo_quadrant, 2)
    hi_quadrant_mod = mod(hi_quadrant, 2)

    if (lo_quadrant_mod == 0 && hi_quadrant_mod == 1) || (lo_quadrant_mod == hi_quadrant_mod && hi_quadrant != lo_quadrant)
        return entireinterval(BareInterval{T}) # cross singularity

    else
        return @round(T, tan(lo), tan(hi))

    end
end

Base.tan(x::BareInterval{<:Rational}) = tan(float(x))

function Base.tan(x::Interval)
    @inline r = tan(bareinterval(x))
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(isbounded(r), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.tan(x::Complex{<:Interval}) = sin(x) / cos(x)

"""
    cot(::BareInterval)
    cot(::Interval)

Implement the `cot` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.cot(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x

    diam(x) > sup(bareinterval(T, π)) && return entireinterval(BareInterval{T})

    isthinzero(x) && return emptyinterval(BareInterval{T})

    lo, hi = bounds(x)

    lo_quadrant = _quadrant(min, lo)
    hi_quadrant = _quadrant(max, hi)

    if (lo_quadrant == 2 || lo_quadrant == 3) && hi == 0
        return @round(T, typemin(T), cot(lo)) # singularity from the left

    elseif (lo_quadrant == hi_quadrant) || (lo_quadrant == 0 && hi_quadrant == 1) || (lo_quadrant == 2 && hi_quadrant == 3)
        return @round(T, cot(hi), cot(lo))

    else
        return entireinterval(BareInterval{T}) # cross singularity

    end
end

Base.cot(x::BareInterval{<:Rational}) = cot(float(x))

# automatically defined for `Interval` since it is a subtype of `Real`

"""
    sec(::BareInterval)
    sec(::Interval)

Implement the `sec` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.sec(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x

    diam(x) > sup(bareinterval(T, π)) && return entireinterval(BareInterval{T})

    lo, hi = bounds(x)

    lo_quadrant = _quadrant(min, lo)
    hi_quadrant = _quadrant(max, hi)

    if lo_quadrant == hi_quadrant
        (lo_quadrant == 0) | (lo_quadrant == 1) && return @round(T, sec(lo), sec(hi)) # increasing
        return @round(T, sec(hi), sec(lo))

    elseif lo_quadrant == 1 && hi_quadrant == 2
        return @round(T, min(sec(lo), sec(hi)), -one(T))

    elseif lo_quadrant == 3 && hi_quadrant == 0
        return @round(T, one(T), max(sec(lo), sec(hi)))

    else
        return entireinterval(BareInterval{T})

    end
end

Base.sec(x::BareInterval{<:Rational}) = sec(float(x))

# automatically defined for `Interval` since it is a subtype of `Real`

"""
    csc(::BareInterval)
    csc(::Interval)

Implement the `csc` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.csc(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x

    diam(x) > sup(bareinterval(T, π)) && return entireinterval(BareInterval{T})

    isthinzero(x) && return emptyinterval(BareInterval{T})

    lo, hi = bounds(x)

    lo_quadrant = _quadrant(min, lo)
    hi_quadrant = _quadrant(max, hi)

    if (lo_quadrant == 2 || lo_quadrant == 3) && hi == 0
        # singularity from the left
        lo_quadrant == 2 && return @round(T, typemin(T), -one(T))
        return @round(T, typemin(T), csc(lo))

    elseif lo_quadrant == hi_quadrant
        (lo_quadrant == 0) | (lo_quadrant == 3) && return @round(T, csc(hi), csc(lo)) # decreasing
        return @round(T, csc(lo), csc(hi))

    elseif lo_quadrant == 0 && hi_quadrant == 1
        return @round(T, one(T), max(csc(lo), csc(hi)))

    elseif lo_quadrant == 2 && hi_quadrant == 3
        return @round(T, min(csc(lo), csc(hi)), -one(T))

    else
        return entireinterval(BareInterval{T})

    end
end

Base.csc(x::BareInterval{<:Rational}) = csc(float(x))

# automatically defined for `Interval` since it is a subtype of `Real`

"""
    asin(::BareInterval)
    asin(::Interval)

Implement the `asin` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.asin(x::BareInterval{T}) where {T<:AbstractFloat}
    domain = _unsafe_bareinterval(T, -one(T), one(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) && return x
    return @round(T, asin(inf(x)), asin(sup(x)))
end

Base.asin(x::BareInterval{<:Rational}) = asin(float(x))

function Base.asin(x::Interval{T}) where {T<:NumTypes}
    domain = _unsafe_bareinterval(T, -one(T), one(T))
    bx = bareinterval(x)
    r = asin(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(issubset_interval(bx, domain), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.asin(x::Complex{Interval{T}}) where {T<:NumTypes} =
    -interval(T, im)*log(interval(T, im)*x + sqrt(interval(T, 1) - x^2))

"""
    acos(::BareInterval)
    acos(::Interval)

Implement the `acos` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.acos(x::BareInterval{T}) where {T<:AbstractFloat}
    domain = _unsafe_bareinterval(T, -one(T), one(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) && return x
    return @round(T, acos(sup(x)), acos(inf(x)))
end

Base.acos(x::BareInterval{<:Rational}) = acos(float(x))

function Base.acos(x::Interval{T}) where {T<:NumTypes}
    domain = _unsafe_bareinterval(T, -one(T), one(T))
    bx = bareinterval(x)
    r = acos(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(issubset_interval(bx, domain), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.acos(x::Complex{Interval{T}}) where {T<:NumTypes} =
    -interval(T, im)*log(x + interval(T, im)*sqrt(interval(T, 1) - x^2))

"""
    atan(::BareInterval)
    atan(::Interval)

Implement the `atan` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.atan(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    return @round(T, atan(inf(x)), atan(sup(x)))
end

Base.atan(x::BareInterval{<:Rational}) = atan(float(x))

function Base.atan(x::Interval)
    r = atan(bareinterval(x))
    d = min(decoration(x), decoration(r))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.atan(x::Complex{Interval{T}}) where {T<:NumTypes} =
    -interval(T, im)/interval(T, 2)*log((interval(T, im) - x)/(interval(T, im) + x))

"""
    acot(::BareInterval)
    acot(::Interval)

Implement the `acot` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.acot(x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    return @round(T, acot(sup(x)), acot(inf(x)))
end

Base.acot(x::BareInterval{<:Rational}) = acot(float(x))

# automatically defined for `Interval` since it is a subtype of `Real`

"""
    atan(::BareInterval, ::BareInterval)
    atan(::Interval, ::Interval)

Implement the `atan2` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function Base.atan(y::BareInterval{T}, x::BareInterval{T}) where {T<:AbstractFloat}
    isempty_interval(y) && return y
    isempty_interval(x) && return x

    ylo, yhi = bounds(y)
    xlo, xhi = bounds(x)

    if isthinzero(x)
        isthinzero(y) && return emptyinterval(BareInterval{T})
        ylo ≥ 0 && return _half_pi(T)
        yhi ≤ 0 && return -_half_pi(T)
        return _half_range_atan(T)

    elseif xlo > 0
        isthinzero(y) && return y
        ylo ≥ 0 && return @round(T, atan(ylo, xhi), atan(yhi, xlo)) # refinement lo bound
        yhi ≤ 0 && return @round(T, atan(ylo, xlo), atan(yhi, xhi))
        return @round(T, atan(ylo, xlo), atan(yhi, xlo))

    elseif xhi < 0
        isthinzero(y) && return bareinterval(T, π)
        ylo ≥ 0 && return @round(T, atan(yhi, xhi), atan(ylo, xlo))
        yhi < 0 && return @round(T, atan(yhi, xlo), atan(ylo, xhi))
        return _range_atan(T)

    else
        if iszero(xlo)
            isthinzero(y) && return y
            ylo ≥ 0 && return _unsafe_bareinterval(T, _fround(atan, ylo, xhi, RoundDown), sup(_half_range_atan(T)))
            yhi ≤ 0 && return _unsafe_bareinterval(T, inf(_half_range_atan(T)), _fround(atan, yhi, xhi, RoundUp))
            return _half_range_atan(T)

        elseif iszero(xhi)
            isthinzero(y) && return bareinterval(T, π)
            ylo ≥ 0 && return _unsafe_bareinterval(T, inf(_half_pi(T)), _fround(atan, ylo, xlo, RoundUp))
            yhi < 0 && return _unsafe_bareinterval(T, _fround(atan, yhi, xlo, RoundDown), sup(-_half_pi(T)))
            return _range_atan(T)

        else
            ylo ≥ 0 && return @round(T, atan(ylo, xhi), atan(ylo, xlo))
            yhi < 0 && return @round(T, atan(yhi, xlo), atan(yhi, xhi))
            return _range_atan(T)

        end
    end
end

Base.atan(y::BareInterval{T}, x::BareInterval{T}) where {T<:Rational} = atan(float(y), float(x))

Base.atan(y::BareInterval, x::BareInterval) = atan(promote(y, x)...)

function Base.atan(y::Interval, x::Interval)
    by = bareinterval(y)
    bx = bareinterval(x)
    r = atan(by, bx)
    d = min(decoration(y), decoration(x), decoration(r))
    d = min(d,
            ifelse(in_interval(0, by),
                   ifelse(in_interval(0, bx),
                          trv,
                          ifelse(sup(bx) < 0, ifelse(inf(by) < 0, def, d), d)),
                   d))
    t = isguaranteed(y) & isguaranteed(x)
    return _unsafe_interval(r, d, t)
end

# helper functions

_unsafe_scale(x::BareInterval{T}, α::T) where {T<:NumTypes} = @round(T, inf(x) * α, sup(x) * α) # assume `α` is postive

_half_pi(::Type{T}) where {T<:NumTypes} = _unsafe_scale(bareinterval(T, π), convert(T, 0.5))

function _range_atan(::Type{T}) where {T<:NumTypes}
    x = sup(bareinterval(T, π))
    return _unsafe_bareinterval(T, -x, x)
end

_half_range_atan(::Type{T}) where {T<:NumTypes} = _unsafe_scale(_range_atan(T), convert(T, 0.5))

module IntervalArithmeticLinearAlgebraExt

using IntervalArithmetic
import LinearAlgebra
import OpenBLASConsistentFPCSR_jll # 32-bit systems are not supported

function __init__()
    if Int != Int32
        # use the same number of threads as the default BLAS library
        ccall((:openblas_set_num_threads64_, OpenBLASConsistentFPCSR_jll.libopenblas),
            Cint, (Cint,),
            LinearAlgebra.BLAS.get_num_threads())
    end
end

if Int != Int32
    function IntervalArithmetic.configure_threads(nthreads::Integer)
        ccall((:openblas_set_num_threads64_, OpenBLASConsistentFPCSR_jll.libopenblas),
            Cint, (Cint,), nthreads)
        return Int(ccall((:openblas_get_num_threads64_, OpenBLASConsistentFPCSR_jll.libopenblas),
            Cint, ()))
    end
end

# contructor for `UniformScaling`

IntervalArithmetic._interval_infsup(::Type{T}, J::LinearAlgebra.UniformScaling, H::LinearAlgebra.UniformScaling, d::IntervalArithmetic.Decoration) where {T<:IntervalArithmetic.NumTypes} =
    LinearAlgebra.UniformScaling(IntervalArithmetic._interval_infsup(T, J.λ, H.λ, d))

IntervalArithmetic._infer_numtype(J::LinearAlgebra.UniformScaling) = numtype(eltype(J))

IntervalArithmetic.exact(J::LinearAlgebra.UniformScaling) = LinearAlgebra.UniformScaling(exact(J.λ))

# by-pass generic `opnorm` from LinearAlgebra to prevent NG flag

function LinearAlgebra.opnorm1(A::AbstractMatrix{T}) where {T<:RealOrComplexI}
    LinearAlgebra.require_one_based_indexing(A)
    m, n = size(A)
    Tnorm = typeof(float(real(zero(T))))
    Tsum = promote_type(Float64, Tnorm)
    nrm = zero(Tsum)
    @inbounds begin
        for j = 1:n
            nrmj = zero(Tsum)
            for i = 1:m
                nrmj += LinearAlgebra.norm(A[i,j])
            end
            nrm = max(nrm, nrmj)
        end
    end
    return convert(Tnorm, nrm)
end

LinearAlgebra.opnorm2(A::AbstractMatrix{T}) where {T<:RealOrComplexI} = sqrt(maximum(abs, LinearAlgebra.eigvals(adjoint(A)*A)))

function LinearAlgebra.opnormInf(A::AbstractMatrix{T}) where {T<:RealOrComplexI}
    LinearAlgebra.require_one_based_indexing(A)
    m, n = size(A)
    Tnorm = typeof(float(real(zero(T))))
    Tsum = promote_type(Float64, Tnorm)
    nrm = zero(Tsum)
    @inbounds begin
        for i = 1:m
            nrmi = zero(Tsum)
            for j = 1:n
                nrmi += LinearAlgebra.norm(A[i,j])
            end
            nrm = max(nrm, nrmi)
        end
    end
    return convert(Tnorm, nrm)
end

# matrix eigenvalues

function LinearAlgebra.eigvals!(A::AbstractMatrix{<:Interval}; permute::Bool=true, scale::Bool=true, sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby)
    # note: this function does not overwrite `A`
    λ = _eigvals(A, permute, scale, sortby)
    isreal(λ) && return real(λ)
    _fold_conjugate!(λ)
    isreal(λ) && return real(λ)
    return λ
end

LinearAlgebra.eigvals!(A::AbstractMatrix{<:Complex{<:Interval}}; permute::Bool=true, scale::Bool=true, sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    # note: this function does not overwrite `A`
    _eigvals(A, permute, scale, sortby)

function _eigvals(A, permute, scale, sortby)
    # Gershgorin circle theorem
    B = _similarity_transform(A, permute, scale, sortby)
    v = LinearAlgebra.diag(B)
    T = eltype(v)
    for j ∈ axes(B, 1)
        r = zero(T)
        for i ∈ axes(B, 2)
            if i ≠ j
                r += abs(B[i,j])
            end
        end
        v[j] = interval(v[j], r; format = :midpoint)
    end
    return v
end

function _similarity_transform(A, permute, scale, sortby)
    mA = mid.(A)
    mλ, mV = LinearAlgebra.eigen(mA; permute = permute, scale = scale, sortby = sortby)
    mλ .+= LinearAlgebra.diag(mV \ (mA * mV - mV * LinearAlgebra.Diagonal(mλ)))
    Λ = LinearAlgebra.Diagonal(interval(mλ))
    V = interval(mV)
    V .= Λ .+ inv(V) * (A * V - V * Λ)
    return V
end

function _fold_conjugate!(λ)
    for i ∈ eachindex(λ)
        λᵢ = λ[i]
        idxs = findall(j -> (j ≠ i) & !isdisjoint_interval(conj(λᵢ), λ[j]), eachindex(λ))
        if isempty(idxs)
            λ[i] = real(λᵢ)
        else
            w = view(λ, idxs)
            z = conj(intersect_interval(conj(λᵢ), reduce(intersect_interval, w)))
            z = complex(IntervalArithmetic.setdecoration(real(z), min(decoration(real(λᵢ)), minimum(decoration ∘ real, w))), IntervalArithmetic.setdecoration(imag(z), min(decoration(imag(λᵢ)), minimum(decoration ∘ imag, w))))
            λ[i] = z
        end
    end
    return λ
end

# matrix determinant

LinearAlgebra.det(A::AbstractMatrix{<:Interval}) = real(reduce(*, LinearAlgebra.eigvals(A)))
LinearAlgebra.det(A::AbstractMatrix{<:Complex{<:Interval}}) = reduce(*, LinearAlgebra.eigvals(A))

# matrix eigendecomposition
# note: use the contraction mapping theorem, only works when the entries of A have small radii, and A has simple eigenvalues

LinearAlgebra.eigen(A::AbstractMatrix{<:RealOrComplexI}; permute::Bool=true, scale::Bool=true, sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby) =
    LinearAlgebra.eigen!(A; permute, scale, sortby)

function LinearAlgebra.eigen!(A::AbstractMatrix{<:RealOrComplexI}; permute::Bool=true, scale::Bool=true, sortby::Union{Function,Nothing}=LinearAlgebra.eigsortby)
    # note: this function does not overwrite `A`
    λ, v = LinearAlgebra.eigen!(mid.(A); permute, scale, sortby)
    n = length(λ)
    inds = [argmax(i -> abs(v[i,j]), 1:n) for j ∈ 1:n]
    ref_scale = [v[inds[j],j] for j ∈ 1:n]
    foreach(j -> v[:,j] ./= ref_scale[j], 1:n)
    λ_bar, v_bar = interval(λ), interval(v)

    F = [[v_bar[inds[j],j] - interval(1) for j ∈ 1:n] ; vec(A * v_bar - v_bar * LinearAlgebra.Diagonal(λ_bar))]
    DF = zeros(eltype(F), n+n^2, n+n^2)
    for j ∈ 1:n
        DF[j,n+inds[j]+(j-1)*n] = interval(1)
        DF[n+(j-1)*n+1:n+j*n,j] .= .- v_bar[:,j]
        DF[n+(j-1)*n+1:n+j*n,n+(j-1)*n+1:n+j*n] .= A - LinearAlgebra.UniformScaling(λ_bar[j])
    end

    approx_DF⁻¹ = interval(inv(mid.(DF)))
    Y = LinearAlgebra.norm(approx_DF⁻¹ * F, Inf)
    Z₁ = LinearAlgebra.opnorm(approx_DF⁻¹ * DF - interval(LinearAlgebra.I), Inf)
    Z₂ = interval(2) * LinearAlgebra.opnorm(approx_DF⁻¹, Inf)

    if strictprecedes(Z₁, one(Z₁)) & precedes(interval(2) * Y * Z₂, (interval(1) - Z₁)^2)
        r = sup(( interval(1) - Z₁ - sqrt( (interval(1) - Z₁)^2 - interval(2) * Y * Z₂ ) ) / Z₂)
        true_λ = interval.(λ, r; format = :midpoint)
        true_v = interval.(v, r; format = :midpoint)
        _fold_conjugate!(eltype(A), true_λ, true_v)
        foreach(j -> true_v[:,j] .*= interval(ref_scale[j]), 1:n)
    else
        true_λ = fill(nai(eltype(λ_bar)), n)
        true_v = fill(nai(eltype(v_bar)), n, n)
    end
    _ensure_ng_flag!(true_v, all(isguaranteed, A))
    return LinearAlgebra.Eigen(true_λ, true_v)
end

_fold_conjugate!(::Type{<:ComplexI}, λ, v) = (λ, v)

function _fold_conjugate!(::Type{<:Interval}, λ, v)
    for i ∈ eachindex(λ)
        λᵢ = λ[i]
        idxs = findall(j -> (j ≠ i) & !isdisjoint_interval(conj(λᵢ), λ[j]), eachindex(λ))
        if isempty(idxs)
            λ[i] = real(λᵢ)
            v[:,i] .= real.(view(v, :, i))
        else
            w = view(λ, idxs)
            z = conj(intersect_interval(conj(λᵢ), reduce(intersect_interval, w)))
            z = complex(IntervalArithmetic.setdecoration(real(z), min(decoration(real(λᵢ)), minimum(decoration ∘ real, w))), IntervalArithmetic.setdecoration(imag(z), min(decoration(imag(λᵢ)), minimum(decoration ∘ imag, w))))
            λ[i] = z
        end
    end
    return λ, v
end

# matrix inversion
# note: use the contraction mapping theorem, only works when the entries of A have small radii

function Base.inv(A::Matrix{<:RealOrComplexI})
    mid_A = mid.(A)
    approx_A⁻¹ = interval(inv(mid_A))
    F = A * approx_A⁻¹ - interval(LinearAlgebra.I)
    Y = LinearAlgebra.norm(approx_A⁻¹ * F, Inf)
    Z₁ = LinearAlgebra.opnorm(F, Inf)
    A⁻¹ = Matrix{eltype(A)}(undef, size(A))
    if isbounded(Y) & strictprecedes(Z₁, one(Z₁))
        r = sup(Y / (one(Z₁) - Z₁))
        A⁻¹ .= interval.(approx_A⁻¹, r; format = :midpoint)
    else
        A⁻¹ .= nai(eltype(approx_A⁻¹))
    end
    _ensure_ng_flag!(A⁻¹, all(isguaranteed, A))
    return A⁻¹
end

# matrix exponential and logarithm

function LinearAlgebra.exp!(A::AbstractMatrix{T}) where {T<:RealOrComplexI}
    # note: this function does not overwrite `A`
    Λ, V = LinearAlgebra.eigen(A)
    V⁻¹ = inv(V)
    return _output_exp(T, V * LinearAlgebra.Diagonal(exp.(Λ)) * V⁻¹)
end
_output_exp(::Type{<:Interval}, A) = real(A) # exponential of a real matrix is always real
_output_exp(::Type{<:Complex{<:Interval}}, A) = A

function LinearAlgebra.log(A::AbstractMatrix{<:Interval})
    Λ, V = LinearAlgebra.eigen(A)
    any(x -> in_interval(0, x), Λ) && return fill(nai(eltype(A)), size(A))
    V⁻¹ = inv(V)
    any(x -> isreal(x) & precedes(real(x), interval(0)), Λ) && return V * LinearAlgebra.Diagonal(log.(complex.(Λ))) * V⁻¹
    return real(V * LinearAlgebra.Diagonal(log.(Λ)) * V⁻¹)
end

function LinearAlgebra.log(A::AbstractMatrix{<:ComplexI})
    Λ, V = LinearAlgebra.eigen(A)
    any(x -> in_interval(0, x), Λ) && return fill(nai(eltype(A)), size(A))
    V⁻¹ = inv(V)
    return V * LinearAlgebra.Diagonal(log.(Λ)) * V⁻¹
end

# matrix multiplication

function LinearAlgebra.mul!(C::AbstractVector{<:RealOrComplexI}, A::AbstractVecOrMat, B::AbstractVector, α::Number, β::Number)
    size(A, 2) == size(B, 1) || return throw(DimensionMismatch("The number of columns of A must match the number of rows of B."))
    return _mul!(IntervalArithmetic.default_matmul(), C, A, B, α, β)
end

function LinearAlgebra.mul!(C::AbstractMatrix{<:RealOrComplexI}, A::AbstractVecOrMat, B::AbstractVecOrMat, α::Number, β::Number)
    size(A, 2) == size(B, 1) || return throw(DimensionMismatch("The number of columns of A must match the number of rows of B."))
    return _mul!(IntervalArithmetic.default_matmul(), C, A, B, α, β)
end

#

LinearAlgebra.mul!(C::AbstractVecOrMat{<:RealOrComplexI}, A::AbstractMatrix{<:RealOrComplexI}, B::AbstractVecOrMat{<:RealOrComplexI}) =
    LinearAlgebra.mul!(C, A, B, interval(true), interval(false))

function _mul!(::IntervalArithmetic.MatMulMode{:slow}, C, A::AbstractMatrix, B::AbstractVecOrMat, α, β)
    if iszero(α)
        if iszero(β)
            C .= zero(eltype(C))
        elseif !isone(β)
            C .*= β
        end
    else
        if iszero(β)
            _matmul_rec!(C, A, B)
            C .*= α
        else
            AB = Matrix{eltype(C)}(undef, size(A, 1), size(B, 2))
            C .= _matmul_rec!(AB, A, B) .* α .+ C .* β
        end
    end
    t = all(isguaranteed, A) & all(isguaranteed, B) & isguaranteed(α) & isguaranteed(β)
    _ensure_ng_flag!(C, t)
    return C
end

function _matmul_rec!(C, A, B)
    m, n = size(A)
    p = size(B, 2)
    fill!(C, zero(eltype(C)))
    return _add_matmul_rec!(m, n, p, 0, 0, 0, C, A, B)
end

function _add_matmul_rec!(m, n, p, i0, j0, k0, C, A, B)
    if m + n + p ≤ 256 # naive matmul for sufficiently small matrices
        for i ∈ 1:m, k ∈ 1:p
            c = zero(eltype(C))
            for j ∈ 1:n
                @inbounds c += A[i0+i,j0+j] * B[j0+j,k0+k]
            end
            @inbounds C[i0+i,k0+k] += c
        end
    else
        m2 = m ÷ 2; n2 = n ÷ 2; p2 = p ÷ 2
        _add_matmul_rec!(m2, n2, p2, i0, j0, k0, C, A, B)

        _add_matmul_rec!(m-m2, n2, p2, i0+m2, j0, k0, C, A, B)
        _add_matmul_rec!(m2, n-n2, p2, i0, j0+n2, k0, C, A, B)
        _add_matmul_rec!(m2, n2, p-p2, i0, j0, k0+p2, C, A, B)

        _add_matmul_rec!(m-m2, n-n2, p2, i0+m2, j0+n2, k0, C, A, B)
        _add_matmul_rec!(m2, n-n2, p-p2, i0, j0+n2, k0+p2, C, A, B)
        _add_matmul_rec!(m-m2, n2, p-p2, i0+m2, j0, k0+p2, C, A, B)

        _add_matmul_rec!(m-m2, n-n2, p-p2, i0+m2, j0+n2, k0+p2, C, A, B)
    end
    return C
end

# fast matrix multiplication
# Note: Rump's algorithm

function _mul!(::IntervalArithmetic.MatMulMode{:fast}, C, A, B, α, β)
    if Int == Int32
        @info "Fast multiplication is not supported on 32-bit systems, using the slow version"
        return _mul!(IntervalArithmetic.MatMulMode{:slow}(), C, A, B, α, β)
    else
        numtype(eltype(C)) <: Union{Float16,Float32,Float64} && return _fastmul!(C, A, B, α, β)
        @info "Fast multiplication is only supported for `Union{Float16,Float32,Float64}`, using the slow version"
        return _mul!(IntervalArithmetic.MatMulMode{:slow}(), C, A, B, α, β)
    end
end

for (T, S) ∈ ((:Interval, :Interval), (:Interval, :Any), (:Any, :Interval))
    @eval function _fastmul!(C, A::AbstractMatrix{<:$T}, B::AbstractVecOrMat{<:$S}, α, β)
        CoefType = eltype(C)
        if iszero(α)
            if iszero(β)
                C .= zero(CoefType)
            elseif !isone(β)
                C .*= β
            end
        else
            BoundType = numtype(CoefType)
            C_inf, C_sup = __mul(A, B)
            if isone(α)
                if iszero(β)
                    C .=  interval.(BoundType, C_inf, C_sup)
                elseif isone(β)
                    C .+= interval.(BoundType, C_inf, C_sup)
                else
                    C .=  interval.(BoundType, C_inf, C_sup) .+ C .* β
                end
            else
                if iszero(β)
                    C .=  interval.(BoundType, C_inf, C_sup) .* α
                elseif isone(β)
                    C .+= interval.(BoundType, C_inf, C_sup) .* α
                else
                    C .=  interval.(BoundType, C_inf, C_sup) .* α .+ C .* β
                end
            end
        end
        t = all(isguaranteed, A) & all(isguaranteed, B) & isguaranteed(α) & isguaranteed(β)
        _ensure_ng_flag!(C, t)
        return C
    end
end

for (T, S) ∈ ((:(Complex{<:Interval}), :(Complex{<:Interval})),
        (:(Complex{<:Interval}), :Complex), (:Complex, :(Complex{<:Interval})))
    @eval function _fastmul!(C, A::AbstractMatrix{<:$T}, B::AbstractVecOrMat{<:$S}, α, β)
        CoefType = eltype(C)
        if iszero(α)
            if iszero(β)
                C .= zero(CoefType)
            elseif !isone(β)
                C .*= β
            end
        else
            BoundType = numtype(CoefType)
            A_real, A_imag = reim(A)
            B_real, B_imag = reim(B)
            C₁_inf, C₁_sup = __mul(A_real, B_real)
            C₂_inf, C₂_sup = __mul(A_imag, B_imag)
            C₃_inf, C₃_sup = __mul(A_real, B_imag)
            C₄_inf, C₄_sup = __mul(A_imag, B_real)
            if isone(α)
                if iszero(β)
                    C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup) .- interval.(BoundType, C₂_inf, C₂_sup),
                                   interval.(BoundType, C₃_inf, C₃_sup) .+ interval.(BoundType, C₄_inf, C₄_sup))
                elseif isone(β)
                    C .+= complex.(interval.(BoundType, C₁_inf, C₁_sup) .- interval.(BoundType, C₂_inf, C₂_sup),
                                   interval.(BoundType, C₃_inf, C₃_sup) .+ interval.(BoundType, C₄_inf, C₄_sup))
                else
                    C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup) .- interval.(BoundType, C₂_inf, C₂_sup),
                                   interval.(BoundType, C₃_inf, C₃_sup) .+ interval.(BoundType, C₄_inf, C₄_sup)) .+ C .* β
                end
            else
                if iszero(β)
                    C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup) .- interval.(BoundType, C₂_inf, C₂_sup),
                                   interval.(BoundType, C₃_inf, C₃_sup) .+ interval.(BoundType, C₄_inf, C₄_sup)) .* α
                elseif isone(β)
                    C .+= complex.(interval.(BoundType, C₁_inf, C₁_sup) .- interval.(BoundType, C₂_inf, C₂_sup),
                                   interval.(BoundType, C₃_inf, C₃_sup) .+ interval.(BoundType, C₄_inf, C₄_sup)) .* α
                else
                    C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup) .- interval.(BoundType, C₂_inf, C₂_sup),
                                   interval.(BoundType, C₃_inf, C₃_sup) .+ interval.(BoundType, C₄_inf, C₄_sup)) .* α .+ C .* β
                end
            end
        end
        t = all(isguaranteed, A) & all(isguaranteed, B) & isguaranteed(α) & isguaranteed(β)
        _ensure_ng_flag!(C, t)
        return C
    end
end

for (T, S) ∈ ((:(Complex{<:Interval}), :Interval), (:(Complex{<:Interval}), :Any), (:Complex, :Interval))
    @eval begin
        function _fastmul!(C, A::AbstractMatrix{<:$T}, B::AbstractVecOrMat{<:$S}, α, β)
            CoefType = eltype(C)
            if iszero(α)
                if iszero(β)
                    C .= zero(CoefType)
                elseif !isone(β)
                    C .*= β
                end
            else
                BoundType = numtype(CoefType)
                A_real, A_imag = reim(A)
                C₁_inf, C₁_sup = __mul(A_real, B)
                C₂_inf, C₂_sup = __mul(A_imag, B)
                if isone(α)
                    if iszero(β)
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup))
                    elseif isone(β)
                        C .+= complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup))
                    else
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .+ C .* β
                    end
                else
                    if iszero(β)
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .* α
                    elseif isone(β)
                        C .+= complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .* α
                    else
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .* α .+ C .* β
                    end
                end
            end
            t = all(isguaranteed, A) & all(isguaranteed, B) & isguaranteed(α) & isguaranteed(β)
            _ensure_ng_flag!(C, t)
            return C
        end

        function _fastmul!(C, A::AbstractMatrix{<:$S}, B::AbstractVecOrMat{<:$T}, α, β)
            CoefType = eltype(C)
            if iszero(α)
                if iszero(β)
                    C .= zero(CoefType)
                elseif !isone(β)
                    C .*= β
                end
            else
                BoundType = numtype(CoefType)
                B_real, B_imag = reim(B)
                C₁_inf, C₁_sup = __mul(A, B_real)
                C₂_inf, C₂_sup = __mul(A, B_imag)
                if isone(α)
                    if iszero(β)
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup))
                    elseif isone(β)
                        C .+= complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup))
                    else
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .+ C .* β
                    end
                else
                    if iszero(β)
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .* α
                    elseif isone(β)
                        C .+= complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .* α
                    else
                        C .=  complex.(interval.(BoundType, C₁_inf, C₁_sup), interval.(BoundType, C₂_inf, C₂_sup)) .* α .+ C .* β
                    end
                end
            end
            t = all(isguaranteed, A) & all(isguaranteed, B) & isguaranteed(α) & isguaranteed(β)
            _ensure_ng_flag!(C, t)
            return C
        end
    end
end

function __mul(A::AbstractMatrix{T}, B::AbstractVecOrMat{S}) where {T,S}
    NewType = float(IntervalArithmetic.promote_numtype(T, S))
    return __mul(interval.(NewType, A), interval.(NewType, B))
end

function __mul(A::AbstractMatrix{Interval{T}}, B::AbstractVecOrMat{Interval{T}}) where {T<:AbstractFloat}
    all(x -> iszero(radius(x)), A) && return ___mul(sup.(A), B)
    all(x -> iszero(radius(x)), B) && return ___mul(A, sup.(B))
    return ___mul(A, B)
end

function ___mul(A::AbstractMatrix{T}, B::AbstractVecOrMat{Interval{T}}) where {T<:AbstractFloat}
    mB, rB = _vec_or_mat_midradius(B)

    cache_1 = zeros(Float64, size(A, 1), size(B, 2))
    cache_2 = zeros(Float64, size(A, 1), size(B, 2))

    rC = _call_gem_openblas!(cache_1, _to_stride_64(abs.(A)), _to_stride_64(rB), RoundUp)

    stride_A  = _to_stride_64(A)
    stride_mB = _to_stride_64(mB)
    C₁ = IntervalArithmetic._fround.(-,
        T.(_call_gem_openblas!(cache_2, stride_A, stride_mB, RoundDown), RoundDown),
        T.(rC, RoundUp),
        RoundDown)
    C₂ = cache_2; C₂ .= IntervalArithmetic._fround.(+,
        T.(_call_gem_openblas!(cache_2, stride_A, stride_mB, RoundUp), RoundUp),
        T.(rC, RoundUp),
        RoundUp)

    return C₁, C₂
end

function ___mul(A::AbstractMatrix{Interval{T}}, B::AbstractVecOrMat{T}) where {T<:AbstractFloat}
    mA, rA = _vec_or_mat_midradius(A)

    cache_1 = zeros(Float64, size(A, 1), size(B, 2))
    cache_2 = zeros(Float64, size(A, 1), size(B, 2))

    rC = _call_gem_openblas!(cache_1, _to_stride_64(rA), _to_stride_64(abs.(B)), RoundUp)

    stride_mA = _to_stride_64(mA)
    stride_B  = _to_stride_64(B)
    C₁ = IntervalArithmetic._fround.(-,
        T.(_call_gem_openblas!(cache_2, stride_mA, stride_B, RoundDown), RoundDown),
        T.(rC, RoundUp),
        RoundDown)
    C₂ = cache_2; C₂ .= IntervalArithmetic._fround.(+,
        T.(_call_gem_openblas!(cache_2, stride_mA, stride_B, RoundUp), RoundUp),
        T.(rC, RoundUp),
        RoundUp)

    return C₁, C₂
end

function ___mul(A::AbstractMatrix{Interval{T}}, B::AbstractVecOrMat{Interval{T}}) where {T<:AbstractFloat}
    mA, rA = _vec_or_mat_midradius(A)
    mB, rB = _vec_or_mat_midradius(B)

    cache_1 = zeros(Float64, size(A, 1), size(B, 2))
    cache_2 = zeros(Float64, size(A, 1), size(B, 2))

    absmA_rB = _call_gem_openblas!(cache_1, _to_stride_64(abs.(mA)), _to_stride_64(rB), RoundUp)
    U = rB; U .= IntervalArithmetic._fround.(+, abs.(mB), rB, RoundUp)
    rA_U = _call_gem_openblas!(cache_2, _to_stride_64(rA), _to_stride_64(U), RoundUp)

    cache_3 = zeros(Float64, size(A, 1), size(B, 2))

    stride_mA = _to_stride_64(mA)
    stride_mB = _to_stride_64(mB)
    C₁ = IntervalArithmetic._fround.(-,
        T.(_call_gem_openblas!(cache_3, stride_mA, stride_mB, RoundDown), RoundDown),
        IntervalArithmetic._fround.(+, T.(absmA_rB, RoundUp), T.(rA_U, RoundUp), RoundUp),
        RoundDown)
    C₂ = cache_3; C₂ .= IntervalArithmetic._fround.(+,
        T.(_call_gem_openblas!(cache_3, stride_mA, stride_mB, RoundUp), RoundUp),
        IntervalArithmetic._fround.(+, T.(absmA_rB, RoundUp), T.(rA_U, RoundUp), RoundUp),
        RoundUp)

    return C₁, C₂
end

_to_stride_64(A::StridedArray{Float64}) = A
_to_stride_64(A::StridedArray{<:AbstractFloat}) = Float64.(A, RoundUp)
_to_stride_64(A::AbstractVector) = _to_stride_64(Vector(A))
_to_stride_64(A::AbstractMatrix) = _to_stride_64(Matrix(A))

function _vec_or_mat_midradius(A::AbstractVecOrMat{Interval{T}}) where {T<:AbstractFloat}
    mA = IntervalArithmetic._fround.(/, IntervalArithmetic._fround.(+, inf.(A), sup.(A), RoundUp), convert(T, 2), RoundUp)
    rA = IntervalArithmetic._fround.(-, mA, inf.(A), RoundUp)
    return mA, rA
end

#-

let fenv_consts = Vector{Cint}(undef, 9)
    ccall(:jl_get_fenv_consts, Cvoid, (Ptr{Cint},), fenv_consts)
    global const JL_FE_INEXACT   = fenv_consts[1]
    global const JL_FE_UNDERFLOW = fenv_consts[2]
    global const JL_FE_OVERFLOW  = fenv_consts[3]
    global const JL_FE_DIVBYZERO = fenv_consts[4]
    global const JL_FE_INVALID   = fenv_consts[5]

    global const JL_FE_TONEAREST  = fenv_consts[6]
    global const JL_FE_UPWARD     = fenv_consts[7]
    global const JL_FE_DOWNWARD   = fenv_consts[8]
    global const JL_FE_TOWARDZERO = fenv_consts[9]
end

if Sys.iswindows()
    _setrounding(i::Integer) = ccall((:fesetround, Base.libm_name), Cint, (Cint,), i)
    _getrounding() = ccall((:fegetround, Base.libm_name), Cint, ())
else
    _setrounding(i::Integer) = ccall(:fesetround, Cint, (Cint,), i)
    _getrounding() = ccall(:fegetround, Cint, ())
end

_to_rounding_mode(::RoundingMode{:Down}) = JL_FE_DOWNWARD
_to_rounding_mode(::RoundingMode{:Up})   = JL_FE_UPWARD

function _call_gem_openblas!(C, A::AbstractMatrix, B::AbstractMatrix, r::RoundingMode)
    m, k = size(A)
    n = size(B, 2)

    α = 1.0
    β = 0.0

    transA = 'N'
    transB = 'N'

    prev_rounding = _getrounding() # save current rounding mode
    _setrounding(_to_rounding_mode(r)) # set rounding mode to upward
    try
        ccall((:dgemm_64_, OpenBLASConsistentFPCSR_jll.libopenblas), Cvoid,
            (Ref{UInt8}, Ref{UInt8}, Ref{LinearAlgebra.BLAS.BlasInt}, Ref{LinearAlgebra.BLAS.BlasInt}, Ref{LinearAlgebra.BLAS.BlasInt},
                Ref{Float64}, Ptr{Float64}, Ref{LinearAlgebra.BLAS.BlasInt},
                Ptr{Float64}, Ref{LinearAlgebra.BLAS.BlasInt},
                Ref{Float64}, Ptr{Float64}, Ref{LinearAlgebra.BLAS.BlasInt}),
            transA, transB, m, n, k,
            α, A, max(1, stride(A, 2)),
            B, max(1, stride(B, 2)),
            β, C, max(1, stride(C, 2))
            )
        return C
    finally
        _setrounding(prev_rounding) # restore previous rounding mode
    end
end

function _call_gem_openblas!(C, A::AbstractMatrix, B::AbstractVector, r::RoundingMode)
    m, k = size(A)

    α = 1.0
    β = 0.0

    transA = 'N'

    prev_rounding = _getrounding() # save current rounding mode
    _setrounding(_to_rounding_mode(r)) # set rounding mode to upward
    try
        ccall((:dgemv_64_, OpenBLASConsistentFPCSR_jll.libopenblas), Cvoid,
            (Ref{UInt8}, Ref{LinearAlgebra.BLAS.BlasInt}, Ref{LinearAlgebra.BLAS.BlasInt},
                Ref{Float64}, Ptr{Float64}, Ref{LinearAlgebra.BLAS.BlasInt},
                Ptr{Float64}, Ref{LinearAlgebra.BLAS.BlasInt},
                Ref{Float64}, Ptr{Float64}, Ref{LinearAlgebra.BLAS.BlasInt}),
            transA, m, k,
            α, A, max(1, stride(A, 2)),
            B, max(1, stride(B, 1)),
            β, C, max(1, stride(C, 1))
            )
        return C
    finally
        _setrounding(prev_rounding) # restore previous rounding mode
    end
end

# convenient function to propagate NG flag

function _ensure_ng_flag!(C::AbstractVecOrMat{<:Interval}, ng_flag::Bool)
    @inbounds @simd for i ∈ eachindex(C)
        C[i] = IntervalArithmetic._unsafe_interval(C[i].bareinterval, C[i].decoration, ng_flag)
    end
    return C
end

function _ensure_ng_flag!(C::AbstractVecOrMat{<:Complex{<:Interval}}, ng_flag::Bool)
    @inbounds @simd for i ∈ eachindex(C)
        C[i] = complex(
            IntervalArithmetic._unsafe_interval(real(C[i]).bareinterval, real(C[i]).decoration, ng_flag),
            IntervalArithmetic._unsafe_interval(imag(C[i]).bareinterval, imag(C[i]).decoration, ng_flag)
            )
    end
    return C
end

end

# This file contains the constants described in Section 10.5.2 of the
# IEEE Standard 1788-2015

"""
    emptyinterval(T=[default_numtype()])

Create an empty interval. This interval is an exception to the fact that the
lower bound is larger than the upper one.

Implement the `empty` function of the IEEE Standard 1788-2015 (Section 10.5.2).
"""
emptyinterval(::Type{BareInterval{T}}) where {T<:AbstractFloat} = _unsafe_bareinterval(T, convert(T, NaN), convert(T, NaN))
# note: `using Base.unsafe_rational(Int, 0, 0)` as an equivalent to `NaN` for `Rational`
# does not work well since most codes for `Rational` assume that the denominator cannot be zero
# e.g. `iszero(Base.unsafe_rational(Int, 0, 0)) == true`
emptyinterval(::Type{BareInterval{T}}) where {T<:Rational} = _unsafe_bareinterval(T, typemax(T), typemin(T))
emptyinterval(::BareInterval{T}) where {T<:NumTypes} = emptyinterval(BareInterval{T})

emptyinterval(::Type{Interval{T}}) where {T<:NumTypes} = _unsafe_interval(emptyinterval(BareInterval{T}), trv, true)
emptyinterval(x::Interval{T}) where {T} = _unsafe_interval(emptyinterval(BareInterval{T}), trv, isguaranteed(x))

emptyinterval(::Type{Complex{T}}) where {T<:Interval} = complex(emptyinterval(T), emptyinterval(T))
emptyinterval(x::Complex{<:Interval}) = complex(emptyinterval(real(x)), emptyinterval(imag(x)))

emptyinterval(::Type{T}) where {T<:NumTypes} = emptyinterval(Interval{T})
emptyinterval(::T) where {T<:NumTypes} = emptyinterval(T)

emptyinterval(::Type{Complex{T}}) where {T<:NumTypes} = complex(emptyinterval(T), emptyinterval(T))
emptyinterval(::Complex{T}) where {T<:NumTypes} = emptyinterval(Complex{T})

emptyinterval() = emptyinterval(Interval{default_numtype()})

"""
    entireinterval(T=[default_numtype()])

Create an interval representing the entire real line, or the entire complex
plane if `T` is complex.

!!! note
    Depending on the flavor, infinity may or may not be considered part of the
    interval.

Implement the `entire` function of the IEEE Standard 1788-2015 (Section 10.5.2).
"""
entireinterval(::Type{BareInterval{T}}) where {T<:NumTypes} = _unsafe_bareinterval(T, typemin(T), typemax(T))
entireinterval(::BareInterval{T}) where {T<:NumTypes} = entireinterval(BareInterval{T})

entireinterval(::Type{Interval{T}}) where {T<:NumTypes} = _unsafe_interval(entireinterval(BareInterval{T}), dac, true)
entireinterval(x::Interval{T}) where {T} = _unsafe_interval(entireinterval(BareInterval{T}), dac, isguaranteed(x))

entireinterval(::Type{Complex{T}}) where {T<:Interval} = complex(entireinterval(T), entireinterval(T))
entireinterval(x::Complex{<:Interval}) = complex(entireinterval(real(x)), entireinterval(imag(x)))

entireinterval(::Type{T}) where {T<:NumTypes} = entireinterval(Interval{T})
entireinterval(::T) where {T<:NumTypes} = entireinterval(T)

entireinterval(::Type{Complex{T}}) where {T<:NumTypes} = complex(entireinterval(T), entireinterval(T))
entireinterval(::Complex{T}) where {T<:NumTypes} = entireinterval(Complex{T})

entireinterval() = entireinterval(Interval{default_numtype()})

"""
    nai(T=[default_numtype()])

Create an NaI (Not an Interval).
"""
nai(::Type{Interval{T}}) where {T<:NumTypes} = _unsafe_interval(emptyinterval(BareInterval{T}), ill, true)
nai(x::Interval{T}) where {T} = _unsafe_interval(emptyinterval(BareInterval{T}), ill, isguaranteed(x))

nai(::Type{Complex{T}}) where {T<:Interval} = complex(nai(T), nai(T))
nai(x::Complex{<:Interval}) = complex(nai(real(x)), nai(imag(x)))

nai(::Type{T}) where {T<:NumTypes} = nai(Interval{T})
nai(::T) where {T<:NumTypes} = nai(T)

nai(::Type{Complex{T}}) where {T<:NumTypes} = complex(nai(T), nai(T))
nai(::Complex{T}) where {T<:NumTypes} = nai(Complex{T})

nai() = nai(Interval{default_numtype()})

@testset "minimal_inf_test" begin

    @test inf(emptyinterval(BareInterval{Float64})) === +Inf

    @test inf(bareinterval(-Inf,+Inf)) === -Inf

    @test inf(bareinterval(1.0,2.0)) === 1.0

    @test inf(bareinterval(-3.0,-2.0)) === -3.0

    @test inf(bareinterval(-Inf,2.0)) === -Inf

    @test inf(bareinterval(-Inf,0.0)) === -Inf

    @test inf(bareinterval(-Inf,-0.0)) === -Inf

    @test inf(bareinterval(-2.0,Inf)) === -2.0

    @test inf(bareinterval(0.0,Inf)) === -0.0

    @test inf(bareinterval(-0.0,Inf)) === -0.0

    @test inf(bareinterval(-0.0,0.0)) === -0.0

    @test inf(bareinterval(0.0,-0.0)) === -0.0

    @test inf(bareinterval(0.0,0.0)) === -0.0

    @test inf(bareinterval(-0.0,-0.0)) === -0.0

end

@testset "minimal_inf_dec_test" begin

    @test isnan(inf(nai(Interval{Float64})))

    @test inf(interval(emptyinterval(BareInterval{Float64}), trv)) === +Inf

    @test inf(interval(bareinterval(-Inf,+Inf), def)) === -Inf

    @test inf(interval(bareinterval(1.0,2.0), com)) === 1.0

    @test inf(interval(bareinterval(-3.0,-2.0), trv)) === -3.0

    @test inf(interval(bareinterval(-Inf,2.0), dac)) === -Inf

    @test inf(interval(bareinterval(-Inf,0.0), def)) === -Inf

    @test inf(interval(bareinterval(-Inf,-0.0), trv)) === -Inf

    @test inf(interval(bareinterval(-2.0,Inf), trv)) === -2.0

    @test inf(interval(bareinterval(0.0,Inf), def)) === -0.0

    @test inf(interval(bareinterval(-0.0,Inf), trv)) === -0.0

    @test inf(interval(bareinterval(-0.0,0.0), dac)) === -0.0

    @test inf(interval(bareinterval(0.0,-0.0), trv)) === -0.0

    @test inf(interval(bareinterval(0.0,0.0), trv)) === -0.0

    @test inf(interval(bareinterval(-0.0,-0.0), trv)) === -0.0

end

@testset "minimal_sup_test" begin

    @test sup(emptyinterval(BareInterval{Float64})) === -Inf

    @test sup(bareinterval(-Inf,+Inf)) === +Inf

    @test sup(bareinterval(1.0,2.0)) === 2.0

    @test sup(bareinterval(-3.0,-2.0)) === -2.0

    @test sup(bareinterval(-Inf,2.0)) === 2.0

    @test sup(bareinterval(-Inf,0.0)) === 0.0

    @test sup(bareinterval(-Inf,-0.0)) === 0.0

    @test sup(bareinterval(-2.0,Inf)) === Inf

    @test sup(bareinterval(0.0,Inf)) === Inf

    @test sup(bareinterval(-0.0,Inf)) === Inf

    @test sup(bareinterval(-0.0,0.0)) === 0.0

    @test sup(bareinterval(0.0,-0.0)) === 0.0

    @test sup(bareinterval(0.0,0.0)) === 0.0

    @test sup(bareinterval(-0.0,-0.0)) === 0.0

end

@testset "minimal_sup_dec_test" begin

    @test isnan(sup(nai(Interval{Float64})))

    @test sup(interval(emptyinterval(BareInterval{Float64}), trv)) === -Inf

    @test sup(interval(bareinterval(-Inf,+Inf), def)) === +Inf

    @test sup(interval(bareinterval(1.0,2.0), com)) === 2.0

    @test sup(interval(bareinterval(-3.0,-2.0), trv)) === -2.0

    @test sup(interval(bareinterval(-Inf,2.0), dac)) === 2.0

    @test sup(interval(bareinterval(-Inf,0.0), def)) === 0.0

    @test sup(interval(bareinterval(-Inf,-0.0), trv)) === 0.0

    @test sup(interval(bareinterval(-2.0,Inf), trv)) === Inf

    @test sup(interval(bareinterval(0.0,Inf), def)) === Inf

    @test sup(interval(bareinterval(-0.0,Inf), trv)) === Inf

    @test sup(interval(bareinterval(-0.0,0.0), dac)) === +0.0

    @test sup(interval(bareinterval(0.0,-0.0), trv)) === +0.0

    @test sup(interval(bareinterval(0.0,0.0), trv)) === +0.0

    @test sup(interval(bareinterval(-0.0,-0.0), trv)) === +0.0

end

@testset "minimal_mid_test" begin

    @test isnan(mid(emptyinterval(BareInterval{Float64})))

    @test mid(bareinterval(-Inf,+Inf)) === 0.0

    @test mid(bareinterval(-0x1.FFFFFFFFFFFFFp1023,+0x1.FFFFFFFFFFFFFp1023)) === 0.0

    @test mid(bareinterval(0.0,2.0)) === 1.0

    @test mid(bareinterval(2.0,2.0)) === 2.0

    @test mid(bareinterval(-2.0,2.0)) === 0.0

    @test mid(bareinterval(0.0,Inf)) === 0x1.FFFFFFFFFFFFFp1023

    @test mid(bareinterval(-Inf,1.2)) === -0x1.FFFFFFFFFFFFFp1023

    @test mid(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022)) === 0.0

    @test mid(bareinterval(-0x0.0000000000001P-1022,0x0.0000000000002P-1022)) === 0.0

    @test mid(bareinterval(0x1.FFFFFFFFFFFFFP+1022,0x1.FFFFFFFFFFFFFP+1023)) === 0x1.7FFFFFFFFFFFFP+1023

    @test mid(bareinterval(0x0.0000000000001P-1022,0x0.0000000000003P-1022)) === 0x0.0000000000002P-1022

end

@testset "minimal_mid_dec_test" begin

    @test isnan(mid(interval(emptyinterval(BareInterval{Float64}), trv)))

    @test isnan(mid(nai(Interval{Float64})))

    @test mid(interval(bareinterval(-Inf,+Inf), def)) === 0.0

    @test mid(interval(bareinterval(-0x1.FFFFFFFFFFFFFp1023,+0x1.FFFFFFFFFFFFFp1023), trv)) === 0.0

    @test mid(interval(bareinterval(0.0,2.0), com)) === 1.0

    @test mid(interval(bareinterval(2.0,2.0), dac)) === 2.0

    @test mid(interval(bareinterval(-2.0,2.0), trv)) === 0.0

    @test mid(interval(bareinterval(0.0,Inf), trv)) === 0x1.FFFFFFFFFFFFFp1023

    @test mid(interval(bareinterval(-Inf,1.2), trv)) === -0x1.FFFFFFFFFFFFFp1023

    @test mid(interval(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022), trv)) === 0.0

    @test mid(interval(bareinterval(-0x0.0000000000001P-1022,0x0.0000000000002P-1022), trv)) === 0.0

    @test mid(interval(bareinterval(0x1.FFFFFFFFFFFFFP+1022,0x1.FFFFFFFFFFFFFP+1023), trv)) === 0x1.7FFFFFFFFFFFFP+1023

    @test mid(interval(bareinterval(0x0.0000000000001P-1022,0x0.0000000000003P-1022), trv)) === 0x0.0000000000002P-1022

end

@testset "minimal_rad_test" begin

    @test radius(bareinterval(0.0,2.0)) === 1.0

    @test radius(bareinterval(2.0,2.0)) === 0.0

    @test isnan(radius(emptyinterval(BareInterval{Float64})))

    @test radius(bareinterval(-Inf,+Inf)) === Inf

    @test radius(bareinterval(0.0,Inf)) === Inf

    @test radius(bareinterval(-Inf, 1.2)) === Inf

    @test radius(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022)) === 0x0.0000000000002P-1022

    @test radius(bareinterval(0x0.0000000000001P-1022,0x0.0000000000002P-1022)) === 0x0.0000000000001P-1022

    @test radius(bareinterval(0x1P+0,0x1.0000000000003P+0)) === 0x1P-51

end

@testset "minimal_rad_dec_test" begin

    @test radius(interval(bareinterval(0.0,2.0), trv)) === 1.0

    @test radius(interval(bareinterval(2.0,2.0), com)) === 0.0

    @test isnan(radius(interval(emptyinterval(BareInterval{Float64}), trv)))

    @test isnan(radius(nai(Interval{Float64})))

    @test radius(interval(bareinterval(-Inf,+Inf), trv)) === Inf

    @test radius(interval(bareinterval(0.0,Inf), def)) === Inf

    @test radius(interval(bareinterval(-Inf, 1.2), trv)) === Inf

    @test radius(interval(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022), trv)) === 0x0.0000000000002P-1022

    @test radius(interval(bareinterval(0x0.0000000000001P-1022,0x0.0000000000002P-1022), trv)) === 0x0.0000000000001P-1022

    @test radius(interval(bareinterval(0x1P+0,0x1.0000000000003P+0), trv)) === 0x1P-51

end

@testset "minimal_mid_rad_test" begin

    @test isnan(midradius(emptyinterval(BareInterval{Float64}))[1]) && isnan(midradius(emptyinterval(BareInterval{Float64}))[2])

    @test midradius(bareinterval(-Inf,Inf))[1] === 0.0 && midradius(bareinterval(-Inf,Inf))[2] === Inf

    @test midradius(bareinterval(-0x1.FFFFFFFFFFFFFP+1023,0x1.FFFFFFFFFFFFFP+1023))[1] === 0.0 && midradius(bareinterval(-0x1.FFFFFFFFFFFFFP+1023,0x1.FFFFFFFFFFFFFP+1023))[2] === 0x1.FFFFFFFFFFFFFP+1023

    @test midradius(bareinterval(0.0,2.0))[1] === 1.0 && midradius(bareinterval(0.0,2.0))[2] === 1.0

    @test midradius(bareinterval(2.0,2.0))[1] === 2.0 && midradius(bareinterval(2.0,2.0))[2] === 0.0

    @test midradius(bareinterval(-2.0,2.0))[1] === 0.0 && midradius(bareinterval(-2.0,2.0))[2] === 2.0

    @test midradius(bareinterval(0.0,Inf))[1] === 0x1.FFFFFFFFFFFFFP+1023 && midradius(bareinterval(0.0,Inf))[2] === Inf

    @test midradius(bareinterval(-Inf, 1.2))[1] === -0x1.FFFFFFFFFFFFFP+1023 && midradius(bareinterval(-Inf, 1.2))[2] === Inf

    @test midradius(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022))[1] === 0.0 && midradius(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022))[2] === 0x0.0000000000002P-1022

    @test midradius(bareinterval(-0x0.0000000000001P-1022,0x0.0000000000002P-1022))[1] === 0.0 && midradius(bareinterval(-0x0.0000000000001P-1022,0x0.0000000000002P-1022))[2] === 0x0.0000000000002P-1022

    @test midradius(bareinterval(0x1.FFFFFFFFFFFFFP+1022,0x1.FFFFFFFFFFFFFP+1023))[1] === 0x1.7FFFFFFFFFFFFP+1023 && midradius(bareinterval(0x1.FFFFFFFFFFFFFP+1022,0x1.FFFFFFFFFFFFFP+1023))[2] === 0x1.0p+1022

    @test midradius(bareinterval(0x0.0000000000001P-1022,0x0.0000000000003P-1022))[1] === 0x0.0000000000002P-1022 && midradius(bareinterval(0x0.0000000000001P-1022,0x0.0000000000003P-1022))[2] === 0x0.0000000000001P-1022

end

@testset "minimal_mid_rad_dec_test" begin

    @test isnan(midradius(emptyinterval(BareInterval{Float64}))[1]) && isnan(midradius(emptyinterval(BareInterval{Float64}))[2])

    @test isnan(midradius(nai(Interval{Float64}))[1]) && isnan(midradius(nai(Interval{Float64}))[2])

    @test midradius(interval(bareinterval(-Inf,Inf), def))[1] === 0.0 && midradius(interval(bareinterval(-Inf,Inf), def))[2] === Inf

    @test midradius(interval(bareinterval(-0x1.FFFFFFFFFFFFFP+1023,0x1.FFFFFFFFFFFFFP+1023), trv))[1] === 0.0 && midradius(interval(bareinterval(-0x1.FFFFFFFFFFFFFP+1023,0x1.FFFFFFFFFFFFFP+1023), trv))[2] === 0x1.FFFFFFFFFFFFFP+1023

    @test midradius(interval(bareinterval(0.0,2.0), com))[1] === 1.0 && midradius(interval(bareinterval(0.0,2.0), com))[2] === 1.0

    @test midradius(interval(bareinterval(2.0,2.0), dac))[1] === 2.0 && midradius(interval(bareinterval(2.0,2.0), dac))[2] === 0.0

    @test midradius(interval(bareinterval(-2.0,2.0), trv))[1] === 0.0 && midradius(interval(bareinterval(-2.0,2.0), trv))[2] === 2.0

    @test midradius(interval(bareinterval(0.0,Inf), trv))[1] === 0x1.FFFFFFFFFFFFFP+1023 && midradius(interval(bareinterval(0.0,Inf), trv))[2] === Inf

    @test midradius(interval(bareinterval(-Inf, 1.2), trv))[1] === -0x1.FFFFFFFFFFFFFP+1023 && midradius(interval(bareinterval(-Inf, 1.2), trv))[2] === Inf

    @test midradius(interval(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022), trv))[1] === 0.0 && midradius(interval(bareinterval(-0x0.0000000000002P-1022,0x0.0000000000001P-1022), trv))[2] === 0x0.0000000000002P-1022

    @test midradius(interval(bareinterval(-0x0.0000000000001P-1022,0x0.0000000000002P-1022), trv))[1] === 0.0 && midradius(interval(bareinterval(-0x0.0000000000001P-1022,0x0.0000000000002P-1022), trv))[2] === 0x0.0000000000002P-1022

    @test midradius(interval(bareinterval(0x1.FFFFFFFFFFFFFP+1022,0x1.FFFFFFFFFFFFFP+1023), trv))[1] === 0x1.7FFFFFFFFFFFFP+1023 && midradius(interval(bareinterval(0x1.FFFFFFFFFFFFFP+1022,0x1.FFFFFFFFFFFFFP+1023), trv))[2] === 0x1.0p+1022

    @test midradius(interval(bareinterval(0x0.0000000000001P-1022,0x0.0000000000003P-1022), trv))[1] === 0x0.0000000000002P-1022 && midradius(interval(bareinterval(0x0.0000000000001P-1022,0x0.0000000000003P-1022), trv))[2] === 0x0.0000000000001P-1022

end

@testset "minimal_wid_test" begin

    @test diam(bareinterval(2.0,2.0)) === 0.0

    @test diam(bareinterval(1.0,2.0)) === 1.0

    @test diam(bareinterval(1.0,Inf)) === Inf

    @test diam(bareinterval(-Inf,2.0)) === Inf

    @test diam(bareinterval(-Inf,+Inf)) === Inf

    @test isnan(diam(emptyinterval(BareInterval{Float64})))

    @test diam(bareinterval(0x1P+0,0x1.0000000000001P+0)) === 0x1P-52

    @test diam(bareinterval(0x1P-1022,0x1.0000000000001P-1022)) === 0x0.0000000000001P-1022

end

@testset "minimal_wid_dec_test" begin

    @test diam(interval(bareinterval(2.0,2.0), com)) === 0.0

    @test diam(interval(bareinterval(1.0,2.0), trv)) === 1.0

    @test diam(interval(bareinterval(1.0,Inf), trv)) === Inf

    @test diam(interval(bareinterval(-Inf,2.0), def)) === Inf

    @test diam(interval(bareinterval(-Inf,+Inf), trv)) === Inf

    @test isnan(diam(interval(emptyinterval(BareInterval{Float64}), trv)))

    @test isnan(diam(nai(Interval{Float64})))

    @test diam(interval(bareinterval(0x1P+0,0x1.0000000000001P+0), trv)) === 0x1P-52

    @test diam(interval(bareinterval(0x1P-1022,0x1.0000000000001P-1022), trv)) === 0x0.0000000000001P-1022

end

@testset "minimal_mag_test" begin

    @test mag(bareinterval(1.0,2.0)) === 2.0

    @test mag(bareinterval(-4.0,2.0)) === 4.0

    @test mag(bareinterval(-Inf,2.0)) === Inf

    @test mag(bareinterval(1.0,Inf)) === Inf

    @test mag(bareinterval(-Inf,+Inf)) === Inf

    @test isnan(mag(emptyinterval(BareInterval{Float64})))

    @test mag(bareinterval(-0.0,0.0)) === 0.0

    @test mag(bareinterval(-0.0,-0.0)) === 0.0

end

@testset "minimal_mag_dec_test" begin

    @test mag(interval(bareinterval(1.0,2.0), com)) === 2.0

    @test mag(interval(bareinterval(-4.0,2.0), trv)) === 4.0

    @test mag(interval(bareinterval(-Inf,2.0), trv)) === Inf

    @test mag(interval(bareinterval(1.0,Inf), def)) === Inf

    @test mag(interval(bareinterval(-Inf,+Inf), trv)) === Inf

    @test isnan(mag(interval(emptyinterval(BareInterval{Float64}), trv)))

    @test isnan(mag(nai(Interval{Float64})))

    @test mag(interval(bareinterval(-0.0,0.0), trv)) === 0.0

    @test mag(interval(bareinterval(-0.0,-0.0), trv)) === 0.0

end

@testset "minimal_mig_test" begin

    @test mig(bareinterval(1.0,2.0)) === 1.0

    @test mig(bareinterval(-4.0,2.0)) === 0.0

    @test mig(bareinterval(-4.0,-2.0)) === 2.0

    @test mig(bareinterval(-Inf,2.0)) === 0.0

    @test mig(bareinterval(-Inf,-2.0)) === 2.0

    @test mig(bareinterval(-1.0,Inf)) === 0.0

    @test mig(bareinterval(1.0,Inf)) === 1.0

    @test mig(bareinterval(-Inf,+Inf)) === 0.0

    @test isnan(mig(emptyinterval(BareInterval{Float64})))

    @test mig(bareinterval(-0.0,0.0)) === 0.0

    @test mig(bareinterval(-0.0,-0.0)) === 0.0

end

@testset "minimal_mig_dec_test" begin

    @test mig(interval(bareinterval(1.0,2.0), com)) === 1.0

    @test mig(interval(bareinterval(-4.0,2.0), trv)) === 0.0

    @test mig(interval(bareinterval(-4.0,-2.0), trv)) === 2.0

    @test mig(interval(bareinterval(-Inf,2.0), def)) === 0.0

    @test mig(interval(bareinterval(-Inf,-2.0), trv)) === 2.0

    @test mig(interval(bareinterval(-1.0,Inf), trv)) === 0.0

    @test mig(interval(bareinterval(1.0,Inf), trv)) === 1.0

    @test mig(interval(bareinterval(-Inf,+Inf), trv)) === 0.0

    @test isnan(mig(interval(emptyinterval(BareInterval{Float64}), trv)))

    @test isnan(mig(nai(Interval{Float64})))

    @test mig(interval(bareinterval(-0.0,0.0), trv)) === 0.0

    @test mig(interval(bareinterval(-0.0,-0.0), trv)) === 0.0

end

using BenchmarkTools
using CairoMakie
using DataFrames

include("benchmarks.jl")

results = run(SUITE ; verbose = true)

df = DataFrame(; constructor = String[], suite = String[], f = String[], trial = BenchmarkTools.Trial[])

for (name, T) in interval_constructors
    # for suite in suites
    begin
        suite = "basics"
        suite_df = DataFrame(results[name][suite], [:f, :trial])
        suite_df[:, :constructor] .= name
        suite_df[:, :suite] .= suite
        df = vcat(df, suite_df)
    end
end

transform!(df,
    :trial => ByRow(trial -> minimum(trial.times)) => :minimum,
    :trial => ByRow(trial -> mean(trial.times)) => :mean,
    :trial => ByRow(trial -> median(trial.times)) => :median
)

df[:, :relative] .= 0.0

for group in groupby(df, :f)
    group[:, :relative] .= group[:, :median] ./ only(group[group.constructor .== "bareinterval", :median])
end

begin
    fig = Figure(size = (800, 500))
    
    data = df[df.suite .== "basics", :]

    fs = vcat(string.(basic_arithmetic), string.(basic_functions))
    to_x = Dict(f => k for (k, f) in enumerate(fs))
    xx = [to_x[f] for f in data.f]
    
    constructors = ["bareinterval", "interval", "BigFloat bareinterval", "BigFloat interval", "BigFloat MPFI"]
    to_dodge = Dict(constructor => k for (k, constructor) in enumerate(constructors))
    dodge = [to_dodge[constructor] for constructor in data.constructor]

    ax = Axis(fig[1, 1] ;
        xlabel = "Benchmarked function",
        xticks = (1:length(fs), fs),
        ylabel = "Relative execution time (log scale)",
        yscale = log10,
    )

    barplot!(ax, xx, data.relative ;
        dodge,
        color = dodge,
        colormap = :mpetroff_10,
        colorrange = (1, 10),
    )

    Legend(fig[0, 1],
        [LineElement(linewidth = 20, color = to_colormap(:mpetroff_10)[k]) for k in eachindex(constructors)],
        constructors ;
        tellwidth = false,
        orientation = :horizontal
    )

    fig
end

@testset "exceptions" begin

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[+infinity]") === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test bareinterval(+Inf,-Inf) === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test bareinterval(nai(Interval{Float64})) === emptyinterval(BareInterval{Float64})

    @test_logs (:warn,) @test parse(BareInterval{Float64}, "[1.0000000000000001, 1.0000000000000002]") === bareinterval(1.0, 0x1.0000000000001p+0)

end

using IntervalArithmetic: interval_diff

# the arguments must be locals of a function for `@allocated` to be meaningful,
# and the call must be compiled before it is measured
function alloc_hull8(x)
    hull(x, x, x, x, x, x, x, x)
    return @allocated hull(x, x, x, x, x, x, x, x)
end

function alloc_intersect8(x)
    intersect_interval(x, x, x, x, x, x, x, x)
    return @allocated intersect_interval(x, x, x, x, x, x, x, x)
end

@testset "hull and intersect_interval" begin
    # the empty interval is neutral for `hull` and absorbing for
    # `intersect_interval`, in either position and for both interval types
    for T ∈ (Float64, Float32, BigFloat, Rational{Int})
        x = bareinterval(T, 1, 2)
        e = emptyinterval(BareInterval{T})

        @test isequal_interval(hull(e, e), e)
        @test isequal_interval(hull(x, e), x)
        @test isequal_interval(hull(e, x), x)
        @test isequal_interval(hull(x, bareinterval(T, 5, 6)), bareinterval(T, 1, 6))

        @test isempty_interval(intersect_interval(e, e))
        @test isempty_interval(intersect_interval(x, e))
        @test isempty_interval(intersect_interval(e, x))
        @test isempty_interval(intersect_interval(x, bareinterval(T, 5, 6)))
        @test isequal_interval(intersect_interval(x, bareinterval(T, 0, 3)), x)

        y = interval(T, 1, 2)
        f = emptyinterval(Interval{T})

        @test isempty_interval(hull(f, f))
        @test isequal_interval(hull(y, f), y)
        @test isequal_interval(hull(f, y), y)
        @test isempty_interval(intersect_interval(y, f))
        @test isempty_interval(intersect_interval(f, y))
    end

    # an NaI operand poisons the result, in either position and at any arity
    n = nai(Float64)
    x = interval(1, 2)

    @test isnai(hull(n, x)) & isnai(hull(x, n)) & isnai(hull(n, n))
    @test isnai(intersect_interval(n, x)) & isnai(intersect_interval(x, n))
    @test isnai(hull(x, x, n)) & isnai(hull(x, n, x)) & isnai(hull(n, x, x))
    @test isnai(hull(x, x, x, n))
    @test isnai(intersect_interval(x, x, n)) & isnai(intersect_interval(n, x, x))

    # `dec = :default` yields `trv`, `dec = :auto` the minimal input decoration
    y = interval(3, 4)
    z = interval(5, Inf)

    @test decoration(hull(x, y)) == trv
    @test decoration(hull(x, y; dec = :auto)) == com
    @test decoration(hull(x, z; dec = :auto)) == dac
    @test decoration(hull(x, y; dec = def)) == def
    @test decoration(intersect_interval(x, y)) == trv
    @test decoration(intersect_interval(x, interval(2, 3); dec = :auto)) == com
    @test_throws ArgumentError hull(x, y; dec = :nonsense)
    @test_throws ArgumentError intersect_interval(x, y; dec = :nonsense)

    # `dec = :auto` cannot promise `com` for an unbounded hull
    @test decoration(hull(interval(-Inf, 0), interval(1, 2); dec = :auto)) == dac

    # bare intervals accept the variadic forms, without a `dec` keyword
    bs = (bareinterval(1, 2), bareinterval(-3, 0), bareinterval(5, 6))

    @test isequal_interval(hull(bs...), bareinterval(-3, 6))
    @test isequal_interval(hull(bs..., bareinterval(7, 9)), bareinterval(-3, 9))
    @test isempty_interval(intersect_interval(bs...))
    @test isequal_interval(
        intersect_interval(bareinterval(0, 4), bareinterval(1, 5), bareinterval(2, 6)),
        bareinterval(2, 4))
    @test_throws MethodError hull(bs...; dec = :auto)

    # the variadic forms agree with the pairwise reduction they replace
    args = (interval(1, 2), interval(-3, 0), interval(5, 6), interval(-1, 8),
        interval(0, 1), interval(-2, 2), interval(4, 7), interval(-5, 5))
    for dec ∈ (:default, :auto, trv, def, com)
        for k ∈ 3:8
            xs = args[1:k]
            @test isequal_interval(hull(xs...; dec = dec), reduce((a, b) -> hull(a, b; dec = dec), xs))
            @test decoration(hull(xs...; dec = dec)) == decoration(reduce((a, b) -> hull(a, b; dec = dec), xs))
            @test isequal_interval(intersect_interval(xs...; dec = dec), reduce((a, b) -> intersect_interval(a, b; dec = dec), xs))
            @test decoration(intersect_interval(xs...; dec = dec)) == decoration(reduce((a, b) -> intersect_interval(a, b; dec = dec), xs))
        end
    end

    # The variadic methods must specialize on the number of arguments: without
    # that, the reductions over the arguments allocate and dispatch dynamically
    # past six arguments, which costs two orders of magnitude.
    @test alloc_hull8(interval(1, 2)) == 0
    @test alloc_intersect8(interval(1, 2)) == 0
    @test alloc_hull8(bareinterval(1, 2)) == 0
    @test alloc_intersect8(bareinterval(1, 2)) == 0

    # `isguaranteed` is the conjunction over all the arguments
    ng = convert(Interval{Float64}, 1)

    @test !isguaranteed(hull(x, ng))
    @test !isguaranteed(hull(x, y, ng))
    @test !isguaranteed(hull(x, y, x, ng))
    @test isguaranteed(hull(x, y, x))
    @test !isguaranteed(intersect_interval(x, y, ng))

    # mixed bound types promote, at any arity
    @test numtype(hull(interval(Float32, 1, 2), interval(Float64, 3, 4))) === Float64
    @test numtype(hull(interval(Float32, 1, 2), interval(Float32, 0, 1), interval(Float64, 3, 4))) === Float64
    @test numtype(intersect_interval(interval(Float32, 1, 2), interval(Float32, 0, 3), interval(Float64, 1, 4))) === Float64

    # a zero lower bound of the result still reports as `-0.0`
    @test inf(hull(interval(0, 1), interval(2, 3))) === -0.0
    @test inf(intersect_interval(interval(0, 1), interval(-1, 3))) === -0.0
end

@testset "removed interval" begin
    @test_throws ArgumentError intersect(interval(1))
    @test_throws ArgumentError intersect(interval(1), 2, [1], 4., 5)
    @test_throws ArgumentError intersect(interval(1), interval(2.), interval(3.))
    @test_throws ArgumentError union(interval(1))
    @test_throws ArgumentError union(interval(1), 2, [1], 4., 5)
    @test_throws ArgumentError union(interval(1), interval(2.), interval(3.))
    @test_throws ArgumentError setdiff(interval(1))
    @test_throws ArgumentError setdiff(interval(1), 2, [1], 4., 5)
    @test_throws ArgumentError setdiff(interval(1), interval(2.), interval(3.))
    @test_throws ArgumentError symdiff(interval(1), interval(2.), interval(3.))
end

@testset "interiordiff" begin
    x = interval(2, 4)
    y = interval(3, 5)

    @test typeof(interiordiff(x, y)) == Vector{Interval{Float64}}

    @test all(isequal_interval.(interiordiff(x, x), [interval(2), interval(4)]))
    @test all(isequal_interval.(interiordiff(x, emptyinterval(x)), [x]))

    @test all(isequal_interval.(interiordiff(x, y), [interval(2, 3)]))
    @test all(isequal_interval.(interiordiff(y, x), [interval(4, 5)]))

    y = interval(2, 5)

    @test all(isequal_interval.(interiordiff(x, y), [interval(2)]))
    @test all(isequal_interval.(interiordiff(y, x), [interval(2), interval(4, 5)]))

    x = interval(2, 5)
    y = interval(3, 4)
    @test all(isequal_interval.(interiordiff(x, y), [interval(2, 3), interval(4, 5)]))

    x = interval(1, 3)
    z = interval(0, 5)
    @test interiordiff(x, z) == Interval{Float64}[]
    @test all(isequal_interval.(interiordiff(z, x), [interval(0, 1), interval(3, 5)]))
end

@testset "interval_diff" begin
    A, B = interval_diff(interval(1, 10), interval(2, 5))
    @test isequal_interval(A, interval(1, 2))
    @test isequal_interval(B, interval(5, 10))

    @test isequal_interval(
        only(interval_diff(interval(1, 10), interval(1, 5))),
        interval(5, 10)
    )

    @test isequal_interval(
        only(interval_diff(interval(1, 10), interval(7, 12))),
        interval(1, 7)
    )

    @test interval_diff(interval(1, 10), interval(-1, 14)) == []
    @test interval_diff(interval(1, 10), interval(1, 10)) == []
end

"""
    ExactReal{T<:Real} <: Real

Real numbers with the assurance that they precisely correspond to the number
described by their binary form. The purpose is to guarantee that a non interval
number is exact, so that `ExactReal` can be used with `Interval` without
producing the "NG" flag.

An `ExactReal` is constructed by wrapping the value with `exact`.

See also: [`@exact`](@ref)

!!! danger
    By using `ExactReal`, users acknowledge the responsibility of ensuring that
    the number they input corresponds to their intended value.
    For example, `exact(0.1)` implies that the user knows that ``0.1`` can
    not be represented exactly as a binary number, and that they are using a
    slightly different number than ``0.1``.
    To help identify the binary number, `ExactReal` is displayed without any
    rounding up to 2000 decimals.

    ```julia
    julia> exact(0.1)
    ExactReal{Float64}(0.1000000000000000055511151231257827021181583404541015625)
    ```

    In case of doubt, [`has_exact_display`](@ref) can be use to check if the
    string representation of a `Real` is equal to its binary value (up to 2000
    decimals).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> 0.5 * interval(1)
Interval{Float64}(0.5, 0.5, com, false)

julia> exact(0.5) * interval(1)
Interval{Float64}(0.5, 0.5, com, true)

julia> setdisplay(:infsup);

julia> [1, interval(2)]
2-element Vector{Interval{Float64}}:
 [1.0, 1.0]_com_NG
 [2.0, 2.0]_com

julia> [exact(1), interval(2)]
2-element Vector{Interval{Float64}}:
 [1.0, 1.0]_com
 [2.0, 2.0]_com
```

See also: [`@exact`](@ref).
"""
struct ExactReal{T<:Real} <: Real
    value :: T

    global exact(value::T) where {T<:Real} = new{T}(value)
end

exact(x::Complex) = complex(exact(real(x)), exact(imag(x)))

exact(x::AbstractArray) = exact.(x)

exact(x::ExactReal) = x # avoid nested `ExactReal`

_value(x::ExactReal) = x.value # hook for interval constructor

isguaranteed(::ExactReal) = true

# utilities

Base.to_index(i::ExactReal{<:Integer}) = i.value # allow to index with ExactReal

Base.zero(::Type{ExactReal{T}}) where {T<:Real} = exact(zero(T))
Base.zero(::ExactReal{T}) where {T<:Real} = zero(ExactReal{T})

Base.zero(::Type{Complex{ExactReal{T}}}) where {T<:Real} = complex(zero(ExactReal{T}), zero(ExactReal{T}))
Base.zero(::Complex{ExactReal{T}}) where {T<:Real} = zero(Complex{ExactReal{T}})

Base.one(::Type{ExactReal{T}}) where {T<:Real} = exact(one(T))
Base.one(::ExactReal{T}) where {T<:Real} = one(ExactReal{T})

Base.one(::Type{Complex{ExactReal{T}}}) where {T<:Real} = complex(one(ExactReal{T}), zero(ExactReal{T}))
Base.one(::Complex{ExactReal{T}}) where {T<:Real} = one(Complex{ExactReal{T}})

Base.hash(x::ExactReal, h::UInt) = hash(x.value, h)

Base.isfinite(x::ExactReal) = isfinite(x.value)
Base.isinteger(x::ExactReal) = isinteger(x.value)
Base.isnan(x::ExactReal) = isnan(x.value) # also ensures that `Base.isinf` works properly

# conversion and promotion

Base.convert(::Type{ExactReal{T}}, x::ExactReal{T}) where {T<:Real} = x # needed since `ExactReal{T}(::T)` is not allowed

Base.promote_rule(::Type{ExactReal{T}}, ::Type{ExactReal{S}}) where {T<:Real,S<:Real} =
    throw(ArgumentError("promotion between `ExactReal` is not allowed"))

for T ∈ (:Rational, :Integer), S ∈ (:Rational, :Integer)
    @eval Base.convert(::Type{ExactReal{R}}, x::ExactReal{U}) where {R<:$T,U<:$S} = exact(convert(R, x.value))

    @eval Base.promote_rule(::Type{ExactReal{R}}, ::Type{ExactReal{U}}) where {R<:$T,U<:$S} = ExactReal{promote_type(R, U)}
end

# to BareInterval

BareInterval{T}(x::ExactReal) where {T<:NumTypes} = convert(BareInterval{T}, x)
BareInterval(x::ExactReal) = BareInterval{promote_numtype(numtype(x.value), numtype(x.value))}(x)

Base.convert(::Type{BareInterval{T}}, x::ExactReal) where {T<:NumTypes} = bareinterval(T, x.value)

Base.promote_rule(::Type{BareInterval{T}}, ::Type{ExactReal{S}}) where {T<:NumTypes,S<:Real} =
    BareInterval{promote_numtype(T, S)}
Base.promote_rule(::Type{ExactReal{T}}, ::Type{BareInterval{S}}) where {T<:Real,S<:NumTypes} =
    BareInterval{promote_numtype(T, S)}

# to Interval

Base.convert(::Type{Interval{T}}, x::ExactReal) where {T<:NumTypes} = interval(T, x.value)

Base.promote_rule(::Type{Interval{T}}, ::Type{ExactReal{S}}) where {T<:NumTypes,S<:Real} =
    Interval{promote_numtype(T, S)}
Base.promote_rule(::Type{ExactReal{T}}, ::Type{Interval{S}}) where {T<:Real,S<:NumTypes} =
    Interval{promote_numtype(T, S)}

# to Real

Base.Bool(x::ExactReal) = convert(Bool, x) # needed to resolve ambiguity
(::Type{T})(x::ExactReal) where {T<:Real} = convert(T, x)
Interval{T}(x::ExactReal) where {T<:NumTypes} = convert(Interval{T}, x) # needed to resolve ambiguity
Interval(x::ExactReal) = Interval{promote_numtype(numtype(x.value), numtype(x.value))}(x) # needed to resolve ambiguity

Base.convert(::Type{T}, x::ExactReal) where {T<:Real} = convert(T, x.value)

Base.promote_rule(::Type{T}, ::Type{ExactReal{S}}) where {T<:Real,S<:Real} =
    promote_type(T, S)
Base.promote_rule(::Type{ExactReal{T}}, ::Type{S}) where {T<:Real,S<:Real} =
    promote_type(T, S)
# needed to resolve method ambiguities
Base.promote_rule(::Type{ExactReal{T}}, ::Type{Bool}) where {T<:Real} =
    promote_type(T, Bool)
Base.promote_rule(::Type{Bool}, ::Type{ExactReal{T}}) where {T<:Real} =
    promote_type(Bool, T)
Base.promote_rule(::Type{ExactReal{T}}, ::Type{BigFloat}) where {T<:Real} =
    promote_type(T, BigFloat)
Base.promote_rule(::Type{BigFloat}, ::Type{ExactReal{T}}) where {T<:Real} =
    promote_type(BigFloat, T)
Base.promote_rule(::Type{ExactReal{T}}, ::Type{S}) where {T<:Real,S<:AbstractIrrational} =
    promote_type(T, S)
Base.promote_rule(::Type{T}, ::Type{ExactReal{S}}) where {T<:AbstractIrrational,S<:Real} =
    promote_type(T, S)

# to complex -- by-pass default from Base which lead to "NG" flag in the (zero) imaginary part

Base.Complex{T}(x::ExactReal) where {T<:Interval} = Complex{T}(x, zero(x))

# display

Base.show(io::IO, x::ExactReal{T}) where {T<:AbstractFloat} =
    print(io, "ExactReal{$T}($(_str_repr(x)))")

Base.show(io::IO, ::MIME"text/plain", x::ExactReal{T}) where {T<:AbstractFloat} =
    print(io, "ExactReal{$T}($(_str_repr(x)))")

_str_repr(x::ExactReal) = string(x.value)

_str_repr(x::ExactReal{T}) where {T<:AbstractFloat} =
    Base.Ryu.writefixed(x.value, 2000, false, false, false, UInt8('.'), true)

# always exact

Base.://(x::ExactReal{<:Union{Integer,Rational}}, y::ExactReal{<:Union{Integer,Rational}}) = exact(x.value // y.value)
Base.://(x::ExactReal{<:Union{Integer,Rational}}, y::Union{Integer,Rational}) = x.value // y
Base.://(x::Union{Integer,Rational}, y::ExactReal{<:Union{Integer,Rational}}) = x // y.value

Base.:-(x::ExactReal{<:Union{Float16,Float32,Float64,BigFloat}}) = exact(-x.value)
Base.:-(x::ExactReal{<:Rational}) = exact(-x.value)
Base.:-(x::ExactReal{<:Integer}) = exact(Base.checked_neg(x.value))

Base.:*(x::ExactReal, y::ExactReal{Bool}) = exact(x.value * y.value)
Base.:*(x::ExactReal{Bool}, y::ExactReal) = exact(x.value * y.value)
Base.:/(x::ExactReal, y::ExactReal{Bool}) = exact(x.value / y.value)
Base.:/(x::ExactReal{Bool}, y::ExactReal) = exact(x.value / y.value)

for T ∈ (:Rational, :Integer)
    @eval Base.:^(x::ExactReal{<:$T}, y::ExactReal{<:Integer}) = exact(_exact_pow(x.value, y.value))
    for S ∈ (:Rational, :Integer)
        @eval begin
            Base.:+(x::ExactReal{<:$T}, y::ExactReal{<:$S}) = exact(_exact_add(x.value, y.value))
            Base.:-(x::ExactReal{<:$T}, y::ExactReal{<:$S}) = exact(_exact_sub(x.value, y.value))
            Base.:*(x::ExactReal{<:$T}, y::ExactReal{<:$S}) = exact(_exact_mul(x.value, y.value))
        end
    end
end

#- needed to resolve method ambiguities (since `Bool <: Integer`)
Base.:*(x::ExactReal{Bool}, y::ExactReal{Bool}) = exact(_exact_mul(x.value, y.value))
Base.:/(x::ExactReal{Bool}, y::ExactReal{Bool}) = exact(_exact_div(x.value, y.value))
for T ∈ (:Rational, :Integer)
    @eval begin
        Base.:*(x::ExactReal{<:$T}, y::ExactReal{Bool}) = exact(_exact_mul(x.value, y.value))
        Base.:*(x::ExactReal{Bool}, y::ExactReal{<:$T}) = exact(_exact_mul(x.value, y.value))
        Base.:/(x::ExactReal{<:$T}, y::ExactReal{Bool}) = exact(_exact_div(x.value, y.value))
        Base.:/(x::ExactReal{Bool}, y::ExactReal{<:$T}) = exact(_exact_div(x.value, y.value))
    end
end
#-

_exact_add(x::Union{Rational,Integer}, y::Union{Rational,Integer}) = x + y
_exact_add(x::Integer, y::Integer) = Base.checked_add(x, y)

_exact_sub(x::Union{Rational,Integer}, y::Union{Rational,Integer}) = x - y
_exact_sub(x::Integer, y::Integer) = Base.checked_sub(x, y)

_exact_mul(x::Union{Rational,Integer}, y::Union{Rational,Integer}) = x * y
_exact_mul(x::Integer, y::Integer) = Base.checked_mul(x, y)

_exact_pow(x::Rational, y::Integer) = x ^ y
if VERSION ≥ v"1.11"
    _exact_pow(x::Integer, y::Integer) = Base.checked_pow(x, y)
else
    _exact_pow(x::Integer, y::Integer) = Integer(Rational(x)^y)
end

Base.literal_pow(::typeof(^), x::ExactReal, ::Val{p}) where {p} =
    x ^ exact(p)
Base.:^(x::ExactReal, p::Integer) = x.value ^ p # by-pass default integer power behaviour

#

Base.:/(x::ExactReal{<:Rational}, y::ExactReal{<:Rational}) = exact(x.value / y.value)
Base.:/(x::ExactReal{<:Rational}, y::ExactReal{<:Integer}) = exact(x.value / y.value)
Base.:/(x::ExactReal{<:Integer}, y::ExactReal{<:Rational}) = exact(x.value / y.value)

function Base.:/(x::ExactReal{T}, y::ExactReal{S}) where {T<:Integer,S<:Integer}
    r = x.value / y.value
    (x.value == typemin(promote_type(T, S))) & (y.value == -1) && return r # check overflow
    (y.value == typemin(promote_type(T, S))) & (x.value == -1) && return r # check overflow
    x.value // y.value == r || return r
    return exact(r)
end

# in general, exactness is lost

Base.:-(x::ExactReal) = -x.value
Base.:+(x::ExactReal, y::ExactReal) = x.value + y.value
Base.:-(x::ExactReal, y::ExactReal) = x.value - y.value
Base.:*(x::ExactReal, y::ExactReal) = x.value * y.value
Base.:^(x::ExactReal, y::ExactReal) = x.value ^ y.value
Base.:/(x::ExactReal, y::ExactReal) = x.value / y.value

# basic operations with `BareInterval` and `ExactReal`

for f ∈ (:+, :-, :*, :/, :\, :^)
    @eval Base.$f(x::BareInterval, y::ExactReal) = $f(promote(x, y)...)
    @eval Base.$f(x::ExactReal, y::BareInterval) = $f(promote(x, y)...)
end

# These specializations improve efficiency, but always agree precisely with
# the promoting fallbacks above. Several circumstances fall back to promotion: a
# non-finite point (whose thin interval is not even valid), an unbounded interval
# times a point (`0 * ∞` is flavor dependent), and division by zero (likewise).
# The type parameter is bounded so that these methods are more specific than the
# generic `Base.$f(::ExactReal, ::BareInterval)`, whose own parameters are bounded
# by `Real` and `NumTypes`.

function Base.:+(x::BareInterval{T}, y::ExactReal{T}) where {T<:NumTypes}
    v = y.value
    isfinite(v) || return +(promote(x, y)...)
    isempty_interval(x) && return x
    return @round(T, inf(x) + v, sup(x) + v)
end
Base.:+(x::ExactReal{T}, y::BareInterval{T}) where {T<:NumTypes} = y + x

function Base.:-(x::BareInterval{T}, y::ExactReal{T}) where {T<:NumTypes}
    v = y.value
    isfinite(v) || return -(promote(x, y)...)
    isempty_interval(x) && return x
    return @round(T, inf(x) - v, sup(x) - v)
end

function Base.:-(x::ExactReal{T}, y::BareInterval{T}) where {T<:NumTypes}
    v = x.value
    isfinite(v) || return -(promote(x, y)...)
    isempty_interval(y) && return y
    return @round(T, v - sup(y), v - inf(y))
end

function Base.:*(x::BareInterval{T}, y::ExactReal{T}) where {T<:NumTypes}
    v = y.value
    isempty_interval(x) && return x # `isbounded` is true for the empty interval
    (isfinite(v) & isbounded(x)) || return *(promote(x, y)...)
    signbit(v) && return @round(T, v * sup(x), v * inf(x))
    return @round(T, v * inf(x), v * sup(x))
end
Base.:*(x::ExactReal{T}, y::BareInterval{T}) where {T<:NumTypes} = y * x

function Base.:/(x::BareInterval{T}, y::ExactReal{T}) where {T<:NumTypes}
    v = y.value
    isempty_interval(x) && return x
    (isfinite(v) & !iszero(v)) || return /(promote(x, y)...)
    signbit(v) && return @round(T, sup(x) / v, inf(x) / v)
    return @round(T, inf(x) / v, sup(x) / v)
end

# `x \ y` is `y / x`; the reverse case is a point divided by an interval, which
# has no shortcut — the zero-crossing tree of `/` is the whole computation.
Base.:\(x::ExactReal{T}, y::BareInterval{T}) where {T<:NumTypes} = y / x

"""
    has_exact_display(x::Real)

Determine if the display of `x` up to 2000 decimals is equal to the bitwise
value of `x`. This is famously not true for the float displayed as `0.1`.
"""
has_exact_display(x::Real) = string(x) == _str_repr(exact(x))

#

"""
    @exact

Wrap every literal numbers of the expression in an [`ExactReal`](@ref). This
macro allows defining generic functions, seamlessly accepting both `Number` and
[`Interval`](@ref) arguments, without producing the "NG" flag.

!!! danger
    By using [`ExactReal`](@ref), users acknowledge the responsibility of
    ensuring that the number they input corresponds to their intended value.
    For example, `exact(0.1)` implies that the user knows that ``0.1`` can
    not be represented exactly as a binary number, and that they are using a
    slightly different number than ``0.1``.
    To help identify the binary number, `ExactReal` is displayed without any
    rounding up to 2000 decimals.

    ```julia
    julia> exact(0.1)
    ExactReal{Float64}(0.1000000000000000055511151231257827021181583404541015625)
    ```

    In case of doubt, [`has_exact_display`](@ref) can be use to check if the
    string representation of a `Real` is equal to its binary value (up to 2000
    decimals).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:infsup);

julia> f(x) = 1.2 * x + 0.1
f (generic function with 1 method)

julia> f(interval(1, 2))
[1.29999, 2.5]_com_NG

julia> @exact g(x) = 1.2 * x + 0.1
g (generic function with 1 method)

julia> g(interval(1, 2))
[1.29999, 2.5]_com

julia> g(1.4)
1.78
```

See also: [`ExactReal`](@ref).
"""
macro exact(expr)
    exact_expr = postwalk(expr) do x
        x isa Real && return exact(x)
        return x
    end

    exact_expr = prewalk(exact_expr) do x
        if @capture(x, im)
            return exact(im)
        end

        if @capture(x, a_ + im) || @capture(x, im + a_)
            if a isa ExactReal
                return :(complex($a, exact(one($a.value))))
            end
        end
        if @capture(x, a_ - im) || @capture(x, -im + a_)
            if a isa ExactReal
                return :(complex($a, exact(-one($a.value))))
            end
        end

        if @capture(x, b_ * im) || @capture(x, im * b_)
            if b isa ExactReal
                return :(complex(exact(zero($b.value)), $b))
            end
        end

        if @capture(x, a_ + b_ * im) || @capture(x, a_ + im * b_) || @capture(x, b_ * im + a_) || @capture(x, im * b_ + a_)
            if a isa ExactReal && b isa ExactReal
                return :(complex($a, $b))
            end
        end
        if @capture(x, a_ - b_ * im) || @capture(x, a_ - im * b_) || @capture(x, b_ * im - a_) || @capture(x, im * b_ - a_)
            if a isa ExactReal && b isa ExactReal
                return :(complex($a, -$b))
            end
        end

        return x
    end

    return esc(exact_expr)
end

@testset "IEEE1788.a" begin

    @test bareinterval(-Inf,Inf) === entireinterval(BareInterval{Float64})

end

@testset "IEEE1788.b" begin

    @test parse(BareInterval{Float64}, "[1.2345]") === bareinterval(0x1.3C083126E978DP+0, 0x1.3C083126E978EP+0)

    @test parse(BareInterval{Float64}, "[1,+infinity]") === bareinterval(1.0, Inf)

    @test parse(Interval{Float64}, "[1,1e3]_com") === interval(bareinterval(1.0, 1000.0), com)

    @test parse(Interval{Float64}, "[1,1E3]_COM") === interval(bareinterval(1.0, 1000.0), com)

end

@testset "IEEE1788.c" begin

    @test parse(BareInterval{Float64}, "[1.e-3, 1.1e-3]") === bareinterval(0x4.189374BC6A7ECP-12, 0x4.816F0068DB8BCP-12)

    @test parse(BareInterval{Float64}, "[-0x1.3p-1, 2/3]") === bareinterval(-0x9.8000000000000P-4, +0xA.AAAAAAAAAAAB0P-4)

    @test parse(BareInterval{Float64}, "[3.56]") === bareinterval(0x3.8F5C28F5C28F4P+0, 0x3.8F5C28F5C28F6P+0)

    @test parse(BareInterval{Float64}, "3.56?1") === bareinterval(0x3.8CCCCCCCCCCCCP+0, 0x3.91EB851EB8520P+0)

    @test parse(BareInterval{Float64}, "3.56?1e2") === bareinterval(355.0, 357.0)

    @test parse(BareInterval{Float64}, "3.560?2") === bareinterval(0x3.8ED916872B020P+0, 0x3.8FDF3B645A1CCP+0)

    @test parse(BareInterval{Float64}, "3.56?") === bareinterval(0x3.8E147AE147AE0P+0, 0x3.90A3D70A3D70CP+0)

    @test parse(BareInterval{Float64}, "3.560?2u") === bareinterval(0x3.8F5C28F5C28F4P+0, 0x3.8FDF3B645A1CCP+0)

    @test parse(BareInterval{Float64}, "-10?") === bareinterval(-10.5, -9.5)

    @test parse(BareInterval{Float64}, "-10?u") === bareinterval(-10.0, -9.5)

    @test parse(BareInterval{Float64}, "-10?12") === bareinterval(-22.0, 2.0)

end

@testset "IEEE1788.d" begin

    @test parse(BareInterval{Float64}, "[1.234e5,Inf]") === bareinterval(123400.0, Inf)

    @test parse(BareInterval{Float64}, "3.1416?1") === bareinterval(0x3.24395810624DCP+0, 0x3.24467381D7DC0P+0)

    @test parse(BareInterval{Float64}, "[Empty]") === emptyinterval(BareInterval{Float64})

end

@testset "IEEE1788.e" begin

    @test_logs (:warn,) @test interval(2,1) === nai(Interval{Float64})

end

@testset "IEEE1788.e" begin

    @test parse(Interval{Float64}, "[ ]") === interval(emptyinterval(BareInterval{Float64}), trv)

    @test parse(Interval{Float64}, "[entire]") === interval(bareinterval(-Inf, +Inf), dac)

    @test parse(Interval{Float64}, "[1.e-3, 1.1e-3]") === interval(bareinterval(0x4.189374BC6A7ECP-12, 0x4.816F0068DB8BCP-12), com)

    @test parse(Interval{Float64}, "[-Inf, 2/3]") === interval(bareinterval(-Inf, +0xA.AAAAAAAAAAAB0P-4), dac)

    @test parse(Interval{Float64}, "[0x1.3p-1,]") === interval(bareinterval(0x1.3p-1, Inf), dac)

    @test parse(Interval{Float64}, "[,]") === interval(entireinterval(BareInterval{Float64}), dac)

    @test parse(Interval{Float64}, "3.56?1") === interval(bareinterval(0x3.8CCCCCCCCCCCCP+0, 0x3.91EB851EB8520P+0), com)

    @test parse(Interval{Float64}, "3.56?1e2") === interval(bareinterval(355.0, 357.0), com)

    @test parse(Interval{Float64}, "3.560?2") === interval(bareinterval(0x3.8ED916872B020P+0, 0x3.8FDF3B645A1CCP+0), com)

    @test parse(Interval{Float64}, "3.56?") === interval(bareinterval(0x3.8E147AE147AE0P+0, 0x3.90A3D70A3D70CP+0), com)

    @test parse(Interval{Float64}, "3.560?2u") === interval(bareinterval(0x3.8F5C28F5C28F4P+0, 0x3.8FDF3B645A1CCP+0), com)

    @test parse(Interval{Float64}, "-10?") === interval(bareinterval(-10.5, -9.5), com)

    @test parse(Interval{Float64}, "-10?u") === interval(bareinterval(-10.0, -9.5), com)

    @test parse(Interval{Float64}, "-10?12") === interval(bareinterval(-22.0, 2.0), com)

    @test parse(Interval{Float64}, "-10??u") === interval(bareinterval(-10.0, Inf), dac)

    @test parse(Interval{Float64}, "-10??") === interval(bareinterval(-Inf, Inf), dac)

    @test parse(Interval{Float64}, "[nai]") === nai(Interval{Float64})

    @test parse(Interval{Float64}, "3.56?1_def") === interval(bareinterval(0x3.8CCCCCCCCCCCCP+0, 0x3.91EB851EB8520P+0), def)

end

@testset "IEEE1788.f" begin

    @test parse(BareInterval{Float64}, "[]") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[empty]") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[ empty ]") === emptyinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[,]") === entireinterval(BareInterval{Float64})

    @test parse(BareInterval{Float64}, "[ entire ]") === entireinterval(BareInterval{Float64})

end

# This file contains the functions described as "Power functions" in Section 9.1
# of the IEEE Standard 1788-2015 and required for set-based flavor in Section
# 10.5.3
# Some of the "Recommended operations" (Section 10.6.1) are also present

# power mechanism used in `^`

"""
    PowerMode

Power mode type for `^`.

Available mode types:
- `:fast` (default): `x ^ y` is semantically equivalent to `fastpow(x, y)`,
    unless `isthininteger(y)` is true in which case it is semantically
    equivalent to `fastpown(x, sup(y))`.
- `:slow`: `x ^ y` is semantically equivalent to `pow(x, y)`, unless
    `isthininteger(y)` is true in which case it is semantically equivalent to
    `pown(x, sup(y))`.
"""
struct PowerMode{T} end

#

"""
    ^(x::BareInterval, y::BareInterval)
    ^(x::Interval, y::Interval)

Compute the power of `x` by `y`. Unless `y` is an integer, the positive real
part of `x^y` is returned. This function is not in the IEEE Standard 1788-2015.
Its behaviour depends on the current [`PowerMode`](@ref).

See also: [`pow`](@ref), [`pown`](@ref), [`fastpow`](@ref) and
[`fastpown`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> bareinterval(2, 3) ^ bareinterval(2)
BareInterval{Float64}(4.0, 9.0)

julia> interval(-1, 1) ^ interval(3)
Interval{Float64}(-1.0, 1.0, com, true)

julia> interval(-1, 1) ^ interval(-3)
Interval{Float64}(-Inf, Inf, trv, true)
```
"""
function Base.:^(x::BareInterval, y::BareInterval)
    isthininteger(y) || return _select_pow(x, y)
    return _select_pown(x, Integer(sup(y)))
end

function Base.:^(x::Interval, y::Interval)
    isthininteger(y) || return _select_pow(x, y)
    r = _select_pown(x, Integer(sup(y)))
    d = min(decoration(r), decoration(y))
    t = isguaranteed(r) & isguaranteed(y)
    return _unsafe_interval(bareinterval(r), d, t)
end

Base.:^(x::Interval, n::Integer) = ^(x, n//one(n))
Base.:^(x::Interval, y::Rational) = ^(x, convert(Interval{typeof(y)}, y))

# power for complex intervals
# See Improve power of complex intervals #745 for a description of the algorithm

Base.:^(x::Complex{<:Interval}, y::Complex{<:Interval}) = ^(promote(x, y)...)

function Base.:^(x::Complex{Interval{T}}, y::Complex{Interval{T}}) where {T<:NumTypes}
    (isempty_interval(x) | isempty_interval(y)) && return emptyinterval(Complex{Interval{T}})
    if isbounded(y) & isreal(y)
        p = real(y)
        logx = log(x)
        a, b = bounds(p)
        kmin = ceil(Integer, a)
        kmax = floor(Integer, b)
        if kmax - kmin < 1 # only one integer in the interval
            n = round(Integer, mid(p)) # pick nearest integer
            u = p - exact(n)
            res = _pow(x, n, u, logx)
            return res
        end
        # kmin slice
        u = interval(T, a - kmin, 0.5)
        res = _pow(x, kmin, u, logx)
        u = interval(T, -0.5, 0.5)
        for k ∈ kmin+1:kmax-1
            res = union_interval(res, _pow(x, k, u, logx); dec = :auto)
        end
        # kmax slice
        u = interval(T, -0.5, b - kmax)
        res = union_interval(res, _pow(x, kmax, u, logx); dec = :auto)
        return res
    end
    return exp(y * log(x))
end

function _pow(x, n, u, logx) # performs x^(n+u) as x^n * exp(u * log(x))
    xn = fastpown(x, n)
    return isthinzero(u) ? xn : xn * exp(u * logx)
end

# needed to avoid method errors
Base.:^(x::Complex{<:Interval}, y::Interval) = ^(promote(x, y)...)
Base.:^(x::Interval, y::Complex{<:Interval}) = ^(promote(x, y)...)

# overwrite behaviour for small integer powers from https://github.com/JuliaLang/julia/pull/24240
Base.literal_pow(::typeof(^), x::Interval, ::Val{n}) where {n} = _select_pown(x, n)
Base.literal_pow(::typeof(^), x::Complex{<:Interval}, ::Val{n}) where {n} = fastpown(x, n)

# helper functions for power

_select_pow(x, y) = _select_pow(default_power(), x, y)
_select_pown(x, y) = _select_pown(default_power(), x, y)

_select_pow(::PowerMode{:fast}, x, y) = fastpow(x, y)
_select_pown(::PowerMode{:fast}, x, y) = fastpown(x, y)
_select_pow(::PowerMode{:slow}, x, y) = pow(x, y)
_select_pown(::PowerMode{:slow}, x, y) = pown(x, y)

"""
    pow(x, y)

Compute the power of the positive real part of `x` by `y`. In particular, even
if `y` is a thin integer, this is not equivalent to `pown(x, sup(y))`.

Implement the `pow` function of the IEEE Standard 1788-2015 (Table 9.1).

See also: [`fastpow`](@ref), [`pown`](@ref) and [`fastpown`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> pow(bareinterval(2, 3), bareinterval(2))
BareInterval{Float64}(4.0, 9.0)

julia> pow(interval(-1, 1), interval(3))
Interval{Float64}(0.0, 1.0, trv, true)

julia> pow(interval(-1, 1), interval(-3))
Interval{Float64}(1.0, Inf, trv, true)
```
"""
pow(x, y)
for U ∈ (:AbstractFloat, :Rational) # needed to resolve ambiguity
    @eval function pow(x::BareInterval{T}, y::BareInterval{T}) where {T<:$U}
        isempty_interval(y) && return y
        domain = _unsafe_bareinterval(T, zero(T), typemax(T))
        x = intersect_interval(x, domain)
        isempty_interval(x) && return x
        isthin(y) && return _thin_pow(x, sup(y))
        return hull(_thin_pow(x, inf(y)), _thin_pow(x, sup(y)))
    end
end
pow(x::BareInterval, y::BareInterval) = pow(promote(x, y)...)
# specialize on rational to improve exactness
function pow(x::BareInterval{T}, y::BareInterval{S}) where {T<:NumTypes,S<:Rational}
    R = promote_numtype(T, S)
    isempty_interval(y) && return emptyinterval(BareInterval{R})
    domain = _unsafe_bareinterval(T, zero(T), typemax(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) && return emptyinterval(BareInterval{R})
    isthin(y) && return BareInterval{R}(_thin_pow(x, sup(y)))
    return BareInterval{R}(hull(_thin_pow(x, inf(y)), _thin_pow(x, sup(y))))
end

pow(x::BareInterval, y::Real) = pow(x, bareinterval(y))
pow(x::BareInterval, n::Integer) = pow(x, n//one(n))

function pow(x::Interval, y::Interval)
    bx = bareinterval(x)
    by = bareinterval(y)
    r = pow(bx, by)
    d = min(decoration(x), decoration(y), decoration(r))
    d = min(d, ifelse((inf(bx) > 0) | ((inf(bx) == 0) & (inf(by) > 0)), d, trv))
    t = isguaranteed(x) & isguaranteed(y)
    return _unsafe_interval(r, d, t)
end

pow(x::Interval, y::Real) = pow(x, interval(y))
pow(x::Interval, n::Integer) = pow(x, n//one(n))

# helper function for `pow`

for U ∈ (:AbstractFloat, :Rational) # needed to resolve ambiguity
    @eval function _thin_pow(x::BareInterval{T}, y::T) where {T<:$U}
        # assume `inf(x) ≥ 0` and `!isempty_interval(x)`
        if sup(x) == 0 # isthinzero(x)
            y > 0 && return x
            return emptyinterval(BareInterval{T})
        else
            isinteger(y) && return pown(x, Integer(y))
            y == 0.5 && return sqrt(x)
            lo = @round(T, inf(x)^y, inf(x)^y)
            hi = @round(T, sup(x)^y, sup(x)^y)
            return hull(lo, hi)
        end
    end

    @eval function _thin_pow(x::BareInterval{T}, y::Rational{S}) where {T<:$U,S<:Integer}
        # assume `inf(x) ≥ 0` and `!isempty_interval(x)`
        if sup(x) == 0 # isthinzero(x)
            y > 0 && return x
            return emptyinterval(BareInterval{T})
        else
            isinteger(y) && return pown(x, S(y))
            return pown(rootn(x, denominator(y)), numerator(y))
        end
    end
end

"""
    pown(x, n)

Implement the `pown` function of the IEEE Standard 1788-2015 (Table 9.1).

See also: [`fastpown`](@ref), [`pow`](@ref) and [`fastpow`](@ref).

# Examples

```jldoctest
julia> using IntervalArithmetic

julia> setdisplay(:full);

julia> pown(bareinterval(2, 3), 2)
BareInterval{Float64}(4.0, 9.0)

julia> pown(interval(-1, 1), 3)
Interval{Float64}(-1.0, 1.0, com, true)

julia> pown(interval(-1, 1), -3)
Interval{Float64}(-Inf, Inf, trv, true)
```
"""
function pown(x::BareInterval{T}, n::Integer) where {T<:NumTypes}
    isempty_interval(x) && return x
    n == 0 && return one(BareInterval{T})
    n == 1 && return x
    (n < 0) & isthinzero(x) && return emptyinterval(BareInterval{T})
    if isodd(n)
        isentire_interval(x) && return x
        if n > 0
            inf(x) == 0 && return @round(T, zero(T), sup(x)^n)
            sup(x) == 0 && return @round(T, inf(x)^n, zero(T))
            return @round(T, inf(x)^n, sup(x)^n)
        else
            if inf(x) ≥ 0
                inf(x) == 0 && return @round(T, sup(x)^n, typemax(T))
                return @round(T, sup(x)^n, inf(x)^n)
            elseif sup(x) ≤ 0
                sup(x) == 0 && return @round(T, typemin(T), inf(x)^n)
                return @round(T, sup(x)^n, inf(x)^n)
            else
                return entireinterval(BareInterval{T})
            end
        end
    else
        if n > 0
            if inf(x) ≥ 0
                return @round(T, inf(x)^n, sup(x)^n)
            elseif sup(x) ≤ 0
                return @round(T, sup(x)^n, inf(x)^n)
            else
                return @round(T, mig(x)^n, mag(x)^n)
            end
        else
            if inf(x) ≥ 0
                return @round(T, sup(x)^n, inf(x)^n)
            elseif sup(x) ≤ 0
                return @round(T, inf(x)^n, sup(x)^n)
            else
                return @round(T, mag(x)^n, mig(x)^n)
            end
        end
    end
end

function pown(x::Interval, n::Integer)
    r = pown(bareinterval(x), n)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse((n < 0) & in_interval(0, x), trv, d))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    rootn(x::BareInterval, n::Integer)

Compute the real `n`-th root of `x`.

Implement the `rootn` function of the IEEE Standard 1788-2015 (Table 9.1).
"""
function rootn(x::BareInterval{T}, n::Integer) where {T<:AbstractFloat}
    isempty_interval(x) && return x
    n == 0 && return emptyinterval(BareInterval{T})
    n == 1 && return x
    n == 2 && return sqrt(x)
    n < 0 && return inv(rootn(x, -n))

    domain = _unsafe_bareinterval(T, ifelse(iseven(n), zero(T), typemin(T)), typemax(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) && return x

    return @round(T, rootn(inf(x), n), rootn(sup(x), n))
end

rootn(x::BareInterval{<:Rational}) = rootn(float(x))

function rootn(x::Interval{T}, n::Integer) where {T<:NumTypes}
    domain = _unsafe_bareinterval(T, ifelse(iseven(n), zero(T), typemin(T)), typemax(T))
    bx = bareinterval(x)
    r = rootn(bx, n)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(issubset_interval(bx, domain), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

"""
    hypot(x, y)

Compute the hypotenuse.

Implement the `hypot` function of the IEEE Standard 1788-2015 (Table 10.5).
"""
Base.hypot(x::BareInterval, y::BareInterval) = sqrt(_select_pown(x, 2) + _select_pown(y, 2))

Base.hypot(x::Interval, y::Interval) = sqrt(_select_pown(x, 2) + _select_pown(y, 2))

"""
    fastpow(x, y)

A faster implementation of `pow(x, y)`, at the cost of maybe returning a larger
interval.

See also: [`pow`](@ref), [`pown`](@ref) and [`fastpown`](@ref).
"""
function fastpow(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    isempty_interval(y) && return y
    domain = _unsafe_bareinterval(T, zero(T), typemax(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) && return x
    if sup(x) == 0 # isthinzero(x)
        sup(y) > 0 && return x
        return emptyinterval(BareInterval{T})
    elseif isthininteger(y)
        n = Integer(sup(y))
        n < 0 && return inv(_positive_power_by_squaring(x, -n))
        return _positive_power_by_squaring(x, n)
    else
        return exp(y * log(x))
    end
end
fastpow(x::BareInterval, y::BareInterval) = fastpow(promote(x, y)...)

fastpow(x::BareInterval, y::Real) = fastpow(x, bareinterval(y))

function fastpow(x::Interval, y::Interval)
    bx = bareinterval(x)
    by = bareinterval(y)
    r = fastpow(bx, by)
    d = min(decoration(x), decoration(y), decoration(r))
    d = min(d, ifelse((inf(bx) > 0) | ((inf(bx) == 0) & (inf(by) > 0)), d, trv))
    t = isguaranteed(x) & isguaranteed(y)
    return _unsafe_interval(r, d, t)
end

fastpow(x::Interval, y::Real) = fastpow(x, interval(y))

"""
    fastpown(x, n)

A faster implementation of `pown(x, n)`, at the cost of maybe returning a larger
interval.

See also: [`pown`](@ref), [`pow`](@ref) and [`fastpow`](@ref).
"""
function fastpown(x::BareInterval{T}, n::Integer) where {T<:NumTypes}
    isempty_interval(x) && return x
    n < 0 && return inv(fastpown(x, -n))
    range = _unsafe_bareinterval(T, ifelse(iseven(n), zero(T), typemin(T)), typemax(T))
    return intersect_interval(_positive_power_by_squaring(x, n), range)
end

function fastpown(x::Interval, n::Integer)
    r = fastpown(bareinterval(x), n)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse((n < 0) & in_interval(0, x), trv, d))
    return _unsafe_interval(r, d, isguaranteed(x))
end

function fastpown(x::Complex{<:Interval}, n::Integer)
    if isthinzero(imag(x))
        return complex(fastpown(real(x), n))
    elseif isthinzero(real(x)) # (im * y)^n = im^n * y^n
        yn = fastpown(imag(x), n)
        rem4 = n % 4
        imn = ifelse(rem4 == 0, 1+0im,
              ifelse(rem4 == 1, 1im,
              ifelse(rem4 == 2, -1+0im, -1im)))
        return exact(imn) * yn
    else
        isempty_interval(x) && return x
        n < 0 && return inv(fastpown(x, -n))
        return _positive_power_by_squaring(x, n)
    end
end

# helper function for `fastpow` and `fastpown`

# code inspired by `power_by_squaring(::Any, ::Integer)` in base/intfuncs.jl
Base.@assume_effects :terminates_locally function _positive_power_by_squaring(x, n)
    n == 0 && return one(x)
    n == 1 && return x
    n == 2 && return x*x
    t = trailing_zeros(n) + 1
    n >>= t
    while (t -= 1) > 0
        x *= x
    end
    y = x
    while n > 0
        t = trailing_zeros(n) + 1
        n >>= t
        while (t -= 1) >= 0
            x *= x
        end
        y *= x
    end
    return y
end

#

for f ∈ (:cbrt, :exp, :exp2, :exp10, :expm1)
    @eval begin
        function Base.$f(x::BareInterval{T}) where {T<:AbstractFloat}
            isempty_interval(x) && return x
            return @round(T, $f(inf(x)), $f(sup(x)))
        end

        Base.$f(x::BareInterval{<:Rational}) = $f(float(x))

        function Base.$f(x::Interval)
            r = $f(bareinterval(x))
            d = min(decoration(x), decoration(r))
            return _unsafe_interval(r, d, isguaranteed(x))
        end
    end
end

Base.exp(x::Complex{<:Interval}) = exp(real(x)) * cis(imag(x))

Base.exp2(x::Complex{<:Interval}) = exp2(real(x)) * cis(imag(x) * log(interval(numtype(x), 2)))

Base.exp10(x::Complex{<:Interval}) = exp10(real(x)) * cis(imag(x) * log(interval(numtype(x), 10)))

Base.expm1(x::Complex{<:Interval}) = exp(x) - interval(numtype(x), 1)

#

for f ∈ (:log, :log2, :log10)
    @eval begin
        function Base.$f(x::BareInterval{T}) where {T<:AbstractFloat}
            domain = _unsafe_bareinterval(T, zero(T), typemax(T))
            x = intersect_interval(x, domain)
            isempty_interval(x) | (sup(x) == 0) && return emptyinterval(BareInterval{T})
            return @round(T, $f(inf(x)), $f(sup(x)))
        end

        Base.$f(x::BareInterval{<:Rational}) = $f(float(x))

        function Base.$f(x::Interval{T}) where {T<:NumTypes}
            domain = _unsafe_bareinterval(T, zero(T), typemax(T))
            bx = bareinterval(x)
            r = $f(bx)
            d = min(decoration(x), decoration(r))
            d = min(d, ifelse(isinterior(bx, domain), d, trv))
            return _unsafe_interval(r, d, isguaranteed(x))
        end
    end
end

Base.log(x::Complex{<:Interval}) = complex(log(abs(x)), angle(x))

Base.log2(x::Complex{<:Interval}) = complex(log2(abs(x)), angle(x)/log(interval(numtype(x), 2)))

Base.log10(x::Complex{<:Interval}) = complex(log10(abs(x)), angle(x)/log(interval(numtype(x), 10)))

function Base.log1p(x::BareInterval{T}) where {T<:AbstractFloat}
    domain = _unsafe_bareinterval(T, -one(T), typemax(T))
    x = intersect_interval(x, domain)
    isempty_interval(x) | (sup(x) == -1) && return emptyinterval(BareInterval{T})
    return @round(T, log1p(inf(x)), log1p(sup(x)))
end

Base.log1p(x::BareInterval{<:Rational}) = log1p(float(x))

function Base.log1p(x::Interval{T}) where {T<:NumTypes}
    domain = _unsafe_bareinterval(T, -one(T), typemax(T))
    bx = bareinterval(x)
    r = log1p(bx)
    d = min(decoration(x), decoration(r))
    d = min(d, ifelse(isinterior(bx, domain), d, trv))
    return _unsafe_interval(r, d, isguaranteed(x))
end

Base.log1p(x::Complex{<:Interval}) = log(interval(numtype(x), 1) + x)

# This file contains the two-output division requested for set-based flavor in
# Section 10.5.5 of the IEEE Standard 1788-2015

"""
    extended_div(x, y)

Two-output division.

Implement the `mulRevToPair` function of the IEEE Standard 1788-2015 (Section 10.5.5).
"""
function extended_div(x::BareInterval{T}, y::BareInterval{T}) where {T<:NumTypes}
    ylo, yhi = bounds(y)
    if ylo < 0 < yhi && !in_interval(0, x)
        sup(x) < 0 && return (x / _unsafe_bareinterval(T, zero(T), yhi), x / _unsafe_bareinterval(T, ylo, zero(T)))
        # inf(x) > 0
        return (x / _unsafe_bareinterval(T, ylo, zero(T)), x / _unsafe_bareinterval(T, zero(T), yhi))
    elseif in_interval(0, x) && in_interval(0, y)
        return (entireinterval(BareInterval{T}), emptyinterval(BareInterval{T}))
    else
        return (x / y, emptyinterval(BareInterval{T}))
    end
end

function extended_div(x::Interval, y::Interval)
    bx = bareinterval(x)
    by = bareinterval(y)
    r₁, r₂ = extended_div(bx, by)
    d = min(decoration(x), decoration(y))
    d₁ = min(d, decoration(r₁), ifelse(!isempty_interval(bx) & !isempty_interval(by) & !in_interval(0, by), d, trv))
    d₂ = min(d, decoration(r₂), trv)
    t = isguaranteed(x) & isguaranteed(y)
    return _unsafe_interval(r₁, d₁, t), _unsafe_interval(r₂, d₂, t)
end

# Overview

The basic idea in [interval arithmetic](https://en.wikipedia.org/wiki/Interval_arithmetic) is to perform computations with a whole interval of real numbers

```math
[a, b] \bydef \{x \in \mathbb{R}: a \le x \le b \},
```

where ``a, b \in \mathbb{R} \cup \{ \pm \infty \}``; note that despite the above notation, ``[a, b]`` does not contain infinity when ``a`` or ``b`` are infinite.

We define functions on intervals in such a way that the result of the computation is a new interval that is guaranteed to contain the true range of the function.

For instance, by monotonicity, the exponential function is given by

```math
e^{[a, b]} \bydef [e^a, e^b].
```

On the other hand, the squaring function is non-monotone, thus it is given by the following cases

```math
[a, b]^2 \bydef
\begin{cases}
[a^2, b^2], &  0 \le a \le b, \\
[0, \max(a^2, b^2)], & a \le 0 \le b, \\
[b^2, a^2], & a \le b \le 0.
\end{cases}
```

Of course, we must round the lower endpoint down and the upper endpoint up to get a guaranteed enclosure of the true result.

IntervalArithmetic defines such behaviour for a wide set of basic functions, thereby allowing the evaluation of more complex functions such as

```math
f(x) = \sin(3x^2 - 2 \cos(1/x))
```



## Applications

To illustrate the use of interval arithmetic, consider the following:

```@repl intro
using IntervalArithmetic
f(x) = x^2 - 2
x = interval(3, 4)
f(x)
```

Since `f(x)` does not contain `0`, the true range of the function ``f`` over the interval ``[3, 4]`` is guaranteed not to contain ``0``, and hence we obtain the following property.

**Theorem:** ``f`` has no root in the interval ``[3, 4]``.

This theorem has been obtained using floating-point computations! In fact, we can even extend this to semi-infinite intervals:

```@repl intro
f(interval(3, Inf))
```

Therefore, we have excluded the whole unbounded set ``[3, \infty)`` from possibly containing roots of ``f``.

Interval arithmetic is the foundation of more powerful and elaborate methods in the field of computer-assisted proofs (see e.g. [IntervalRootFinding.jl](https://juliaintervals.github.io/IntervalRootFinding.jl)).

The interested reader may refer to the following books:
- R. E. Moore, R. B. Kearfott and M. J. Cloud, [*Introduction to Interval Analysis*](https://doi.org/10.1137/1.9780898717716), Society for Industrial and Applied Mathematics (2009)
- W. Tucker, [*Validated Numerics: A Short Introduction to Rigorous Computations*](https://press.princeton.edu/books/hardcover/9780691147819/validated-numerics), Princeton University Press (2010)



## Compliance with the IEEE standard for interval arithmetic

[IntervalArithmetic.jl](https://juliaintervals.github.io/IntervalArithmetic.jl) complies with the specifications described in the [IEEE standard for interval arithmetic](https://ieeexplore.ieee.org/document/7140721).
However, the reverse-mode of functions are not implemented (see Section 10.5.4).

# The submodule Symbols

IntervalArithmetic includes the submodule Symbols to make coding a bit simpler with respect to the use of some functions of the library. Some examples are provided here.

```@repl
using IntervalArithmetic, IntervalArithmetic.Symbols
a = 0 .. 2
b = 1 ± 0.5
a ≛ a
b ⊑ a
b ⋤ a
∅ ⪽ ℝ
```

The following table summarizes the functions, the usage with the corresponding (unicode) symbols, how to obtain the symbol in Julia, and a brief description of the function.

| Function                           | Symbol    | Julia syntax        | Description                                                 |
|------------------------------------|-----------|---------------------|-------------------------------------------------------------|
| `interval(a, b; format=:infsup)`   | `..(a,b)` |                     | Create interval `[a, b]` using bounds                       |
| `interval(m, r; format=:midpoint)` | `±(m, r)` | `\pm<tab>`          | Create interval `[m - r, m + r]` using midpoint-radius form |
| `isequal_interval(x, y)`           | `≛(x, y)` | `\starequal<tab>`   | Check interval equality                                     |
| `issubset_interval(x, y)`          | `⊑(x, y)` | `\sqsubseteq<tab>`  | Check if `x` is a (non-strict) subset of `y`                |
| `isstrictsubset(x, y)`             | `⋤(x, y)` | `\sqsubsetneq<tab>` | Check if `x` is a strict subset of `y`                      |
| `isinterior(x, y)`                 | `⪽(x, y)` | `\subsetdot<tab>`   | Check if `x` is in the interior of `y`                      |
| `precedes(x, y)`                   | `⪯(x, y)` | `\preceq<tab>`      | Precedes relation                                           |
| `strictprecedes(x, y)`             | `≺(x, y)` | `\prec<tab>`        | Strictly precedes relation                                  |
| `hull(x, y)`                       | `⊔(x, y)` | `\sqcup<tab>`       | Interval hull of `x` and `y`                                |
| `intersect_interval(x, y)`         | `⊓(x, y)` | `\sqcap<tab>`       | Intersection of intervals                                   |
| `emptyinterval()`                  | `∅`       | `\emptyset<tab>`    | Empty interval                                              |
| `entireinterval()`                 | `ℝ`       | `\bbR<tab>`         | Entire real line                                            |

# Manipulating intervals



### Display modes

There are several useful output representations for intervals. The display is controlled globally by the [`setdisplay`](@ref) function, which has the following options:

- interval output format:

    - `:infsup`: output of the form `[1.09999, 1.30001]`, rounded to the current number of significant figures.

    - `:full`: output of the form `Interval(1.0999999999999999, 1.3)`, as in the `showfull` function.

    - `:midpoint`: output in the midpoint-radius form, e.g. `1.2 ± 0.100001`.

- `sigdigits :: Int` keyword argument: number of significant digits to show in standard mode.

- `decorations :: Bool` keyword argument: whether to show decorations or not.

```@repl
using IntervalArithmetic
a = interval(1.1, pi) # default display
setdisplay(; sigdigits = 10)
a
setdisplay(:full)
a
setdisplay(:midpoint)
a
setdisplay(; sigdigits = 4)
a
setdisplay(:infsup)
a
```



### Arithmetic operations

Basic arithmetic operations (`+`, `-`, `*`, `/`, `^`) are defined for pairs of intervals in a standard way: the result is the smallest interval containing the result of operating with each element of each interval. More precisely, for two intervals ``X`` and ``Y`` and an operation ``\bigcirc``, we define the operation on the two intervals by

```math
X \bigcirc Y \bydef \{ x \bigcirc y \,:\, x \in X \text{ and } y \in Y \}.
```

For example,

```@repl usage
using IntervalArithmetic
setdisplay(:full)
X = interval(0, 1)
Y = interval(1, 2)
X + Y
```

Due to the above definition, subtraction of two intervals may give poor enclosures:

```@repl usage
X - X
```



### Elementary functions

The main elementary functions are implemented. The functions for `Interval{Float64}` internally use routines from the correctly-rounded [CRlibm library](https://github.com/dpsanders/CRlibm.jl) where possible, i.e. for the following functions defined in that library:
- `exp`, `expm1`
- `log`, `log1p`, `log2`, `log10`
- `sin`, `cos`, `tan`
- `asin`, `acos`, `atan`
- `sinh`, `cosh`

Other functions that are implemented for `Interval{Float64}` internally convert
to an `Interval{BigFloat}`, and then use routines from the MPFR library
(`BigFloat` in Julia):
- `^`
- `exp2`, `exp10`
- `atan`, `atanh`

In particular, in order to obtain correct rounding for the power function (`^`), intervals are converted to and from `BigFloat`; this implies a significant slow-down in this case.

For example,

```@repl usage
X = interval(1)
sin(X)
cos(cosh(X))
setprecision(BigFloat, 53)
Y = big(X)
sin(Y)
cos(cosh(Y))
setprecision(BigFloat, 128)
sin(Y)
```



### Comparisons

If the result of a comparison can be established with guarantee,
it will be return, otherwise, an error is thrown.

```@repl usage
interval(1) < interval(2)
interval(1, 5) < interval(7, 9)
interval(1, 5) < interval(4.99, 9)
interval(1.23) == interval(1.23)
interval(1.23) == interval(4.99, 9)
interval(1.23) == interval(1.2, 1.3)
```

In particular, `if ... else ... end` statements used for floating-points will often break with intervals.

See [Philosophy](@ref) for more details and why this choice was made.



### Set operations

Set operations are all disallowed and error on intervals to avoid ambiguities.
To perform set operations on intervals, use the `*_interval` equivalent explicitly,
e.g. `issubset_interval` instead of `issubset`.


```@repl usage
issubset(interval(1, 2), interval(2))
issubset_interval(interval(1, 2), interval(2))
intersect(interval(1, 2), interval(2))
intersect_interval(interval(1, 2), interval(2))
```

See [Philosophy](@ref) for more details and why this choice was made.



### Piecewise functions

Since intervals don't play well with `if ... else ... end` statement,
we provide a utility to define function by pieces:

```@repl usage
myabs = Piecewise(
    Domain{:open, :closed}(-Inf, 0) => x -> -x,
    Domain{:open, :open}(0, Inf) => identity
)
myabs(-1.23)
myabs(interval(-1, 23))
```

The resulting function work with both standard numbers and intervals,
and deal properly with the decorations of intervals.



### Custom interval bounds type

A `BareInterval{T}` or `Interval{T}` have the restriction `T <: Union{Rational,AbstractFloat}` which is the parametric type for the bounds of the interval. Supposing one wishes to use their own numeric type `MyNumType <: Union{Rational,AbstractFloat}`, they must provide their own arithmetic operations (with correct rounding!).

# IntervalArithmetic.jl

IntervalArithmetic.jl is a Julia package for validated numerics in Julia. All calculations are carried out using [interval arithmetic](https://en.wikipedia.org/wiki/Interval_arithmetic) where quantities are treated as intervals. The final result is a rigorous enclosure of the true value.



## Installation

```@repl
using Pkg # Julia v1.10 or above
redirect_stderr(devnull) do # hide
Pkg.add("IntervalArithmetic")
end # hide
```



## Citation

If you use the IntervalArithmetic library in your publication, research, teaching, or other activities, please use the BibTeX template [CITATION.bib](https://github.com/JuliaIntervals/IntervalArithmetic.jl/blob/main/CITATION.bib).

# API

```@meta
CollapsedDocStrings = true
```

```@autodocs
Modules = [IntervalArithmetic]
Private = false
```

## Internal

```@docs
IntervalArithmetic.is_valid_interval
IntervalArithmetic.atomic
```

# Configuration options

The IntervalArithmetic.jl package provides a [`configure`](@ref) function (not exported) that allows users to fine-tune certain aspects of the package’s behavior. This is particularly useful for controlling trade-offs between computational speed and rigor.

!!! warning
    The [`configure`](@ref) function redefines methods that alter the internal behavior of IntervalArithmetic. This persists across the current Julia session and affect all subsequent interval arithmetic computations.

Each keyword argument sets a specific configuration option:
- `numtype`: control the default numerical type used to represent the bounds of the intervals.
- `flavor`: control the flavor type of the intervals.
- `rounding`: control the rounding type.
- `power`: control the implementation used for the interval power operation, that is, the computation of `x^n` where `x` is an interval and `n` is a number. The choice of power implementation has implications for both performance and accuracy.
- `matmul`: control the matrix multiplication algorithm.

```@repl
using IntervalArithmetic
x = interval(π)
IntervalArithmetic.configure(; power = :slow)
radius(x^3)
IntervalArithmetic.configure(; power = :fast) # default
radius(x^3)
```

# Guaranteed intervals

A *guaranteed interval* is a concept distinct from decorations (see [Decorations](@ref Decorations)) and not specified in the IEEE 1788-2015 standard. It is introduced to accommodate Julia’s flexible system of type conversion and promotion, while retaining reliability in computations.



### "NG" label

An interval `x` constructed via [`interval`](@ref) satisfies `isguaranteed(x) == true`. However, if a call to `convert(::Type{<:Interval}, ::Real)` occurs, then the resulting interval `x` satisfies `isguaranteed(x) == false`, receiving the "NG" (not guaranteed) label.

For instance, consider the following examples:

```@repl guarantee
using IntervalArithmetic
setdisplay(; sigdigits = 6)
convert(Interval{Float64}, 1.) # considered "not guaranteed" as this call can be done implicitly
interval(1) # considered "guaranteed" as the user explicitly constructed the interval
```

In contrast, a [`BareInterval`](@ref) can only be constructed via [`bareinterval`](@ref), it is not a subtype of `Real`, and there are no allowed conversion with `Number`. Thus, this interval type is always guaranteed.

!!! danger
    A user interested in validated numerics should **always** track down the source of an "NG" label.



### Exact numbers

When typing Julia code, it is combersome to manually wrap all numerical numbers with [`interval`](@ref). Also, we sometimes want to use the same function for both floating-point arithmetic (maybe to check have a fast quick checks) and interval arithmetic. Then, we would want the typed-in numerical numbers to convert automatically to the appropriate numerical type depending on the context. To this end, the [`ExactReal`](@ref) structure marks any `Real` number as a user exactly typed-in value.

For instance, consider the following examples:

```@repl guarantee
interval(1)
interval(1) + exact(1)
@exact 2interval(1) + 1 + exp(im * interval(1))
@exact foo(x) = 2x + 1 + exp(im * x)
foo(1.)
foo(interval(1))
```

# Constructing intervals

The library provides two interval types. The first one is [`BareInterval`](@ref), corresponding to a basic implementation of intervals, stored by their infimum and supremum. The second type is [`Interval`](@ref) and builds on top of bare intervals, with the additional fields `decoration` and `isguaranteed`. See the sections below.

```@repl construction
using IntervalArithmetic
setdisplay(:full) # print the interval in full
bareinterval(1, π) # `bareinterval(Float64, 1, π)`
interval(1, π) # `interval(Float64, 1, π)`, interval decorated with `com` (common)
```

Therefore, we **strongly recommend the use of [`Interval`](@ref) over [`BareInterval`](@ref)** to better track the effect of functions according to the IEEE Standard 1788-2015 specifications. For instance, taking the square root of an interval discards the negative part of the interval, without any notice for bare intervals:

```@repl construction
sqrt(bareinterval(-1, 1)) # `sqrt(bareinterval(0, 1))`
sqrt(interval(-1, 1)) # interval decorated with `trv` (trivial)
```



### Decorations

A *decoration* is a label that indicates the status of a given interval. Decorated intervals provide valuable information on the result of evaluating a function on an initial interval.

Upon the application of a function ``f`` on an interval ``x``, the resulting interval ``f(x)`` has either one of the following decorations:

- `com` (common): ``x`` is a closed, bounded, non-empty subset of the domain of ``f``, ``f`` is continuous on the interval ``x``, and ``f(x)`` is bounded.

- `dac` (defined and continuous): ``x`` is a non-empty subset of the domain of ``f``, and ``f`` is continuous on ``x``.

- `def` (defined): ``x`` is a non-empty subset of the domain of ``f``; in other words, ``f`` is defined at each point of ``x``.

- `trv` (trivial): ``f(x)`` carries no meaningful information.

- `ill` (ill-formed): ``f(x)`` is Not an Interval (NaI).

Each decoration is paired with an integer as follows: `ill = 0`, `trv = 1`, `def = 2`, `dac = 3` and `com = 4`. Then, decorations degrade according to the propagation order `com > dac > def > trv > ill`.

One can specify a decoration when constructing intervals. Otherwise, the interval is initialised with a decoration according to the underlying bare interval:

- `com`: non-empty and bounded.

- `dac`: unbounded.

- `trv`: empty.

- `ill`: NaI.


#### Examples

##### Common

```@repl construction
x = interval(0.5, 3)
sqrt(x)
```

Both input `x` and output `sqrt(x)` are common intervals since they are closed, bounded, non-empty and the square root is continuous over ``[1/2, 3]``.

Observe that these decorations, together with the fact that any element of the interval `sqrt(x)` is also in the interval `x`, imply that the [Schauder Fixed-Point Theorem](https://en.wikipedia.org/wiki/Schauder_fixed-point_theorem) is satisfied. More precisely, this computation proves the existence of a fixed-point of the square root in ``[1/2, 3]`` (in this simple example, ``\sqrt(1) = 1``).

##### Defined and continuous

```@repl construction
x = interval(3, Inf)
sqrt(x)
```

Both the intervals are unbounded, hence the maximum possible decoration is `dac`.

Note that overflows can also produce the decoration `dac`:

```@repl construction
x = interval(floatmax(Float64))
x + interval(1)
```

##### Defined and continuous

```@repl construction
x = interval(-3, 4)
sign(x)
```

The ``\sign`` function is discontinuous at ``0``, but is defined everywhere on the input interval, so the decoration of the result is `def`.

##### Trivial

```@repl construction
x = interval(-3.5, 4)
sqrt(x)
```

The negative part of `x` is discarded before evaluating the square root since its domain is ``[0, \infty)``. The process of discarding parts of an interval that are not in the domain of a function is called *loose evaluation*. This event has been recorded by degrading the decoration of the resulting interval to `trv`, indicating that nothing is known about the relationship between `x` and `sqrt(x)`.

In this case, we know why the decoration was reduced to `trv`. Generally, if this were just a single step in a longer calculation, a resulting decoration `trv` shows only that something like this occured at some step.

For instance,

```@repl construction
f = asin ∘ sqrt
x = interval(-3, 3)
f(x)
y = interval(0, 3)
f(y)
```

In both cases, `asin(sqrt(X))` gives a result with the decoration `trv`; to find out where things went wrong, the function must be analyzed.

```@repl construction
sqrt(x) # `f(x)` has the decoration is `trv` since `x` contains negative values
sqrt(y) # the decoration is `com`
asin(sqrt(y)) # `f(x)` has the decoration is `trv` since `sqrt(y)` contains values stricly greater than `1`
```

This shows that loose evaluation occurred in different parts of `f` for `x` and `y`.

!!! danger
    The decoration `trv` is an indicator of information loss. Often this also reveals that something unexpected occured. Therefore, any interval marked by this decoration may not be trusted and the code may need to be revised.

##### Ill-formed

```@repl construction
interval(2, 1)
interval(NaN)
```

These are all examples of ill-formed intervals,
also known as `NaI`, resulting in the decoration `ill`.

Similarly to the floating point `NaN`,
all boolean operations on an ill-formed interval return `false`.

!!! danger
    The decoration `ill` is an indicator that an error has occured.
    Therefore, when an ill-formed interval is created, a warning is raised.
    Any interval marked by this decoration cannot be trusted and the code needs to be debugged.


### More constructors

The submodule `IntervalArithmetic.Symbols` exports the infix operator `..` and `±` as an alias for `interval`; this submodule must be explicitly imported.

```@repl construction
using IntervalArithmetic.Symbols
0.1 .. 0.2 # interval(0.1, 0.2; format = :infsup)
0.1 ± 0.2 # interval(0.1, 0.2; format = :midpoint)
```

Moreover, one can parse strings into intervals. The various string formats are the following:

- `"[m]"` is equivalent to `interval(m, m)`.

- `"[l, r]"` is equivalent to `interval(l, r)`.

- `"m?r"` is equivalent to `interval(m-r, m+r)`.

- `"m?ren"` is equivalent to `interval((m-r)*1en, (m+r)*1en)`.

- `"m?rd"` is equivalent to `interval(m-r, m)`.

- `"m?ru"` is equivalent to `interval(m, m+r)`.

- `"m?"` is equivalent to `interval(m + 5 precision units, m - 5 precision units)`.

- `"m??"` is equivalent to `interval(-Inf, +Inf)`.

- `"m??d"` is equivalent to `interval(-Inf, m)`.

- `"m??u"` is equivalent to `interval(m, +Inf)`.

- `"[Entire]"`, `"[entire]"` and `"[,]"` are equivalent to `entireinterval()`.

- `"[Empty]"`, `"[empty]"` and `"[]"` are equivalent to `emptyinterval()`.

- `"[nai]"` and any other unsupported string formats are equivalent to `nai()`.

To add a specific decoration, add `"_com"`, `"_dac"`, `"_dec"`, `"_trv"` and `"_ill"` at the end of the string.

!!! danger
    Most real numbers cannot be exactly represented by floating-points. In such cases, the literal expression is rounded at parse time. To construct an interval enclosing the true real number, one must rely on the string constructor mentioned above.

    For instance, consider

    ```@repl construction
    x = 0.1
    ```

    This appears to store the real number ``1/10``  in a variable `x` of type `Float64`. Yet,

    ```@repl construction
    x > 1//10
    ```

    Hence, the floating-point `0.1` is (slightly) greater than the real number ``1/10`` since ``1/10`` **cannot be represented exactly in binary floating-point arithmetic, at any precision**. The true value must be approximated by a floating-point number with fixed precision -- this procedure is called rounding.

    In particular, this implies that `interval(0.1)` **does not** contain the real number ``1/10``. A valid interval containing the real number ``1/10`` can be constructed by

    ```@repl construction
    I"0.1"
    ```

# Philosophy

The goal of the `Interval` type is to be directly used to replace floating point
numbers in arbitrary julia code, such that, in any calculation,
the resulting interval is guaranteed to bound the true image of the starting
intervals.

So, essentially, we would like `Interval` to act as numbers.
And the julia ecosystem has evolved to use `Real` as the default supertype
for numerical types that are not complex.
Therefore, to ensure the widest compatiblity,
our `Interval` type must be a subtype of `Real`.

Mathematically, for any function `f(x::Real)`,
we want the following to hold
(note that it holds for **all** real numbers in `X`,
even those that cannot be represented as floating point numbers):
```math
f(x) \in f(X), \qquad \forall x \in X.
```
The interval-valued function `f(X)` is called
the _pointwise extension_ of `f(x)` (which is defined on real numbers).

At first glance, this is reasonable:
all arithmetic operations are well-defined for both real numbers and intervals,
therefore we can use multiple dispatch to define the interval behavior of
operations such has `+`, `/`, `sin` or `log`.
Then a code written for `Real`s can be used as is with `Interval`s.

However, being a `Real` means way more than just being compatible with
arithmetic operations.
`Real`s are also expected to

1. Be compatible with any other `Number` through promotion.
2. Support comparison operations, such as `==` or `<`.
3. Act as a container of a single element,
   e.g. `collect(x)` returns a 0-dimensional array containing `x`.

Each of those points lead to specific design choices for `IntervalArithmetic.jl`,
choices that we detail below.



## Compatibility with other `Number`s

In julia it is expected that `1 + 2.2` silently promoted the integer `1`
to a `Float64` to be able to perform the addition.
Following this logic, it means that `0.1 + interval(2.2, 2.3)` should
silently promote `0.1` to an interval.

However, in this case we cannot guarantee that `0.1` is known exactly,
because we do not know how it was produced in the first place
(it could be contain numerical inaccuracy from another computation from example).
Following the julia convention is thus in contradiction with providing
guaranteed result.

In this case, we choose to be mostly silent,
the information that a non-interval of unknown origin is recorded in the `NG` flag,
but the calculation is not interrupted, and no warning is printed.
If an interval is flagged with `NG` it means that it was produced through
promotion of real numbers from unknown origin, for example
```julia
julia> X = interval(1, 2)
[1.0, 2.0]_com  # The interval is guaranteed because it was explicitly created

julia> X + 0.1
[1.1, 2.1]_com_NG  # The NG flag appears, because 0.1 is not provably exact
```

For convenience, we provide the [`ExactReal`](@ref) and [`@exact`](@ref) macro
to allow explicitly marking a number as being exact,
and not produce the `NG` flag when mixed with intervals.

Note that this still assume that all interval inputs are correct.
Please see the [contructors page](@ref "Constructing intervals") for more information
about potential caveats.


## Comparison operators

We can extend the definition of the pointwise extension of a function `f` for two real numbers
`x` and `y`, and their respective intervals `X` and `Y`, as
```math
f(x, y) \in f(X, Y), \qquad \forall x \in X, y \in Y.
```

With this in mind, an operation such as `==` can easily be defined for intervals

1. If the intervals are disjoints (`X ∩ Y === ∅`), then `X == Y` is `[false]`.
2. If the intervals both contain a single floating point number,
   and that element is the same for both,
   `X == Y` is `[true]`.
3. Otherwise, we can not conclude anything, and `X == Y` must be `[false, true]`.

Not that we use intervals for all outputs, because, according to our definition,
the true result must be contained in the returned interval.
However, this is not convenient, as any `if` statement would error when used
with an interval.
Instead, we have opted to return respectively `false` and `true`
for cases 1 and 2, and to immediately error otherwise.

In this way, we can return a more informative error,
but we only error when the result is ambiguous.

This has a clear cost, however, in that some expected behaviors do not hold.
For example, an `Interval` is not equal to itself.

```julia
julia> X = interval(1, 2)
[1.0, 2.0]_com

julia> X == X
ERROR: InconclusiveBooleanOperation: `==` is purposely not supported when the intervals are overlapping. See instead `isequal_interval`
Stacktrace:
 [1] ==(x::Interval{Float64}, y::Interval{Float64})
```



## Intervals as sets

We have taken the perspective to always let `Interval`s act as if they were numbers.

But they are also sets of numbers,
and it would be nice to use all set operations defined in julia on them.

However, `Real` are also sets. For example, the following is valid

```julia
julia> 3 in 3
true
```

Then what should `3 in interval(2, 6)` do?

For interval as a set, it is clearly `true`.
But for intervals as a subtype of `Real` this is equivalent to
```julia
3 == interval(2, 6)
```
which must either be false (they are not the same things),
or error as the result can not be established.

To be safe, we decided to go one step further and disable
**all** set operations from julia `Base` on intervals.
These operations can instead be performed with the specific `*_interval` function,
for example `in_interval` as a replacement for `in`.

`setdiff` is an exception,
as we can not meaningfully define the set difference of two intervals,
because our intervals are always closed,
while the result of `setdiff` can be open.


## `hash`

The function `hash` is the only case where we do not define the value of
a function based on its interval extension.

`hash` return a single hash, and not an interval bounding the image
of the function.

```julia
julia> hash(interval(1, 2))
0xda823f68b9653b1a

julia> hash(1.2) in hash(interval(-10, 10))
false
```

This is justified as `hash` is not a mathematical function,
and julia requires that `hash` returns a `UInt`.

# Summary

| | Functions | Behavior | Note |
| :---- | :---- | :---- | :---- |
| Arithmetic operations | `+`, `-`, `*`, `/`, `^` | Interval extension | Produce the `NG` flag when mixed with non-interval |
| Other numeric function | `sin`, `exp`, `sqrt`, etc. | Interval extension |  |
| Boolean operations | `==`, `<`, `<=`, `iszero`, `isnan`, `isinteger`, `isfinite` | Error if the result can not be guaranteed to be either `true` or `false` | See [`isequal_interval`](@ref) to test equality of intervals, and [`isbounded`](@ref) to test the finiteness of the elements |
| Set operations | `in`, `issubset`, `isdisjoint`, `issetequal`, `isempty`, `union`, `intersect` | Always error | Use the `*_interval` function instead (e.g. [`in_interval`](@ref))
| Exceptions | `≈`, `setdiff` | Always error | No meaningful interval extension |
| Hash | `hash` | Hash the interval as a julia object | |

# Arblib.jl

[Arblib.jl](https://github.com/kalmarek/Arblib.jl/) is a Julia package for rigorous numerics based on ball arithmetic. It provides a thin and efficient wrapper around the parts of the C library [FLINT](https://flintlib.org/) that are concerned with real and complex numbers.

The purpose of the Arblib package extension is to make conversions between the types defined in IntervalArithmetic and Arblib straightforward. This allows for easy switching between the two packages, depending on which one suits a specific part of a computation best.

Some of the things that Arblib excels at are:
1. Fast high precision computations, including linear algebra routines.
2. A large library of special functions.
3. [Support for mutable arithmetic](https://kalmarek.github.io/Arblib.jl/stable/interface-mutable/).
4. [Taylor series expansions](https://kalmarek.github.io/Arblib.jl/stable/interface-series/).

Some of the things that IntervalArithmetic excels at are:
1. Fast computations at `Float32` and `Float64` precision.
2. Computations with wide intervals (FLINT is in general not optimized for this, though the situation is improving).
3. Built-in safety features, such as decorations (see [Decorations](@ref)) and the "NG" flag (see ["NG" label](@ref)).



## Conversion between `Interval` and Arblib types

The fundamental types in Arblib are `Arb` and `Acb`, corresponding to real and complex balls respectively. Conversion between `Interval` and `Arb`, as well as between `Complex{<:Interval}` and `Acb`, is done through the standard constructors. If no type is specified when calling `interval`, it defaults to `Interval{BigFloat}` for `Arb` and `Complex{Interval{BigFloat}}` for `Acb`.

```@repl 1
using IntervalArithmetic, Arblib

x = interval(π)
Arb(x)

y = Arb(π)
interval(y) # Defaults to BigFloat
interval(Float64, y) # Other type can be explicitly specified

z = complex(interval(2), interval(1 // 3))
Acb(z)

w = Acb(2, 1 // 3)
interval(w)
interval(Float64, w)
```



## Linear algebra

To use the optimized linear algebra routines from FLINT, the matrices should be converted to `ArbMatrix` or `AcbMatrix` (depending on
whether they are real or complex). Basic methods can then be used directly:

```@repl
using IntervalArithmetic, Arblib, LinearAlgebra

A = interval.(BigFloat, [1 2; 3 4])

B = ArbMatrix(A)

B * B

inv(B)

B \ B

eigvals(AcbMatrix(B)) # Eigenvalues are only supported for AcbMatrix
```

Full documentation about supported methods can be found in the FLINT documentation for [arb_mat](https://flintlib.org/doc/arb_mat.html) and
[acb_mat](https://flintlib.org/doc/acb_mat.html). Note that many of these methods are not wrapped in Arblib, but most of them can be used through a [low level wrapper](https://kalmarek.github.io/Arblib.jl/stable/wrapper-methods/).



## Special functions

Arblib wraps a large number of the special functions from [SpecialFunctions.jl](https://github.com/JuliaMath/SpecialFunctions.jl).

``` @repl
using IntervalArithmetic, Arblib, SpecialFunctions

x = interval(BigFloat, 2)

interval(besselj0(Arb(x))) # Convert to Arb and then back

interval(gamma(Arb(x)))

interval(zeta(Arb(x)))
```

Note that FLINT implements several special functions that are not in SpecialFunctions.jl, such as the [confluent hypergeometric functions](https://flintlib.org/doc/acb_hypgeom.html#confluent-hypergeometric-functions) and the [Lerch transcendent](https://flintlib.org/doc/acb_dirichlet.html#lerch-transcendent); they can be used through the [low-level wrapper](https://kalmarek.github.io/Arblib.jl/stable/wrapper-methods/):

``` @repl
using IntervalArithmetic, Arblib

z = interval(BigFloat, 2 + 3im)
s = interval(BigFloat, 2)
a = interval(BigFloat, 4)

interval(Arblib.dirichlet_lerch_phi!(Acb(), Acb(z), Acb(s), Acb(a)))
```

In this example, we compute rigorous bounds on ``\pi`` using interval arithmetic[^1], via the [`IntervalArithmetic.jl`](https://github.com/JuliaIntervals/IntervalArithmetic.jl) package.

[^1]: W. Tucker, [*Validated Numerics: A Short Introduction to Rigorous Computations*](https://press.princeton.edu/books/hardcover/9780691147819/validated-numerics), Princeton University Press, 2011.

There are many ways to calculate ``\pi``. For illustrative purposes, we will use the following sum

```math
S \bydef \sum_{n=1}^\infty \frac{1}{n^2}.
```

According to the [Basel Problem](https://en.wikipedia.org/wiki/Basel_problem), the exact value is ``S = \frac{\pi^2}{6}``. Thus, if we can calculate a rigorous enclosure of ``S``, then we can deduce a rigorous enclosure of ``\pi``.

First, we split ``S`` into a finite and infinite part, ``S = S_N + T_N``, where

```math
S_N \bydef \sum_{n=1}^N \frac{1}{n^2}, \qquad
T_N \bydef S - S_N = \sum_{n=N+1}^\infty \frac{1}{n^2}.
```

Using integrals from below and above, we obtain ``\frac{1}{N+1} \le T_N \le \frac{1}{N}``. It remains to compute rigorous bounds for ``S_N``, which can be found by calculating the sum using interval arithmetic:

```@example pi
using IntervalArithmetic

function forward_sum(N)
    S_N = interval(0)

    for i ∈ 1:N
        S_N += interval(1) / interval(i) ^ interval(2)
    end

    T_N = interval(1) / interval(N, N+1)

    S = S_N + T_N

    return sqrt(interval(6) * S)
end

pi_interval = forward_sum(10^6)

midradius(pi_interval)
```

The above computation shows that the midpoint of the computed interval is correct to about 10 decimal places. We can also verify directly that ``\pi`` is indeed contained in the interval:

```@example pi
in_interval(π, pi_interval)
```

Lastly, let us note that, due to floating-point arithmetic, computing the sum in the opposite direction yields a more accurate answer:

```@example pi
function backward_sum(N)
    S_N = interval(0)

    for i ∈ N:-1:1
        S_N += interval(1) / interval(i) ^ interval(2)
    end

    T_N = interval(1) / interval(N, N+1)

    S = S_N + T_N

    return sqrt(interval(6) * S)
end

improved_pi_interval = backward_sum(10^6)

midradius(improved_pi_interval)
```
